// BackButton.java
// Copyright (c) 1999 by Xerox Corporation
// bchang@parc.xerox.com

// $Header: /FluidDocs/annotation/BackButton.java 3     7/15/99 6:35p Bchang $

package annotation;

import fluid.*;

import java.awt.*;

public class BackButton extends FluidComponent {
  public BackButton(Insets margins) {
    setLocation(new Point(20, margins.top + 2));
    setSize(new Dimension(12, 12));
//    drawnSize = new Dimension(0, 0);
    drawnSize = getSize();
    setColor(Color.gray);
  }
  
  protected Color highlightColor = Color.red;
  protected Color overColor = Color.darkGray;
  
  protected Dimension drawnSize;
  public void setDrawnSize(Dimension s) { drawnSize = s; }
  public Dimension getDrawnSize() { return drawnSize; }
  
  protected boolean fill = false;
  protected boolean over = false;
  
  public void drawSelf(Graphics g) {
    if (fill) {
//      g.setColor(highlightColor);
      g.setColor(color);
    } else if (over) {
      g.setColor(overColor);
    } else {
      g.setColor(color);
    }
//    g.drawOval(0, 0, drawnSize.width, drawnSize.height);
    g.drawLine(0, getHeight() / 2, getWidth(), 0);
    g.drawLine(0, getHeight() / 2, getWidth(), getHeight());
    g.drawLine(1, getHeight() / 2, getWidth() + 1, 0);
    g.drawLine(1, getHeight() / 2, getWidth() + 1, getHeight());
    g.drawLine(2, getHeight() / 2, getWidth() + 2, 0);
    g.drawLine(2, getHeight() / 2, getWidth() + 2, getHeight());    
      //    g.drawRect0, 0, drawnSize.width, drawnSize.height);
    if (fill) {
//      g.fillRect(0, 0, drawnSize.width, drawnSize.height);
//      g.fillOval(0, 0, drawnSize.width, drawnSize.height);

    }
  }
  
  protected Animation drawnSizeAnimation = null;
  public AnimDimension changeDrawnSize(final Dimension tosize) {
    return new AnimDimension() {
      protected void setStart() { start = getDrawnSize(); }
      protected void setEnd() { end = tosize; }
      protected void stepTarget(double fraction) {
        setDrawnSize(currentValue(fraction));
      }
      protected Animation getCurrentAnimation() { return drawnSizeAnimation; }
      protected void setCurrentAnimation(Animation anim) { drawnSizeAnimation = anim; }
    };
  }
  
  public void grow() {
    Animation anim = changeDrawnSize(getSize());
    anim.setDuration(200);
    startAnimation(anim);
  }
  
  public void highlight() {
    fill = true;
    repaint();
  }
  
  public void unhighlight() {
    fill = false;
    repaint();
  }
  
  public void shrink() {
    unhighlight();
    Animation anim = changeDrawnSize(new Dimension(0, 0));
    anim.setDuration(200);
    startAnimation(anim);
  }

  public void mouseEnter(Event evt, int x, int y) {
    // grow();
    over = true;
    repaint();
  }
  
  public void mouseLeave(Event evt, int x, int y, FluidComponent originatingComp, FluidComponent enteredComp) {
    // shrink();
    over = false;
    repaint();
  }

  public void mouseDown(Event evt, int x, int y) {
//    highlight();
  }

  public void mouseUp(Event evt, int x, int y) {
//    shrink();
    ((Page)getParent()).back();
  }
}

/* $Log: /FluidDocs/annotation/BackButton.java $
 * 
 * 3     7/15/99 6:35p Bchang
 * made default color gray (rather than lightgray)
 * 
 * 2     7/14/99 8:42a Bchang
 * commented out highlight and shrink behavior which is no longer being
 * used
 * 
 * 1     1/26/99 8:13p Bchang
 * initial version
 *
 */
