// GlossAttributes.java
// Copyright (c) 1999 by Xerox Corporation
// bchang@parc.xerox.com

// $Header: /FluidDocs/annotation/GlossAttributes.java 2     5/20/99 12:14p Bchang $

package annotation;

import org.xml.sax.*;
import java.awt.Color;
import java.awt.Font;
import fluid.Util;

public class GlossAttributes {
  
  public String type = "";
  public String source = "";
  public String ctag = "title";  // default tag to be fetched from href file as gloss value
  public int width = 0;
  public int height = 0;
  public String fontname = "";
  public int fontstyle = -1;
  public int fontsize = -1;
  public int linespacing = -1;
  public Color color = null;
  public String style = "";
  public String imgpos = "left";
  public int x = 0;
  
  public GlossAttributes() {}

  public GlossAttributes(AttributeList attributes) {
    
  	for (int i = 0; i < attributes.getLength(); i++) {
      if (attributes.getName(i).equalsIgnoreCase("type")) {
        type = attributes.getValue(i);
		  }
		  if (attributes.getName(i).equalsIgnoreCase("tag")) {
        ctag = attributes.getValue(i);
      }
      if (attributes.getName(i).equalsIgnoreCase("source")) {
        source = attributes.getValue(i);
      }
      if (attributes.getName(i).equalsIgnoreCase("width")) {
        width = Integer.parseInt(attributes.getValue(i));
      }
      if (attributes.getName(i).equalsIgnoreCase("height")) {
        height = Integer.parseInt(attributes.getValue(i));
      }
      if (attributes.getName(i).equalsIgnoreCase("fontname")) {
        fontname = attributes.getValue(i);
      }
      if (attributes.getName(i).equalsIgnoreCase("fontsize")) {
        fontsize = Integer.parseInt(attributes.getValue(i));
      }
      if (attributes.getName(i).equalsIgnoreCase("linespacing")) {
        linespacing = Integer.parseInt(attributes.getValue(i));
      }
      if (attributes.getName(i).equalsIgnoreCase("fontstyle")) {
        String low = attributes.getValue(i).toLowerCase();
        if (low.equals("italic")) {
          fontstyle = Font.ITALIC;
        } else if (low.equals("bold")) {
          fontstyle = Font.BOLD;
        } else {
          fontstyle = Font.PLAIN;
        }
      }
      if (attributes.getName(i).equalsIgnoreCase("color")) {
        color = Util.hexToColor(attributes.getValue(i));
      }
      if (attributes.getName(i).equalsIgnoreCase("style")) {
        style = attributes.getValue(i);
      }
      if (attributes.getName(i).equalsIgnoreCase("imgpos")) {
        imgpos = attributes.getValue(i);
      }
      if (attributes.getName(i).equalsIgnoreCase("x")) {
        x = Integer.parseInt(attributes.getValue(i));
      }
    }
  }
}


/* $Log: /FluidDocs/annotation/GlossAttributes.java $
 * 
 * 2     5/20/99 12:14p Bchang
 * added no-arg constructor
 * 
 * 1     5/12/99 11:31a Bchang
 * Introduced this class to process attributes of the <gloss> tag during
 * FluidLinksXMLHandler.
 */