// AnimColor.java
// Copyright (c) 1999 by Xerox Corporation
// bchang@parc.xerox.com

// $Header: /FluidDocs/fluid/AnimColor.java 3     1/13/99 5:48p Bchang $

package fluid;

import java.awt.Color;

public abstract class AnimColor extends Animation {
  protected Color start, end;
  
  public AnimColor() {}
    
  public AnimColor(Color s, Color e) {
    start = s;
    end = e;
  }
  
  protected Color currentValue(double fraction) {
    int r = interpolateInt(start.getRed(), end.getRed(), fraction);
    int g = interpolateInt(start.getGreen(), end.getGreen(), fraction);
    int b = interpolateInt(start.getBlue(), end.getBlue(), fraction);
    return new Color(r, g, b);
  }
} 

/* $Log: /FluidDocs/fluid/AnimColor.java $
 * 
 * 3     1/13/99 5:48p Bchang
 * Added $Log at bottom of file.
 * Added No-arg constructor.
 */
