// AnimDimension.java
// Copyright (c) 1999 by Xerox Corporation
// bchang@parc.xerox.com

// $Header: /FluidDocs/fluid/AnimDimension.java 3     1/13/99 5:48p Bchang $

package fluid;

import java.awt.Dimension;

public abstract class AnimDimension extends Animation {
  protected Dimension start, end;
  
  public AnimDimension() {}
      
  public AnimDimension(Dimension s, Dimension e) {
    start = s;
    end = e;
  }
    
  protected Dimension currentValue(double fraction) {
    int w = interpolateInt(start.width, end.width, fraction);
    int h = interpolateInt(start.height, end.height, fraction);
    return new Dimension(w, h);
  }
}

/* $Log: /FluidDocs/fluid/AnimDimension.java $
 * 
 * 3     1/13/99 5:48p Bchang
 * Added $Log at bottom of file.
 * Added No-arg constructor.
 */
