// AnimPoint.java
// Copyright (c) 1999 by Xerox Corporation
// bchang@parc.xerox.com

// $Header: /FluidDocs/fluid/AnimPoint.java 3     1/13/99 5:48p Bchang $

package fluid;

import java.awt.Point;

public abstract class AnimPoint extends Animation {
  protected Point start, end;
  
  public AnimPoint() {}
  
  public AnimPoint(Point s, Point e) {
    start = s;
    end = e;
  }
  
  protected Point currentValue(double fraction) {
    int x = interpolateInt(start.x, end.x, fraction);
    int y = interpolateInt(start.y, end.y, fraction);
    return new Point(x, y);
  }
} 

/* $Log: /FluidDocs/fluid/AnimPoint.java $
 * 
 * 3     1/13/99 5:48p Bchang
 * Added $Log at bottom of file.
 * Added No-arg constructor.
 */
