package AOMetrics;

import org.eclipse.ui.plugin.*;
import org.eclipse.core.runtime.*;
import org.eclipse.core.resources.*;

import AOMetrics.views.StatsBuildListener;

import java.util.*;

/**
 * The main plugin class to be used in the desktop.
 */
public class AOMetricsPlugin extends AbstractUIPlugin {
	//The shared instance.
	private static AOMetricsPlugin plugin;
	//Resource bundle.
	private ResourceBundle resourceBundle;
	
	/**
	 * The constructor.
	 */
	public AOMetricsPlugin(IPluginDescriptor descriptor) {
		super(descriptor);
		plugin = this;
		try {
			resourceBundle= ResourceBundle.getBundle("AOMetrics.AOMetricsPluginResources");
		} catch (MissingResourceException x) {
			resourceBundle = null;
		}
		
		org.aspectj.ajde.Ajde.getDefault().getBuildManager().addListener(new StatsBuildListener());
	}

	/**
	 * Returns the shared instance.
	 */
	public static AOMetricsPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the workspace instance.
	 */
	public static IWorkspace getWorkspace() {
		return ResourcesPlugin.getWorkspace();
	}

	/**
	 * Returns the string from the plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString(String key) {
		ResourceBundle bundle= AOMetricsPlugin.getDefault().getResourceBundle();
		try {
			return bundle.getString(key);
		} catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}
}
