package AspectMetrics;

import org.eclipse.ui.plugin.*;
import org.eclipse.core.runtime.*;
import org.eclipse.core.resources.*;
import java.util.*;

/**
 * The main plugin class to be used in the desktop.
 */
public class AspectMetricsPlugin extends AbstractUIPlugin {
	//The shared instance.
	private static AspectMetricsPlugin plugin;
	//Resource bundle.
	private ResourceBundle resourceBundle;
	
	/**  
	 * The constructor.
	 */
	public AspectMetricsPlugin(IPluginDescriptor descriptor) {
		super(descriptor);
	
		plugin = this;
		try {
			resourceBundle= ResourceBundle.getBundle("AspectMetrics.AspectMetricsPluginResources");
		} catch (MissingResourceException x) {
			resourceBundle = null;
		}
		org.aspectj.ajde.Ajde.getDefault().getBuildManager().addListener(new StatsBuildListener());
		
	}

	/**
	 * Returns the shared instance.
	 */
	public static AspectMetricsPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the workspace instance.
	 */
	public static IWorkspace getWorkspace() {
		return ResourcesPlugin.getWorkspace();
	}

	/**
	 * Returns the string from the plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString(String key) {
		ResourceBundle bundle= AspectMetricsPlugin.getDefault().getResourceBundle();
		try {
			return bundle.getString(key);
		} catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}
}
