#!/bin/sh
#                 Sun Public License Notice
#
# The contents of this file are subject to the Sun Public License
# Version 1.0 (the "License"). You may not use this file except in
# compliance with the License. A copy of the License is available at
# http://www.sun.com/
#
# The Original Code is NetBeans. The Initial Developer of the Original
# Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
# Microsystems, Inc. All Rights Reserved.

#get the right dir
IDE_DIR=`dirname $0`
if [ -z $IDE_DIR ]; then
    IDE_DIR=`pwd`
fi

OI_INSTALL=''
OI_ARGS=''
# XXX why is this needed? otherwise throws many security exceptions...
REGULAR_ARGS='-J-Dnetbeans.security.nocheck=true'

while [ $# -gt 0 ] ; do
    case "$1" in
        -h|-help) cat <<EOF
Usage: exactly like regular runide.sh, however the following arguments are
recognized as well:

-optithome PATH
    Specify the path to OptimizeIt! (this is mandatory)
-Ooption
    Pass option to OptimizeIt!

Example of complete usage:

runide_optimizeit.sh -J-classic -optithome /opt/optit -J-Dnetbeans.debug.exceptions=true -O-startCPUprofiler -userdir /tmp/testud
EOF
exit 1
;;
        -optithome) shift; if [ $# -gt 0 ] ; then OI_INSTALL="$1"; fi;;
        -O*) oopt=`expr "$1" : '-O\(.*\)'`; OI_ARGS="$OI_ARGS \"-J$oopt\"";;
        *) REGULAR_ARGS="$REGULAR_ARGS \"$1\"" ;;
    esac
    shift
done

if [ -z "$OI_INSTALL" ]; then
    echo 'You need to pass -optithome PATH'
    echo '(please run with -help for usage)'
    exit 1
fi

if [ -z "$LD_LIBRARY_PATH" ]; then
    LD_LIBRARY_PATH="$OI_INSTALL/lib"
else
    LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$OI_INSTALL/lib"
fi
export LD_LIBRARY_PATH

echo 'In OptimizeIt!, choose File | New, Remote Application, and Attach.'

#echo "$IDE_DIR/../runide.sh $REGULAR_ARGS -cp:a $OI_INSTALL/lib/optit.jar -J-Xrunoii -Jintuitive.audit.Audit $OI_ARGS"
eval $IDE_DIR/../runide.sh $REGULAR_ARGS -cp:a "$OI_INSTALL/lib/optit.jar" -J-Xrunoii -Jintuitive.audit.Audit $OI_ARGS
