/*
 *                         Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/
 *
 * The Original Code is the Ant module
 * The Initial Developer of the Original Code is Jayme C. Edwards.
 * Portions created by Jayme C. Edwards are Copyright (c) 2000.
 * All Rights Reserved.
 *
 * Contributor(s): Jayme C. Edwards, Jesse Glick.
 */
 
package org.apache.tools.ant.module.api;

import org.w3c.dom.Element;

import org.openide.nodes.Node;

/** 
 * Contains state needed to represent an Ant Target in the IDE.
 */
public interface AntTargetCookie extends Node.Cookie {
    /** Get the project this is a part of.
     * @return the project cookie
     */
    AntProjectCookie getProjectCookie ();
    /** Get the element corresponding to this target.
     * @return the DOM element, or null for a misparse
     */
    Element getTargetElement ();
}
