/*
 *                         Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/
 *
 * The Original Code is the Ant module
 * The Initial Developer of the Original Code is Jayme C. Edwards.
 * Portions created by Jayme C. Edwards are Copyright (c) 2000.
 * All Rights Reserved.
 *
 * Contributor(s): Jesse Glick.
 */

package org.apache.tools.ant.module.run;

import java.awt.Image;
import java.beans.*;

import org.openide.execution.Executor;
import org.openide.util.NbBundle;

public class AntExecutorBeanInfo extends SimpleBeanInfo {

    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] {
                       Introspector.getBeanInfo (Executor.class)
                   };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }

    public BeanDescriptor getBeanDescriptor () {
        BeanDescriptor desc = new BeanDescriptor (AntExecutor.class);
        desc.setDisplayName (NbBundle.getMessage (AntExecutorBeanInfo.class, "LBL_executor"));
        desc.setShortDescription (NbBundle.getMessage (AntExecutorBeanInfo.class, "HINT_executor"));
        desc.setValue ("version", "1.1"); // NOI18N
        return desc;
    }

    public PropertyDescriptor[] getPropertyDescriptors () {
        try {
            PropertyDescriptor target = new PropertyDescriptor ("target", AntExecutor.class);
            target.setDisplayName (NbBundle.getMessage (AntExecutorBeanInfo.class, "PROP_target"));
            target.setShortDescription (NbBundle.getMessage (AntExecutorBeanInfo.class, "HINT_target"));
            PropertyDescriptor properties = new PropertyDescriptor ("properties", AntExecutor.class);
            properties.setDisplayName (NbBundle.getMessage (AntExecutorBeanInfo.class, "PROP_executor_properties"));
            properties.setShortDescription (NbBundle.getMessage (AntExecutorBeanInfo.class, "HINT_executor_properties"));
            return new PropertyDescriptor[] { target, properties };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }

    private static Image icon;
    public Image getIcon (int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            if (icon == null)
                icon = loadImage ("/org/apache/tools/ant/module/resources/AntIcon.gif");
            return icon;
        } else {
            return null;
        }
    }

}
