/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.apisupport;

import java.lang.reflect.*;
import java.io.IOException;

import org.openide.TopManager;
import org.openide.execution.ThreadExecutor;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;

import org.netbeans.modules.apisupport.beanbrowser.PropSetKids;

public class BeanTester extends ThreadExecutor {

    private static final long serialVersionUID =-4004964495171713724L;
    public HelpCtx getHelpCtx () {
        return new HelpCtx ("org.netbeans.modules.apisupport.testers.Bean");
    }

    protected void checkClass (Class clazz) throws IOException {
        if (! Modifier.isPublic (clazz.getModifiers ()))
            throw new IOException ("Class is not public");
        try {
            Constructor c = clazz.getConstructor (new Class[] { });
            if (! Modifier.isPublic (c.getModifiers ()))
                throw new IOException ("Constructor is not public");
        } catch (ThreadDeath td) {
            throw td;
        } catch (Throwable t) {
            IOException ioe = new IOException ();
            TopManager.getDefault ().getErrorManager ().annotate (ioe, t);
            throw ioe;
        }
    }

    protected void executeClass (Class clazz, String[] args) {
        try {
            Object o = clazz.newInstance ();
            Node n;
            if (o instanceof Node) {
                n = (Node) o;
            } else {
                n = PropSetKids.makeObjectNode (o);
            }
            TopManager.getDefault ().getNodeOperation ().explore (n);
        } catch (ThreadDeath td) {
            throw td;
        } catch (Throwable t) {
            t.printStackTrace ();
        }
    }

}
