/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.apisupport;

import java.awt.Image;
import java.beans.*;

import org.openide.execution.ThreadExecutor;

public class ExecutorTesterBeanInfo extends SimpleBeanInfo {

    public BeanDescriptor getBeanDescriptor () {
        // [PENDING] customizer to choose the class and args from Repo
        BeanDescriptor bd = new BeanDescriptor (ExecutorTester.class);
        bd.setDisplayName ("Test Executor Objects");
        return bd;
    }

    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (ThreadExecutor.class) };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }

    public PropertyDescriptor[] getPropertyDescriptors () {
        try {
            PropertyDescriptor testableClass = new PropertyDescriptor ("testableClass", ExecutorTester.class);
            testableClass.setDisplayName ("Testing Class");
            testableClass.setShortDescription ("Name of a class (or other object, class-style format) to test on; if blank, will prompt.");
            // XXX proped to browse to it would be nice
            PropertyDescriptor testableArgs = new PropertyDescriptor ("testableArgs", ExecutorTester.class);
            testableArgs.setDisplayName ("Testing Arguments");
            testableArgs.setShortDescription ("List of arguments to use, if Testing Class is set.");
            return new PropertyDescriptor[] { testableClass, testableArgs };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }

    private static Image icon;
    public Image getIcon (int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            if (icon == null)
                icon = loadImage ("resources/ExecutorTesterIcon.gif");
            return icon;
        } else {
            return null;
        }
    }

}
