/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.apisupport.beanbrowser;

import org.openide.*;
import org.openide.nodes.*;
import org.openide.util.*;
import org.openide.util.actions.NodeAction;

/** Browse the current node selection. */
public class BeanBrowseAction extends NodeAction {
    static final long serialVersionUID =3942849820352945054L;
    public boolean enable (Node[] nodes) {
        return nodes.length == 1;
    }
    public void performAction (Node[] nodes) {
        if (enable (nodes)) {
            TopManager.getDefault ().getNodeOperation ().explore (Wrapper.make (nodes[0]));
        }
    }
    public HelpCtx getHelpCtx () {
        return new HelpCtx ("org.netbeans.modules.apisupport.beanbrowser");
    }
    public String getName () {
        return "Bean Browse Node";
    }
    protected String iconResource () {
        return "/org/netbeans/modules/apisupport/resources/BeanBrowserIcon.gif";
    }
}
