/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.apisupport.beanbrowser;

import org.openide.*;
import org.openide.nodes.*;
import org.openide.util.*;
import org.openide.util.actions.*;
import org.openide.windows.*;

import java.awt.*;
import java.beans.*;

/** Browse the selected window. */
public class BeanBrowseWindowAction extends CallableSystemAction {

    static final long serialVersionUID =363544761434854016L;
    public String getName () {
        return "Bean Browse Window";
    }

    public HelpCtx getHelpCtx () {
        return new HelpCtx ("org.netbeans.modules.apisupport.beanbrowser");
    }

    public void performAction () {
        try {
            Component c = TopComponent.getRegistry ().getActivated ();
            if (c == null)
                c = TopManager.getDefault ().getWindowManager ().getMainWindow ();
            Node n = Wrapper.make (new RefinedBeanNode (c));
            TopManager.getDefault ().getNodeOperation ().explore (n);
        } catch (IntrospectionException e) {
            TopManager.getDefault ().notifyException (e);
        }
    }
    protected String iconResource () {
        return "/org/netbeans/modules/apisupport/resources/BeanBrowserIcon.gif";
    }
}
