/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.apisupport.beanbrowser;

import org.openide.nodes.*;
import org.openide.util.HelpCtx;

/** A node representing a property set of the parent node.
* E.g. might represent regular or expert properties.
*/
public class PropSet extends AbstractNode {

    private Node original;
    private Node.PropertySet ps;

    public PropSet (Node original, Node.PropertySet ps) {
        super (new PropSetKids (original, ps));
        setName ("Properties (" + ps.getName () + ")");
        setIconBase ("/org/netbeans/modules/apisupport/resources/BeanBrowserIcon");
    }

    public HelpCtx getHelpCtx () {
        return new HelpCtx ("org.netbeans.modules.apisupport.beanbrowser");
    }

}
