/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.apisupport.lite;

import javax.swing.event.ChangeListener;

import org.openide.WizardDescriptor;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;

/** Panel for new module wizard
*
* @author Ales Kemr
*/
public class IntroPanel extends javax.swing.JPanel {

    private Wizard.Validator validator;

    public IntroPanel( Wizard.Validator validator ) {
        putClientProperty("WizardPanel_autoWizardStyle", new Boolean(true));
        putClientProperty("WizardPanel_contentDisplayed", new Boolean(true));
        putClientProperty("WizardPanel_contentNumbered", new Boolean(true));
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(0));
        putClientProperty("WizardPanel_contentData", new String[] {
            bundle.getString("STEP_Introduction"),
            bundle.getString("STEP_Module"),
            bundle.getString("STEP_Selection"),
            bundle.getString("STEP_Loader"),
            bundle.getString("STEP_Menu"),
            bundle.getString("STEP_Manifest")
        });
        setName(bundle.getString("LAB_Introduction"));
        initComponents();
        setPreferredSize(new java.awt.Dimension(500, 400));

        this.validator = validator;        
    }

    private void initComponents() {//GEN-BEGIN:initComponents
        descriptionTextArea = new javax.swing.JTextArea();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        descriptionTextArea.setWrapStyleWord(true);
        descriptionTextArea.setLineWrap(true);
        descriptionTextArea.setEditable(false);
        descriptionTextArea.setText(bundle.getString("TXT_Introduction"));
        descriptionTextArea.setBackground(new java.awt.Color(204, 204, 204));
        descriptionTextArea.setDisabledTextColor(java.awt.Color.black);
        descriptionTextArea.setEnabled(false);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(descriptionTextArea, gridBagConstraints1);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea descriptionTextArea;
    // End of variables declaration//GEN-END:variables

    private static final java.util.ResourceBundle bundle = NbBundle.getBundle( IntroPanel.class );
}
