/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.apisupport.lite;

import java.awt.Image;
import java.beans.*;

import org.openide.ErrorManager;
import org.openide.TopManager;
import org.openide.execution.Executor;
import org.openide.util.NbBundle;

/** BeanInfo for the lite installer.
 * @author Jesse Glick
 */
public class LiteInstallerBeanInfo extends SimpleBeanInfo {

    public BeanDescriptor getBeanDescriptor () {
        BeanDescriptor bd = new BeanDescriptor (LiteInstaller.class);
        bd.setDisplayName (NbBundle.getMessage (LiteInstallerBeanInfo.class, "LBL_install_as_module"));
        bd.setValue ("version", "1.1"); // NOI18N
        return bd;
    }

    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (Executor.class) };
        } catch (IntrospectionException ie) {
            TopManager.getDefault ().getErrorManager ().notify (ErrorManager.INFORMATIONAL, ie);
            return null;
        }
    }

    private static Image icon;
    public Image getIcon (int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            if (icon == null)
                icon = loadImage ("resources/LiteInstallerIcon.gif"); // NOI18N
            return icon;
        } else {
            return null;
        }
    }

}
