/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.apisupport.lite;

import java.util.Arrays;
import java.util.List;
import javax.swing.event.ChangeListener;

import org.openide.WizardDescriptor;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;

/** Panel for new module wizard
*
* @author Ales Kemr
*/
public class SelectionPanel extends javax.swing.JPanel implements org.openide.WizardDescriptor.Panel {

    private Wizard.Validator validator;

    public SelectionPanel(Wizard.Validator validator) {
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(2));
        setName(bundle.getString("LAB_Selection"));
        initComponents();
        setPreferredSize(new java.awt.Dimension(500, 400));
        

        newFileTypeCheckBox.setSelected(true);
        newMenuToolbarItemCheckBox.setSelected(true);

        this.validator = validator;
    }

    /*
    public void removeFromLeftPane(String name) {
        String[] steps = (String[])WizardDescriptor.getProperty("WizardPanel_contentData");
        int len = steps.length;
        List list = Arrays.asList(steps);
        if (list.contains(name)) {
            list.remove(name);
            steps = new String[len - 1];
            for (int i=0;i<list.size();i++)
                steps[i] = (String)list.get(i);
            putClientProperty("WizardPanel_contentData",steps);
        }
    }
     */

    private void initComponents() {//GEN-BEGIN:initComponents
        descriptionTextArea = new javax.swing.JTextArea();
        needLabel = new javax.swing.JLabel();
        newFileTypeCheckBox = new javax.swing.JCheckBox();
        newMenuToolbarItemCheckBox = new javax.swing.JCheckBox();
        jPanel1 = new javax.swing.JPanel();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        descriptionTextArea.setWrapStyleWord(true);
        descriptionTextArea.setLineWrap(true);
        descriptionTextArea.setEditable(false);
        descriptionTextArea.setText(bundle.getString("TXT_Selection"));
        descriptionTextArea.setBackground(needLabel.getBackground());
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        add(descriptionTextArea, gridBagConstraints1);
        
        needLabel.setText(bundle.getString("LBL_Need"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(11, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(needLabel, gridBagConstraints1);
        
        newFileTypeCheckBox.setMnemonic(bundle.getString("CBX_File_Mnemonic").charAt(0));
        newFileTypeCheckBox.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/apisupport/lite/Bundle").getString("CBX_File"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(11, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(newFileTypeCheckBox, gridBagConstraints1);
        
        newMenuToolbarItemCheckBox.setMnemonic(bundle.getString("CBX_Menu_Mnemonic").charAt(0));
        newMenuToolbarItemCheckBox.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/apisupport/lite/Bundle").getString("CBX_Menu"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(11, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(newMenuToolbarItemCheckBox, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel1, gridBagConstraints1);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea descriptionTextArea;
    private javax.swing.JLabel needLabel;
    private javax.swing.JCheckBox newFileTypeCheckBox;
    private javax.swing.JCheckBox newMenuToolbarItemCheckBox;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables

    private static final java.util.ResourceBundle bundle = NbBundle.getBundle( SelectionPanel.class );

    private boolean dataLoader;

    private boolean menu;

    /** Get the component displayed in this panel.
     * @return the component
     */
    public java.awt.Component getComponent() {
        return this;
    }

    /** Help for this panel.
     * When the panel is active, this is used as the help for the wizard dialog.
     * @return the help or <code>null</code> if no help is supplied
     */
    public HelpCtx getHelp() {
        return null;
    }

    /** Provides the wizard panel with the current data--either
     * the default data or already-modified settings, if the user used the previous and/or next buttons.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
     */
    public void readSettings(Object settings) {
    }

    /** Provides the wizard panel with the opportunity to update the
     * settings with its current customized state.
     * Rather than updating its settings with every change in the GUI, it should collect them,
     * and then only save them when requested to by this method.
     * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
     * rather, the (copy) passed in here should be mutated according to the collected changes.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing a settings of the wizard
     */
    public void storeSettings(Object settings) {
    }

    /** Test whether the panel is finished and it is safe to proceed to the next one.
     * If the panel is valid, the "Next" (or "Finish") button will be enabled.
     * @return <code>true</code> if the user has entered satisfactory information
     */
    public boolean isValid() {
        return true;
    }

    /** Add a listener to changes of the panel's validity.
     * @param l the listener to add
     * @see #isValid
     */
    public void addChangeListener(ChangeListener l) {
    }

    /** Remove a listener to changes of the panel's validity.
     * @param l the listener to remove
     */
    public void removeChangeListener(ChangeListener l) {
    }

    public boolean isDataLoader() {
        return newFileTypeCheckBox.isSelected();
    }

    public boolean isMenu() {
        return newMenuToolbarItemCheckBox.isSelected();
    }

}
