/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.applet;

import java.util.Enumeration;
import java.io.*;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;

import org.openide.modules.ModuleInstall;
import org.openide.execution.Executor;
import org.openide.execution.ExecutorTask;
import org.openide.execution.ProcessExecutor;
import org.openide.filesystems.FileSystem;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileLock;
import org.openide.util.NbBundle;
import org.openide.loaders.DataObject;
import org.openide.TopManager;
import org.openide.NotifyDescriptor;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileLock;
import org.openide.filesystems.FileAlreadyLockedException;
import org.openide.loaders.DataFolder;


/**
* Module installation class for applet support
*
* @author Petr Jiricka
*/
public class AppletModule extends ModuleInstall {

    static final long serialVersionUID =7084077369777137515L;
    /** Module installed for the first time. */
    public void installed() {
        // installSecurityPolicy ();
    }

    // -----------------------------------------------------------------------------
    // (Package) private methods

    static void installSecurityPolicy () {
        try {
            FileSystem defaultFs = TopManager.getDefault().getRepository().getDefaultFileSystem();
            FileObject fo = defaultFs.findResource (AppletDebuggerType.DEBUGGING_POLICY_RESOURCE);
            if (fo == null) {
                int sep = AppletDebuggerType.DEBUGGING_POLICY_RESOURCE.indexOf ('/');
                int sep2 = AppletDebuggerType.DEBUGGING_POLICY_RESOURCE.indexOf ('.');
                String folderName = AppletDebuggerType.DEBUGGING_POLICY_RESOURCE.substring (0, sep);
                String fileName = AppletDebuggerType.DEBUGGING_POLICY_RESOURCE.substring (sep+1, sep2);
                String fileExt = AppletDebuggerType.DEBUGGING_POLICY_RESOURCE.substring (sep2+1);
                
                FileObject folder = defaultFs.findResource (folderName);
                if (folder == null) {
                    folder = defaultFs.getRoot ().createFolder (folderName);
                }
                FileObject policy = folder.createData (fileName, fileExt);
                FileLock lock = policy.lock ();
                try {
                    PrintWriter out = new PrintWriter (policy.getOutputStream (lock));
                    try {
                        out.println ("grant {");  // NOI18N
                        out.println ("  permission java.security.AllPermission;"); // NOI18N
                        out.println ("};"); // NOI18N
                    }
                    finally {
                        out.close();
                    }
                } 
                finally {
                    lock.releaseLock ();
                }
            }
            
        } catch (java.io.IOException e) {
            org.openide.TopManager.getDefault ().notifyException (e);
        }
    }

}
