/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.modules.autoupdate;

import java.io.File;
import java.io.IOException;
import javax.swing.JFileChooser;
import java.util.*;

import org.openide.TopManager;
import org.openide.util.NbBundle;

/** Represents add Nbm object in the Option - Modules - New.
 *
 * @author Ales Kemr
 */
public class AutoModuleNewType extends org.netbeans.core.ModuleNode.ModuleNewType {
        
    /** Last directory used by the install new module file chooser. */
    private static File lastChosenDir = null;

    /** Resource bundle */
    static ResourceBundle bundle = NbBundle.getBundle(AutoModuleNewType.class);

    public String getName () {
        return bundle.getString( "CTL_NewModuleByNBM");
    }

    public void create () throws IOException {
        addFile ();
    }

    void addFile () throws IOException {
        final JFileChooser chooser = new JFileChooser ();
        if (lastChosenDir != null) chooser.setCurrentDirectory (lastChosenDir);
        chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        chooser.setApproveButtonText ( bundle.getString( "CTL_ModuleSelect"));
        chooser.setApproveButtonToolTipText (bundle.getString( "CTL_ModuleSelectToolTip"));
        chooser.setFileFilter (new javax.swing.filechooser.FileFilter () {
                                   public String getDescription () {
                                       return bundle.getString( "CTL_FileFilterDescription");
                                   }
                                   public boolean accept (File f) {
                                       return f.isDirectory () || f.getName ().endsWith (".nbm"); // NOI18N
                                   }
                               });

        int result = chooser.showOpenDialog (TopManager.getDefault ().getWindowManager ().getMainWindow ());
        lastChosenDir = chooser.getCurrentDirectory ();
        if (result == JFileChooser.APPROVE_OPTION) {
             // install the file                
            XMLUpdates updates = new XMLUpdates( new File[] { 
                   chooser.getSelectedFile()
                } );
            updates.checkDownloadedModules();
            Wizard wizard = new Wizard( updates, 1 );                        
            wizard.go();                                            
        }

    }

}
