/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.autoupdate;

import javax.swing.*;
import org.openide.DialogDescriptor;
import org.openide.TopManager;
import org.openide.util.NbBundle;
import org.openide.util.HelpCtx;

/**
 *
 * @author 
 */
public class ConnectingDialog extends javax.swing.JPanel {

    static final int CANCEL = 0;
    /** The resource bundle */
    private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/autoupdate/Bundle");

    static boolean canceled = false;
    
    /** Creates new form ConnectingDialog */
    public ConnectingDialog() {
        initComponents();
        setPreferredSize(new java.awt.Dimension(350,120));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        iconLabel = new javax.swing.JLabel();
        setLayout(new java.awt.BorderLayout());
        setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(18, 18, 18, 18)));
        
        iconLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/netbeans/modules/autoupdate/resources/gears.gif")));
        iconLabel.setText(bundle.getString("CTL_Connecting_Label"));
        iconLabel.setForeground(java.awt.Color.black);
        iconLabel.setFont(new java.awt.Font ("Dialog", 1, 11));
        iconLabel.setIconTextGap(16);
        
        add(iconLabel, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel iconLabel;
    // End of variables declaration//GEN-END:variables
    
    private static DialogDescriptor createDialog() {

        final JButton cancelButton = new JButton(bundle.getString( "CTL_Connecting_Cancel" ) );
        cancelButton.setToolTipText( bundle.getString( "CTL_Connecting_Cancel_ToolTip" ) );

        DialogDescriptor dd;
        dd = new DialogDescriptor(
                 new ConnectingDialog(),
                 bundle.getString( "CTL_Connecting_Title" ),
                 true,                                  // Modal
                 new Object [] {
                     cancelButton
                 },                                     // Option list
                 cancelButton,                          // Default
                 DialogDescriptor.DEFAULT_ALIGN,        // Align
                 null,                                  // Help
                 null);

        dd.setClosingOptions( null );

        return dd;
    }
    
    static void closeDialog(java.awt.Dialog dialog) {
        canceled = false;
        dialog.dispose();
    }
    
    static boolean isCanceled() {
        return canceled;
    }
    
    static java.awt.Dialog getDialog() {
        DialogDescriptor dd = createDialog();
        canceled = true;
        java.awt.Dialog dialog = TopManager.getDefault().createDialog( dd );
        return dialog;        
    }
}

