/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.autoupdate;

import java.awt.Dialog;
import java.util.ResourceBundle;
import java.text.MessageFormat;
import javax.swing.event.ChangeListener;

import org.openide.DialogDescriptor;
import org.openide.NotifyDescriptor;
import org.openide.TopManager;
import org.openide.util.NbBundle;
import org.openide.util.HelpCtx;
import org.openide.util.RequestProcessor;
import org.openide.WizardDescriptor;
import org.openide.util.HelpCtx;

public class DownloadProgressPanel extends javax.swing.JPanel implements ProgressDialog {

    private static final String EMPTY_STRING = ""; // NOI18N

    /** The task it's progress is showed in the dialog */
    private Runnable task;
    /** The dialog */
    private Dialog dialog;
    /** Title of the dialog */
    private String title;
    /** Current value of the jProgressBar2 */
    private int overallValue;
    /** Current value of the jProgressBar1 */
    private int partialValue;

    static final long serialVersionUID =1986287669107010921L;
    
    private Wizard.WizardPanel wizardPanel;
    
    /** Creates new form DownloadProgressPanel */
    public DownloadProgressPanel(Wizard.WizardPanel wizardPanel) {        
        this.wizardPanel = wizardPanel;
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(2));
        setName(bundle.getString("LBL_Download"));
        initComponents();
        
        jLabel2.setText( EMPTY_STRING );
        jLabel1.setText( EMPTY_STRING );
    }
    
    /** Overload getPreffered size to get a bit bigger dialog */
    public java.awt.Dimension getPreferredSize() {
        return new java.awt.Dimension( 350, super.getPreferredSize().height );
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jTextArea1 = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jProgressBar1 = new javax.swing.JProgressBar();
        jLabel2 = new javax.swing.JLabel();
        jProgressBar2 = new javax.swing.JProgressBar();
        bottomLabel = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jTextArea1.setLineWrap(true);
        jTextArea1.setFont(new java.awt.Font ("Dialog", 0, 11));
        jTextArea1.setBackground(new java.awt.Color (204, 204, 204));
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setEditable(false);
        jTextArea1.setText(bundle.getString("LBL_31"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(jTextArea1, gridBagConstraints1);
        
        
        jLabel1.setText("jLabel1");
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(12, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabel1, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipady = 10;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jProgressBar1, gridBagConstraints1);
        
        
        jLabel2.setText("jLabel2");
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(12, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabel2, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipady = 10;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jProgressBar2, gridBagConstraints1);
        
        
        bottomLabel.setText(bundle.getString("LBL_32"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.insets = new java.awt.Insets(12, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weighty = 1.0;
        add(bottomLabel, gridBagConstraints1);
        
        
        jButton1.setText(bundle.getString("BTN_Stop"));
        jButton1.setMnemonic(bundle.getString("BTN_Stop_Mnem").charAt(0));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.insets = new java.awt.Insets(12, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHEAST;
        add(jButton1, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        if (IncompleteDialog.showDialog() == IncompleteDialog.STOP)
            wizardPanel.end(false);
    }//GEN-LAST:event_jButton1ActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JProgressBar jProgressBar2;
    private javax.swing.JLabel bottomLabel;
    private javax.swing.JButton jButton1;
    // End of variables declaration//GEN-END:variables

    private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/autoupdate/Bundle");    

    void setEnableStop(boolean enable) {
        jButton1.setEnabled(enable);
    }
    /** Starts the task in RequestProcessor when the panel is added to dialog */
    public void addNotify() {
        super.addNotify();
        if ( task != null )
            RequestProcessor.postRequest( task );
    }
    
    // IMPLEMENTATION OF ProgressDialog -----------------------------------------

    /** Shows the dialog and runs the task. The method blocks until the task is
     * done or CancelButton is pressed
     *@param task The task which will be executed
     *@param listener for cancel button
     */
    public void showAndGo(Runnable task, java.awt.event.ActionListener cancelListener) {

        this.task = task;

        // Create progress dialog
        DialogDescriptor dd = new DialogDescriptor(
                                  this,
                                  title,
                                  true,                                                 // Modal
                                  new Object[] { NotifyDescriptor.CANCEL_OPTION },      // Option list
                                  NotifyDescriptor.CANCEL_OPTION,                       // Default
                                  DialogDescriptor.BOTTOM_ALIGN,                        // Align
                                  new HelpCtx ( DownloadProgressPanel.class ),            // Help
                                  cancelListener
                              );

        dialog = TopManager.getDefault().createDialog( dd );
        dialog.show();
    }


    /** Closes the dialog */
    public void close() {
        dialog.setVisible( false );
        dialog.dispose();
        dialog = null;
    }

    /** Indexed getter for property gaugeValue.
     *@param index Index of the property.
     *@return Value of the property at <CODE>index</CODE>.
     */
    public int getGaugeValue(int gauge) {
        if ( gauge == PARTIAL_GAUGE ) {
            return partialValue;
        }
        else if ( gauge == OVERALL_GAUGE ) {
            return overallValue;
        }
        else {
            return -1;
        }
    }

    /** Indexed setter for property gaugeValue.
     *@param index Index of the property.
     *@param gaugeValue New value of the property at <CODE>index</CODE>.
     */
    public void setGaugeValue(int gauge, final int gaugeValue) {
        if ( gauge == PARTIAL_GAUGE ) {
            partialValue = gaugeValue;
            javax.swing.SwingUtilities.invokeLater( new Runnable() {
                                                        public void run() {
                                                            jProgressBar1.setValue( gaugeValue );
                                                        }
                                                    } );
        }
        else if ( gauge == OVERALL_GAUGE ) {
            overallValue = gaugeValue;
            javax.swing.SwingUtilities.invokeLater( new Runnable() {
                                                        public void run() {
                                                            jProgressBar2.setValue( gaugeValue );
                                                        }
                                                    } );
        }
    }

    /** Indexed setter for property gaugeBounds.
     *@param index Index of the property.
     *@param gaugeBounds New value of the property at <CODE>index</CODE>.
     */
    public void setGaugeBounds(int gauge, final int gaugeMin, final int gaugeMax) {
        if ( gauge == PARTIAL_GAUGE ) {
            javax.swing.SwingUtilities.invokeLater( new Runnable() {
                                                        public void run() {
                                                            jProgressBar1.setMinimum( gaugeMin );
                                                            jProgressBar1.setMaximum( gaugeMax );
                                                        }
                                                    } );
        }
        else if ( gauge == OVERALL_GAUGE ) {
            javax.swing.SwingUtilities.invokeLater( new Runnable() {
                                                        public void run() {
                                                            jProgressBar2.setMinimum( gaugeMin );
                                                            jProgressBar2.setMaximum( gaugeMax );
                                                        }
                                                    } );
        }
    }

    /** Indexed getter for property labelText.
     *@param index Index of the property.
     *@return Value of the property at <CODE>index</CODE>.
     */
    public String getLabelText(int label) {
        if ( label == PARTIAL_LABEL ) {
            return jLabel1.getText();
        }
        else if ( label == OVERALL_LABEL ) {
            return jLabel2.getText();
        }
        else if ( label == EXTRA_LABEL ) {
            return bottomLabel.getText();
        }

        else {
            return null;
        }
    }

    /** Indexed setter for property labelText.
     *@param index Index of the property.
     *@param labelText New value of the property at <CODE>index</CODE>.
     */
    public void setLabelText(int label, final String labelText) {
        if ( label == PARTIAL_LABEL ) {
            javax.swing.SwingUtilities.invokeLater( new Runnable() {
                                                        public void run() {
                                                            jLabel1.setText( labelText );
                                                        }
                                                    } );
        }
        else if ( label == OVERALL_LABEL ) {
            javax.swing.SwingUtilities.invokeLater( new Runnable() {
                                                        public void run() {
                                                            jLabel2.setText( labelText );
                                                        }
                                                    } );
        }
        else if ( label == EXTRA_LABEL ) {
            javax.swing.SwingUtilities.invokeLater( new Runnable() {
                                                        public void run() {
                                                            bottomLabel.setText( labelText );
                                                        }
                                                    } );
        }
    }

    /** Getter for property title.
     *@return Value of property title.
     */
    public String getTitle() {
        return title;
    }

    /** Setter for property title.
     *@param title New value of property title.
     */
    public void setTitle(String title) {
        this.title = title;
    }
    
}
