/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.autoupdate;

import org.openide.WizardDescriptor;
import org.openide.explorer.propertysheet.PropertyPanel;

public class FirstPanel extends javax.swing.JPanel {

    Wizard.Validator validator;

    Settings settings = null;
    
    static final long serialVersionUID =-3335860872113235775L;
    
    private PropertyPanel lPanel;
    
    /** Creates new form FirstPanel */
    public FirstPanel( Wizard.Validator validator ) {
        putClientProperty("WizardPanel_autoWizardStyle", new Boolean(true));
        putClientProperty("WizardPanel_contentDisplayed", new Boolean(true));
        putClientProperty("WizardPanel_contentNumbered", new Boolean(true));
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(0));
        putClientProperty("WizardPanel_contentData", new String[] {
            bundle.getString("WIZ_First"),            
            bundle.getString("WIZ_Select"),
            bundle.getString("WIZ_Download"),
            bundle.getString("WIZ_View")
        });
        setName(bundle.getString("LAB_First"));
        initComponents ();
        setPreferredSize(new java.awt.Dimension(500, 380));        
        
        settings = Settings.getShared();

        this.validator = validator;
        
        lPanel = new PropertyPanel(settings, "autoupdateType", PropertyPanel.PREF_INPUT_STATE );
        
        java.awt.GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(12, 36, 12, 0);        
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;                
        
        add(lPanel, gridBagConstraints1);                                        
    }           
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jRadioButton1 = new javax.swing.JRadioButton();
        nextLabel = new javax.swing.JLabel();
        jRadioButton2 = new javax.swing.JRadioButton();
        rb2Label1 = new javax.swing.JLabel();
        proxyButton = new javax.swing.JButton();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        jRadioButton1.setMnemonic(bundle.getString("CTL_Radio1_Mnem").charAt(0));
        jRadioButton1.setSelected(true);
        jRadioButton1.setText(bundle.getString("CTL_Radio1"));
        
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.RELATIVE;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(jRadioButton1, gridBagConstraints1);
        
        nextLabel.setText(bundle.getString("LAB_Init"));
        nextLabel.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 8;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.insets = new java.awt.Insets(12, 36, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(nextLabel, gridBagConstraints1);
        
        jRadioButton2.setMnemonic(bundle.getString("CTL_Radio2_Mnem").charAt(0));
        jRadioButton2.setText(bundle.getString("CTL_Radio2_Top"));
        buttonGroup=new javax.swing.ButtonGroup(); buttonGroup.add(jRadioButton1); buttonGroup.add(jRadioButton2);
        
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 9;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.insets = new java.awt.Insets(48, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(jRadioButton2, gridBagConstraints1);
        
        rb2Label1.setText(bundle.getString("CTL_Radio2_Bottom"));
        rb2Label1.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 10;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.insets = new java.awt.Insets(0, 17, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weighty = 1.0;
        add(rb2Label1, gridBagConstraints1);
        
        proxyButton.setMnemonic(bundle.getString("BNT_Proxy_Mnem").charAt(0));
        proxyButton.setText(bundle.getString("BNT_Proxy"));
        
        proxyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                proxyButtonActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 7;
        gridBagConstraints1.insets = new java.awt.Insets(12, 36, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(proxyButton, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void proxyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_proxyButtonActionPerformed
        ProxyDialog.showDialog();
    }//GEN-LAST:event_proxyButtonActionPerformed
    
    private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
         radioChange();
    }//GEN-LAST:event_jRadioButton2ActionPerformed
    
  private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
         radioChange();
  }//GEN-LAST:event_jRadioButton1ActionPerformed
  
  
  private void radioChange(){  
      if(jRadioButton1.isSelected()){          
          proxyButton.setEnabled(true);
          nextLabel.setEnabled(true);
          lPanel.setEnabled(true);
      }
      else{
          proxyButton.setEnabled(false);
          nextLabel.setEnabled(false);
          lPanel.setEnabled(false);
      }
      validator.setValid( true );
  }
    
    /** Returns the type of wizard the user selected */
    int getWizardType( ) {
        if ( jRadioButton1.isSelected() )
            return 0;
       
        else
            return 1;
    }        
  
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JLabel nextLabel;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JLabel rb2Label1;
    private javax.swing.JButton proxyButton;
    // End of variables declaration//GEN-END:variables
private javax.swing.ButtonGroup buttonGroup;

private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/autoupdate/Bundle");





}
