/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.autoupdate;

import java.util.*;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.event.ChangeListener;

import org.openide.util.NbBundle;
import org.openide.TopManager;
import org.openide.NotifyDescriptor;
import org.openide.WizardDescriptor;
import org.openide.util.HelpCtx;

public class ResultsPanel extends javax.swing.JPanel {

    private DefaultListModel jList1Model;
    
    private Wizard.Validator validator;

    private Updates updates;

    private int modulesOK;

    private java.awt.Dimension preferredDimension = null;

    static final long serialVersionUID =-6053101371836354161L;
    /** Creates new form ResultsPanel */
    public ResultsPanel( Wizard.Validator validator ) {
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(3));
        setName(bundle.getString("LBL_View"));
        initComponents();
        
        this.updates = updates;
        this.validator = validator;

        jList1Model = new DefaultListModel();

        jList1.setSelectionMode( javax.swing.ListSelectionModel.SINGLE_SELECTION );

        jList1.setModel( jList1Model );
        
        jList1.setCellRenderer( new ResultListCellRenderer() );

        jList1.getSelectionModel().addListSelectionListener(
            new javax.swing.event.ListSelectionListener() {
                public void valueChanged( javax.swing.event.ListSelectionEvent evt ) {
                    selectionChange();
                }
            }
        );

        selectionChange();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jTextArea1 = new javax.swing.JTextArea();
        includeLabel = new javax.swing.JLabel();
        mnameLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        certificateButton = new javax.swing.JButton();
        jTextArea2 = new javax.swing.JTextArea();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setLineWrap(true);
        jTextArea1.setFont(new java.awt.Font ("Dialog", 0, 11));
        jTextArea1.setText(bundle.getString("LBL_41"));
        jTextArea1.setBackground(new java.awt.Color (206, 206, 206));
        jTextArea1.setDisabledTextColor(java.awt.Color.black);
        jTextArea1.setEnabled(false);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 12, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        add(jTextArea1, gridBagConstraints1);
        
        includeLabel.setText(bundle.getString("LBL_42"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(includeLabel, gridBagConstraints1);
        
        mnameLabel.setText(bundle.getString("LBL_43"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(mnameLabel, gridBagConstraints1);
        
        
        jList1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jList1MouseClicked(evt);
            }
        }
        );
        
        jScrollPane1.setViewportView(jList1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jScrollPane1, gridBagConstraints1);
        
        certificateButton.setMnemonic(bundle.getString("BTN_View_Mnem").charAt(0));
        certificateButton.setText(bundle.getString("BTN_View"));
        
        certificateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                certificateButtonActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(12, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        add(certificateButton, gridBagConstraints1);
        
        jTextArea2.setWrapStyleWord(true);
        jTextArea2.setLineWrap(true);
        jTextArea2.setFont(new java.awt.Font ("Dialog", 0, 11));
        jTextArea2.setText(bundle.getString("LBL_44"));
        jTextArea2.setBackground(new java.awt.Color (206, 206, 206));
        jTextArea2.setDisabledTextColor(java.awt.Color.black);
        jTextArea2.setEnabled(false);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(jTextArea2, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void jList1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jList1MouseClicked
        int i=jList1.getSelectedIndex();
        if ( i == -1 ) // no row selected
            return;
        if (((ResultListCellRenderer)jList1.getCellRenderer().getListCellRendererComponent(jList1,jList1Model.get(i),i,true,true)).isCheckBoxSelected(evt)) {
            if ( getListSelection().getSecurity() == SignVerifier.NOT_SIGNED ) {
                if ( getListSelection().isInstallApproved() ) {
                    getListSelection().setInstallApproved( false );
                    checkValidity();
                } 
                else {    
                    NotifyDescriptor.Confirmation nd = new NotifyDescriptor.Confirmation(
                                                   bundle.getString( "MSG_NotSignedConfirmation" ),
                                                   bundle.getString( "CTL_NotSignedConfirmation" ),
                                                   NotifyDescriptor.YES_NO_OPTION );
                    if ( TopManager.getDefault().notify( nd ).equals( NotifyDescriptor.YES_OPTION ) ) {
                        getListSelection().setInstallApproved( true );
                        checkValidity();
                    }                                    
                }
            }
            else if ( getListSelection().getSecurity() == SignVerifier.SIGNED ||
                      getListSelection().getSecurity() == SignVerifier.TRUSTED ||
                      getListSelection().getSecurity() == SignVerifier.CORRUPTED ) {
                doCertAction(CertificateDialog.showDialog( 
                                      getListSelection().getCerts(), 
                                      getListSelection().getSecurity()
                                )
                );
            }
            else {
                NotifyDescriptor.Message nd = 
                      new NotifyDescriptor.Message(bundle.getString( "MSG_BadDownload" ) );
                TopManager.getDefault().notify( nd );
            }
            jList1.invalidate();
            jList1.repaint();
            selectionChange();
        }
    }//GEN-LAST:event_jList1MouseClicked

    private void certificateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_certificateButtonActionPerformed
        int accValue = CertificateDialog.showDialog( getListSelection().getCerts(), 
                                      getListSelection().getSecurity() );        
        doCertAction(accValue);        
        jList1.invalidate();
        jList1.repaint();
        selectionChange();
    }//GEN-LAST:event_certificateButtonActionPerformed
    
    void doCertAction(int accValue) {
        switch ( accValue ) {
            /*
        case CertificateDialog.FOR_MODULE:
            getListSelection().setInstallApproved( true );
            checkValidity();
            break;
             */
        case CertificateDialog.ACCEPT:
            setApproved4All( getListSelection().getCerts(), true, -1 );
            checkValidity();
            break;
        case CertificateDialog.REJECT:
            setApproved4All( getListSelection().getCerts(), false, -1 );
            checkValidity();
            break;
        case CertificateDialog.NOT_ALWAYS_ACCEPT:
            setApproved4All( getListSelection().getCerts(), false, SignVerifier.SIGNED );
            checkValidity();
            try {
                SignVerifier.removeCertificates( getListSelection().getCerts() );
            }
            catch ( java.security.cert.CertificateException e ) {
                if ( Boolean.getBoolean ("netbeans.debug.exceptions") ) // NOI18N
                    System.out.println("Can't add certificate to keystore " + e ); // NOI18N
            }
            catch ( java.security.KeyStoreException e ) {
                if ( Boolean.getBoolean ("netbeans.debug.exceptions") ) // NOI18N
                    System.out.println("Can't add certificate to keystore " + e ); // NOI18N
            }
            catch ( java.io.IOException e ) {
                if ( Boolean.getBoolean ("netbeans.debug.exceptions") ) // NOI18N
                    System.out.println("Can't add certificate to keystore " + e ); // NOI18N
            }
            catch ( java.security.NoSuchAlgorithmException e ) {
                if ( Boolean.getBoolean ("netbeans.debug.exceptions") ) // NOI18N
                    System.out.println("Can't add certificate to keystore " + e ); // NOI18N
            }
            break;
        case CertificateDialog.ALWAYS_ACCEPT:
            setApproved4All( getListSelection().getCerts(), true, SignVerifier.TRUSTED );
            checkValidity();
            try {
                SignVerifier.addCertificates( getListSelection().getCerts() );
            }
            catch ( java.security.cert.CertificateException e ) {
                if ( Boolean.getBoolean ("netbeans.debug.exceptions") ) // NOI18N
                    System.out.println("Can't add certificate to keystore " + e ); // NOI18N
            }
            catch ( java.security.KeyStoreException e ) {
                if ( Boolean.getBoolean ("netbeans.debug.exceptions") ) // NOI18N
                    System.out.println("Can't add certificate to keystore " + e ); // NOI18N
            }
            catch ( java.io.IOException e ) {
                if ( Boolean.getBoolean ("netbeans.debug.exceptions") ) // NOI18N
                    System.out.println("Can't add certificate to keystore " + e ); // NOI18N
            }
            catch ( java.security.NoSuchAlgorithmException e ) {
                if ( Boolean.getBoolean ("netbeans.debug.exceptions") ) // NOI18N
                    System.out.println("Can't add certificate to keystore " + e ); // NOI18N
            }
            break;
        default:
            return;
        }        
    }
    
    /** Utility function approves installing of all modules signed
    * by given Collection of certs 
    */
    private void setApproved4All( Collection certs, boolean approved, int security ) {

        if ( certs == null ) {
            return;
        }

        Enumeration modules = jList1Model.elements();

        while( modules.hasMoreElements() ) {
            ModuleUpdate mu = (ModuleUpdate)modules.nextElement();

            if ( mu.getCerts() != null && certs.containsAll( mu.getCerts() ) ) {
                mu.setInstallApproved( approved );

                if ( security == SignVerifier.TRUSTED || security == SignVerifier.SIGNED ) {
                    mu.setSecurity( security );
                }
            }

        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JLabel includeLabel;
    private javax.swing.JLabel mnameLabel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JList jList1;
    private javax.swing.JButton certificateButton;
    private javax.swing.JTextArea jTextArea2;
    // End of variables declaration//GEN-END:variables

    private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/autoupdate/Bundle");    

    int generateResults( Updates updates ) {

        this.updates = updates;

        modulesOK = 0;

        jList1Model.clear();

        Collection modules = updates.getModules();
        Iterator it = modules.iterator();
        while( it.hasNext() ) {
            ModuleUpdate mu = (ModuleUpdate)it.next();

            if ( mu.isSelected() ) {
                jList1Model.addElement( mu );
                if ( mu.isDownloadOK() ) {
                    modulesOK ++;
                    if (jList1.getSelectedIndex() == -1)
                        if (!mu.isInstallApproved())
                            jList1.setSelectedIndex(jList1Model.getSize()-1);
                }
            }

        }
        checkValidity();
        selectionChange();
        return modulesOK;
    }

    /** Called when the selection in selectedList or explorerView changes */
    private void selectionChange() {
        ModuleUpdate mu = getListSelection();        

        // Enable/Disable view button
        if ( mu != null &&
                ( mu.getSecurity() == SignVerifier.SIGNED ||
                  mu.getSecurity() == SignVerifier.TRUSTED )
           ) {
            certificateButton.setEnabled( true );
        }
        else {
            certificateButton.setEnabled( false );
        }

    }

    /** Gets the ModuleUpdate selected in the list */
    private ModuleUpdate getListSelection() {

        int index = jList1.getMinSelectionIndex();

        if ( index < 0 )
            return null;

        return (ModuleUpdate) jList1Model.get( index );
    }

    /** Checks wther there exists at least one update with approved install
    * if so enables finish button
    */
    private void checkValidity() {

        boolean valid = false;
        int okCount = 0;

        Collection modules = updates.getModules();
        Iterator it = modules.iterator();
        while( it.hasNext() ) {
            ModuleUpdate mu = (ModuleUpdate)it.next();

            if ( mu.isInstallApproved() ) {
                valid = true;
                okCount++;
            }

        }

        validator.setValid( valid );

    }
}
