/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.autoupdate;

import java.awt.Image;
import java.beans.*;
import java.util.ResourceBundle;

import org.openide.util.NbBundle;
import org.openide.explorer.propertysheet.editors.FileOnlyEditor;
import org.openide.explorer.propertysheet.editors.StringArrayCustomEditor;

/** BeanInfo for Autoupdate settings
*
* @author Ales Kemr
*/
public class XMLAutoupdateTypeBeanInfo extends SimpleBeanInfo {
    /** Icons for compiler settings objects. */
    static Image icon;
    static Image icon32;

    static final ResourceBundle bundle = NbBundle.getBundle(XMLAutoupdateTypeBeanInfo.class);

    /** Array of property descriptors. */
    private static PropertyDescriptor[] desc;
    
    private static BeanDescriptor bdesc;
    
    // initialization of the array of descriptors
    static {
        bdesc = new BeanDescriptor (XMLAutoupdateType.class);
        bdesc.setDisplayName (bundle.getString("CTL_XMLAutoupdateType_Name"));
        bdesc.setValue ("version", "1.1"); // NOI18N
        try {
            desc = new PropertyDescriptor[] {
                       new PropertyDescriptor("URL", XMLAutoupdateType.class)
                   };

            desc[0].setDisplayName(bundle.getString("PROP_Url"));
            desc[0].setShortDescription(bundle.getString("HINT_Url"));            
            
        } catch (IntrospectionException ex) {
            //throw new InternalError ();
            ex.printStackTrace ();
        }
    }

    /**
    * loads icons
    */
    public XMLAutoupdateTypeBeanInfo() {
    }

    /** Returns the ExternalCompilerSettings' icon */
    public Image getIcon(int type) {
        if ((type == java.beans.BeanInfo.ICON_COLOR_16x16) || (type == java.beans.BeanInfo.ICON_MONO_16x16)) {
            if (icon == null)
                icon = loadImage("/org/netbeans/modules/autoupdate/resources/updateAction.gif"); // NOI18N
            return icon;
        } else {
            if (icon32 == null)
                icon32 = loadImage ("/org/netbeans/modules/autoupdate/resources/updateAction32.gif"); // NOI18N
            return icon32;
        }
    }
    
    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (org.openide.ServiceType.class) };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions")) // NOI18N
                ie.printStackTrace ();
            return null;
        }
    }

    public BeanDescriptor getBeanDescriptor () {
        return bdesc;
    }

    /** Descriptor of valid properties
    * @return array of properties
    */
    public PropertyDescriptor[] getPropertyDescriptors () {                
        return desc;
    }
}
