@echo off

rem MAINTAINER: Gili Tzabari (L8R@email.com)
rem PLATFORM: OS/2 or eCS with JDK 1.3

rem ******** Modify IDE_HOME, USER_DIR and JAVA_PATH to configure for your specific system

SET IDE_HOME=d:\netbeans
SET USER_DIR=d:\home\netbeans
SET JAVA_PATH=d:\java13

rem ************************************************************************************************* 
rem ** NOTE: IDE_HOME and USER_DIR should point to different directories so the IDE can be upgraded *
rem ** without losing user files                                                                    *
rem *************************************************************************************************

rem *** END OF CONFIGURATION BLOCK ****************************************

if not exist %IDE_HOME%\lib\core.jar goto NO_IDE
if %JAVA_PATH%. == . goto NO_JAVA

:TOP
SET CLASS_PATH=

for %%f in ( %USER_DIR%\lib\patches\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\patches\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\patches\locale\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\patches\locale\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\locale\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\locale\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\ext\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\ext\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\ext\locale\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %USER_DIR%\lib\ext\locale\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\patches\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\patches\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\patches\locale\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\patches\locale\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\locale\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\locale\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\ext\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\ext\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\ext\locale\*.jar ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f
for %%f in ( %IDE_HOME%\lib\ext\locale\*.zip ) do call %IDE_HOME%\bin\addpathenv CLASS_PATH %%f

SET CLASS_PATH=%CLASS_PATH%;%JAVA_PATH%\lib\dt.jar;%JAVA_PATH%\lib\tools.jar;%JAVA_PATH%\JRE\LIB\RT.JAR
SET JAVA_HIGH_MEMORY=1

%JAVA_PATH%\jre\bin\java -Djava.security.policy=%IDE_HOME%\bin\ide.policy -Dnetbeans.home=%IDE_HOME% -Dnetbeans.user=%USER_DIR% -Xmx96m -classpath %CLASS_PATH% org.netbeans.Main

if errorlevel 67 goto CLEANUP
if errorlevel 66 goto APPLY_PATCH
goto CLEANUP

:APPLY_PATCH
%JAVA_PATH%\jre\bin\java -Djava.security.policy=%IDE_HOME%\bin\ide.policy -Dnetbeans.home=%IDE_HOME% -Dnetbeans.user=%USER_DIR% -Xmx96m -classpath %CLASS_PATH%;%IDE_HOME%\lib\updater.jar org.netbeans.updater.UpdaterFrame
goto TOP

:NO_IDE
echo Error: _IDE_HOME variable does not point to your
echo IDE installation. Please edit your startup script. 
pause
goto END

:NO_JAVA
echo Error: JAVA_PATH variable does not point to a Java 2
echo installation. Please edit your startup script.  
pause
goto END

:CLEANUP
SET IDE_HOME=
SET USER_DIR=
SET JAVA_PATH=
SET CLASS_PATH=

:END
