/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.beaninfo;

import java.awt.Image;
import java.beans.*;

import org.openide.*;
import org.openide.execution.ScriptType;

/** BeanInfo for ScriptType.
 * @author David Strupl
 */
public class ScriptTypeBeanInfo extends SimpleBeanInfo {
    private static BeanDescriptor beanDescriptor;
    private static Image icon;
    private static Image icon32;
    
    public BeanDescriptor getBeanDescriptor () {
        if (beanDescriptor == null) {
            beanDescriptor = new BeanDescriptor(ScriptType.class);
        } 

        return beanDescriptor;
    }

    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (org.openide.ServiceType.class) };
        } catch (IntrospectionException ie) {
            TopManager.getDefault().getErrorManager().notify(ErrorManager.INFORMATIONAL, ie);
            return null;
        }
    }
    
    public Image getIcon(int type) {
        if (icon == null) {
            icon = loadImage("/org/netbeans/core/resources/scriptTypes.gif"); // NOI18N
            icon32 = loadImage("/org/netbeans/core/resources/scriptTypes32.gif"); // NOI18N
        }

        if ((type == java.beans.BeanInfo.ICON_COLOR_16x16) || (type == java.beans.BeanInfo.ICON_MONO_16x16))
            return icon;
        else
            return icon32;
    }
}
