/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.beaninfo.swing;

import java.awt.Image;
import java.beans.*;
import java.util.ResourceBundle;

public class GridLayoutBeanInfo extends SimpleBeanInfo {

    private static PropertyDescriptor propertyDescriptors[] = null;
    private static Image icon = null;
    private static Image icon32 = null;
    private static String path = "org/netbeans/beaninfo/swing/";

    private static void createPropertyDescriptors() {
        try {
            ResourceBundle bundle = ResourceBundle.getBundle(path + "Bundle");

            PropertyDescriptor pd1 = new PropertyDescriptor("hgap",
                                           java.awt.GridLayout.class,
                                           "getHgap", "setHgap");
            pd1.setDisplayName(bundle.getString("PROP_Hgap"));
            pd1.setShortDescription(bundle.getString("HINT_Hgap"));

            PropertyDescriptor pd2 = new PropertyDescriptor("vgap",
                                           java.awt.GridLayout.class,
                                           "getVgap", "setVgap");
            pd2.setDisplayName(bundle.getString("PROP_Vgap"));
            pd2.setShortDescription(bundle.getString("HINT_Vgap"));

            PropertyDescriptor pd3 = new PropertyDescriptor("rows",
                                           java.awt.GridLayout.class,
                                           "getRows", "setRows");
            pd3.setDisplayName(bundle.getString("PROP_Rows"));
            pd3.setShortDescription(bundle.getString("HINT_Rows"));

            PropertyDescriptor pd4 = new PropertyDescriptor("columns",
                                           java.awt.GridLayout.class,
                                           "getColumns", "setColumns");
            pd4.setDisplayName(bundle.getString("PROP_Columns"));
            pd4.setShortDescription(bundle.getString("HINT_Columns"));

            propertyDescriptors = new PropertyDescriptor[4];
            propertyDescriptors[0] = pd1;
            propertyDescriptors[1] = pd2;
            propertyDescriptors[2] = pd3;
            propertyDescriptors[3] = pd4;
        }
        catch(IntrospectionException ex) {
            ex.printStackTrace();
        }
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        if (propertyDescriptors == null)
            createPropertyDescriptors();
        return propertyDescriptors;
    }

    public Image getIcon(int type) {
        if ( icon == null) {
            icon = loadImage("/" + path + "gridLayout.gif");
            icon32 = loadImage("/" + path + "gridLayout32.gif");
        }
        return type == ICON_COLOR_32x32 || type == ICON_MONO_32x32 ?
               icon32 : icon;
    }
}
