package org.netbeans.core.actions;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;

/** 
 * Runs the setup wizard with all panels.
 * @author  dstrupl
 */
public class SetupWizardAction extends CallableSystemAction {

    static final long serialVersionUID = -4981993389589427122L;
    
    public void performAction () {
        org.netbeans.core.ui.SetupWizard.showSetupWizard(true);
    }

    public String getName () {
        return NbBundle.getMessage (SetupWizardAction.class, "LBL_SetupWizard");
    }

    protected String iconResource () {
        return "/org/netbeans/core/resources/setupWizard.gif";
        // [PENDING] icon ???
    }

    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // [PENDING] return new HelpCtx (SetupWizardAction.class);
    }

    /**
     * Adding hint.
     */
    protected void initialize () {
	super.initialize ();
        putProperty (SetupWizardAction.SHORT_DESCRIPTION, NbBundle.getMessage (SetupWizardAction.class, "HINT_SetupWizard"));
    }
}
