/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.core.actions;

import org.netbeans.core.Main;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;

/** TipOfTheDay action.
*
* @author   Ian Formanek (checked - [PENDING HelpCtx])
*/
public class WelcomeAction extends CallableSystemAction {

    /** The help context of this action */
    private static HelpCtx help;

    /** Human presentable name of the action. This should be
    * presented as an item in a menu.
    * @return the name of the action
    */
    public String getName() {
        try
          {
            return NbBundle.getBundle(WelcomeAction.class).getString("WelcomePanel");
          }
        catch(Exception exc)
          {
          }
        return NbBundle.getBundle(WelcomeAction.class).getString("TipOfTheDay");
    }

    /** Help context where to find more about the action.
    * @return the help context for this action
    */
    public HelpCtx getHelpCtx() {
        return new HelpCtx (WelcomeAction.class);
    }

    /** Icon of this action.
    * @return name of the action icon
    */
    protected String iconResource() {
        return "/org/netbeans/core/resources/actions/tipOfTheDay.gif"; // NOI18N
    }

    public void performAction() {
        org.netbeans.core.ui.WelcomePanel.showGettingStarted();
    }
}
