/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.core.perftool;

import java.text.Format;


/** Notifies about a performance event.
 *
 */
public class PerformanceEvent extends java.util.EventObject {
    
    /** Formatter for prints */
    private Format formatter;
    /** Args */
    private Object args;
    
    /** Constructs new Event object */
    public PerformanceEvent(Object source) {
        super(source);
    }
    
    /** Constructs new Event object */
    public PerformanceEvent(Object source, Format formatter, Object args) {
        super(source);
        this.formatter = formatter;
        this.args = args;
    }
    
    /** Sets formatter */
    public final void setFormatter(Format newFormat) {
        formatter = newFormat;
    }
    
    /** Gets formatter */
    public final Format getFormatter() {
        return formatter;
    }
    
    /** Sets formatter */
    public final void setArguments(Object newArguments) {
        args = newArguments;
    }
    
    /** Gets formatter */
    public final Object getArguments() {
        return args;
    }
    
    /** Overrides */
    public String toString() {
        if ((formatter != null) && (args != null)) {
            return formatter.format(args);
        } else {
            return super.toString();
        }
    }
}