/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.core.perftool;


/** The class collects performance info about different
 * actions in the IDE.
 *
 */
public interface PerformanceMeter {
    
    public static final String NAMING_NAME = "openide.performance.meter"; // NOI18N

    /** Caller notifies PerformanceMeter
     * about a PerformanceEvent
     */
    public void notify(PerformanceEvent ev);

    /** Convenience method  - notifies that an operation took millis milliseconds */
    public void notifyTime(String msg, long millis);
    /** Convenience method  - notifies that an operation took "bytes" bytes of heap */
    public void notifyMemory(String msg, long bytes);
}