/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.core.perftool;

import org.openide.TopManager;
import org.openide.ErrorManager;

/** Creates PerformanceMeter
 *
 */
public final class PerformanceMeterFactory {
    
    /** ref to an instance */
    private static PerformanceMeter instance;

    /** Getter for a PerformanceMeter */
    public static PerformanceMeter getPerformanceMeter() {
        if (instance == null) {
            String opt = System.getProperty(PerformanceMeter.NAMING_NAME);
            if (opt != null && !opt.equals(Boolean.TRUE.toString())) {
                try {
                    Class clz = Class.forName(opt, false, TopManager.getDefault().systemClassLoader());
                } catch (ClassNotFoundException e) {
                    TopManager.getDefault().getErrorManager().notify(ErrorManager.WARNING, e);
                    instance = PerformanceMeterImpl.getInstance();
                }
            } else {
                instance = PerformanceMeterImpl.getInstance();
            }
        }
        
        return instance;
    }
}