/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.core.ui;

import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.NodeAction;

/** Define a proxy server.
 * New version - testing new look.
 *
 * @author Rostislav Levy
 */

public class ProxySettingsAction extends NodeAction {

    /** Creates new ProxySettingsAction */
    public ProxySettingsAction() {
    }

    protected boolean enable (Node[] activatedNodes) {
        return true;
    }

    protected void performAction (Node[] activatedNodes) {
        ProxySettingsDialog.showDialog();
    }

    /* Human presentable name of the action. This should be
    * presented as an item in a menu.
    * @return the name of the action
    */
    public String getName() {
        return NbBundle.getBundle(ProxySettingsAction.class).getString("ProxySettings");
    }

    /* Help context where to find more about the action.
    * @return the help context for this action
    */
    public HelpCtx getHelpCtx() {
        return new HelpCtx (ProxySettingsAction.class);
    }

    /* Resource name for the icon.
    * @return resource name
    */
    protected String iconResource () {
        return "/org/netbeans/core/resources/Proxysettings.gif"; // NOI18N
    }
}
