package org.netbeans.core.ui;

/**
 *
 * @author  Rostislav Levy
 * @version 
 */

import java.awt.Dialog;

import org.openide.DialogDescriptor;
import org.openide.TopManager;
import org.openide.util.HelpCtx;

import org.netbeans.core.UpdateSupport;

public class ProxySettingsDialog extends javax.swing.JPanel {

    /** Creates new form ProxySettingsDialog */
    public ProxySettingsDialog() {
        initComponents ();
        jCheckBoxProxyUse.setSelected(UpdateSupport.isUseProxy());
        jTextFieldProxyHost.setText(UpdateSupport.getProxyHost());
        jTextFieldProxyPort.setText(UpdateSupport.getProxyPort());
        jCheckBoxProxyUse.setMnemonic(bundle.getString("LAB_ProxyUse_Mnemonic").charAt(0));
        jLabelProxyHost.setDisplayedMnemonic(bundle.getString("LAB_ProxyHost_Mnemonic").charAt(0));
        jLabelProxyPort.setDisplayedMnemonic(bundle.getString("LAB_ProxyPort_Mnemonic").charAt(0));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jCheckBoxProxyUse = new javax.swing.JCheckBox();
        jLabelProxyHost = new javax.swing.JLabel();
        jTextFieldProxyHost = new javax.swing.JTextField();
        jLabelProxyPort = new javax.swing.JLabel();
        jTextFieldProxyPort = new javax.swing.JTextField();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jCheckBoxProxyUse.setText(bundle.getString("LAB_ProxyUse"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 11, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jCheckBoxProxyUse, gridBagConstraints1);
        
        
        jLabelProxyHost.setLabelFor(jTextFieldProxyHost);
        jLabelProxyHost.setText(bundle.getString("LAB_ProxyHost"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 11, 12);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabelProxyHost, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 11, 11);
        gridBagConstraints1.weightx = 1.0;
        add(jTextFieldProxyHost, gridBagConstraints1);
        
        
        jLabelProxyPort.setLabelFor(jTextFieldProxyPort);
        jLabelProxyPort.setText(bundle.getString("LAB_ProxyPort"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 17, 12);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabelProxyPort, gridBagConstraints1);
        
        
        jTextFieldProxyPort.setPreferredSize(new java.awt.Dimension(40, 20));
        jTextFieldProxyPort.setMaximumSize(new java.awt.Dimension(40, 2147483647));
        jTextFieldProxyPort.setMinimumSize(new java.awt.Dimension(40, 20));
        jTextFieldProxyPort.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextFieldProxyPortActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 17, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jTextFieldProxyPort, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void jTextFieldProxyPortActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextFieldProxyPortActionPerformed
        // Add your handling code here:
    }//GEN-LAST:event_jTextFieldProxyPortActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox jCheckBoxProxyUse;
    private javax.swing.JLabel jLabelProxyHost;
    private javax.swing.JTextField jTextFieldProxyHost;
    private javax.swing.JLabel jLabelProxyPort;
    private javax.swing.JTextField jTextFieldProxyPort;
    // End of variables declaration//GEN-END:variables

    private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/core/ui/Bundle");    

    boolean isProxyUse () {
        return(jCheckBoxProxyUse.isSelected());
    }

    String getProxyHost () {
        return(jTextFieldProxyHost.getText());
    }

    String getProxyPort () {
        return(jTextFieldProxyPort.getText());
    }

    public static void showDialog () {
        ProxySettingsDialog proxysettingsdialog;
        DialogDescriptor dialogdescriptor=new DialogDescriptor(proxysettingsdialog=new ProxySettingsDialog(),
                                                               bundle.getString("PROP_ProxySettings"),
                                                               true,                                        // Modal
                                                               DialogDescriptor.OK_CANCEL_OPTION,           // Option list
                                                               DialogDescriptor.OK_OPTION,                  // Default
                                                               DialogDescriptor.BOTTOM_ALIGN,               // Align
                                                               new HelpCtx(ProxySettingsDialog.class),      // Help
                                                               null);
        Dialog dialog=TopManager.getDefault().createDialog(dialogdescriptor);
        dialog.show();
        if (dialogdescriptor.getValue()==DialogDescriptor.OK_OPTION)
            UpdateSupport.setProxyConfiguration(proxysettingsdialog.isProxyUse(),proxysettingsdialog.getProxyHost(),proxysettingsdialog.getProxyPort());
    }

    public static void main (String args[]) {
        showDialog();
    }
}
