/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.core.windows;

/** Specifies default programmatic names for default workspaces
8 presented in the system.
*
* @author Dafe Simonek
*/
public interface WellKnownWorkspaceNames {

    /** Name of the editing workspace */
    public static final String EDITING = "Editing"; // NOI18N
    /** Name of the gui editing workspace */
    public static final String VISUAL = "Visual"; // NOI18N
    /** Name of the browsing workspace */
    public static final String BROWSING = "Browsing"; // NOI18N
    /** Name of the running workspace */
    public static final String RUNNING = "Running"; // NOI18N
    /** Name of the debugging workspace */
    public static final String DEBUGGING = "Debugging"; // NOI18N

}

/*
* Log
*  2    Gandalf-post-FCS1.1         3/13/00  David Simonek   lower / upper case 
*       changed in workspace names
*  1    Gandalf-post-FCS1.0         3/10/00  David Simonek   
* $
*/