/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.core.windows.frames;

import java.util.EventObject;
import java.util.EventListener;

/** Allows implementors to listen to events on top component frame.
* This listener is very similar like window listener plus bound change
* events.
*
* @author Dafe Simonek
*/
public interface FrameTypeListener extends EventListener {

    /** When frame is being deactivated */
    public void frameDeactivated (FrameTypeEvent fe);

    /** When frame was closed */
    public void frameClosed (FrameTypeEvent fe);

    /** When frame was brought back from icon to normal state */
    public void frameDeiconified (FrameTypeEvent fe);

    /** When frame was brought back from maximize to normal state */
    public void frameNormalized (FrameTypeEvent fe);

    /** When frame was opened - showed */
    public void frameOpened (FrameTypeEvent fe);

    /** When frame was iconified */
    public void frameIconified (FrameTypeEvent fe);

    /** When user tried to invoke frame closing */
    public void frameClosing (FrameTypeEvent fe);

    /** When frame was made active - receives focus */
    public void frameActivated (FrameTypeEvent fe);
    
    /** When frame was maximized */
    public void frameMaximized (FrameTypeEvent fe);
}

/*
* Log
*  3    Gandalf   1.2         12/17/99 David Simonek   #1913, #2970
*  2    Gandalf   1.1         10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun 
*       Microsystems Copyright in File Comment
*  1    Gandalf   1.0         7/11/99  David Simonek   
* $
*/