/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.openide.TopManager;
import org.openide.debugger.Watch;
import org.openide.debugger.DebuggerNotFoundException;
import org.netbeans.modules.debugger.support.util.Validator;


/**
* Standart enhancement of Watch interface. 
* Should be moved to org.openide.debugger.
* @see org.openide.debugger.Watch
*
* @author   Jan Jancura
* @version  0.18, Feb 23, 1998
*/
public abstract class AbstractWatch extends Watch implements AbstractVariable {
    
    public static final String  PROP_ERROR_MESSAGE = "errorMessage";
    
    public abstract void validate ();
    /**
    * Returns error message if watch cannot be resolved or null.
    *
    * @return AbstractVariable object for this class.
    */
    public abstract String getErrorMessage ();
}

