/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger;

import javax.swing.JComponent;
import org.openide.debugger.Debugger;


/**
 * This class represents one type of debugger - Debugger Implementation.
 *
 * @author Jan Jancura
 */
public abstract class DebuggerImpl {

    /**
     * Returns display name of debugger.
     *
     * @return display name of debugger
     */
    public abstract String getDisplayName ();

    /**
     * Returns a new instance of Debugger.
     */
    public abstract Debugger createDebugger ();
}

