/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger;

import org.openide.debugger.Breakpoint;
import org.openide.debugger.Watch;

/**
* This listener notifies about changing in the debugger (e. g. adding / removing
* breakpoints, threads, thread groups and watches).
*
* @author   Jan Jancura
* @version  0.11, Jan 30, 1998
*/
public interface DebuggerListener {

    /**
    * Called when some breakpoint is added.
    *
    * @param breakpoint
    */
    public void breakpointAdded (Breakpoint breakpoint);

    /**
    * Called when some breakpoint is removed.
    *
    * @param breakpoint
    */
    public void breakpointRemoved (Breakpoint b);

    /**
    * Called when some watch is added.
    *
    * @param watch
    */
    public void watchAdded (Watch watch);

    /**
    * Called when some watch is removed.
    *
    * @param watch
    */
    public void watchRemoved (Watch watch);
}
