/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger;

import java.beans.*;
import java.util.*;

import javax.swing.SwingUtilities;

import org.openide.text.Line;

public interface Location {
    
    public String getLocationName ();
    
    /**
    * If this thread is suspended returns line object representing position
    * in the editor where this thread is stopped. If thread has 
    * no stack returns null.
    *
    * @throws DebuggerException if informations about source are 
    *   not included or some other error occurres.
    * @return line object representing position where this thread is stopped.
    */
    public Line getLine ();
}
