/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger;

/**
* This listener notifies about changing in the debugger (e. g. adding / removing
* breakpoints, threads, thread groups and watches).
*
* @author   Jan Jancura
*/
public interface ThreadListener {

    /**
    * Called when some thread is added.
    *
    * @param thread
    */
    public void threadCreated (AbstractThread thread);

    /**
    * Called when some thread is removed.
    *
    * @param thread
    */
    public void threadDeath (AbstractThread thread);
}
