/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger;

import java.util.*;
import java.beans.PropertyChangeEvent;

import javax.swing.SwingUtilities;

import org.openide.debugger.DebuggerException;


public interface ThreadsProducer {
    
    public static final String  PROP_THREADS = "threads";
    
    /**
    * Returns array of thread in this thread group.
    *
    * @return array of thread in this thread group.
    */
    public AbstractThread[] getThreads ();

    /**
    * Adds thread group listener for this thread group.
    *
    * @param l listener to be added.
    */
    public void addThreadListener (ThreadListener l);

    /**
    * Removes thread group listener from this thread group.
    *
    * @param l listener to be removed.
    */
    public void removeThreadListener (ThreadListener l);
}
