/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger;

import java.beans.PropertyChangeListener;

public interface ThreadsRoot {

    public static final String  PROP_CURRENT_THREAD = "currentThread";
    
    
    /**
    * Returns current thread or null.
    */
    public abstract AbstractThread getCurrentThread ();

    /**
    * Sets current thread. If thread is null, unsets curent thread.
    */
    public abstract void setCurrentThread (AbstractThread thread);
    
    /**
    * Returns array of thread in this thread group.
    *
    * @return array of thread in this thread group.
    */
    public ThreadsProducer getThreadsRoot ();

    /**
    * Adds listener on the property changing.
    */
    public void addPropertyChangeListener (PropertyChangeListener listener);

    /**
    * Removes listener on the property changing.
    */
    public void removePropertyChangeListener (PropertyChangeListener listener);
}
