/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.multisession.actions;

import org.openide.nodes.Node.Cookie;

/**
* Support for Session actions.
*
* @author Jan Jancura
*/
public interface SessionCookie extends Cookie {
    /** generated Serialized Version UID */
    static final long serialVersionUID = -7764755649985036556L;

    /**
    * Returns state of session.
    */
    public boolean isConnected ();

    /**
    * Sets state of session.
    */
    public void setConnected (boolean connected);

    /**
    * Finish this session.
    */
    public void finish ();

    /**
    * Show output window for this session.
    */
    //public void showOutput ();

    /**
    * Restarts this session.
    */
    public void restart ();

    /**
    * Destroyes curent session.
    */
    public void destroy ();
}

/*
* <<Log>>
*/
