/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.multisession.nodes;

import java.util.Comparator;
import java.util.ResourceBundle;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import java.lang.ref.WeakReference;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.nodes.Node;
import org.openide.nodes.Children;
import org.openide.nodes.AbstractNode;

import org.netbeans.modules.debugger.*;
import org.netbeans.modules.debugger.support.java.CallStackFrame;

/**
*
* @author   Jan Jancura
*/
public final class ConnectionNode extends AbstractNode {
    /** generated Serialized Version UID */
    static final long                 serialVersionUID = -8259352660661283488L;


    // variables .................................................................

    private AbstractThread            thread;
    private CallStackFilter           callStackFilter;


    // init ......................................................................

    /**
    * Creates empty CallStackNode node.
    */
    public ConnectionNode (
        AbstractThread thread,
        CallStackFrame [] callStack,
        String connectionName,
        String connectionIcon
    ) {
        super (new Children.Array ());
        this.thread = thread;
        this.callStackFilter = callStackFilter;
        /*    ((Children.Array) getChildren ()).setComparator (
              new CallStackComparator ()
            );*/
        setDisplayName (connectionName);
        setName (connectionName);
        setIconBase (connectionIcon);

        Children.Array myChildren = (Children.Array) getChildren ();
//        Node an = thread.getAditionalThreadInfo ();
        Node an = null;
        int i, k = callStack.length;
        Node [] nodes = new Node [k + ((an == null) ? 0 : 1)];
        for (i = 0; i < k; i++)
           nodes [i] = NodesRegistry.getNode (
               callStack [i], 
               new Object[] {callStack [i], new Integer (i)} // byla tu 0!
           );
        if (an != null)
            nodes [i] = an;
        myChildren.add (nodes);
    }

    public HelpCtx getHelpCtx() {
        return new HelpCtx("NetbeansDebuggerConnectionNode");        //NOI18N
    }

}
