/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.support;

import java.awt.Image;
import java.beans.*;
import java.util.ResourceBundle;

import org.openide.util.NbBundle;


/** A BeanInfor for DebuggerProjectSettings.
*
* @author Jan Jancura
* @version 0.11, May 16, 1998
*/
public class DebuggerProjectSettingsBeanInfo extends SimpleBeanInfo {

    /** Array of property descriptors. */
    private static PropertyDescriptor[] desc;
    private static BeanDescriptor descr;

    /** Icons */
    static Image icon;
    static Image icon32;


    // initialization of the array of descriptors
    static {
        descr = new BeanDescriptor (DebuggerProjectSettings.class);
        descr.setHidden (true);

        try {
            desc = new PropertyDescriptor[] {new PropertyDescriptor (
                    "debugger", DebuggerProjectSettings.class, // NOI18N
                    "getRemoteDebugger", "setRemoteDebugger"
            )};
            desc[0].setHidden (true);
        } catch (IntrospectionException ex) {
            //throw new InternalError ();
            ex.printStackTrace (); //[PENDINGbeta comment out]
        }
    }

    /**
    * Returns BeanDescriptor.
    */
    public BeanDescriptor getBeanDescriptor () {
        return descr;
    }

    /** Descriptor of valid properties
    * @return array of properties
    */
    public PropertyDescriptor[] getPropertyDescriptors () {
        return desc;
    }

   /** Returns the DebuggerSettings' icon */
    public Image getIcon(int type) {
        if ((type == java.beans.BeanInfo.ICON_COLOR_16x16) || (type == java.beans.BeanInfo.ICON_MONO_16x16)) {
            if (icon == null)
                icon = loadImage("/org/netbeans/core/resources/debuggerSettings.gif"); // NOI18N
            return icon;
        } else {
            if (icon32 == null)
                icon32 = loadImage ("/org/netbeans/core/resources/debuggerSettings32.gif"); // NOI18N
            return icon32;
        }
    }
}
