/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.support.java;

import java.util.ResourceBundle;
import javax.swing.JComponent;
import javax.swing.SwingUtilities;

import org.openide.TopManager;
import org.openide.text.Line;
import org.openide.debugger.DebuggerNotFoundException;
import org.openide.debugger.Watch;
import org.openide.nodes.Node;
import org.openide.nodes.PropertySupport;
import org.openide.util.NbBundle;

import org.netbeans.modules.debugger.*;


/**
*
* @author   Jan Jancura
*/
public interface InfoProducer {

        /**
        * Aditional ifno about debugger state when this event occures.
        * If event do not produce this type of info, null is returned.
        */
        public JavaThread getThread ();

        /**
        * Aditional ifno about debugger state when this event occures.
        * If event do not produce this type of info, null is returned.
        */
        public CallStackFrame[] getCallStack ();

        /**
        * Aditional info about debugger state when this event occures.
        * If event do not produce this type of info, null is returned.
        */
        public JavaVariable getVariable ();
}
