/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.support.util;

import org.netbeans.modules.debugger.*;
import org.netbeans.modules.debugger.support.*;
import org.netbeans.modules.debugger.support.java.CallStackFrame;

/**
*
* @author   Jan Jancura
*/
public class LinesCallStackFilter implements CallStackFilter {

    private int linesFromTop;
    private int linesFromBottom;
    
    
    public LinesCallStackFilter (
        int linesFromTop,
        int linesFromBottom
    ) {
        this.linesFromTop = linesFromTop;
        this.linesFromBottom = linesFromBottom;
    }
    
    /**
    */
    public Location[] filter (Location[] callStackLine) {
        if ( callStackLine.length <= 
             (linesFromTop + linesFromBottom)
        ) return new Location [0];
        
        Location[] n = new Location [
            callStackLine.length - linesFromTop - linesFromBottom
        ];
        int i, k = n.length;
        for (i = 0; i < k; i++)
          n [i] = callStackLine [i + linesFromTop];
        return n;
    }
}

