/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.jpda;

import org.openide.util.NbBundle;


/**
* Customizer panel for ClassBreakpoint.
*
* @author  Jan Jancura
*/
public class ClassBreakpointPanel extends javax.swing.JPanel {

    private ClassBreakpoint classBreakpoint;


    /** Creates new form ClassBreakpointPanel */
    public ClassBreakpointPanel (ClassBreakpoint cb) {
        classBreakpoint = cb;
        initComponents ();
        jComboBox1.addItem (NbBundle.getBundle (ClassBreakpointPanel.class).
                            getString ("CTL_Class_prepare"));
        jComboBox1.addItem (NbBundle.getBundle (ClassBreakpointPanel.class).
                            getString ("CTL_Class_unload"));
        jComboBox1.addItem (NbBundle.getBundle (ClassBreakpointPanel.class).
                            getString ("CTL_Class_both"));
        jTextField1.setText (classBreakpoint.getClassFilter ());
        jCheckBox1.setSelected (classBreakpoint.getExclusionFilter ());
        jComboBox1.setSelectedIndex (classBreakpoint.getType () - 1);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jCheckBox1 = new javax.swing.JCheckBox();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jLabel1.setText(NbBundle.getBundle (ClassBreakpointPanel.class).getString ("CTL_Class_filter"));
        jLabel1.setLabelFor(jTextField1);
        jLabel1.setDisplayedMnemonic (NbBundle.getBundle (ClassBreakpointPanel.class).getString ("CTL_Class_filter_mnemonic").charAt (0));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabel1, gridBagConstraints1);
        
        
        jTextField1.setColumns(25);
        jTextField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField1FocusLost(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(2, 6, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(jTextField1, gridBagConstraints1);
        
        
        jCheckBox1.setMnemonic (NbBundle.getBundle (ClassBreakpointPanel.class).getString ("CTL_Class_exclusion_filter_mnemonic").charAt (0));
        jCheckBox1.setText(NbBundle.getBundle (ClassBreakpointPanel.class).getString ("CTL_Class_exclusion_filter"));
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(2, 10, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jCheckBox1, gridBagConstraints1);
        
        
        jLabel3.setText(NbBundle.getBundle (ClassBreakpointPanel.class).getString ("CTL_Class_filter_hint"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.insets = new java.awt.Insets(0, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabel3, gridBagConstraints1);
        
        
        jLabel2.setText(NbBundle.getBundle (ClassBreakpointPanel.class).getString ("CTL_Class_breakpoint_type"));
        jLabel2.setLabelFor(jComboBox1);
        jLabel2.setDisplayedMnemonic (NbBundle.getBundle (ClassBreakpointPanel.class).getString ("CTL_Class_breakpoint_type_mnemonic").charAt (0));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(6, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabel2, gridBagConstraints1);
        
        
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.insets = new java.awt.Insets(5, 6, 0, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jComboBox1, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 10;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel1, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void jTextField1FocusLost (java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField1FocusLost
        // Add your handling code here:
        classBreakpoint.setClassFilter (jTextField1.getText ());
    }//GEN-LAST:event_jTextField1FocusLost

    private void jCheckBox1ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        // Add your handling code here:
        classBreakpoint.setExclusionFilter (jCheckBox1.isSelected ());
    }//GEN-LAST:event_jCheckBox1ActionPerformed


    private void jComboBox1ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        // Add your handling code here:
        classBreakpoint.setType (jComboBox1.getSelectedIndex () + 1);
    }//GEN-LAST:event_jComboBox1ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
}


/*
* Log
*  4    Jaga      1.2.1.0     3/2/00   Jan Jancura     
*  3    Gandalf   1.2         11/5/99  Jan Jancura     Add Breakpoint Dialog 
*       design updated
*  2    Gandalf   1.1         10/23/99 Ian Formanek    NO SEMANTIC CHANGE - Sun 
*       Microsystems Copyright in File Comment
*  1    Gandalf   1.0         9/28/99  Jan Jancura     
* $
*/
