/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.jpda;

import java.util.List;
import java.util.LinkedList;

import com.sun.jdi.*;

import org.netbeans.modules.debugger.*;
import org.netbeans.modules.debugger.support.*;
import org.netbeans.modules.debugger.support.java.*;

public class JPDAMonitor extends Monitor {
    
    // variables .................................................................
    
    private ObjectReference ref;
    private JPDADebugger debugger;
    
    // init ......................................................................
    
    public JPDAMonitor (JPDADebugger debugger, ObjectReference ref) {
        this.debugger = debugger;
        this.ref = ref;
    }

    public String name () {
        return ref.toString ();
    }
    
    public JavaThread owningThread () {
        try {
            ThreadReference thread = ref.owningThread ();
            if (thread != null)
                return debugger.threadManager.findThread (thread);
        } catch (Exception e) {
        }
        return null;
    }
    
    public JavaThread [] waitingThreads () {
        LinkedList temp = new LinkedList ();
        try {
            List threads = ref.waitingThreads ();
            for (int x = 0; x < threads.size (); x++) {
                JavaThread thread = 
                    debugger.threadManager.findThread ((ThreadReference) threads.get (x));
                if (thread != null)
                    temp.add (thread);
            }
        } catch (Exception e) {
        }
        JavaThread [] result = new JavaThread [temp.size ()];
        for (int x = 0; x < temp.size (); x++)
            result [x] = (JavaThread) temp.get (x);
        return result;
    }
    
    ObjectReference reference () {
        return ref;
    }
    
    public int hashCode () {
        return ref.hashCode ();
    }
    
    public boolean equals (Object obj) {
        if (!(obj instanceof JPDAMonitor))
            return false;
        return ref.equals (((JPDAMonitor)obj).reference ());
    }
    
}
