/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.jpda;

import org.openide.util.NbBundle;

/**
* Customizer of MethodBreakpointEvent.
*
* @author  Jan Jancura
*/
public class MethodBreakpointPanel extends javax.swing.JPanel {

    static final long serialVersionUID =3971964099761185802L;

    private MethodBreakpoint event;

    /** Creates new form MethodBreakpointPanel */
    public MethodBreakpointPanel (MethodBreakpoint e) {
        event = e;
        initComponents ();
        jLabel4.setDisplayedMnemonic(NbBundle.getBundle(LineBreakpointPanel.class).getString("CTL_Condition_mnemonic").charAt(0));
        jTextField1.setText (e.getClassName ());
        jTextField2.setText (e.getMethodName ());
        jCheckBox1.setSelected (e.getAllMethods ());
        jTextField2.setEnabled (!e.getAllMethods ());
        jTextField3.setText (e.getCondition ());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jLabel1.setText(NbBundle.getBundle(MethodBreakpointPanel.class).getString("CTL_Class_name"));
        jLabel1.setLabelFor(jTextField1);
        jLabel1.setDisplayedMnemonic(NbBundle.getBundle(MethodBreakpointPanel.class).getString("CTL_Class_name_mnemonic").charAt(0));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabel1, gridBagConstraints1);
        
        jTextField1.setColumns(25);
        jTextField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField1FocusLost(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(2, 6, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(jTextField1, gridBagConstraints1);
        
        jLabel2.setText(NbBundle.getBundle(MethodBreakpointPanel.class).getString("CTL_Method_name"));
        jLabel2.setLabelFor(jTextField2);
        jLabel2.setDisplayedMnemonic(NbBundle.getBundle(MethodBreakpointPanel.class).getString("CTL_Method_name_mnemonic").charAt(0));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabel2, gridBagConstraints1);
        
        jTextField2.setColumns(25);
        jTextField2.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField2FocusLost(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(2, 6, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(jTextField2, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel1, gridBagConstraints1);
        
        jCheckBox1.setText(NbBundle.getBundle(MethodBreakpointPanel.class).getString("CTL_All_methods"));
        jCheckBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox1ActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.insets = new java.awt.Insets(4, 2, 2, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jCheckBox1, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        add(jLabel3, gridBagConstraints1);
        
        jLabel4.setText(NbBundle.getBundle(ExceptionBreakpointPanel.class).getString("CTL_Condition"));
        jLabel4.setLabelFor(jTextField3);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(2, 2, 0, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(jLabel4, gridBagConstraints1);
        
        jTextField3.setMinimumSize(new java.awt.Dimension(50, 20));
        jTextField3.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField3FocusLost(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(2, 6, 0, 2);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(jTextField3, gridBagConstraints1);
        
    }//GEN-END:initComponents

  private void jTextField3FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField3FocusLost
// Add your handling code here:
      event.setCondition (jTextField3.getText ());
  }//GEN-LAST:event_jTextField3FocusLost

    private void jCheckBox1ActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox1ActionPerformed
        // Add your handling code here:
        event.setAllMethods (jCheckBox1.isSelected ());
        jTextField2.setEnabled (!jCheckBox1.isSelected ());
    }//GEN-LAST:event_jCheckBox1ActionPerformed

    private void jTextField1FocusLost (java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField1FocusLost
        // Add your handling code here:
        event.setClassName (jTextField1.getText ());
    }//GEN-LAST:event_jTextField1FocusLost

    private void jTextField2FocusLost (java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField2FocusLost
        // Add your handling code here:
        event.setMethodName (jTextField2.getText ());
    }//GEN-LAST:event_jTextField2FocusLost

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JTextField jTextField3;
    // End of variables declaration//GEN-END:variables
}
/*
 * Log
 *  5    Jaga      1.3.1.0     3/2/00   Jan Jancura     
 *  4    Gandalf   1.3         11/5/99  Jan Jancura     Add Breakpoint Dialog 
 *       design updated
 *  3    Gandalf   1.2         10/23/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  2    Gandalf   1.1         9/28/99  Jan Jancura     
 *  1    Gandalf   1.0         9/28/99  Jan Jancura     
 * $
 */
