/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.debug;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;

import org.openide.debugger.Debugger;
import org.openide.debugger.DebuggerInfo;

import org.netbeans.modules.debugger.support.DebuggerInfoProducer;


/**
 * This class represents one type of debugger - Debugger Implementation.
 *
 * @author Jan Jancura
 */
class ConnectPanel extends JPanel implements DebuggerInfoProducer {

    private static String host = "localhost"; // NOI18N
    private JTextField tfHost;
    private JTextField tfPassword;

    ConnectPanel () {
        setLayout (new GridBagLayout ());
        //      setBorder (new EmptyBorder (8, 8, 8, 8));
        GridBagConstraints c = new GridBagConstraints ();

        tfHost = new JTextField (host, 25);
        tfPassword = new JTextField (25);
        JLabel hostnameLabel = new JLabel (ToolsDebugger.getLocString ("CTL_HostName"));
        hostnameLabel.setDisplayedMnemonic(ToolsDebugger.getLocString ("CTL_HostName_Mnemonic").charAt(0));
        hostnameLabel.setLabelFor(tfHost);
        JLabel passwordLabel = new JLabel (ToolsDebugger.getLocString ("CTL_Password"));
        passwordLabel.setDisplayedMnemonic(ToolsDebugger.getLocString ("CTL_Password_Mnemonic").charAt(0));
        passwordLabel.setLabelFor(tfPassword);
        
        c.insets = new Insets (0, 0, 3, 3);
        c.anchor = GridBagConstraints.WEST;
        add (hostnameLabel, c);

        c = new GridBagConstraints ();
        c.gridwidth = 0;
        c.insets = new Insets (0, 6, 3, 0);
        c.fill = java.awt.GridBagConstraints.HORIZONTAL;
        c.weightx = 1.0;
        add (tfHost, c);

        c = new GridBagConstraints ();
        c.insets = new Insets (3, 0, 0, 3);
        c.anchor = GridBagConstraints.WEST;
        add (passwordLabel, c);

        c = new GridBagConstraints ();
        c.gridwidth = 0;
        c.fill = java.awt.GridBagConstraints.HORIZONTAL;
        c.weightx = 1.0;
        c.insets = new Insets (3, 6, 0, 0);
        add (tfPassword, c);

        c = new GridBagConstraints ();
        c.fill = java.awt.GridBagConstraints.BOTH;
        c.weighty = 1.0;
        JPanel p = new JPanel ();
        p.setPreferredSize (new Dimension (1, 1));
        add (p, c);
    }

    /**
    * Returns DebuggerInfo.
    */
    public DebuggerInfo getDebuggerInfo () {
        return new RemoteDebuggerInfo (
            tfHost.getText (),
            tfPassword.getText ()
        );
    }
}



