/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.debugger.debug;

import org.openide.TopManager;

import org.netbeans.modules.debugger.Register;


/**
* Module installation class for HtmlModule
*
* @author Jan Jancura
*/
public class ToolsDebuggerModule extends org.openide.modules.ModuleInstall {

    static final long serialVersionUID =8693835612618896479L;
    
    private static ToolsDebuggerImpl toolsDebuggerImpl = new ToolsDebuggerImpl ();
    
     
    static ToolsDebuggerImpl getToolsDebuggerImpl () {
        return toolsDebuggerImpl;
    }
   
    /** Module installed again. */
    public void restored () {
        Register.registerDebuggerImpl (
            toolsDebuggerImpl
        );
    }

    /** Module was uninstalled. */
    public void uninstalled () {
        try {
            Register.unregisterDebuggerImpl (
                toolsDebuggerImpl
            );
        } catch (RuntimeException e) {
        }
    }

}
