/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.editor.ext.java;


import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;

import javax.swing.event.DocumentListener;
import javax.swing.event.DocumentEvent;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;
import javax.swing.ListCellRenderer;
import javax.swing.border.*;
import java.util.*;

import org.netbeans.editor.LocaleSupport;

/**
 * The panel for opening java classes.
 * 
 * @author Miloslav Metelka
 * @version 1.0
 */
class JavaFastImportPanel extends javax.swing.JPanel {
   
    private JavaFastImport jfi;
    
    /** Creates new form SaveMacroPanel */
    public JavaFastImportPanel(JavaFastImport jfi) {
        this.jfi = jfi;
        
        initComponents ();
        
        listScrollPane.setViewportView(jfi.getResultList());
        
        setMaximumSize( new Dimension( 400, 200 ) );
        
    }

    public Dimension getPreferredSize() {
        Dimension pref = super.getPreferredSize();
        Dimension max = getMaximumSize();
        if( pref.width > max.width ) pref.width = max.width;
        if( pref.height > max.height ) pref.height = max.height;
	return pref;
    }
    
    void popupNotify() {
        listScrollPane.requestFocus();
    }
    
    private void initComponents() {//GEN-BEGIN:initComponents
        listPanel = new javax.swing.JPanel();
        listScrollPane = new javax.swing.JScrollPane();
        
        setLayout(new java.awt.BorderLayout());
        
        setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(12, 12, 12, 11)));
        listPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        listScrollPane.setPreferredSize(new java.awt.Dimension(200, 100));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridheight = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        listPanel.add(listScrollPane, gridBagConstraints1);
        
        add(listPanel, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents
    

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel listPanel;
    private javax.swing.JScrollPane listScrollPane;
    // End of variables declaration//GEN-END:variables

}
