/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.editor.java;

import javax.swing.SwingUtilities;

/**
 *
 * @author  Miloslav Metelka
 * @version 1.0
 */
class JCProgressPanel extends javax.swing.JPanel {

    private String doneString;

    static final long serialVersionUID =6703090319845123415L;
    /** Creates new form JCProgressPanel */
    JCProgressPanel() {
        initComponents ();
    }

    public void invokeSetBuilding(final String s) {
        SwingUtilities.invokeLater(
            new Runnable() {
                public void run() {
                    buildingLabel.setText(s);
                }
            }
        );
    }

    public void invokeSetCurrentClass(final String s) {
        SwingUtilities.invokeLater(
            new Runnable() {
                public void run() {
                    currentLabel.setText(s);
                }
            }
        );
    }

    public void invokeSetDoneString(final String s) {
        SwingUtilities.invokeLater(
            new Runnable() {
                public void run() {
                    doneLabel.setText(s);
                }
            }
        );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        buildingLabel = new javax.swing.JLabel();
        currentLabel = new javax.swing.JLabel();
        doneLabel = new javax.swing.JLabel();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 12, 11);
        add(buildingLabel, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 12, 11);
        add(currentLabel, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 17, 11);
        add(doneLabel, gridBagConstraints1);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel buildingLabel;
    private javax.swing.JLabel currentLabel;
    private javax.swing.JLabel doneLabel;
    // End of variables declaration//GEN-END:variables

}
