/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.editor.java;

import java.awt.event.ActionEvent;
import org.openide.util.actions.SystemAction;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.netbeans.editor.ext.ListCompletionView;

/**
 * Open java source according to the given expression.
 *
 * @author Miloslav Metelka
 * @version 1.0
 */

public class JavaFastOpenAction extends SystemAction {
    
    private static final String HELP_ID = "editing.fastopen"; // !!! NOI18N
    
    public void actionPerformed(ActionEvent e) {
        new NbJavaFastOpen().setDialogVisible(true);
    }
    
    public String getName() {
        return NbBundle.getBundle(JavaFastOpenAction.class).getString("NAME_JavaFastOpenAction"); // NOI18N
    }
    
    public HelpCtx getHelpCtx() {
        return new HelpCtx(HELP_ID);
    }
    
}
