/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.editor.java;

import javax.swing.ListCellRenderer;
import javax.swing.text.Document;
import javax.swing.text.JTextComponent;
import org.openide.src.Import;
import org.openide.src.Identifier;
import org.openide.src.SourceElement;
import org.openide.src.SourceException;
import org.openide.cookies.SourceCookie;
import org.openide.loaders.DataObject;
import org.netbeans.editor.ext.java.JavaFastImport;
import org.netbeans.editor.ext.java.JCClass;

/**
 *
 * @author Miloslav Metelka
 * @version 1.0
 */

public class NbJavaFastImport extends JavaFastImport {
    
    public NbJavaFastImport(JTextComponent target) {
        super(target);
    }
    
    protected void updateImport(Object item) {
        if (item instanceof JCClass) {
            JCClass cls = (JCClass)item;
            Object o = target.getDocument().getProperty(Document.StreamDescriptionProperty);
            if (o instanceof DataObject) {
                DataObject dob = (DataObject)o;
                if (dob != null) {
                    SourceCookie sc = (SourceCookie)dob.getCookie(SourceCookie.class);
                    if (sc != null) {
                        SourceElement se = sc.getSource();
                        if (se != null) {
                            try {
                                se.addImport(new Import(Identifier.create(cls.getFullName()), false));
                            } catch (SourceException e) {
                            }
                        }
                    }
                }
            }
        }
    }
    
    protected ListCellRenderer createCellRenderer() {
        NbJCCellRenderer rr = new NbJCCellRenderer();
        rr.setClassDisplayFullName(true);
        return rr;
    }
    
}
