/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.extbrowser;

import org.openide.util.NbBundle;

public class BrowserPropertyEditor extends java.beans.PropertyEditorSupport {

    public java.lang.String getAsText() {
        Object o = getValue ();
        if (o == null)
            return NbBundle.getMessage (BrowserPropertyEditor.class, "LBL_SystemDefaultBrowser");
        
        return (String)o;
    }

    public void setAsText(java.lang.String str) throws java.lang.IllegalArgumentException {
        if (str == null)
            throw new IllegalArgumentException ();

        if (str.equals(ExtBrowserSettings.IEXPLORE) || str.equals(ExtBrowserSettings.NETSCAPE))
            setValue (str);

        if (str.equals (NbBundle.getMessage (BrowserPropertyEditor.class, "LBL_SystemDefaultBrowser")))
            setValue (null);
        
        return;
    }

    public java.lang.String[] getTags() {
        String [] tags = {
            NbBundle.getMessage (BrowserPropertyEditor.class, "LBL_SystemDefaultBrowser"),
            ExtBrowserSettings.IEXPLORE,
            ExtBrowserSettings.NETSCAPE
        };
        return tags;
    }
}

