/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.extbrowser;

/**
 *
 * @author  rkubacki
 * @version
 */
import java.util.*;
public class DdeBrowserSupport {
    
    /** extracts n-th field of string returned from DDE communication.
     *  input string has fields delimited by , and they can be embedded with quotes
     */
    public static String getNthField (String s, int i) {
        String fld = "";
        int idx;
        
        for (; i>0; i--) {
            if (s == null || s.equals(""))  // NOI18N 
                return "";
            
            if (s.charAt(0) == '"') {
                idx = s.indexOf ('"',1);
                fld = s.substring (1, idx);
                idx = s.indexOf (',', idx);
                s = (idx==-1)? "": s.substring (idx+1);
            }
            else {
                idx = s.indexOf (',');
                fld = (idx==-1)? s: s.substring (0, idx);
                s = (idx==-1)? "": s.substring (idx+1);
            }
        }
        return fld;
    }
    
    public static int getDWORDAtOffset (byte p[], int off) {
        int j = p[off] < 0 ? 256 + p[off] : ((int) (p[off]));
        j += (p[off + 1] < 0 ? 256 + p[off + 1] : p[off + 1]) << 8;
        j += (p[off + 2] < 0 ? 256 + p[off + 2] : p[off + 2]) << 16;
        j += (p[off + 3] < 0 ? 256 + p[off + 3] : p[off + 3]) << 24;
        return j;
    }

}
