/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.extbrowser;           

import java.io.InputStream;
import javax.servlet.*;
import javax.servlet.http.*;

import org.openide.execution.NbfsStreamHandlerFactory;
import org.openide.execution.NbfsURLConnection;
import org.openide.filesystems.*;
import org.openide.TopManager;
/** This servlet is used to give access to documentation previously 
 *  displayed through nbfs: protocol
 *
 * @author  rkubacki
 * @version 
 */
public class JavaDocServlet extends HttpServlet {
   
    /** Initializes the servlet.
    */  
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
    }

    /** Destroys the servlet.
    */  
    public void destroy() {

    }

    /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest (HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        response.setContentType("text/html");   // NOI18N
        java.io.PrintWriter out = response.getWriter();
        
        // output your page here
        String path = request.getPathInfo ();
        try {
            java.net.URL url = new java.net.URL ("nbfs:"+path); // NOI18N
            NbfsURLConnection conn = new NbfsURLConnection (url);
            InputStream in = conn.getInputStream ();
            byte [] buff = new byte [256];
            int len;
            
            while ((len = in.read (buff)) != -1) {
                out.print (new String (buff, 0, len));
            }
            in.close ();
        }
        catch (java.net.MalformedURLException ex) {
            ex.printStackTrace (out);
        }
        catch (java.io.IOException ex) {
            ex.printStackTrace (out);
        }
        
            /*
            out.println ("<html>");
            out.println ("<head>");
            out.println ("<title>JavaDocServlet</title>");
            out.println ("</head>");
            out.println ("<body>");
             
            out.println ("Test output");
            out.println ("<P>no nbfs parameter.");
            out.println ("</body>");
            out.println ("</html>");
             */
        out.close();
    }

    /** Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    } 

    /** Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, java.io.IOException {
        processRequest(request, response);
    }

    /** Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "java documentation servlet";
    }

}