/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.extbrowser;

import java.awt.Image;
import java.beans.*;

import org.openide.util.NbBundle;

public class WinWebBrowserBeanInfo extends SimpleBeanInfo {

    private static BeanDescriptor descr = null; 

    private static PropertyDescriptor[] properties = null; 

    public BeanDescriptor getBeanDescriptor() {
        if (descr == null) {
            descr = new BeanDescriptor (ExtWebBrowser.class);
            descr.setDisplayName (NbBundle.getMessage (WinWebBrowserBeanInfo.class, "CTL_WinBrowserName"));
            descr.setShortDescription (NbBundle.getMessage (WinWebBrowserBeanInfo.class, "HINT_WinBrowserName"));
        }
	return descr;
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        if (properties == null) {
            try {
                properties = new PropertyDescriptor [] {
                    new PropertyDescriptor ("dDEServer", WinWebBrowser.class, "getDDEServer", "setDDEServer")    // NOI18N
                };
                properties[0].setDisplayName (NbBundle.getMessage (WinWebBrowserBeanInfo.class, "PROP_DDEServer"));
                properties[0].setShortDescription (NbBundle.getMessage (WinWebBrowserBeanInfo.class, "HINT_DDEServer"));
                properties[0].setPropertyEditorClass (BrowserPropertyEditor.class);
            } catch (IntrospectionException ie) {
                if (Boolean.getBoolean ("netbeans.debug.exceptions"))   // NOI18N
                    ie.printStackTrace ();
                return null;
            }
        }
        return properties;
    }

    /**
    * Returns the IceBrowserSettings' icon. 
    */
    public Image getIcon (int type) {
        return loadImage("/org/openide/resources/html/htmlView.gif"); // NOI18N
    }
    
    /**
     * Claim there are no other relevant BeanInfo objects.  You
     * may override this if you want to (for example) return a
     * BeanInfo for a base class.
     */
    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (ExtWebBrowser.class) };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }
    
}
