/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.form;

import java.beans.*;
import java.lang.reflect.*;

/**
 * A class that represents one EventSet
 */

public class EventSet
{
    EventSet(RADComponent metacomp, EventSetDescriptor desc) {
        this.desc = desc;
        Method[] methods = desc.getListenerMethods();
        events = new Event[methods.length];
        for (int i = 0; i < methods.length; i++)
            events [i] = new Event(metacomp, methods [i]);
    }

    public Event[] getEvents() {
        return events;
    }

    public int getEventCount() {
        return events.length;
    }

    public String getName() {
        return desc.getName();
    }

    EventSetDescriptor getEventSetDescriptor() {
        return desc;
    }

    private EventSetDescriptor desc;
    private Event[] events;
}
