/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.form;

import org.openide.util.WeakListener;


public class FormModelWeakListener extends WeakListener
                                   implements FormModelListener {

    public FormModelWeakListener(FormModelListener l) {
        super(FormModelListener.class, l);
    }

    protected String removeMethodName () {
        return "removeFormModelListener"; // NOI18N
    }

    // -------------

    public void formLoaded(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.formLoaded(e);
    }

    public void formChanged(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.formChanged(e);
    }

    public void formToBeSaved(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.formToBeSaved(e);
    }

    public void layoutChanged(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.layoutChanged(e);
    }

    public void componentAdded(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.componentAdded(e);
    }

    public void componentRemoved(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.componentRemoved(e);
    }

    public void componentPropertyChanged(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.componentPropertyChanged(e);
    }

    public void eventHandlerAdded(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.eventHandlerAdded(e);
    }

    public void eventHandlerRemoved(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.eventHandlerRemoved(e);
    }

    public void eventHandlerRenamed(FormModelEvent e) {
        FormModelListener l = (FormModelListener)super.get(e);
        if (l != null) l.eventHandlerRenamed(e);
    }
}
