/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.form;

import java.io.*;
import javax.swing.SwingUtilities;

import org.openide.windows.TopComponent;
import org.openide.windows.Workspace;

/**
 * This class is here only for correct project deserialization from NB 3.1.
 * The functionality was replaced by FormDesigner class.
 */
public class FormTopComponent extends TopComponent {
    static final long serialVersionUID =5367782511020527952L;

    public void readExternal(ObjectInput in) throws IOException, 
                                                    ClassNotFoundException {
        super.readExternal(in);
        Object o = in.readObject();
        if (o instanceof FormDataObject) {
            FormEditorSupport formSupport = ((FormDataObject)o).getFormEditor();
            formSupport.open();
        }
    }

    public void writeExternal(ObjectOutput out) throws IOException {
        super.writeExternal(out);
        out.writeObject(new Serializable() {} );
    }

    public void open(Workspace workspace) {
        // this TopComponent should not be opened
    }
}
