/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.form;

import java.beans.*;
import java.awt.*;
import org.openide.filesystems.JarFileSystem;

/**
 *
 * @author Tran Duc Trung
 */

/** Marks it as global (not project-specific). */

public class GlobalJarFileSystemBeanInfo extends SimpleBeanInfo
{
    public BeanDescriptor getBeanDescriptor () {
        BeanDescriptor bd = new BeanDescriptor (GlobalJarFileSystem.class);
        bd.setValue ("global", Boolean.TRUE); // NOI18N
        return bd;
    }
    
    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (JarFileSystem.class) };
        } catch (IntrospectionException ie) {
            return null;
        }
    }
    
    public Image getIcon (int kind) {
        try {
            return Introspector.getBeanInfo(JarFileSystem.class).getIcon(kind);
        } catch (IntrospectionException ie) {
            return null;
        }
    }
}
