/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.form;

/** The InvalidBeanException is thrown when an invalid bean used in
 * FormEditor is used.
 *
 * @author Ian Formanek, Petr Hamernik
 * @version 0.10, May 14, 1998
 */
public class InvalidBeanException extends Exception {
    /** generated Serialized Version UID */
    static final long serialVersionUID = -1338307778718678583L;

    /** Constructs a new InvalidBeanException */
    public InvalidBeanException() {
    }

    /** Constructs a new InvalidBeanException for specified underlying exception*/
    public InvalidBeanException(Exception e) {
        super(e.getClass().getName());
        exception = e;
    }

    /** Constructs a new InvalidBeanException with specified string description */
    public InvalidBeanException(String s) {
        super(s);
    }

    /** @return An underlying exception that caused the bean to be invalid
     * or null if not specified 
     */
    public Exception getException() {
        return exception;
    }

    /** The underlying exception that caused the bean to be invalid */
    private Exception exception;
}
