/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.form;

import org.openide.nodes.*;

/**
 *
 * @author Ian Formanek
 */
public class NonVisualChildren extends Children.Keys
{
    public NonVisualChildren(FormModel model) {
        updateKeys(model);
    }

    void updateKeys(FormModel model) {
        RADComponent[] subComps = model.getNonVisualComponents();
        setKeys(subComps);
    }
    
    /**
     * Create nodes for a given key.
     * @param key the key
     * @return child nodes for this key
     */
    protected Node[] createNodes(Object key) {
        Node node = new RADComponentNode((RADComponent)key);
        node.getChildren().getNodes(); // enforce subnodes creation
        return new Node[] { node };
    }
}
