/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.form.actions;

import org.openide.util.HelpCtx;
import org.openide.util.actions.CallableSystemAction;

import org.netbeans.modules.form.*;

/** The ComponentInspector action. Displays the ComponentInspector.
 *
 * @author   Ian Formanek
 */
public class ComponentInspectorAction extends CallableSystemAction {
    static final long serialVersionUID =-3952196749375353118L;
    /** generated Serialized Version UID */
    //  static final long serialVersionUID = 9171231622495988045L;

    public ComponentInspectorAction() {
        setEnabled(false);
    }

    /** Human presentable name of the action. This should be presented
     * as an item in a menu.
     * @return the name of the action
     */
    public String getName() {
        return org.openide.util.NbBundle.getBundle(ComponentInspectorAction.class).getString("ACT_ComponentInspector");
    }

    /** Help context where to find more about the action.
     * @return the help context for this action
     */
    public HelpCtx getHelpCtx() {
        return new HelpCtx("gui.component-inspector"); // NOI18N
    }

    /** Icon resource.
     * @return name of resource for icon
     */
    protected String iconResource() {
        return "/org/netbeans/modules/form/resources/inspector.gif"; // NOI18N
    }

    /** This method is called by one of the "invokers" as a result of
     * some user's action that should lead to actual "performing" of the action.
     * This default implementation calls the assigned actionPerformer if it
     * is not null otherwise the action is ignored.
     */
    public void performAction() {
        ComponentInspector ci = ComponentInspector.getInstance();
        ci.open();
        ci.requestFocus();
    }

}
