/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.form.compat2.border;

import org.openide.nodes.*;
import org.netbeans.modules.form.*;

/**
 * @author Tomas Pavek
 */

public class DesignBorder implements FormDesignValue, FormPropertyContainer {

    BorderDesignSupport borderSupport;

    public DesignBorder(BorderDesignSupport borderSupport) {
        this.borderSupport = borderSupport;
    }

    public Object getDesignValue() {
        return borderSupport.getBorder();
    }

    public String getDescription() {
        return borderSupport.getDisplayName();
    }

    public Node.Property[] getProperties() {
        return borderSupport.getProperties();
    }

    public BorderDesignSupport getBorderSupport() {
        return borderSupport;
    }
}
