/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.form.palette;

import javax.swing.*;
import java.beans.*;

import org.openide.nodes.*;
import org.openide.util.WeakListener;


/** Menu item representing one bean in Component Palette's beans menu.
 */
class PaletteMenuItem extends JMenuItem implements NodeListener {
    PaletteButton palButton;
    PaletteItem palItem;

    public PaletteMenuItem(PaletteButton button) {
        this(button.getItem());
        palButton = button;
    }

    public PaletteMenuItem(PaletteItem item) {
        super(item.getName(),
              new ImageIcon(item.getItemNode().getIcon(BeanInfo.ICON_COLOR_16x16)));
        palItem = item;

        palItem.getItemNode().addNodeListener(WeakListener.node(this,
                                                       palItem.getItemNode()));
    }

    PaletteButton getButton() {
        return palButton;
    }

    PaletteItem getItem() {
        return palItem;
    }

    public void propertyChange(PropertyChangeEvent ev) {
        if (Node.PROP_ICON.equals(ev.getPropertyName())) {
            setIcon(new ImageIcon(palItem.getItemNode().getIcon(
                                                 BeanInfo.ICON_COLOR_16x16)));
        }
    }

    public void childrenAdded(NodeMemberEvent ev) {
    }
    public void childrenRemoved(NodeMemberEvent ev) {
    }
    public void childrenReordered(NodeReorderEvent ev) {
    }
    public void nodeDestroyed(NodeEvent ev) {
    }
}
