/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.form.palette;

import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.ResourceBundle;
import java.text.MessageFormat;

import org.openide.awt.JPopupMenuPlus;
import org.openide.nodes.*;
import org.openide.*;


/** Popup menu for compoennt palette.
 *
 * @author Tomas Pavek
 */
class PalettePopupMenu extends JPopupMenuPlus {

    PaletteNode palNode;

    public PalettePopupMenu() {
        palNode = PaletteNode.getPaletteNode();

        JMenuItem menuItem;

        ResourceBundle bundle = ComponentPalette.getBundle();

/*        menuItem = new JMenuItem("Install New Bean");
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                BeanInstaller.installBean();
            }
        });
        add(menuItem); */

        menuItem = new JMenuItem(bundle.getString("CTL_CreateCategory")); // NOI18N
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                createCategory();
            }
        });
        add(menuItem);
        addSeparator();

        menuItem = new JMenuItem(bundle.getString("CTL_OrderCategories")); // NOI18N
        menuItem.setEnabled(palNode.getCookie(Index.class) != null);
        menuItem.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                reorderCategories();
            }
        });
        add(menuItem);
    }

    private void reorderCategories() {
        Index order = (Index)palNode.getCookie(Index.class);
        if (order != null)
            order.reorder();
    }

    private void createCategory() {
        try {
            palNode.createNewCategory();
        }
        catch (java.io.IOException e) {
            if (Boolean.getBoolean("netbeans.debug.exceptions")) // NOI18N
                e.printStackTrace();
            TopManager.getDefault().getErrorManager().notify(e);
        }
    }
}
