/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.form.palette;

import javax.swing.*;
import java.lang.reflect.*;


/** Hacked JMenu - to use ScrollPopupMenu as its popup menu.
 */
public class ScrollMenu extends JMenu {

    public ScrollMenu(String txt,int maxH) {
        super(txt);
        ScrollPopupMenu popup = new ScrollPopupMenu(maxH);
        popup.setInvoker(this);

        try {
            Field f = JMenu.class.getDeclaredField("popupMenu"); // NOI18N
            f.setAccessible(true);
            f.set(this, popup);
        }
        catch (Exception ex) {
            System.out.println("[WARNING] Cannot create scrollable popup menu."); // NOI18N
        }
    }
}
