/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.i18n;


import org.netbeans.modules.i18n.java.JavaI18nSupport;
import org.netbeans.modules.i18n.jsp.JspI18nSupport;

import org.openide.modules.ModuleInstall;


/** 
 * Installation class for i18n module.
 *
 * @author Petr Jiricka
 */
public class I18nModule extends ModuleInstall {

    /** Generated serial version UID. */
    static final long serialVersionUID =1159160389747335713L;
    
    
    /** Installs java and jsp i18n support. */
    public void restored() {
        FactoryRegistry.registerSupport("org.netbeans.modules.java.JavaDataObject", new JavaI18nSupport.Factory()); // NOI18N
        FactoryRegistry.registerSupport("org.netbeans.modules.web.core.jsploader.JspDataObject", new JspI18nSupport.Factory()); // NOI18N
    }
    
    /** Unregisters java and jsp i18n support from registry. */
    public void uninstalled() {
        FactoryRegistry.unregisterSupport("org.netbeans.modules.java.JavaDataObject"); // NOI18N
        FactoryRegistry.unregisterSupport("org.netbeans.modules.web.core.jsploader.JspDataObject"); // NOI18N
    }
    
}
