/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.i18n.wizard;


import javax.swing.JPanel;


/**
 * Panel to monitor long tasks in i18n wizard. Namely searchnig
 * for hard codes strings and replacing the hard coded string 
 * with internationalized ones.
 *
 * @author  Peter Zavadsky
 */
public class ProgressWizardPanel extends JPanel {

    /** Creates new form ProgressPanel */
    public ProgressWizardPanel(boolean withSubProgress) {
        initComponents();
        
        if(!withSubProgress) {
            remove(subLabel);
            remove(subProgress);
        }
        
        setPreferredSize(I18nWizardDescriptor.PREFERRED_DIMENSION);
    }

    
    /** Sets text of main label. */
    public void setMainText(String text) {
        mainLabel.setText(text);
    }
    
    /** Sets text of sub label. */
    public void setSubText(String text) {
        subLabel.setText(text);
    }

    /** Sets main progress bar value. */
    public void setMainProgress(int value) {
        mainProgress.setValue(value);
    }
    
    /** Sets sub progress bar value. */
    public void setSubProgress(int value) {
        subProgress.setValue(value);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        mainLabel = new javax.swing.JLabel();
        mainProgress = new javax.swing.JProgressBar();
        subLabel = new javax.swing.JLabel();
        subProgress = new javax.swing.JProgressBar();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(mainLabel, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(7, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints1.weightx = 1.0;
        add(mainProgress, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(11, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(subLabel, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(7, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints1.weightx = 1.0;
        add(subProgress, gridBagConstraints1);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel mainLabel;
    private javax.swing.JProgressBar mainProgress;
    private javax.swing.JLabel subLabel;
    private javax.swing.JProgressBar subProgress;
    // End of variables declaration//GEN-END:variables

}
