/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.icebrowser;

import java.awt.Image;
import java.awt.Toolkit;
import java.beans.*;
import java.util.ResourceBundle;

import org.openide.util.NbBundle;


/**
* A BeanInfo for ICEBrowserSettings.
*
* @author Jan Jancura
*/
public class ICEBrowserSettingsBeanInfo extends SimpleBeanInfo {

    /** Array of property descriptors. */
    private static PropertyDescriptor[] desc;

    /** Icons */
    static Image icon;
    static Image icon32;

    // initialization of the array of descriptors
    static {
        try {
            desc = new PropertyDescriptor [] {
                       new PropertyDescriptor (
                           ICEBrowserSettings.PROP_DEFAULT_BACKGROUND, ICEBrowserSettings.class,
                           "getDefaultBackground", "setDefaultBackground"), // 0 // NOI18N
                       new PropertyDescriptor (
                           ICEBrowserSettings.PROP_FIXED_FONT, ICEBrowserSettings.class,
                           "getFixedFont", "setFixedFont"), // 1 // NOI18N
                       new PropertyDescriptor (
                           ICEBrowserSettings.PROP_PROPORTIONAL_FONT, ICEBrowserSettings.class,
                           "getProportionalFont", "setProportionalFont"), // 2 // NOI18N
                       new PropertyDescriptor (
                           "history", ICEBrowserSettings.class, // NOI18N
                           "getHistory", "setHistory"), // 3 // NOI18N
                       new PropertyDescriptor (
                           "encoding", ICEBrowserSettings.class, // NOI18N
                           "getEncoding", "setEncoding"), // 4 // NOI18N
                       new PropertyDescriptor (
                           "imageAnimation", ICEBrowserSettings.class, // NOI18N
                           "isAnimation", "setAnimation"), // 5 // NOI18N
                   };
            ResourceBundle bundle = NbBundle.getBundle (ICEBrowserSettingsBeanInfo.class);
            desc[0].setDisplayName (bundle.getString ("PROP_DEFAULT_BACKGROUND"));
            desc[0].setShortDescription (bundle.getString ("HINT_DEFAULT_BACKGROUND"));
            desc[1].setDisplayName (bundle.getString ("PROP_FIXED_FONT"));
            desc[1].setShortDescription (bundle.getString ("HINT_FIXED_FONT"));
            desc[2].setDisplayName (bundle.getString ("PROP_PROPORTIONAL_FONT"));
            desc[2].setShortDescription (bundle.getString ("HINT_PROPORTIONAL_FONT"));
            desc[3].setHidden (true);
            desc[4].setDisplayName (bundle.getString ("PROP_ENCODING"));
            desc[4].setShortDescription (bundle.getString ("HINT_ENCODING"));
            desc[4].setPropertyEditorClass (EncodingEditor.class);
            desc[5].setDisplayName (bundle.getString ("PROP_ANIMATION"));
            desc[5].setShortDescription (bundle.getString ("HINT_ANIMATION"));
        } catch (IntrospectionException ex) {
            //throw new InternalError ();
            ex.printStackTrace (); //[PENDINGbeta comment out]
        }
    }


    /** Descriptor of valid properties
    * @return array of properties
    */
    public PropertyDescriptor[] getPropertyDescriptors () {
        return desc;
    }

    /**
    * Returns the ICEBrowserSettings' icon. 
    */
    public Image getIcon (int type) {
        return loadImage("/org/openide/resources/html/htmlView.gif"); // NOI18N
    }
}
