/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.jarpackager;

import java.util.zip.Deflater;
import java.beans.PropertyEditor;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.openide.util.NbBundle;
import org.openide.explorer.propertysheet.editors.*;

/** Property editor for compression level property. This editor is used
 * also in packaging panel as one of its parts. 
 *
 * @author  Dafe Simonek
 */
public class CompressionEditor extends javax.swing.JPanel implements PropertyEditor {

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        levelSlider = new javax.swing.JSlider();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jLabel1.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/jarpackager/Bundle").getString("CTL_Level"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        add(jLabel1, gridBagConstraints1);
        
        
        levelSlider.setSnapToTicks(true);
        levelSlider.setPaintLabels(true);
        levelSlider.setMajorTickSpacing(1);
        levelSlider.setMaximum(9);
        levelSlider.setValue(6);
        levelSlider.setPreferredSize(new java.awt.Dimension(200, 40));
        levelSlider.setName("");
        levelSlider.setMinimumSize(new java.awt.Dimension(200, 40));
        levelSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                levelSliderStateChanged(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints1.weighty = 1.0;
        add(levelSlider, gridBagConstraints1);
        
    }//GEN-END:initComponents

  private void levelSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_levelSliderStateChanged
// Add your handling code here:
      //  setting save flag * in window title   
        doSetValue(new CompressionLevel(levelSlider.getValue()));
  }//GEN-LAST:event_levelSliderStateChanged


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jLabel1;
  private javax.swing.JSlider levelSlider;
  // End of variables declaration//GEN-END:variables

    /** Holds value of compression level */
    private CompressionLevel value;
    /** Helper support for firing, listeners etc. */
    private PropertyChangeSupport support;

    private static java.util.ResourceBundle bundle = NbBundle.getBundle(JarPackagerModule.class);
    
    
    /** Creates new form CompressionEditor */
    public CompressionEditor() {
        initComponents ();
        localize();
        // value initialization
        setValue(new CompressionLevel(6));
    }
 
    /** Helper operation, sets localized title of the border */
    private void localize () {
        // compression panel title
        setBorder (new javax.swing.border.CompoundBorder(
                           new javax.swing.border.TitledBorder(
                               new javax.swing.border.EtchedBorder(java.awt.Color.white, new java.awt.Color (134, 134, 134)),
                               NbBundle.getBundle(CompressionEditor.class).getString("CTL_CompressionEditor")
                           ),
                           new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 5, 4, 5))));
    }


    public String getJavaInitializationString () {
        return value.getValue().toString();
    }

    public java.awt.Component getCustomEditor() {
        return this;
    }

    public boolean supportsCustomEditor () {
        return true;
    }

    public boolean isPaintable() {
        return false;
    }

    public void paintValue(java.awt.Graphics p1, java.awt.Rectangle p2) {
    }

    public String[] getTags() {
        return null;
    }

    public void addPropertyChangeListener (PropertyChangeListener pchl) {
        support().addPropertyChangeListener(pchl);
    }

    public void removePropertyChangeListener(PropertyChangeListener pchl) {
        support().removePropertyChangeListener(pchl);
    }

    public void setValue (Object value) {
        doSetValue(value);
        updateGui(value);
    }

    public Object getValue() {
        return value;
    }
    public Object getPropertyValue() {
        return value;
    }

    public void setAsText (String text) throws IllegalArgumentException {
        value = new CompressionLevel(text);
        support().firePropertyChange("", null, null);
    }

    public String getAsText() {
        return value.getValue().toString();
    }

    /** Safe getter for property change support with lazy initialization */
    private PropertyChangeSupport support () {
        if (support == null) {
            support = new PropertyChangeSupport(this);
        }
        return support;
    }
    
    /** Actually performs value change, without visual effects */
    void doSetValue (Object value) {
        if (!(value instanceof CompressionLevel)) throw new IllegalArgumentException (value.toString ());
        // create our value for modification instead of modifying given one
        this.value = new CompressionLevel((CompressionLevel)value);
        // notify listeners
        support().firePropertyChange("", null, null);
    }
    
    /** Utility method, update gui of this custom property editor according
    * to given property value. */
    void updateGui (Object value) {
        levelSlider.setValue(((CompressionLevel)value).getValue().intValue());
    }
    

}
