/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.jarpackager;

import java.util.ArrayList;
import java.util.Collection;
import org.openide.loaders.DataObject;

/** Helper 'marker' class. We need special type of class for 
* the property that will hold a list of data objects.

 * @author  Dafe Simonek
 */
public class DataObjectList extends ArrayList {

    /** generated Serialized Version UID */
    static final long serialVersionUID = -672724081610777399L;

    public DataObjectList() {
        super();
    }

    public DataObjectList(Collection collection) {
        super(collection);
    }

    public DataObjectList(int capacity) {
        super(capacity);
    }

    public String toString() {
    	StringBuffer result = new StringBuffer();
	for (int i = 0; i < this.size(); i++) {
	    result.append(((DataObject)this.get(i)).getName());
	    result.append(';');
	}
	return new String(result);
    }
}
