/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.jarpackager;

import org.openide.util.NbBundle;
import org.openide.explorer.propertysheet.ExPropertyEditor;
import java.beans.PropertyEditor;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import javax.swing.DefaultComboBoxModel;

import org.apache.regexp.RESyntaxException;
import org.openide.util.HelpCtx;


/** Property editor for FIlter property. Also contained directly
 * in packaging panel as its part.
 *
 * @author  Dafe Simonek
 */
public class FilterEditor extends javax.swing.JPanel implements PropertyEditor {
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        filterRadio = new javax.swing.JRadioButton();
        filtersComboBox = new javax.swing.JComboBox();
        regExpRadio = new javax.swing.JRadioButton();
        regExpTextField = new javax.swing.JTextField();
        negativeCheckBox = new javax.swing.JCheckBox();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        filterRadio.setToolTipText(bundle.getString("CTL_CommonFilterTip"));
        filterRadio.setText(bundle.getString("CTL_CommonFilter"));
        filterRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filterRadioActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(filterRadio, gridBagConstraints1);
        
        filtersComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filtersComboBoxActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 0);
        gridBagConstraints1.weightx = 1.0;
        add(filtersComboBox, gridBagConstraints1);
        
        regExpRadio.setToolTipText(bundle.getString("CTL_RegExpTip"));
        regExpRadio.setText(bundle.getString("CTL_RegExp"));
        regExpRadio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                regExpRadioActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(regExpRadio, gridBagConstraints1);
        
        regExpTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                regExpTextFieldActionPerformed(evt);
            }
        });
        
        regExpTextField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                regExpTextFieldFocusLost(evt);
            }
        });
        
        regExpTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                regExpTextFieldKeyReleased(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipady = 4;
        gridBagConstraints1.weightx = 1.0;
        add(regExpTextField, gridBagConstraints1);
        
        negativeCheckBox.setToolTipText(bundle.getString("CTL_NegativeTip"));
        negativeCheckBox.setText(bundle.getString("CTL_Negative"));
        negativeCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                negativeCheckBoxActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.insets = new java.awt.Insets(0, 10, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        add(negativeCheckBox, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void negativeCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_negativeCheckBoxActionPerformed
        // Add your handling code here:
        updateValue();
    }//GEN-LAST:event_negativeCheckBoxActionPerformed

    private void regExpTextFieldFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_regExpTextFieldFocusLost
        // Add your handling code here:
        updateValue();

    }//GEN-LAST:event_regExpTextFieldFocusLost
    
    private void regExpTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_regExpTextFieldActionPerformed
        // Add your handling code here:
        updateValue();
        
    }//GEN-LAST:event_regExpTextFieldActionPerformed
    
  private void filtersComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filtersComboBoxActionPerformed
      // Add your handling code here:
      //  setting save flag * in window title
      updateValue();
  }//GEN-LAST:event_filtersComboBoxActionPerformed
  
  private void regExpTextFieldKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_regExpTextFieldKeyReleased
      // Add your handling code here:
      //  setting save flag * in window title
      regExpTextField.setForeground(checkValid() ? java.awt.SystemColor.textText : java.awt.Color.red);
  }//GEN-LAST:event_regExpTextFieldKeyReleased
  
  private void filterRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filterRadioActionPerformed
      // Add your handling code here:
      //  setting save flag * in window title
      updateValue();
      checkValid();
      updateFilteringControlStates();
  }//GEN-LAST:event_filterRadioActionPerformed
  
  private void regExpRadioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_regExpRadioActionPerformed
      // Add your handling code here:
      //  setting save flag * in window title
      updateValue();
      checkValid();
      updateFilteringControlStates();
  }//GEN-LAST:event_regExpRadioActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  protected javax.swing.JRadioButton filterRadio;
  protected javax.swing.JComboBox filtersComboBox;
  protected javax.swing.JRadioButton regExpRadio;
  protected javax.swing.JTextField regExpTextField;
  protected javax.swing.JCheckBox negativeCheckBox;
  // End of variables declaration//GEN-END:variables
  
    /** Creates new form FilterEditor */
  public FilterEditor() {
      initComponents ();
      localize();
      model = new DefaultComboBoxModel();
      model.addElement(JarContent.DEFAULT);
      model.addElement(JarContent.CLASSES_ONLY);
      model.addElement(JarContent.ALL);
      filtersComboBox.setModel(model);
      // initialize default value
      setValue(JarContent.DEFAULT);
      HelpCtx.setHelpIDString (this, FilterEditor.class.getName ());

  }
  
    /** Holds current value of chosen filter */
  private FileObjectFilter value;
    /** Serves both as model for combo box abd holds list of available common filters */
  private DefaultComboBoxModel model;
    /** Helper support for firing, listeners etc. */
  private PropertyChangeSupport support;
    /** current validity */
    private boolean isValid = true;

    /** return current validity */
    public boolean isValid() {
    	return isValid;
    }

    /** set current validity */
    private boolean checkValid() {
	boolean nowValid = true;
	if (regExpRadio.isSelected()) {
	    nowValid = REFilter.checkRegExp(regExpTextField.getText());
	}
	if (nowValid != isValid) {
	    isValid = nowValid;
	    support().firePropertyChange(ExPropertyEditor.PROP_VALUE_VALID,
					 !isValid, isValid);
	}
	return isValid;
    }

  private static java.util.ResourceBundle bundle = NbBundle.getBundle(JarPackagerModule.class);
  
    /** Helper operation, sets localized title of the border */
  private void localize () {
      // compression panel title
      setBorder (new javax.swing.border.CompoundBorder(
      new javax.swing.border.TitledBorder(
      new javax.swing.border.EtchedBorder(java.awt.Color.white, new java.awt.Color (134, 134, 134)),
      NbBundle.getBundle(FilterEditor.class).getString("CTL_FilterEditor")
      ),
      new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 8, 7, 8))));
      // group of radio buttons
      javax.swing.ButtonGroup bg = new javax.swing.ButtonGroup();
      bg.add(filterRadio);
      bg.add(regExpRadio);
  }
  
  
  public String getJavaInitializationString () {
      return null; // no code generation
  }
  
  public boolean supportsCustomEditor () {
      return true;
  }
  
  public java.awt.Component getCustomEditor() {
      return this;
  }
  
  public boolean isPaintable() {
      return false;
  }
  
  public void paintValue(java.awt.Graphics p1, java.awt.Rectangle p2) {
  }
  
  public String[] getTags() {
      // we don't support tags
      return null;
  }
  
  public void addPropertyChangeListener (PropertyChangeListener pchl) {
      support().addPropertyChangeListener(pchl);
  }
  
  public void removePropertyChangeListener(PropertyChangeListener pchl) {
      support().addPropertyChangeListener(pchl);
  }
  
  public void setValue (Object value) {
      doSetValue(value);
      updateGui(value);
  }
  
  public Object getValue() {
      return value;
  }
  
  public void setAsText (String text) throws IllegalArgumentException {
      // not supported
      throw new IllegalArgumentException();
  }
  
  public String getAsText() {
      // Ugly, but REFIlter.toString() not including any indication of 
      // negativity is entrenched
      if (value instanceof REFilter) {
	   return ((REFilter)value).getSummary();
      }
      else {
	  return value.toString();
      }
  }
  
    /** Adds new filter to the list of available filters.
     * @param filter filter to be added
     */
  public void addFilter (FileObjectFilter filter) {
      model.addElement(filter);
  }
  
    /** Removes specified filter from filter list
     * @param filter filter to be removed
     */
  public void removeFilter (FileObjectFilter filter) {
      model.removeElement(filter);
  }
  
    /** Actually performs the task of setting new value of this property.
     * Throws IllegalArgumentException if value cannot be accepted */
  void doSetValue (Object value) {
      // accept value only if it's one of filters in the model or
      // regular expression filter
      if ((model.getIndexOf(value) < 0) && !(value instanceof REFilter)) {
          throw new IllegalArgumentException (value.toString());
      }
      this.value = (FileObjectFilter)value;
      // notify listeners
      support().firePropertyChange("", null, null);
  }
  
    /** Safe getter for property change support with lazy initialization */
  private PropertyChangeSupport support () {
      if (support == null) {
          support = new PropertyChangeSupport(this);
      }
      return support;
  }
  
    /** Utility method, update enabled / disabled state of controls */
  void updateFilteringControlStates () {
      boolean regExpEnabled = regExpRadio.isSelected();
      regExpTextField.setEnabled(regExpEnabled);
      negativeCheckBox.setEnabled(regExpEnabled);
      filtersComboBox.setEnabled(filterRadio.isSelected() && (model.getSize() > 0));
  }
  
    /** Utility method, update property editor's value when user changed
     * state of some control. */
  void updateValue () {
      boolean regExpEnabled = regExpRadio.isSelected();
      FileObjectFilter newValue = null;
      if (regExpEnabled) {
          // try to construct filter from regular expression
          String pattern = regExpTextField.getText();
          try {
              newValue = new REFilter(pattern);
              ((REFilter)newValue).setNegative(negativeCheckBox.isSelected());
          } catch (RESyntaxException exc) {
              // ignore exception but don't set any value
              return;
          }
      } else {
          // get value from combo box
          newValue = (FileObjectFilter)model.getSelectedItem();
      }
      doSetValue(newValue);
  }
  
    /** Utility method, update gui of this custom property editor according
     * to given property value. */
  void updateGui (Object value) {
      boolean isRegExp = value instanceof REFilter;
      regExpRadio.setSelected(isRegExp);
      filterRadio.setSelected(!isRegExp);
      filtersComboBox.setEnabled(!isRegExp);
      regExpTextField.setEnabled(isRegExp);
      negativeCheckBox.setEnabled(isRegExp);
      if (isRegExp) {
          REFilter reFilter = (REFilter)value;
          regExpTextField.setText(reFilter.toString());
          negativeCheckBox.setSelected(reFilter.isNegative());
      } else {
          model.setSelectedItem(value);
      }
  }
  
  
}
