/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.jarpackager;

import java.awt.Image;
import java.beans.*;
import java.io.File;
import java.util.ResourceBundle;

import org.openide.execution.*;
import org.openide.explorer.propertysheet.editors.*;
import org.openide.util.NbBundle;

/** Object that provides beaninfo for {@link JarExecutor}.
*
* @author Mike Schilling
*/
public class JarExecutorBeanInfo extends SimpleBeanInfo {
    private static Image icon;
    private static Image icon32;


    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (ProcessExecutor.class) };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions")) // NOI18N
                ie.printStackTrace ();
            return null;
        }
    }

    /* Provides the Jar's icon */
    public Image getIcon(int type) {
        if (icon == null) {
            icon = loadImage("/org/netbeans/modules/jarpackager/resources/jarObject.gif"); // NOI18N
            icon32 = loadImage("/org/netbeans/modules/jarpackager/resources/jarObject32.gif"); // NOI18N
        }

        if ((type == java.beans.BeanInfo.ICON_COLOR_16x16) || (type == java.beans.BeanInfo.ICON_MONO_16x16))
            return icon;
        else
            return icon32;
    }
}
