/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.jarpackager;

import java.io.*;

/** No longer used, but exists to prevent serialization errors
*
* @author Dafe Simonek
*/
public final class PackagingView {

    protected Object writeReplace ()
    throws java.io.ObjectStreamException {
        return new Replacer();
    }

    private static final class Replacer implements java.io.Serializable {
        /** serial version UID */
        static final long serialVersionUID = 2230042447556712133L;

        private Object readResolve ()
        throws java.io.ObjectStreamException {
            return new PackagingView();
        }

	/** read the data of the version from given input */
	public void readData (ObjectInput in) 
		    throws IOException, ClassNotFoundException {
	  JarContent jc = new JarContent();            
	  jc.readContent(in);
	}              
  
	/** write the data of the version to given output */
	public void writeData (ObjectOutput out)
		    throws IOException {
	   (new JarContent()).writeContent(out);
	}

    } // end of inner Replacer inner class

}

/*
* <<Log>>
*  20   Jaga      1.18.1.0    4/14/00  David Simonek   first draft of major 
*       update (for forte guys)
*  19   Gandalf   1.18        1/26/00  David Simonek   Minor changes concerning 
*       correct action installation / removal
*  18   Gandalf   1.17        1/25/00  David Simonek   Various bugfixes and i18n
*  17   Gandalf   1.16        1/16/00  David Simonek   i18n
*  16   Gandalf   1.15        12/7/99  David Simonek   
*  15   Gandalf   1.14        11/11/99 David Simonek   add to jar action failure
*       repaired
*  14   Gandalf   1.13        11/10/99 David Simonek   testing code removed
*  13   Gandalf   1.12        11/6/99  David Simonek   L&F bugfixes
*  12   Gandalf   1.11        10/23/99 Ian Formanek    NO SEMANTIC CHANGE - Sun 
*       Microsystems copyright in file comment
*  11   Gandalf   1.10        9/16/99  David Simonek   a lot of bugfixes (RE 
*       filters, empty jar content etc)  added templates
*  10   Gandalf   1.9         9/8/99   David Simonek   new version of jar 
*       packager
*  9    Gandalf   1.8         8/19/99  Ian Formanek    Better UI (border around)
*  8    Gandalf   1.7         8/19/99  Ian Formanek    Proper texts 
*       capitalization
*  7    Gandalf   1.6         8/17/99  David Simonek   installations of actions,
*       icon changing
*  6    Gandalf   1.5         6/10/99  David Simonek   progress dialog now 
*       functional
*  5    Gandalf   1.4         6/9/99   David Simonek   bugfixes, progress 
*       dialog, compiling progress..
*  4    Gandalf   1.3         6/9/99   Ian Formanek    ---- Package Change To 
*       org.openide ----
*  3    Gandalf   1.2         6/8/99   David Simonek   
*  2    Gandalf   1.1         6/8/99   David Simonek   bugfixes....
*  1    Gandalf   1.0         6/3/99   David Simonek   
* $
*/
