/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.jarpackager.filesystem;

import org.openide.util.actions.*;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.nodes.Node;
import org.openide.loaders.DataFolder;
import org.openide.filesystems.FileSystem;
import org.openide.TopManager;

/**
 * This action updates the content of the jar file
 * accociated with the WritableJarFileSystem.
 * @author  dstrupl
 */
public class UpdateWritableJarFileSystemAction extends NodeAction {

    public void performAction() {
    }
    
    public void performAction(Node[] nodes) {
    }
    
    public void actionPerformed (java.awt.event.ActionEvent ev) {
        Node[] nodes = getActivatedNodes ();
        Node n = nodes[0];
        DataFolder dfo = (DataFolder)n.getCookie(DataFolder.class);
        if (dfo != null) {
            FileSystem fs = null;
            try {
                fs = dfo.getPrimaryFile().getFileSystem();
            } catch (java.io.IOException x) {
                  TopManager.getDefault().notifyException(x);
            }
            if (fs instanceof WriteableJarFileSystem) {
                WriteableJarFileSystem wjfs = (WriteableJarFileSystem)fs;
                wjfs.updateJarFileContent();
            }
        }
    }
    
    /* Human presentable name of the action. This should be
     * presented as an item in a menu.
     * @return the name of the action
     */
    public String getName() {
        return NbBundle.getBundle(UpdateWritableJarFileSystemAction.class).
               getString("CTL_UpdateJarAction");
    }

    /** 
     */
    protected boolean enable (Node[] activatedNodes) {
        // TODO: correct this
        return true;
    }

    /* Help context where to find more about the action.
    * @return the help context for this action
    */
    public HelpCtx getHelpCtx() {
        return new HelpCtx (UpdateWritableJarFileSystemAction.class); //PENDING
    }

    /** The action's icon location.
    * @return the action's icon location
    */
    protected String iconResource () {
        return "/org/netbeans/modules/jarpackager/resources/updateJar.gif"; // NOI18N
    }

}