/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.jarpackager.options;

import org.openide.options.*;
import org.openide.util.*;

public class JarOption extends ContextSystemOption {

    /** serial version UID */
    static final long serialVersionUID = 2216855924823089903L;	


    /** Singleton instance */
    private static JarOption singletonInstance;

    /** Creates new JarOption */
    public JarOption() {
    	// Add our child. Other modules with jar packaging options can
	// add other children
    	singleton().addOption((SystemOption)JarPackagerOption.singleton());
    }

    /** Returns default instance of jar system option */
    public static JarOption singleton () {
	if (singletonInstance == null) {
	    singletonInstance = (JarOption) SharedClassObject.findObject (JarOption.class, true);
	}
	return singletonInstance;
    }
	
    /** Get a human presentable name of the action.
    * This may be presented as an item in a menu.
    * @return the name of the option
    */
    public String displayName () {
        return NbBundle.getBundle(JarOption.class).
               getString("CTL_RootOptionParent");
    }   

    public HelpCtx getHelpCtx () {
        return new HelpCtx (JarOption.class);
    }
	
}
