package org.netbeans.modules.jarpackager;

import java.util.*;
import java.io.*;
import org.openide.loaders.*;
import org.openide.filesystems.*;
import org.netbeans.modules.jarpackager.api.*;
/**
* Simple example of archive builder and controller
* removes all files whose names contain the string "CVS"
*/

public class Controller1 implements ArchiveBuilder {
	
    /** return controller */
    public ArchiveController initController(java.io.File target, Map options) {
    	return new TheController();
    }

    static class TheController implements ArchiveController {

	/** Remove any entry which contains "CVS" */
	public void processMemberSet(ArchiveMemberSet set) {
	    ArchiveMember all[] = set.allMembers();
	    for (int i = 0; i < all.length; i++) {
		String name =  
		    all[i].getDataObject().getPrimaryFile().getPackageName('/');
		if (name.indexOf("CVS") >= 0) {
		    set.removeMember(all[i].getDataObject());
		}
	    }
	}

	/** Add a member that indicates we were here */
	public ArchiveEntry[] addEntry() {
	    ArchiveEntry sae = 
		new StringArchiveEntry("/fake/controller1", "Kilroy1 was here\n");
	    return new ArchiveEntry[]{sae};
	}

	/** No postprocessing */
	public int willPostprocess(ArchiveEntry entry) {
	    return ArchiveController.WILL_NOT_POSTPROCESS;
	}

	/** No postprocessing */
	public InputStream postProcess(ArchiveEntry entry, InputStream input) {

	    // should never be called, but just in case
	    return input;
	}
    }
}

