/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.api.java.comparators;

import java.util.Comparator;

/**
 *
 * @author  thurka
 * @version 
 */
class ArrayComparator extends Object implements Comparator {

    private Comparator comparators[];
    
    /** Creates new ArrayComparator */
    protected ArrayComparator(Comparator compArray[]) {
        comparators=compArray;
    }

    public int compare(Object o1, Object o2) {
        int i;
        
        for (i=0;i<comparators.length;i++) {
            int result=comparators[i].compare(o1,o2);
            
            if (result!=0)
                return result;
        }
        return 0;
    }

    public boolean equals(Object ob) {
        return getClass().isInstance(ob) && comparators.equals(((ArrayComparator)ob).getComparators());
    }
    
    public Comparator[] getComparators() {
        return comparators;
    }
}
