/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.api.java.comparators;

import org.openide.src.ClassElement;
import java.util.Comparator;

class ClassComparator extends MemberNameComparator {

    protected ClassComparator(int type) {
        super(type);
    }    

    public int compare(Object o1, Object o2) {
        boolean o1Class,o2Class;
        ClassElement ce1=(ClassElement)o1;
        ClassElement ce2=(ClassElement)o2;
        int result;
        
        if ((type&NAME)!=0) {
            result=super.compare(ce1,ce2);
            if (result!=0) return result;
        }
        if ((type&ISCLASS)!=0) {
            o2Class=ce1.isClassOrInterface();
            o1Class=ce2.isClassOrInterface();
            return (o1Class?1:0)-(o2Class?1:0);
        }
        return 0;
    }
    
    static Comparator createComparator(int type) {
        return new ClassComparator(type);
    }
    
}

