/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.api.java.comparators;

import org.openide.src.FieldElement;
import java.util.Comparator;

class FieldComparator extends MemberNameComparator {
    private Comparator typeComparator;    
    
    protected FieldComparator(int type) {
        super(type);
        if ((type&TYPE)!=0) {
            typeComparator=TypeComparator.createComparator(type&SOURCE);
        }  
    }

    public int compare(Object o1, Object o2) {
        FieldElement fe1=(FieldElement)o1;
        FieldElement fe2=(FieldElement)o2;
        int result;

        if ((type&NAME)!=0) {
            result = super.compare(fe1, fe2);
            if (result!=0) return result;
        }
        if (typeComparator!=null) {
            result = typeComparator.compare(fe1, fe2);
            if (result!=0) return result;
        }
        if ((type&MODIFIERS)!=0) {
            result = fe1.getModifiersMask()-fe2.getModifiersMask();

            if (result<0) return -1;
            if (result==0) return 0;
            return 1;
        }
        return 0;
    }     
    
    static Comparator createComparator(int type) {
        return new FieldComparator(type);
    }
    
}

