/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.api.java.comparators;

import org.openide.src.Identifier;
import java.util.Comparator;

class IdentifierComparator extends JavaElementComparator {

    protected IdentifierComparator(int type) {
        super(type);
    }    

    public int compare(Object o1, Object o2) {
        int result;
        Identifier id1=(Identifier)o1;
        Identifier id2=(Identifier)o2;

        result=id1.getFullName().compareTo(id2.getFullName());
        if (result!=0)
            return result;
        if ((type&SOURCE)!=0)
            return id1.getSourceName().compareTo(id2.getSourceName());
        return 0;
    }     
    
    static Comparator createComparator(int type) {
        return new IdentifierComparator(type);
    }
    
}

