/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.api.java.comparators;

import org.openide.src.MethodParameter;
import java.util.Comparator;

class MParameterComparator extends JavaElementComparator {
    private Comparator typeComparator;    
    
    protected MParameterComparator(int type) {
        super(type);
        if ((type&TYPE)!=0) {
            typeComparator=TypeComparator.createComparator(type&SOURCE);
        }  
    }

    public int compare(Object o1, Object o2) {
        MethodParameter mp1=(MethodParameter)o1;
        MethodParameter mp2=(MethodParameter)o2;
        int result;

        if (typeComparator!=null) {
            result = typeComparator.compare(mp1.getType(),mp2.getType());
            if (result!=0) return result;
        }
        if ((this.type&NAME)!=0) {
            result=mp1.getName().compareTo(mp2.getName());
            if (result!=0) return result;
        }
        if ((this.type&MODIFIERS)!=0) {
            return (mp1.isFinal()?1:0)-(mp2.isFinal()?1:0);
        }
        return 0;
    }     
    
    static Comparator createComparator(int type) {
        return new MParameterComparator(type);
    }
    
}

