/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.api.java.comparators;

import org.openide.src.MemberElement;
import java.util.Comparator;

abstract class MemberNameComparator extends JavaElementComparator {

    private Comparator idComparator;    
    
    protected MemberNameComparator(int type) {
        super(type);
        idComparator=new IdentifierComparator(type&SOURCE);
    }

    public int compare(Object o1, Object o2) {
        MemberElement me1=(MemberElement)o1;
        MemberElement me2=(MemberElement)o2;
        return idComparator.compare(me1.getName(),me2.getName());
    }      
}

