/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.api.java.comparators;

import org.openide.src.MethodElement;
import java.util.Comparator;

class MethodComparator extends ConstructorComparator {

    private Comparator retTypeComparator;    
    
    protected MethodComparator(int type) {
        super(type);
        if ((type&RETURN_TYPE)!=0)
            retTypeComparator=TypeComparator.createComparator(type&SOURCE);
    }

    public int compare(Object o1, Object o2) {
        boolean o1Class,o2Class;
        MethodElement me1=(MethodElement)o1;
        MethodElement me2=(MethodElement)o2;

        if ((type&(NAME|PARAMETERS|EXCEPTIONS))!=0) {
            int result = super.compare(me1, me2);
            if (result!=0)
                return result;
        }
        if (retTypeComparator!=null)
            return retTypeComparator.compare(me1.getReturn(),me2.getReturn()); 
        return 0;
    }      
    
    static Comparator createComparator(int type) {
        return new MethodComparator(type);
    }
    
}

