/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java;

import java.awt.Image;
import java.beans.*;

import org.openide.*;
import org.openide.execution.ProcessExecutor;

/** Trivial description of JavaProcessExecutor.
 * @author Jesse Glick
 */
public final class JavaProcessExecutorBeanInfo extends SimpleBeanInfo {

    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (ProcessExecutor.class) };
        } catch (IntrospectionException ie) {
            TopManager.getDefault ().getErrorManager ().notify (ErrorManager.WARNING, ie);
            return null;
        }
    }

    public BeanDescriptor getBeanDescriptor () {
        BeanDescriptor desc = new BeanDescriptor (JavaProcessExecutor.class);
        BeanInfo[] supebi = getAdditionalBeanInfo ();
        if (supebi != null) {
            BeanDescriptor supe = supebi[0].getBeanDescriptor ();
            desc.setName (supe.getName ());
            desc.setDisplayName (supe.getDisplayName ());
            desc.setShortDescription (supe.getShortDescription ());
        }
        return desc;
    }

    public Image getIcon (int type) {
        BeanInfo[] supebi = getAdditionalBeanInfo ();
        if (supebi != null) {
            return supebi[0].getIcon (type);
        } else {
            return null;
        }        
    }

}
