/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.codegen;

import org.openide.src.*;

import org.netbeans.modules.java.model.Binding;

/**
 *
 * @author  sdedic
 * @version 
 */
class Member extends ElementBinding implements Binding.Member {
    /** Creates new Member */
    public Member(MemberElement me, SourceText s) {
        super(me, s);
    }
    
    protected Element cloneElement() {
        try {
            return (MemberElement)((MemberElement)getElement()).clone();
        } catch (CloneNotSupportedException ex) {
            throw new InternalError("Cannot clone element.");
        }
    }

    /**
     * Requests change of member's modifiers.
     */
    public void changeModifiers(int newMods) throws SourceException {
        if (!source.isGeneratorEnabled())
            return;
        
        MemberElement el = (MemberElement)cloneElement();
        el.setModifiers(newMods);
        regenerateHeader(el);
    }
    
    /**
     * Requests a change of member's name.
     */
    public void changeName(Identifier name) throws SourceException {
        if (!source.isGeneratorEnabled())
            return;
        
        MemberElement el = (MemberElement)cloneElement();
        el.setName(name);
        regenerateHeader(el);
    }
    
    /**
     * Updates the storage binding object from an external SourceText.
     */
    public void updateFrom(Binding other) {
    }
}
