/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.environment;

import java.beans.*;

import org.openide.util.Utilities;

/**
 *
 * @author  sdedic
 * @version 
 */
public class LibraryArchiveBeanInfo extends SimpleBeanInfo {
    
    private static final String LIBRARY_ICON = "/org/netbeans/modules/java/resources/library.gif";
    
    public java.awt.Image getIcon(int param) {
        return Utilities.loadImage(LIBRARY_ICON);
    }
    
    public java.beans.BeanInfo[] getAdditionalBeanInfo() {
        try {
            return new BeanInfo[] {
                Introspector.getBeanInfo(org.openide.filesystems.JarFileSystem.class)
            };
        } catch (IntrospectionException ie) {
            return null;
        }
    }
    
    public java.beans.BeanDescriptor getBeanDescriptor() {
        BeanDescriptor bd = new BeanDescriptor(LibraryArchive.class);
        //bd.setValue("global", Boolean.TRUE);
        bd.setValue("transient", Boolean.TRUE);
	bd.setValue("global", Boolean.TRUE);
        return bd;
    }
}
