/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * AbstractProp.java
 *
 * Created on March 2, 2001, 12:01 PM
 */

package org.netbeans.modules.java.imptool;

import org.openide.nodes.PropertySupport;

/**
 *
 * @author  thurka
 * @version 
 */

    /** Property support for nodes properties.
    */
abstract class AbstractProp extends PropertySupport {

    AbstractProp(String name,Class type,boolean canWrite) {
        super(name,type,Util.getString("PROP_"+name),Util.getString("HINT_"+name),true,canWrite); // NOI18N
    }

   /* Setter for the value.
    * @param val the value of the property
    * @exception IllegalAccessException cannot access the called method
    * @exception IllegalArgumentException wrong argument
    * @exception InvocationTargetException an exception during invocation
    */
    public void setValue (Object val) throws
        IllegalAccessException {
        throw new IllegalAccessException("Cannot write to ReadOnly property"); // NOI18N
    }
}
