/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * ImpDataSourceNode.java
 *
 * Created on February 27, 2001, 11:02 AM
 */

package org.netbeans.modules.java.imptool;

import org.openide.nodes.AbstractNode;
import org.openide.nodes.Children;
/**
 *
 * @author  thurka
 * @version 
 */
public class ImpDataSourceNode extends AbstractNode {

    private ImpDataSource dataSource;
    static final int CLASS_NODE=0;
    static final int PACKAGE_NODE=1;
    static final int RESOLVE_NODE=2;
    
    /** Creates new ImpDataSourceNode */
    public ImpDataSourceNode(ImpDataSource ds,Children ch,int classNode) {
        super(ch);
        dataSource=ds;
        switch (classNode) {
            case CLASS_NODE:
                setDisplayName(Util.getString("PROP_CLASS_NAME"));    // NOI18N
                setName("Class");    // NOI18N
                break;
            case PACKAGE_NODE:
                setDisplayName(Util.getString("PROP_PACKAGE_NAME"));  // NOI18N
                setName("Package");    // NOI18N
                break;
            case RESOLVE_NODE:
                setDisplayName(Util.getString("PROP_RESOLVE_NAME"));   // NOI18N
                setName("Resolve");    // NOI18N
                break;
        }
        setIconBase("/org/netbeans/modules/java/resources/impDataSource");
    }

    /** Getter for property dataSource.
     * @return Value of property dataSource.
     */
    ImpDataSource getDataSource() {
        return dataSource;
    }
    
    
}
