/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.model;

import org.openide.src.*;

/**
 *
 * @author  sdedic
 * @version 
 */
class ConstructorCollection extends PartialCollection {
    static final ConstructorElement[] EMPTY = new ConstructorElement[0];
    
    public ConstructorCollection(ElementEvents events,ElementCreator creator,MemberCollection allMembers) {
        super(events, creator, allMembers, ElementProperties.PROP_CONSTRUCTORS);
    }

    public Class getElementImplClass() {
        return ConstructorElementImpl.class;
    }

    public ElementImpl createElement(Element parent) {
        ConstructorElementImpl cimpl = creator.createConstructor((ClassElement)parent);
        return cimpl;
    }

    protected Object[] createEmpty() {
        return EMPTY;
    }

    protected Element[] createEmpty(int size) {
        return new ConstructorElement[size];
    }
    
    public ConstructorElement getConstructor(Type[] argtypes) {
        ConstructorElement[] elems = (ConstructorElement[])getElements();

        cons:
        for (int i = 0; i < elems.length; i++) {
            ConstructorElement el = elems[i];
            MethodParameter[] params = el.getParameters();
            if (params.length != argtypes.length)
                continue;
            
            for (int j = 0; j < params.length; j++) {
                if (!params[j].getType().equals(argtypes[j]))
                    continue cons;
            }
            
            return el;
        }
        return null;
    }
}
