/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.model;

import org.openide.src.*;

/**
 *
 * @author  svata
 * @version 
 */
public interface ElementCreator {
    public FieldElementImpl         createField(ClassElement parent);
    public MethodElementImpl        createMethod(ClassElement parent);
    public ConstructorElementImpl   createConstructor(ClassElement parent);
    public InitializerElementImpl   createInitializer(ClassElement parent);
    public ClassElementImpl         createInnerClass(ClassElement parent);
    public ClassElementImpl         createTopClass(SourceElement parent);
    public ImportImpl               createImport(SourceElement parent);
    public SourceElementImpl        createSource();
    public WrapperFactory           getWrapper();

    // Identifier management
    public Identifier createLocalIdentifier(Element context,
        String full, String src, int status);
    public Identifier createLocalIdentifier(Element context,
        Identifier original, int status);
    public boolean isSameContext(Element context, Identifier id);
}
