/*
 * IdentContextSupport.java
 *
 * Created on January 29, 2001, 3:43 PM
 */

package org.netbeans.modules.java.model;

import java.util.*;
import java.lang.ref.*;

import org.openide.src.Identifier;

/**
 *
 * @author  sdedic
 * @version 
 */
class IdentContextSupport extends Object {
    Map     identifierSet;
    
    public IdentContextSupport(int capacity) {
        identifierSet = new HashMap(capacity * 4 / 3);
    }
    
    public Identifier create(Identifier id, int status) {
        Reference refV = (Reference)identifierSet.get(id.getSourceName());
        if (refV != null) {
            Identifier oldID = (Identifier)refV.get();
            if (oldID != null) {
                if (oldID.getResolutionStatus() == status && 
                    oldID.getFullName() == id.getFullName())
                    // exactly the same identifier with a matching status.
                    return oldID;
            }
        }
        if (id.getResolutionStatus() != status) {
            id = Identifier.create(id.getFullName(), id.getSourceName(), status);
        }
        identifierSet.put(id.getSourceName(), new WeakReference(id));
        return id;
    }
    
    public boolean checkContext(Identifier id) {
        Reference refV = (Reference)identifierSet.get(id);
        if (refV == null)
            return false;
        Identifier x = (Identifier)refV.get();
        return x == id;
    }
}
