/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.model;

import org.openide.src.*;

/**
 *
 * @author  sdedic
 * @version 
 */
public class ImportElement extends Element {
    SourceElement   source;
    
    public ImportElement(ImportElement.Impl impl, SourceElement source) {
        super(impl);
        this.source = source;
    }
    
    public SourceElement getSource() {
        return source;
    }
    
    public Import getImport() {
        return ((ImportElement.Impl)impl).getImport();
    }
    
    public void setImport(Import im) throws SourceException {
        ((ImportElement.Impl)impl).setImport(im);
    }
    
    /** Print this element (and all its subelements) into an element printer.
     * @param printer the element printer
     * @exception ElementPrinterInterruptException if the printer canceled the printing
     */
    public void print(ElementPrinter printer) throws ElementPrinterInterruptException {
        Impl i = (Impl)super.impl;
        printer.print(i.getImport().toString());
        printer.print(";"); // NOI18N
    }
    
    public interface Impl extends Element.Impl {
        public Import   getImport();
        public void     setImport(Import imp) throws SourceException;
    }
}
