/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.model;

import org.openide.src.*;

/**
 *
 * @author  sdedic
 * @version 
 */
public class InitializerCollection extends PartialCollection {
    static final InitializerElement[] EMPTY = new InitializerElement[0];
    
    public InitializerCollection(ElementEvents events, ElementCreator creator, 
            MemberCollection allMembers) {
        super(events, creator, allMembers, ElementProperties.PROP_INITIALIZERS);
    }

    public Class getElementImplClass() {
        return InitializerElementImpl.class;
    }

    public ElementImpl createElement(Element parent) {
        InitializerElementImpl iimpl = creator.createInitializer((ClassElement)parent);
        return iimpl;
    }

    protected Object[] createEmpty() {
        return EMPTY;
    }

    protected Element[] createEmpty(int size) {
        return new InitializerElement[size];
    }
    
}
