/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.model;

import java.beans.PropertyChangeEvent;
import java.util.ResourceBundle;

import org.openide.src.SourceException;
import org.openide.util.NbBundle;

import org.openide.TopManager;
import org.openide.ErrorManager;

/**
 *
 * @author  sdedic
 * @version 
 */
class Util extends Object {
    /** ResourceBundle for java-loader package. */
    static ResourceBundle bundle;

    /** Computes the localized string for the key.
    * @param key The key of the string.
    * @return the localized string.
    */
    static String getString(String key) {
        if (bundle == null)
            bundle = NbBundle.getBundle(Util.class);
        return bundle.getString(key);
    }

    static void throwException(String desc, String bundleKey) throws SourceException {
	throw (SourceException)org.openide.TopManager.getDefault().getErrorManager().annotate(
	    new SourceException(desc),
	    getString(bundleKey)
	);
    }
    
    static PropertyChangeEvent computePropretyDiffs(Object[] oldValues, Object[] newValues) {
        if (newValues.length == oldValues.length)
            // array lengths match, there's a change or a reorder.
            return null;
            //return computeChange(oldValues, newValues);
        return null;
    }
    
    /*
    static org.openide.ErrorManager getErrorManager() {
        return org.openide.TopManager.getDefault().getErrorManager().getInstance("org.netbeans.modules.java.model");
    }
     */
    
    static ErrorManager em;
    
    static void log(String msg) {
        if (em == null) {
            synchronized (Util.class) {
                if (em == null)
                    em = TopManager.getDefault().getErrorManager().getInstance("org.netbeans.modules.java.model");
            }
        }
        em.log(msg);
    }
}
