/*
 * DefaultModelSupport.java
 *
 * Created on January 25, 2001, 9:25 AM
 */

package org.netbeans.modules.java.parser;

import org.openide.src.*;

import org.netbeans.modules.java.model.Binding;
import org.netbeans.modules.java.model.WrapperFactory;
import org.netbeans.modules.java.model.BindingFactory;
import org.netbeans.modules.java.model.ImportElement;

/**
 *
 * @author  sdedic
 * @version 
 */
public class DefaultWrapper implements WrapperFactory {
    private static WrapperFactory instance;
    
    public synchronized static WrapperFactory getInstance() {
        if (instance != null)
            return instance;
        return instance = new DefaultWrapper();
    }

    /* ----------------- wrapper factory methods --------------------- */
    public FieldElement wrapField(FieldElement.Impl theImpl, Element parent) {
        return new FieldElement(theImpl, (ClassElement)parent);
    }
    
    public ClassElement wrapClass(ClassElement.Impl theImpl, Element parent) {
        if (parent instanceof SourceElement) {
            return new ClassElement(theImpl, (SourceElement)parent);
        } else {
            return new ClassElement(theImpl, (ClassElement)parent);
        }
    }
    
    public MethodElement wrapMethod(MethodElement.Impl theImpl, Element parent) {
        return new MethodElement(theImpl, (ClassElement)parent);
    }
    
    public ConstructorElement wrapConstructor(ConstructorElement.Impl theImpl, Element parent) {
        return new ConstructorElement(theImpl, (ClassElement)parent);
    }
    
    public InitializerElement wrapInitializer(InitializerElement.Impl theImpl, Element parent) {
        return new InitializerElement(theImpl, (ClassElement)parent);
    }
    
    public ImportElement wrapImport(ImportElement.Impl theImpl, Element parent) {
        return new ImportElement(theImpl, (SourceElement)parent);
    }
}
