/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.parser;

import org.openide.src.*;
import org.openide.text.*;

import org.netbeans.modules.java.model.LangModel;
import org.netbeans.modules.java.model.ElementImpl;

import org.netbeans.modules.java.codegen.DocumentBinding;
import org.netbeans.modules.java.codegen.TextBinding;

/**
 *
 * @author  svata
 * @version 
 */
public class FieldInfo extends BaseElementInfo {
    Type            type;
    String          initValue;
    FieldInfo       nextField;
    
    PositionBounds  typeBounds;

    public FieldInfo(String name, int modifiers) {
        super(name, modifiers);
    }
    
    protected Element createModelImpl(LangModel.Updater model, Element parent) {
        return ((ElementImpl)model.createField((ClassElement)parent)).getElement();
    }
    
    public void updateBinding(DocumentBinding doc, TextBinding target) {
        super.updateBinding(doc, target);

        target.updateBounds(target.BOUNDS_FIELD_TYPE, typeBounds);
        
        if (nextField != null) {
            target.linkAfter(nextField.binding);
        } else {
            target.linkAfter(null);
        }
    }
    
    public void updateElement(LangModel.Updater model, Element target) 
    throws SourceException {
        super.updateElement(model, target);
        super.updateBase(target);
        
        FieldElement f = (FieldElement)target;
        f.setType(type);
        f.setInitValue(initValue);
        updateJavaDoc(f.getJavaDoc());
        // PENDING: update binding with field link information.
    }
}
