/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.parser;

import org.openide.src.*;

import org.netbeans.modules.java.model.LangModel;
import org.netbeans.modules.java.model.ElementImpl;

/**
 *
 * @author  svata
 * @version 
 */
public class InitializerInfo extends BaseElementInfo {
    public InitializerInfo(int modifiers) {
        super(null, modifiers);
    }
    
    protected Element createModelImpl(LangModel.Updater m, Element parent) {
        return ((ElementImpl)m.createInitializer((ClassElement)parent)).getElement();
    }
    
    public void updateElement(LangModel.Updater m, Element target) throws SourceException {
        super.updateElement(m, target);
        InitializerElement i = (InitializerElement)target;
        i.setStatic(modifiers > 0);
        m.updateBody(i, bodyContent);
    }
}
