/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * ProcessorObjectRequest.java
 *
 * Created on March 20, 2001, 1:40 PM
 */

package org.netbeans.modules.java.parser;

import org.openide.text.CloneableEditorSupport;
import org.netbeans.modules.java.parser.JavaParser;

/**
 *
 * @author  thurka
 * @version 
 */
public interface ProcessorObjectRequest {

    /** Notifies the request object that the engine has resheduled this request.
     * Internal request data should be cleared.
    */
    public void notifyReschedule();
    
    /**
     * Notifies the request that the source text has been changed. This causes
     * cancellation of the request in some cases.
    */
    public void sourceChanged();

    /**
     * Notifies the request that the model has been changed. This causes
     * cancellation of the request in some cases.
    */
    public void modelChanged();
    
    /**
     *
    */
    public DocumentModelUpdater getUpdater();     

    public void setEnvironment(JavaParser.Env env);
    
    public void setEditorSupport(CloneableEditorSupport editor);
}

