/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.parser;

import java.util.*;

import org.openide.src.*;

import org.netbeans.modules.java.model.ElementImpl;
import org.netbeans.modules.java.codegen.TextBinding;

/**
 *
 * @author  svata
 * @version 
 */
public class TextPositionMatch implements ElementMatch.Finder {
    public void findMatches(ElementMatch data) {
        int oldPos = 0;
        Element[] elements = data.getOldElements();
        
        for (; data.hasMoreElements(); ) {
            TextBinding found = null;
            BaseElementInfo info = data.nextElement();
            
            while (oldPos < elements.length) {
                TextBinding b;
                int beginPos, endPos;
                int relativePos;

                ElementImpl impl = (ElementImpl)elements[oldPos].getCookie(ElementImpl.class);
                b = (TextBinding)impl.getBinding();
                relativePos = info.comparePositionTo(b);
                if (relativePos == 0) {
                    found = b;
                    break;
                } else if (relativePos > 0) {
                    oldPos++;
                } else if (relativePos < 0) {
                    break;
                }
            }
            
            if (found != null) {
                data.matchElement(oldPos++);
            }
        }
    }
}
