/*
 * JEditorToolbar.java
 *
 * Created on March 9, 2001, 7:22 PM
 */

package org.netbeans.modules.java.ui;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JToolBar;

import org.openide.loaders.DataFolder;
import org.openide.loaders.DataObject;
import org.openide.loaders.DataObjectNotFoundException;
import org.openide.loaders.FolderInstance;
import org.openide.filesystems.FileObject;
import org.openide.util.actions.CallableSystemAction;
import org.openide.TopManager;

import org.netbeans.modules.java.ui.actions.NavigateAction;

/**
 *
 * @author  sdedic
 * @version 
 */
public class JEditorToolbar /* extends FolderInstance */ {
    JToolBar        toolBar;

    JEditorToolbar(DataFolder f) {
        toolBar = new javax.swing.JToolBar();
        toolBar.setFloatable(false);
        toolBar.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 5, 0));
        initComponents();
    }
    
    private void initComponents() {
        CallableSystemAction ac = (CallableSystemAction)CallableSystemAction.findObject(NavigateAction.class, true);

        toolBar.add(ac.getToolbarPresenter());
    }
    
    public static JToolBar createToolBar(String folderName) {
        FileObject f = TopManager.getDefault().getRepository().getDefaultFileSystem().
            findResource(folderName);
        if (f == null) {
            return null;
        }
        DataObject d;
        
        try {
            d = DataObject.find(f);
        } catch (DataObjectNotFoundException ex) {
            return null;
        }
        DataFolder contentFolder = (DataFolder)d.getCookie(DataFolder.class);
        if (contentFolder == null) {
            System.err.println("the target is not a folder");
            return null;
        }
        
        JEditorToolbar tb = new JEditorToolbar(contentFolder);
        return tb.getToolBar();
    }
    
    public JToolBar getToolBar() {
        return toolBar;
    }

    /*
    protected Object createInstance(InstanceCookie[] cookies) {
    }
    
    public Class instanceClass() {
        return getToolBar().getClass();
    }
    
    public InstanceCookie acceptDataObject(DataObject d) {
        InstanceCookie ic = super.
    }
    */
}
