/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.ui.actions;

import org.openide.util.actions.CookieAction;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.nodes.Node;
import org.openide.src.SourceException;

import org.netbeans.modules.java.codesync.SynchronizeCodeCookie;

public class SynchronizeAction extends CookieAction {
    private static final String ICON_RESOURCE =
        "/org/netbeans/modules/java/resources/synchronize.gif"; // NOI18N
    
    /** generated Serialized Version UID */
    static final long serialVersionUID = 287995853453453479L;

    /** Creates and starts a thread for generating documentation
    */
    protected void performAction(Node[] activatedNodes) {
        for (int i = 0; i < activatedNodes.length; i++) {
            SynchronizeCodeCookie ck = (SynchronizeCodeCookie)activatedNodes[i].
                getCookie(SynchronizeCodeCookie.class);
            if (ck != null) {
                try {
                    ck.synchronize();
                } catch (SourceException ex) {
                }
            }
        }
    }

    protected final Class[] cookieClasses () {
        return new Class[] { SynchronizeCodeCookie.class };
    }

    protected int mode () {
        return MODE_ALL;
    }

    public HelpCtx getHelpCtx() {
        return new HelpCtx (SynchronizeAction.class);
    }

    public String getName() {
        return NavigateAction.getString("LAB_SynchronizeAction");
    }
    
    public String iconResource() {
        return ICON_RESOURCE;
    }
    
}
