/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.ui.wizard;

import java.lang.reflect.Modifier;
import java.awt.Component;

/**
 *
 * @author  jrojcek
 */
public class FieldTypePanel extends javax.swing.JPanel
                            implements ModifierEditor.ModifierPanel {


    /** Creates new form FieldModifiersPanel */
    public FieldTypePanel() {
        initComponents();
        setBorder(new javax.swing.border.TitledBorder(
            new javax.swing.border.EtchedBorder(), 
            org.openide.util.NbBundle.getBundle(FieldTypePanel.class).getString("LBL_FieldType")));
    }

    public void setTypeModifier(int mod) {
        finalCheckBox.setSelected(Modifier.isFinal(mod));
        transientCheckBox.setSelected(Modifier.isTransient(mod));
        staticCheckBox.setSelected(Modifier.isStatic(mod));
        volatileCheckBox.setSelected(Modifier.isVolatile(mod));

        finalCheckBox.setMnemonic('i');
        transientCheckBox.setMnemonic('r');
        staticCheckBox.setMnemonic('t');
        volatileCheckBox.setMnemonic('o');
    }    

    public int getTypeModifier() {
        int mod = 0;
        if (finalCheckBox.isSelected()) mod |= Modifier.FINAL;
        if (transientCheckBox.isSelected()) mod |= Modifier.TRANSIENT;
        if (staticCheckBox.isSelected()) mod |= Modifier.STATIC;
        if (volatileCheckBox.isSelected()) mod |= Modifier.VOLATILE;
        return mod;
    }
    
    public int getMask() {
        return Modifier.FINAL | Modifier.STATIC
               | Modifier.TRANSIENT | Modifier.VOLATILE;
    }
    
    public Component getComponent() {
        return this;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        finalCheckBox = new javax.swing.JCheckBox();
        transientCheckBox = new javax.swing.JCheckBox();
        staticCheckBox = new javax.swing.JCheckBox();
        volatileCheckBox = new javax.swing.JCheckBox();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        setBorder(new javax.swing.border.TitledBorder("Field Type"));
        
        finalCheckBox.setText("final");
        finalCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkBoxActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 0, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(finalCheckBox, gridBagConstraints1);
        
        
        transientCheckBox.setText("transient");
        transientCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkBoxActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(transientCheckBox, gridBagConstraints1);
        
        
        staticCheckBox.setText("static");
        staticCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkBoxActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(6, 0, 0, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(staticCheckBox, gridBagConstraints1);
        
        
        volatileCheckBox.setText("volatile");
        volatileCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkBoxActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(volatileCheckBox, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void checkBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkBoxActionPerformed
        firePropertyChange(PROP_TYPE_MODIFIER, null, null);
    }//GEN-LAST:event_checkBoxActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox finalCheckBox;
    private javax.swing.JCheckBox transientCheckBox;
    private javax.swing.JCheckBox staticCheckBox;
    private javax.swing.JCheckBox volatileCheckBox;
    // End of variables declaration//GEN-END:variables

}
