/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.wizard;

import java.io.IOException;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyVetoException;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JButton;

import org.openide.nodes.Index;
import org.openide.nodes.Node;
import org.openide.nodes.Children;
import org.openide.explorer.view.ListView;
import org.openide.explorer.ExplorerManager;
import org.openide.explorer.ExplorerPanel;
import org.openide.util.Mutex;

/**
 * This class serves as a panel with up, down add and remove buttons that can
 * be used for manipulating various nodes.
 * @deprecated This class is obsolete and should not be used any more. Implementation
 * suitable to Java NFT Wizard has been moved to package ui.wizard.
 * The class will be removed before final release of NetBeans 3.2
 */
public class IndexableExplorerList extends javax.swing.JPanel {
    private ListView view;
    private ExplorerManager manager;
    private Index indexableParent;
    private PropertyChangeListener managerListener;
    
    private static final Node[] EMPTY_SELECTION = new Node[0];

    /** Creates new form NodeListPanel */
    public IndexableExplorerList() {
        initComponents ();
        view = new ListView();
        view.setDragSource(false);
        view.setDropTarget(false);
        view.setPopupAllowed(false);
        expHolder.add(view, BorderLayout.CENTER);

        if (!reorderEnabled()) {
            //remove(reorderPanel);
            remove(upButton);
            remove(downButton);
            
            buttonWidth = Math.max(addButton.getPreferredSize().width,
                Math.max(removeButton.getPreferredSize().width,
                Math.max(upButton.getPreferredSize().width, downButton.getPreferredSize().width)
                ));
        }
    }

    public ExplorerManager getExplorerManager() {
        if (manager != null) {
            return manager;
        }
        return ExplorerManager.find(view);
    }
    
    public void addNotify() {
        managerListener = new java.beans.PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent evt) {
                if (ExplorerManager.PROP_SELECTED_NODES.equals(evt.getPropertyName())) {
                    updateButtons();
                }
                if (ExplorerManager.PROP_EXPLORED_CONTEXT.equals(evt.getPropertyName())) {
                    indexableParent = (Index)((Node)evt.getNewValue()).getCookie(Index.class);
                    updateButtons();
                }
            }
        };
        updateButtons();
        getExplorerManager().addPropertyChangeListener(managerListener);
        Node n = getExplorerManager().getExploredContext();
        if (n != null) {
            indexableParent = (Index)n.getCookie(Index.class);
            updateButtons();
        }
        super.addNotify();
    }

    public void removeNotify() {
        getExplorerManager().removePropertyChangeListener(managerListener);
    }
    
    public JButton addButton() {
        return this.addButton;
    }
    
    public JButton removeButton() {
        return this.removeButton;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        expHolder = new javax.swing.JPanel() {
            public java.awt.Dimension getPreferredSize() {
                return resolvePreferredSize( super.getPreferredSize() );
            }
        };
        buttonPanel = new javax.swing.JPanel();
        addButton = createButton();
        removeButton = createButton();
        upButton = createButton();
        downButton = createButton();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        expHolder.setLayout(new java.awt.BorderLayout());
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(expHolder, gridBagConstraints1);
        
        
        buttonPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        addButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
          addButton.setPreferredSize(new java.awt.Dimension(35, 27));
          addButton.setText("Add");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 6, 6);
          buttonPanel.add(addButton, gridBagConstraints2);
          
          
        removeButton.setMargin(new java.awt.Insets(2, 2, 2, 2));
          removeButton.setText(org.openide.util.NbBundle.getBundle(IndexableExplorerList.class).getString("IndexableExplorerList.removeButton.text"));
          removeButton.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  removeButtonActionPerformed(evt);
              }
          }
          );
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 0;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 6, 0);
          buttonPanel.add(removeButton, gridBagConstraints2);
          
          
        upButton.setText(org.openide.util.NbBundle.getBundle(IndexableExplorerList.class).getString("IndexableExplorerList.upButton.text"));
          upButton.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  upButtonActionPerformed(evt);
              }
          }
          );
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 0, 6);
          buttonPanel.add(upButton, gridBagConstraints2);
          
          
        downButton.setText(org.openide.util.NbBundle.getBundle(IndexableExplorerList.class).getString("IndexableExplorerList.downButton.text"));
          downButton.addActionListener(new java.awt.event.ActionListener() {
              public void actionPerformed(java.awt.event.ActionEvent evt) {
                  downButtonActionPerformed(evt);
              }
          }
          );
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 1;
          buttonPanel.add(downButton, gridBagConstraints2);
          
          
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.gridheight = 0;
        gridBagConstraints1.insets = new java.awt.Insets(8, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        add(buttonPanel, gridBagConstraints1);
        
    }//GEN-END:initComponents

  private void removeButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeButtonActionPerformed
        Node[] selected = getExplorerManager().getSelectedNodes();
        if (selected.length == 0)
                return;
        int selIndex = 0;
        final Children ch = getExplorerManager().getExploredContext().getChildren();
        Node[] allNodes = ch.getNodes();
        for (int i = 0; i < allNodes.length; i++) {
            if (allNodes[i] == selected[0]) {
                selIndex = i;
                break;
            }
        }
        for (int i = 0; i < selected.length; i++) {
            removeNode(selected[i]);
        }
        // restore the selection:
        if (ch.getNodesCount() <= selIndex) {
            selIndex = ch.getNodesCount() - 1;
        } 
        if (selIndex != -1) {
            final int select = selIndex;
            javax.swing.SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    try {
                        getExplorerManager().setSelectedNodes(
                            new Node[] {
                                ch.getNodes()[select]
                            }
                        );
                    } catch (PropertyVetoException ex) {
                    }
                }
            });
        }
        updateButtons();
  }//GEN-LAST:event_removeButtonActionPerformed

  private void downButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_downButtonActionPerformed
        Node[] n = getExplorerManager().getSelectedNodes();
        indexableParent.moveDown(indexableParent.indexOf(n[0]));
        updateSelection(n[0]);
        updateButtons();
  }//GEN-LAST:event_downButtonActionPerformed

  private void upButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_upButtonActionPerformed
        Node[] n = getExplorerManager().getSelectedNodes();
        indexableParent.moveUp(indexableParent.indexOf(n[0]));
        updateSelection(n[0]);
        updateButtons();
  }//GEN-LAST:event_upButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel expHolder;
  private javax.swing.JPanel buttonPanel;
  private javax.swing.JButton addButton;
  private javax.swing.JButton removeButton;
  private javax.swing.JButton upButton;
  private javax.swing.JButton downButton;
  // End of variables declaration//GEN-END:variables

    private void updateSelection(Node previous) {
        final Node n = reselectNode(previous);
        if (n == null) {
            try {
                getExplorerManager().setSelectedNodes(EMPTY_SELECTION);
            } catch (PropertyVetoException ex) {
            }
        } else {
	    javax.swing.SwingUtilities.invokeLater(new Runnable() {
	    public void run() {
            org.openide.nodes.Children.MUTEX.postWriteRequest(
                new Runnable() {
                    public void run() {
                        try {
                            getExplorerManager().setSelectedNodes(
                                new Node[] {
                                    n
                            });
                        } catch (PropertyVetoException ex) {
                        }
                    }
                }
            );
	    }});
        }
    }
        
    private void updateButtons() {
        ExplorerManager m = getExplorerManager();
        Node[] nodes = m.getSelectedNodes();   
        boolean singleSel = nodes.length == 1;

        // these buttons are valid only for single selection
        if (indexableParent != null && singleSel) {
            // If the nodes provide ReorderCookie, they can be reordered inside their parent.
            upButton.setEnabled(!isFirst(nodes[0]));
            downButton.setEnabled(!isLast(nodes[0]));
        } else {
            upButton.setEnabled(false);
            downButton.setEnabled(false);
        }

        boolean canRemove = false;
        for (int i = 0; i < nodes.length; i++) {
            if (nodes[i].canDestroy()) {
                canRemove = true;
                break;
            }
        }
        removeButton.setEnabled(canRemove);
    }

    protected boolean isFirst(Node n) {
        return indexableParent.indexOf(n) == 0;
    }

    protected boolean isLast(Node n) {
        return indexableParent.indexOf(n) == indexableParent.getNodesCount() - 1;
    }

    protected void removeNode(Node n) {
        try {
            n.destroy();
        } catch (IOException e) {
        }
    }

    protected void createNewNode(Node parent) {
        try {
            parent.getNewTypes()[0].create();
        } catch (IOException e) {
        }
    }

    /*********************************************************************/
    protected boolean reorderEnabled() {
        return true;
    }
    
    protected boolean customizeEnabled() {
        return true;
    }
 
    /** Reselect a node based on a previous one. This is a kind of hack, because
     * not all nodes provide proper equality support, so this implementation
     * might not work on (e.g.) MemberElements.
     * @param n previously selected node
     * @return node to be selected, or null if the selection should be cleared.
     */
    protected Node reselectNode(Node n) {
        Node[] children = getExplorerManager().getExploredContext().getChildren().getNodes();
        Node node = null;
        for (int i = 0; i < children.length; i++) {
            if (n.equals(children[i])) {
                node = children[i];
                break;
            }
        }
        return node;
    }

   /** Preferable size */
    private static final int X_PREFERRED = 200;

    private int buttonWidth;
 
    private JButton createButton() {
        return new JButton() {
            public Dimension getPreferredSize() {
                Dimension old = super.getPreferredSize();
                if (buttonWidth == -1)
                    return old;
                return new Dimension(Math.max(buttonWidth, 
                    super.getPreferredSize().width),
                    old.height);
            }
        };
    }

    /** Finds the best Prefered size of the pannels 
    */
    private java.awt.Dimension resolvePreferredSize( java.awt.Dimension old ) {
        return new java.awt.Dimension( java.lang.Math.max( buttonPanel.getPreferredSize().width + 30, X_PREFERRED), old.height );
    }
}