/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.wizard;

import org.openide.src.*;
import org.openide.*;

/**
 * Simple input class for interface identifiers -- provides most common
 * names in a combo box.
 * @deprecated Wizard UI implementation has been moved to ui.wizard package.
 */
public class InterfaceInputPanel extends javax.swing.JPanel {
    static final String[] COMMON_INTERFACES = new String[] {
        "java.lang.Cloneable",
        "java.io.Serializable",
        "java.io.Externalizable",
        "java.lang.Runnable",
        "java.lang.Comparable",
        "java.util.Comparator",
        "java.util.EventListener",
        "java.beans.PropertyChangeListener"
    };
    
    /** Creates new form InterfaceInputPanel */
    public InterfaceInputPanel() {
        initComponents ();
        for (int i = 0; i < COMMON_INTERFACES.length; i++) {
            nameCombo.addItem(COMMON_INTERFACES[i]);
        }
        setInterfaceName("");
    }
    
    public boolean display() {
        DialogDescriptor dlg = new DialogDescriptor(
            this, Util.getString("TIT_ImplementInterface"),
            true,
            NotifyDescriptor.OK_CANCEL_OPTION,
            NotifyDescriptor.OK_OPTION,
            DialogDescriptor.BOTTOM_ALIGN,
            null, null);
        TopManager.getDefault().notify(dlg);
        return dlg.getValue() == DialogDescriptor.OK_OPTION;
    }
    
    public String getInterfaceName() {
        Object selItem = nameCombo.getSelectedItem();
        String value;

        if (selItem == null)
            return null;
        value=selItem.toString();
        if ("".equals(value))
            return null;
        return value;
    }
    
    public void setInterfaceName(String name) {
        nameCombo.setSelectedItem(name);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        nameCombo = new javax.swing.JComboBox();
        setLayout(new java.awt.BorderLayout());
        
        jLabel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 0, 0, 10)));
        jLabel1.setText(org.openide.util.NbBundle.getBundle(InterfaceInputPanel.class).getString("LBL_InterfaceName"));
        
        add(jLabel1, java.awt.BorderLayout.WEST);
        
        
        nameCombo.setEditable(true);
        
        add(nameCombo, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JComboBox nameCombo;
    // End of variables declaration//GEN-END:variables
}