/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.java.wizard;

import org.openide.nodes.*;
import org.openide.src.*;
import org.openide.src.nodes.MethodElementNode;

/*
 * @deprecated Wizard UI implementation has been moved to ui.wizard package.
 */
public class MethodsChildren extends IndexedPropertyChildren {
    private ClassElement clazz;
    private static ElementFormat METHOD_FORMAT = new ElementFormat("{n}({p})");
    
    /** Creates new MethodsChildren */
    public MethodsChildren(ClassElement clazz) {
        super(clazz, ElementProperties.PROP_METHODS);
        this.clazz = clazz;
    }
    
    protected Node[] createNodes(Object key) {
        return new Node[] {
            createMethodNode((MethodElement)key)
        };
    }
    
    private MethodElementNode createMethodNode(MethodElement m) {
        MethodElementNode mn = new MethodElementNode(m, true);
        mn.setElementFormat(METHOD_FORMAT);
        return mn;
    }
}