/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.lib.cvsclient.command;

import java.io.File;
import java.util.LinkedList;
import java.util.Iterator;

/**
 * Describes checkout/tag/update information for a file.
 * The fields in instances of this object are populated by response handlers.
 *
 * @author  Thomas Singer
 * @version $Revision: 1.2 $
 */
public class DefaultFileInfoContainer extends FileInfoContainer {

    private File file;

    private String type;

    //private StringBuffer log = new StringBuffer();

    public DefaultFileInfoContainer()
    {
    }

    /**
     * Returns the associated file.
     */
    public File getFile()
    {
        return file;
    }

    /**
     * Sets the associated file.
     */
    public void setFile(File file)
    {
        this.file = file;
    }

    /**
     * Returns the type.
     */
    public String getType()
    {
        return type;
    }

    /**
     * Sets the type.
     */
    public void setType(char type)
    {
        this.type = String.valueOf(type);
    }

    /**
     * Sets the type.
     * @deprecated
     */
    public void setType(String type)
    {
        this.type = type;
    }

    /**
     * Return a string representation of this object. Useful for debugging.
     */
    public String toString()
    {
        return type + "  " + (file != null ? file.getAbsolutePath()
                                           : "null");
    }       
}
