/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.lib.cvsclient.command.add;

import java.io.File;
import java.util.LinkedList;
import java.util.Iterator;
import org.netbeans.lib.cvsclient.command.DefaultFileInfoContainer;


/**
 * Describes add information for a file. This is the result of doing a
 * cvs add command. The fields in instances of this object are populated
 * by response handlers.
 * @author  Milos Kleint
 * 
 */
public class AddInformation extends DefaultFileInfoContainer {
    /**
     * Holds value of property file.
     */
    private File file;
    
    /** Holds value of property directory. */
    private boolean directory;
    
    
    public AddInformation() {
    }
    
    /** Getter for property type.
     * @return Value of property type.
     */
    public boolean isDirectory() {
        return directory;
    }
    
    /** Setter for property type.
     * @param type New value of property type.
     */
    public void setDirectory(boolean isDirectory) {
        directory = isDirectory;
    }
    
    
    /**
     * Return a string representation of this object. Useful for debugging.
     */
    public String toString() {
        StringBuffer buf = new StringBuffer(30);
        buf.append((isDirectory() ? "Directory" : "File"));
        buf.append("  " + ((file != null)?file.getAbsolutePath():"null"));
        return buf.toString();
    }
    
}