/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.lib.cvsclient.command.checkout;

import java.io.File;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Iterator;
import org.netbeans.lib.cvsclient.command.FileInfoContainer;

public class PipedFileInformation extends FileInfoContainer {    
    /** 
     * Holds value of property file.
     */
    private File file;
    
    /**
     * Holds value of property repositoryRevision. 
     */
    private String repositoryRevision;
    
    /** Holds value of property repositoryFileName.
     */
    private String repositoryFileName;
    

    /** Holds value of propertytempFile 
     */
    
    private File tempFile;
    
    private BufferedOutputStream tempOutStream;
    
    public PipedFileInformation(File temp) {
        tempFile = temp;
        try {
          tempOutStream = new BufferedOutputStream(new FileOutputStream(tempFile));
        } catch (IOException exc) {
            //TODO
        }
    }
    
    /**
     * Getter for property file.
     * @return Value of property file.
     */
    public File getFile()
    {
        return file;
    }
    
    /**
     * Setter for property file.
     * @param file New value of property file.
     */
    public void setFile(File file)
    {
        this.file = file;
    }            
    
    
    /**
     * Getter for property repositoryRevision.
     * @return Value of property repositoryRevision.
     */
    public String getRepositoryRevision()
    {
        return repositoryRevision;
    }
    
    /**
     * Setter for property repositoryRevision.
     * @param repositoryRevision New value of property repositoryRevision.
     */
    public void setRepositoryRevision(String repositoryRevision)
    {
        this.repositoryRevision = repositoryRevision;
    }

    /**
     * Getter for property repositoryFileName.
     * @return Value of property repositoryFileName.
     */
    public String getRepositoryFileName()
    {
        return repositoryFileName;
    }
    
    /**
     * Setter for property repositoryFileName.
     * @param repositoryRevision New value of property repositoryFileName.
     */
    public void setRepositoryFileName(String repositoryFileName)
    {
        this.repositoryFileName = repositoryFileName;
    }
    
    public void addToTempFile(String line) throws IOException{
        if (tempOutStream != null) {
            line = line + "\n";
            tempOutStream.write(line.getBytes());
        }
    }
    
    public void closeTempFile() throws IOException {
        if (tempOutStream != null) {
            tempOutStream.flush();
            tempOutStream.close();
        }
    }
    
    public File getTempFile() {
        return tempFile;
    }

}