/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.lib.cvsclient.command.remove;

import java.io.File;
import java.util.LinkedList;
import java.util.Iterator;
import org.netbeans.lib.cvsclient.command.FileInfoContainer;


/**
 * Describes remove information for a file. This is the result of doing a
 * cvs remove command. The fields in instances of this object are populated
 * by response handlers.
 * @author  Milos Kleint
 * 
 */
public class RemoveInformation extends FileInfoContainer {
    /**
     * Holds value of property file.
     */
    private File file;
    
    /** Holds value of property removed. */
    private boolean removed;
    
    
    public RemoveInformation() {
    }
    
    /**
     * Getter for property file.
     * @return Value of property file.
     */
    public File getFile() {
        return file;
    }
    
    /**
     * Setter for property file.
     * @param file New value of property file.
     */
    public void setFile(File file) {
        this.file = file;
    }
    
    public void setRemoved(boolean rem) {
        removed = rem;
    }    
    
    public boolean isRemoved() {
        return removed;
    }    
    
    /**
     * Return a string representation of this object. Useful for debugging.
     */
    public String toString() {
        StringBuffer buf = new StringBuffer(30);
        buf.append("  " + ((file != null)?file.getAbsolutePath():"null"));
        return buf.toString();
    }
    
}