/*****************************************************************************
 * Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version 
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/

 * The Original Code is the CVS Client Library.
 * The Initial Developer of the Original Code is Robert Greig.
 * Portions created by Robert Greig are Copyright (C) 2000.
 * All Rights Reserved.

 * Contributor(s): Robert Greig.
 *****************************************************************************/
package org.netbeans.lib.cvsclient.commandLine.command;

import java.io.File;

import org.netbeans.lib.cvsclient.command.Command;
import org.netbeans.lib.cvsclient.command.add.AddCommand;

import org.netbeans.lib.cvsclient.commandLine.GetOpt;

/**
 * Adds a file or directory to the repository
 * @author  Robert Greig
 * @version $Revision: 1.8 $
 */
public class add
{
    public static Command createCommand(String[] args, Integer index)
    {
        AddCommand command = new AddCommand();
        command.setBuilder(null);
        final String getOptString = command.getOptString();
        GetOpt go = new GetOpt(args, getOptString);
        int ch = -1;
        go.optIndexSet(index.intValue());
        boolean usagePrint = false;
        String arg;
        while ((ch = go.getopt()) != go.optEOF)
        {   
            boolean ok = command.setCVSCommand((char)ch, go.optArgGet());
            if (!ok) usagePrint = true;
        }
        if (usagePrint)
        {
            throw new IllegalArgumentException("cvs add [-k] [-m <message>] [files|directories]");            
        }
        int fileArgsIndex = go.optIndexGet();
        // test if we have been passed any file arguments
        if (fileArgsIndex < args.length)
        {
            File[] fileArgs = new File[args.length - fileArgsIndex];
            // send the arguments as absolute paths
            File workingDir = new File(System.getProperty("user.dir"));
            for (int i=fileArgsIndex; i < args.length; i++)
            {
                fileArgs[i-fileArgsIndex] = new File(workingDir, args[i]);
            }
            command.setFiles(fileArgs);
        }
        return command;
    }
}