/*****************************************************************************
 * Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version 
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/

 * The Original Code is the CVS Client Library.
 * The Initial Developer of the Original Code is Robert Greig.
 * Portions created by Robert Greig are Copyright (C) 2000.
 * All Rights Reserved.

 * Contributor(s): Robert Greig.
 *****************************************************************************/
package org.netbeans.lib.cvsclient.commandLine.command;

import java.io.File;

import org.netbeans.lib.cvsclient.command.Command;
import org.netbeans.lib.cvsclient.command.status.StatusCommand;

import org.netbeans.lib.cvsclient.commandLine.GetOpt;

/**
 * The status command
 * @author  Robert Greig
 * @version $Revision: 1.10 $
 */
public class status
{
    public static Command createCommand(String[] args, Integer index)
    {
        StatusCommand command = new StatusCommand();        
        final String getOptString = command.getOptString();
        GetOpt go = new GetOpt(args, getOptString);
        int ch = -1;
        go.optIndexSet(index.intValue());
        boolean usagePrint = false;
        while ((ch = go.getopt()) != go.optEOF)
        {
           boolean ok = command.setCVSCommand((char)ch, go.optArgGet());
/*            if ((char)ch == 'R')
                command.setRecursive(true);
            else if ((char)ch == 'l')
                command.setRecursive(false);      
            else if ((char)ch == 'v')
                command.setIncludeTags(true);            

            else
 */
           if (!ok)  usagePrint = true;
        }
        if (usagePrint)
        {
            throw new IllegalArgumentException("cvs status [-Rlv] [files...]");            
        }
        int fileArgsIndex = go.optIndexGet();
        // test if we have been passed any file arguments
        if (fileArgsIndex < args.length)
        {
            File[] fileArgs = new File[args.length - fileArgsIndex];
            // send the arguments as absolute paths
            File workingDir = new File(System.getProperty("user.dir"));
            for (int i=fileArgsIndex; i < args.length; i++)
            {
                fileArgs[i-fileArgsIndex] = new File(workingDir, args[i]);
            }
            command.setFiles(fileArgs);
        }
        return command;
    }
}