/*****************************************************************************
 * Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version 
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/

 * The Original Code is the CVS Client Library.
 * The Initial Developer of the Original Code is Robert Greig.
 * Portions created by Robert Greig are Copyright (C) 2000.
 * All Rights Reserved.

 * Contributor(s): Robert Greig.
 *****************************************************************************/
package org.netbeans.lib.cvsclient.connection;

import java.io.IOException;

import org.netbeans.lib.cvsclient.util.LoggedDataInputStream;
import org.netbeans.lib.cvsclient.util.LoggedDataOutputStream;

import org.netbeans.lib.cvsclient.request.Request;

/**
 * Provides a way to modify the communication channel between client and
 * server.
 * @author  Robert Greig
 * @version $Revision: 1.3 $
 */
public interface ConnectionModifier {

    void modifyInputStream(LoggedDataInputStream ldis) throws IOException;
    
    void modifyOutputStream(LoggedDataOutputStream ldos) throws IOException;
      
}

