/*****************************************************************************
 * Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version 
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/

 * The Original Code is the CVS Client Library.
 * The Initial Developer of the Original Code is Robert Greig.
 * Portions created by Robert Greig are Copyright (C) 2000.
 * All Rights Reserved.

 * Contributor(s): Robert Greig.
 *****************************************************************************/
package org.netbeans.lib.cvsclient.request;

/**
 * The checkout (co) request. Gets files from the repostory. This uses any
 * previous Argument, Directory, Entry or Modified requests, if they have been
 * sent. Arguments to this command are module names; the client cannot know
 * what directories they correspond to expect by
 * <OL><LI>Just sending the <pre>co</pre> request and then seeing what
 * directory names the server sends back in its responses</LI>
 * <LI>the <pre>expand-modules</pre> request.</LI></OL>
 * @author  Robert Greig
 * @version $Revision: 1.3 $
 */
public class CheckoutRequest extends Request
{
    /**
     * Construct a new checkout request. Notice that no arguments are sent
     * explicitly. Use the Argument request instead.
     */
    public CheckoutRequest()
    {
    }
    
    /**
     * Get the request String that will be passed to the server 
     * @return the request String
     */
    public String getRequestString() throws UnconfiguredRequestException
    {        
        return "co \n";
    }
    
    /**
     * Is a response expected from the server?
     * @return true if a response is expected, false if no response if
     * expected
     */
    public boolean isResponseExpected()
    {
        return true;
    }
}