/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.lib.cvsclient.request;

/**
 * Sends the tag request.
 * This request uses any Directory, Entry,Modified and Argument requests
 * previously sent.
 *
 * @author  Thomas Singer
 * @version $Revision: 1.1 $
 */
public class TagRequest extends Request
{
    /**
     * Get the request String that will be passed to the server.
     */
    public String getRequestString()
    {
        return "tag \n";
    }

    /**
     * Returns true to indicate that a server-response is expected.
     */
    public boolean isResponseExpected()
    {
        return true;
    }
}
