/*****************************************************************************
 * Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version 
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/

 * The Original Code is the CVS Client Library.
 * The Initial Developer of the Original Code is Robert Greig.
 * Portions created by Robert Greig are Copyright (C) 2000.
 * All Rights Reserved.

 * Contributor(s): Robert Greig.
 *****************************************************************************/
package org.netbeans.lib.cvsclient.request;

/**
 * Actually perform a CVS Update. This uses any previous <pre>Argument<pre>,
 * <pre>Directory</pre>, <pre>Entry</pre> or <pre>Modified<pre> requests that
 * have been sent. <p>
 * The last <pre>Directory</pre> sent specifies the working directory at the 
 * time of the operation. <p>
 * Files which the clients knows it is safe to ignore should not be sent, and
 * <pre>Questionable</pre> requests should be sent for the others.
 * @author  Robert Greig
 * @version $Revision: 1.3 $
 */
public class UpdateRequest extends Request
{
    /**
     * Get the request String that will be passed to the server 
     * @return the request String
     * @throws UnconfiguredRequestException if the request has not been
     * properly configured
     */
    public String getRequestString() throws UnconfiguredRequestException
    {
        return "update \n";
    }
   
    /**
     * Is a response expected from the server?
     * @return true if a response is expected, false if no response if
     * expected
     */
    public boolean isResponseExpected()
    {
        return true;
    }    
}