/*****************************************************************************
 * Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version 
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/

 * The Original Code is the CVS Client Library.
 * The Initial Developer of the Original Code is Robert Greig.
 * Portions created by Robert Greig are Copyright (C) 2000.
 * All Rights Reserved.

 * Contributor(s): Robert Greig.
 *****************************************************************************/
package org.netbeans.lib.cvsclient.response;

/**
 * This exception is thrown when an error occurs while processing the
 * server's responses.
 * @author  Robert Greig
 * @version $Revision: 1.3 $
 */
public class ResponseException extends Exception
{
    private Throwable underlyingException;
    
    public ResponseException(Exception e)
    {
        super();
        underlyingException = e;
    }
    
    public ResponseException(String message)
    {
        super(message);
    }
    
    public String getMessage()
    {
        return "underlying exception: " + underlyingException.getMessage();
    }
    
    public void printStackTrace()
    {
        underlyingException.printStackTrace();
    }
}