/*****************************************************************************
 * Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License Version 
 * 1.0 (the "License"). You may not use this file except in compliance with 
 * the License. A copy of the License is available at http://www.sun.com/

 * The Original Code is the CVS Client Library.
 * The Initial Developer of the Original Code is Robert Greig.
 * Portions created by Robert Greig are Copyright (C) 2000.
 * All Rights Reserved.

 * Contributor(s): Robert Greig.
 *****************************************************************************/
package org.netbeans.lib.cvsclient.response;

/**
 * Create response objects appropriate for handling different types of response
 * @author  Robert Greig
 * @version $Revision: 1.11.2.1 $
 */
public class ResponseFactory
{
    public static Response createResponse(String responseName)
    {
        if (responseName.equalsIgnoreCase("E"))
        {
            return new ErrorMessageResponse();
        }
        else if (responseName.equalsIgnoreCase("M"))
        {
            return new MessageResponse();
        }
        else if (responseName.equalsIgnoreCase("MT"))
        {
            return new MessageTaggedResponse();
        }
        else if (responseName.equalsIgnoreCase("Updated"))
        {
            return new UpdatedResponse();
        }
        else if (responseName.equalsIgnoreCase("Checked-in"))
        {
            return new CheckedInResponse();
        }
        else if (responseName.trim().equalsIgnoreCase("ok"))
        {
            return new OKResponse();
        }
        else if (responseName.trim().equalsIgnoreCase("error"))
        {
            return new ErrorResponse();
        }
        else if (responseName.equalsIgnoreCase("Set-static-directory"))
        {
            return new SetStaticDirectoryResponse();
        }        
        else if (responseName.equalsIgnoreCase("Clear-static-directory"))
        {
            return new ClearStaticDirectoryResponse();
        }
        else if (responseName.equalsIgnoreCase("Set-sticky"))
        {
            return new SetStickyResponse();
        }        
        else if (responseName.equalsIgnoreCase("Clear-sticky"))
        {
            return new ClearStickyResponse();
        }
        else if (responseName.equalsIgnoreCase("Valid-requests"))
        {
            return new ValidRequestsResponse();
        }
        else if (responseName.equalsIgnoreCase("Merged"))
        {
            return new MergedResponse();
        }
        else if (responseName.equalsIgnoreCase("Removed"))
        {
            return new RemovedResponse();
        }
        else if (responseName.equalsIgnoreCase("Remove-entry"))
        {
            return new RemoveEntryResponse();
        }
        else if (responseName.equalsIgnoreCase("Copy-file"))
        {
            return new CopyFileResponse();
        }
        else if (responseName.equalsIgnoreCase("Mod-time"))
        {
            return new ModTimeResponse();
        }
        else if (responseName.equalsIgnoreCase("Template"))
        {
            return new TemplateResponse();
        }
        else if (responseName.equalsIgnoreCase("Module-expansion"))
        {
            return new ModuleExpansionResponse();
        }
        else
        {
            throw new IllegalArgumentException("Unhandled response: " +
                                               responseName + ".");
        }
    }
}
