/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is Forte for Java, Community Edition. The Initial
 * Developer of the Original Code is Sun Microsystems, Inc. Portions
 * Copyright 1997-2000 Sun Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.modules.cvsclient;

import java.io.IOException;

/** Exception generated by the file system.
 * Might be visible to the user under many circumstances,
 * for example if a file could not be modified because of a lock.
 *
 * @author mkleint
 */
public class JavaCvsFileSystemException extends IOException {

    private String localizedMessage;

    static final long serialVersionUID = 3374997421956432894L;
    
    /** Create an exception.
     * To be displayed to the user, the localized message must
     * differ from the regular detail message, as a signal that it
     * is localized. Otherwise, the user is presented with a generic
     * message without details.
     * @param detailMessage an invisible debugging-only message
     * @param localizedMessage the message that will be displayed to the user if needed
     */
    public JavaCvsFileSystemException (String detailMessage, String localizedMessage) {
        super (detailMessage);
        this.localizedMessage = localizedMessage;
    }

    public String getLocalizedMessage () {
        return localizedMessage;
    }

}