/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient;

import java.awt.Image;
import java.beans.*;

import org.openide.util.NbBundle;

/** BeanInfo for JavaCvsSettings
*
* @author Milos Kleint
*/
public class JavaCvsSettingsBeanInfo extends SimpleBeanInfo {

    /** Icons for compiler settings objects. */
    static Image icon;
    static Image icon32;

    static final java.util.ResourceBundle bundle =
        NbBundle.getBundle(JavaCvsSettingsBeanInfo.class);


    /**
    * loads icons
    */
    public JavaCvsSettingsBeanInfo() {
    }

    /** @return the  icon */
    //TODO new ICONS
    public Image getIcon(int type) {
        if ((type == java.beans.BeanInfo.ICON_COLOR_16x16) || (type == java.beans.BeanInfo.ICON_MONO_16x16)) {
            if (icon == null)
                icon = loadImage("/org/netbeans/modules/cvsclient/JavaCvsSettingsIcon.gif"); // NOI18N
            return icon;
        } else {
            return icon32;
        }
    }

    /** Descriptor of valid properties
    * @return array of properties
    */
    public PropertyDescriptor[] getPropertyDescriptors () {
        try {
  // use globally 
            PropertyDescriptor global = new PropertyDescriptor ("useGlobal", JavaCvsSettings.class);
            global.setDisplayName (bundle.getString("PROP_useGlobal"));
            global.setShortDescription (bundle.getString("HINT_useGlobal"));            
            
  // work off-line
            PropertyDescriptor offLine = new PropertyDescriptor ("offLine", JavaCvsSettings.class);
            offLine.setDisplayName (bundle.getString("PROP_offLine"));
            offLine.setShortDescription (bundle.getString("HINT_offLine"));
  // automatic refresh
            PropertyDescriptor autoRefresh = new PropertyDescriptor ("autoRefresh", JavaCvsSettings.class);
            autoRefresh.setDisplayName (bundle.getString("PROP_autoRefresh"));
            autoRefresh.setShortDescription (bundle.getString("HINT_autoRefresh"));
            autoRefresh.setPropertyEditorClass(RefreshModePropertyEditor.class);
//            autoRefresh.setPropertyEditorClass();
  // send/receive zipped
/*            PropertyDescriptor zippedTransfer = new PropertyDescriptor ("zippedTransfer", JavaCvsSettings.class);
            zippedTransfer.setDisplayName (bundle.getString("PROP_zippedTransfer"));
            zippedTransfer.setShortDescription (bundle.getString("HINT_zippedTransfer"));
 */
  // User Interface Mode
            PropertyDescriptor uiMode = new PropertyDescriptor ("uiMode", JavaCvsSettings.class);
            uiMode.setDisplayName (bundle.getString("PROP_uiMode"));
            uiMode.setShortDescription (bundle.getString("HINT_uiMode"));            
            uiMode.setPropertyEditorClass(UiModePropertyEditor.class);
            
              // Display Type
            PropertyDescriptor displayType = new PropertyDescriptor ("displayType", JavaCvsSettings.class);
            displayType.setDisplayName (NbBundle.getMessage (JavaCvsSettingsBeanInfo.class, "PROP_displayType"));
            displayType.setShortDescription (NbBundle.getMessage (JavaCvsSettingsBeanInfo.class, "HINT_displayType"));            
            displayType.setPropertyEditorClass(DisplayTypePropertyEditor.class);
            
            PropertyDescriptor cvsHome = new PropertyDescriptor ("cvsHome", JavaCvsSettings.class);
            cvsHome.setDisplayName (bundle.getString("PROP_cvsHome"));
            cvsHome.setShortDescription (bundle.getString("HINT_cvsHome"));
            
            return new PropertyDescriptor[] {global, offLine, autoRefresh, uiMode, displayType, cvsHome };
            
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }
}

