/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands;

import org.netbeans.lib.cvsclient.Client;
import org.netbeans.lib.cvsclient.command.GlobalOptions;
import org.netbeans.lib.cvsclient.util.IgnoreFileFilter;
import org.netbeans.lib.cvsclient.connection.AuthenticationException;
/**
 *
 * @author  mkleint
 * @version 
 */
public interface ClientProvider  {

    public Client createClient(String root) throws ClientCreationException;
    
    public void openConnection(Client client, String root) throws AuthenticationException;
    
    public JavaCvsCommandFactory getCommandFactory();
    
    public boolean isOffLine();
    
    public boolean isFileSystemClient();
    
    public GlobalOptions getGlobalOptions();
    
    public String getCvsRootString();
    
    public int getUiMode();
    
    public int getDisplayType();
    
    public IgnoreFileFilter getIgnoreFilter();
    
}

