/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands;

/**
 *
 * Interface for all classes that display the results returned by the executed command.
 * @author  mkleint
 * @version 
 */

import java.util.Collection;

public interface CommandDisplayer {


    
    /** 
     * moment constant, used when calling the Displayer 
     * in FileSystemCommand.finishedCommand().
     * Data param. is generally List of results - FileSystemCommand.getResultList().
     */
    public static final int MOMENT_FINISHED_COMMAND = 100;
    
    /** 
     * moment constant, used when calling the Displayer 
     * in FileSystemCommand.beforeEachExecute().
     * Data param. is generally Command class indicating the current command.
     */
    public static final int MOMENT_BEFORE_EACH_EXECUTE = 30;
    
    /** 
     * moment constant, used when calling the Displayer 
     * in FileSystemCommand.afterEachExecute().
     * Data param. is generally list of results - FileSystemCommand.getResultList().
     */
    public static final int MOMENT_AFTER_EACH_EXECUTE = 70;

    /** 
     * moment constant, used when calling the Displayer 
     * in FileSystemCommand.fileInfoGenerated().
     * Data param. is generally FileInfoContainer instance - the info generated.
     */
    public static final int MOMENT_FILE_INFO_GENERATED = 50;

    /** 
     * moment constant, used when calling the Displayer 
     * in FileSystemCommand.executeFailed().
     * Data param. is generally list of results - FileSystemCommand.getResultList().
     */
    public static final int MOMENT_EXECUTE_FAILED = 150;    

    /** 
     * moment constant, used when calling the Displayer 
     * in FileSystemCommand.afterParamInput().
     * Data param. is generally null.
     */
    public static final int MOMENT_AFTER_PARAM_INPUT = 20;
    
    public static final int MOMENT_MESSAGE_RECEIVED = 15;

    /** Does the actual display - docking into the javacvs Mode, 
     *   displaying as single Dialog.. whatever.
     */
    public void displayOutputData(int moment, Object data);
    
}

