/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.cvsclient.commands;

import java.util.*;
import java.io.IOException;
import java.io.File;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.text.StyledDocument;
import java.awt.*;
import java.awt.event.*;
import org.netbeans.lib.cvsclient.command.update.*;
import org.netbeans.modules.vcscore.util.Debug;
import org.netbeans.modules.cvsclient.JavaCvsFileSystem;
import org.netbeans.modules.cvsclient.commands.*;
import org.openide.util.NbBundle;
import org.openide.filesystems.*;
import org.openide.*;

public class CommandLineInfoPanel extends javax.swing.JPanel implements CommandDisplayer {
    private Debug E=new Debug("CommandLineInfoPanel", true); // NOI18N
    private Debug D=E;
    
    DialogDescriptor dd;
    FileSystemCommand command;
    /** Creates new form UpdateInfoPanel */
    public CommandLineInfoPanel(FileSystemCommand fscommand) {
        initComponents ();
        command = fscommand;
        setPreferredSize(new java.awt.Dimension(450, 325));
        setMinimumSize(new java.awt.Dimension(450, 325));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        pnlButtons = new javax.swing.JPanel();
        spCentral = new javax.swing.JScrollPane();
        txOutput = new javax.swing.JTextArea();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        pnlButtons.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 11);
        add(pnlButtons, gridBagConstraints1);
        
        
        spCentral.setPreferredSize(new java.awt.Dimension(250, 60));
        
        spCentral.setViewportView(txOutput);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 11);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(spCentral, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void btnEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditActionPerformed

    }//GEN-LAST:event_btnEditActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel pnlButtons;
    private javax.swing.JScrollPane spCentral;
    private javax.swing.JTextArea txOutput;
    // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/Bundle");  

   
/** this method should be used with Choosers to display the dialog.. 
 * then later the displayOutputData will just present the datat gotten from server
 * Reason: to have something displayer right away..
 * This method is to be called when creating the command and Chooser.
 */
    public void displayFrameWork() {
        String title = NbBundle.getBundle(CommandLineInfoPanel.class).getString("CommandLineInfoPanel.dialogTitle") + " " + command.getName();
        dd = new DialogDescriptor(this, title);
        String[] options = new String[1];
        options[0] = NbBundle.getBundle(CommandLineInfoPanel.class).getString("CommandLineInfoPanel.stopButton");
        dd.setOptions(options);
        Object[] empty = new Object[1];
        dd.setClosingOptions(empty); // none are closing
        dd.setButtonListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                shutDownCommand();
            }
        });
        javax.swing.SwingUtilities.invokeLater(new Runnable () {
            public void run () {
               Dialog dial = TopManager.getDefault().createDialog(dd);
               dial.setModal(false);
               dial.show();
            }
        });        
    }
    
    private void shutDownCommand() {
        // we can do that because it's running from other thread then command and won't kill itself
        command.hardCommandStop();
//        displayOutputData();
    }


    /** Does the actual display - docking into the javacvs Mode, 
 *  displaying as single Dialog.. whatever.
 */
    public void displayOutputData() {
        Object[] options = new Object[1];
        JButton btnClose = new JButton();
        btnClose.setText(NbBundle.getBundle(CommandLineInfoPanel.class).getString("CommandLineInfoPanel.closeButton"));
        btnClose.setDefaultCapable(true);
        options[0] = btnClose;
        dd.setValue(btnClose);
        Object[] closing = new Object[1];
        closing[0] = options[0];
        dd.setOptions(options);
        dd.setClosingOptions(closing); // all are closing
    }  
    
    /** Does the actual display - docking into the javacvs Mode, 
     *  displaying as single Dialog.. whatever.
 */
    public void displayOutputData(int moment,Object data) {
        if (moment == CommandDisplayer.MOMENT_AFTER_PARAM_INPUT) {
            // display empty panel.
            displayFrameWork();
        } 
        else if (moment == CommandDisplayer.MOMENT_MESSAGE_RECEIVED) {
            String added = (String)data;
            if (dd == null) {
                displayFrameWork();
            }
            txOutput.append(added + "\n");
            JScrollBar bar = spCentral.getVerticalScrollBar();
            bar.setValue(bar.getMaximum());
            
        } else if (moment == CommandDisplayer.MOMENT_FINISHED_COMMAND 
                || moment == CommandDisplayer.MOMENT_EXECUTE_FAILED) { 
            // do change the buttons.
             if (dd == null) {
                 displayFrameWork();
             }
             displayOutputData();
        }        
    }
    
}
