/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands;

import org.netbeans.lib.cvsclient.command.Command;
import org.netbeans.lib.cvsclient.commandLine.GetOpt;
import java.util.StringTokenizer;
import java.util.LinkedList;
import org.openide.util.NbBundle;

/**
 *  A CommandParamInput implementing class that parses the switches received by user
 * and sets the apropriate properties of the Command.
 * @author  mkleint
 */
public class CommandLineParamInput extends javax.swing.JPanel 
                                   implements CommandParamInput {

    /** Creates new form CommandLineParamInput */
    public CommandLineParamInput() {
        initComponents ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        lblCommandLine = new javax.swing.JLabel();
        txCommandLine = new javax.swing.JTextField();
        lblCommandName = new javax.swing.JLabel();
        txCommandName = new javax.swing.JTextField();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        lblCommandLine.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/Bundle").getString("CommandLineParamInput.lblCommandLine.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        add(lblCommandLine, gridBagConstraints1);
        
        
        txCommandLine.setPreferredSize(new java.awt.Dimension(175, 20));
        txCommandLine.setMinimumSize(new java.awt.Dimension(50, 20));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txCommandLine, gridBagConstraints1);
        
        
        lblCommandName.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/Bundle").getString("CommandLineParamInput.lblCommandName.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        add(lblCommandName, gridBagConstraints1);
        
        
        txCommandName.setPreferredSize(new java.awt.Dimension(70, 20));
        txCommandName.setEditable(false);
        txCommandName.setText("jTextField1");
        txCommandName.setMinimumSize(new java.awt.Dimension(40, 20));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txCommandName, gridBagConstraints1);
        
    }//GEN-END:initComponents

    /** fills the param input with a command.. the switches of the param input
     * act accordingly and set themselves that way
     */
    public void getData(Command command) {
        txCommandLine.setText(command.getCVSArguments());
        String name = command.getCVSCommand();
        int index = name.indexOf(' ');
        if (index > 0) {
            name = name.substring(0, index);
        }
        txCommandName.setText(name);
    }    

    /** sets the comand with the params the user selected in the dialog.
     */
    public void setData(Command command) {
        StringTokenizer tokens = new StringTokenizer(txCommandLine.getText(), " \"", true);
        boolean withinString = false;
        LinkedList stringList = new LinkedList();
        while (tokens.hasMoreTokens()) {
            String tok = tokens.nextToken();
            if (tok.equals("\"")) {
                 String param = "";
                 while (tokens.hasMoreTokens()) {
                    String toke2 = tokens.nextToken();
                    if (toke2.equals("\"")) break;
                    param = param + toke2;
                }
                stringList.add(param);
            } else {
                if (!tok.equals(" ")) {
                    stringList.add(tok);
                }
            }
        }
        String[] args = new String[stringList.size()];
        args = (String[])stringList.toArray(args);
        // DEBUG start
/*        for (int id = 0; id < args.length; id++) {
            System.out.println("args[" + id + "]=" + args[id]);
        }
 */
        // DEBUG end
        // 2. set the parameters to the command.
        command.resetCVSCommand();
        final String getOptString = command.getOptString();
        GetOpt go = new GetOpt(args, getOptString);
        int ch = -1;
        go.optIndexSet(0);
           // maybe should be set to another number         go.optIndexSet(0);
        boolean usagePrint = false;
        String arg;
        while ((ch = go.getopt()) != go.optEOF)
        {   
   //         System.out.println("option=" + (char)ch + "arg=" + go.optArgGet());
            boolean ok = command.setCVSCommand((char)ch, go.optArgGet());
        }
        int fileArgsIndex = go.optIndexGet();
    }
    
    /** For GUI instances, uses the returned string as The dialog Label. 
     */
    public String getDialogTitle() {
        return NbBundle.getBundle(CommandLineParamInput.class).getString("CommandLineParamInput.dialogTitle");
    }
    
    /** Defines wheather the ParamInput needs to be displayed or not. 
     * If set to true, it puts the class into the DialogDescriptor.
     */
    public boolean requiresUI() {
        return true;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel lblCommandLine;
    private javax.swing.JTextField txCommandLine;
    private javax.swing.JLabel lblCommandName;
    private javax.swing.JTextField txCommandName;
    // End of variables declaration//GEN-END:variables

}
