/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands;

/**
 *  Defines the interface for all classes (both GUI and non-GUI that set 
 * the switches to the cvs commands.
 * @author  mkleint
 */

import org.netbeans.lib.cvsclient.command.Command;

public interface CommandParamInput {

    /** fills the param input with a command.. the switches of the param input
     * act accordingly and set themselves that way
     */
    public void getData(Command command);
    
    /** sets the comand with the params the user selected in the dialog.
     */
    public void setData(Command command);
    
    /** For GUI instances, uses the returned string as The dialog Label. 
     */
    public String getDialogTitle();
    
    /** Defines wheather the ParamInput needs to be displayed or not. 
     * If set to true, it puts the class into the DialogDescriptor.
     */
    public boolean requiresUI();
        
}

