/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.cvsclient.commands.add;

import java.util.*;
import java.io.IOException;
import java.io.File;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;
import org.netbeans.lib.cvsclient.command.*;
import org.netbeans.lib.cvsclient.command.add.*;
import org.netbeans.modules.vcscore.util.Debug;
import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.modules.cvsclient.commands.commit.CvsCommit;

import org.openide.util.NbBundle;
import org.openide.*;


public class AddInfoPanel extends javax.swing.JPanel implements CommandDisplayer {
    private Debug E=new Debug("AddInfoPanel", true); // NOI18N
    private Debug D=E;
    
    ArrayList resultList;
    ArrayList listeners;
    ClientProvider provider;
    CvsAdd command;
    AddTableInfoModel model;
    DialogDescriptor dd;
    private boolean stopped;
    
    /** Creates new form UpdateInfoPanel */
    public AddInfoPanel(ClientProvider fs, CvsAdd comm) {
        initComponents ();
        provider = fs;
        command = comm;
        setPreferredSize(new java.awt.Dimension(450, 300));
        setMinimumSize(new java.awt.Dimension(450, 200));        
        stopped = false;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        pnlButtons = new javax.swing.JPanel();
        spCentral = new javax.swing.JScrollPane();
        tblAdded = new javax.swing.JTable();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        pnlButtons.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        add(pnlButtons, gridBagConstraints1);
        
        
        spCentral.setPreferredSize(new java.awt.Dimension(250, 60));
        
        tblAdded.setModel(new javax.swing.table.DefaultTableModel (
        new Object [][] {
            {null, null, null, null},
            {null, null, null, null},
            {null, null, null, null},
            {null, null, null, null}
        },
        new String [] {
            "Title 1", "Title 2", "Title 3", "Title 4"
        }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class
            };
            
            public Class getColumnClass (int columnIndex) {
                return types [columnIndex];
            }
        });
        spCentral.setViewportView(tblAdded);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 11);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(spCentral, gridBagConstraints1);
        
    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel pnlButtons;
    private javax.swing.JScrollPane spCentral;
    private javax.swing.JTable tblAdded;
    // End of variables declaration//GEN-END:variables
    
    
/** this method should be used with Choosers to display the dialog..
 * then later the displayOutputData will just present the datat gotten from server
 * Reason: to have something displayer right away..
 * This method is to be called when creating the command and Chooser.
 */
    public void displayFrameWork() {
        model = new AddTableInfoModel();
        tblAdded.setModel(model);
        TableColumn col = tblAdded.getColumnModel().getColumn(0);
        col.setPreferredWidth(80);
          // HACK to set the width of column at desired size
        
        String title = NbBundle.getBundle(AddInfoPanel.class).getString("AddInfoPanel.dialogTitle") + " " + command.getName();
        dd = new DialogDescriptor(this, title);
        String[] options = new String[1];
        options[0] = NbBundle.getBundle(AddInfoPanel.class).getString("AddInfoPanel.stopButton");
        dd.setOptions(options);
        Object[] empty = new Object[1];
        dd.setClosingOptions(empty); // none are closing
        dd.setButtonListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                shutDownCommand();
            }
        });
        javax.swing.SwingUtilities.invokeLater(new Runnable () {
            public void run () {
                Dialog dial = TopManager.getDefault().createDialog(dd);
                dial.setModal(false);
                dial.show();
            }
        });
    }
    
    private void shutDownCommand() {
        // we can do that because it's running from other thread then command and won't kill itself
        command.hardCommandStop();
        stopped = true;
//        displayOutputData();
    }
    
    
    /** Does the actual display - docking into the javacvs Mode,
     *  displaying as single Dialog.. whatever.
     */
    public void displayOutputData() {
        int size;
        boolean anyScheduled = anyScheduledFiles();
        // forces the NbPresenter to keep the user's resizing.
        this.setPreferredSize(getSize());
        if (stopped || !anyScheduled) size = 2;
        else size = 3;
        Object[] options = new Object[size];
        final String log = NbBundle.getBundle(AddInfoPanel.class).getString("AddInfoPanel.logButton");
        JButton btnClose = new JButton(NbBundle.getBundle(AddInfoPanel.class)
                                 .getString("AddInfoPanel.closeButton"));
        btnClose.setDefaultCapable(true);
        final String commit = NbBundle.getBundle(AddInfoPanel.class).getString("AddInfoPanel.commitButton");
        options[size - 1] = btnClose;
        options[size - 2] = log;
        Object[] closing = new Object[size - 1];
        if (!stopped && anyScheduled) {
            options[0] = commit;
            closing[0] = options[0];            
        }
        closing[size - 2] = options[size - 1];
        dd.setValue(btnClose); // HACK
        dd.setOptions(options);
        dd.setClosingOptions(closing); // all are closing
        dd.setButtonListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                if (evt.getActionCommand().equals(commit)) {
                    performCommit();
                }
                if (evt.getActionCommand().equals(log)) {
                    showLog();
                }    
            }
        });
        JTableHeader head = tblAdded.getTableHeader();
        head.setUpdateTableInRealTime(true);
        ColumnSortListener listen = new ColumnSortListener(tblAdded);
        head.addMouseListener(listen);
    }

    private boolean anyScheduledFiles() {
        int rowCount = model.getRowCount();
        for (int index = 0; index < rowCount; index++) {
            AddInformation addInfo = (AddInformation)model.getElementAt(index);
            if (!addInfo.isDirectory()) {
                return true;
            }
        }
        return false;
    }
    
    private void performCommit() {
        //TODO after commit is implemented
        if (provider.isOffLine()) return;
        int rowCount = model.getRowCount();
        LinkedList fileList = new LinkedList();
        for (int index = 0; index < rowCount; index++) {
            AddInformation addInfo = (AddInformation)model.getElementAt(index);
            if (!addInfo.isDirectory()) {
                if (addInfo.getType().equals("A")) {
                    fileList.add(addInfo.getFile());
                }
            }
        }
        if (fileList.size() > 0) {
            File[] fileArray = new File[fileList.size()];
            fileArray = (File[])fileList.toArray(fileArray);
            CvsCommit myStat = new CvsCommit(fileArray, provider);
            myStat.setForceParamInput(true);
            myStat.startCommand();
        } else {
            //TODO.. message??
            String noScheduled = NbBundle.getBundle(AddInfoPanel.class)
                          .getString("AddInfoPanel.noScheduledAvailable");
            TopManager.getDefault().notify(new NotifyDescriptor.Message(noScheduled));
        }
    }
    
    private void showLog() {
        command.doShowCommandLog();
    }    
    
    /** Does the actual display - docking into the javacvs Mode, 
     *  displaying as single Dialog.. whatever.
     */
    public void displayOutputData(int moment, Object data) {
        if (moment == CommandDisplayer.MOMENT_AFTER_PARAM_INPUT) {
            // display empty panel.
            displayFrameWork();
        } 
        else if (moment == CommandDisplayer.MOMENT_FILE_INFO_GENERATED) {
            // new file added. Assumes the Info generated is AddInformation object
            if (data instanceof AddInformation) {
                model.addElement(data);
                tblAdded.changeSelection(model.getRowCount(), 0, false, false);
            }
        } else if (moment == CommandDisplayer.MOMENT_FINISHED_COMMAND 
                || moment == CommandDisplayer.MOMENT_EXECUTE_FAILED) { 
            // do change the buttons.
             displayOutputData();
        }
        
        
    }    
    
}
