/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */



package org.netbeans.modules.cvsclient.commands.add;

import java.util.*;
import javax.swing.*;
import org.openide.util.*;
import org.netbeans.modules.vcscore.util.Debug;

import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.lib.cvsclient.command.update.*;
import org.netbeans.lib.cvsclient.command.*;
import org.netbeans.lib.cvsclient.command.add.*;

/**
 *
 * @author  mkleint
 * @version 
 */
public class AddParamInput extends javax.swing.JPanel implements CommandParamInput {
    private Debug E=new Debug("LogParamInput", true); // NOI18N
    private Debug D=E; 
    
    private static final String K_NONE = NbBundle.getBundle(AddParamInput.class).getString("AddParamInput.NoSubstitution");
    private static final String K_BINARY = NbBundle.getBundle(AddParamInput.class).getString("AddParamInput.BinarySubst");
    private static final String K_KEYWORD_VALUE = NbBundle.getBundle(AddParamInput.class).getString("AddParamInput.KeywordValueSubst");
    private static final String K_KEYWORD_VALUE_LOCKER = NbBundle.getBundle(AddParamInput.class).getString("AddParamInput.KeywordValueLockerSubst");
    private static final String K_KEYWORD = NbBundle.getBundle(AddParamInput.class).getString("AddParamInput.Keyword");
    private static final String K_VALUE = NbBundle.getBundle(AddParamInput.class).getString("AddParamInput.Value");
    private static final String K_OLD = NbBundle.getBundle(AddParamInput.class).getString("AddParamInput.Old");
    
    private Object[] comboValues = new Object[] { K_NONE, K_BINARY, K_KEYWORD_VALUE, 
                K_KEYWORD_VALUE_LOCKER, K_KEYWORD, K_VALUE, K_OLD} ;
                
    private String[] cvsValues = new String[] { null, "b", "kv", "kvl", "k", "v", "o" };

    
    // needed to set the setRecursive() property
    private CvsAdd addFsCommand;
    
    /** Creates new form LogParamInput */
    public AddParamInput(CvsAdd addFsComm) {
        initComponents ();
        addFsCommand = addFsComm;
        cbKeyword.setModel(new DefaultComboBoxModel(comboValues));
        cbKeyword.setSelectedIndex(0);
        //TODO if all files in command are dirs, disable message + keyword subst.
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jSeparator1 = new javax.swing.JSeparator();
        lblMessage = new javax.swing.JLabel();
        spMessage = new javax.swing.JScrollPane();
        taMessage = new javax.swing.JTextArea();
        lblKeyword = new javax.swing.JLabel();
        cbKeyword = new javax.swing.JComboBox();
        lblRecursive = new javax.swing.JLabel();
        cbRecursive = new javax.swing.JCheckBox();
        lblRecursive2 = new javax.swing.JLabel();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jSeparator1.setPreferredSize(new java.awt.Dimension(100, 2));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 0, 6);
        add(jSeparator1, gridBagConstraints1);
        
        lblMessage.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/add/Bundle").getString("AddParamInput.lblMessage.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblMessage, gridBagConstraints1);
        
        spMessage.setPreferredSize(new java.awt.Dimension(100, 60));
        spMessage.setViewportView(taMessage);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 0, 6);
        add(spMessage, gridBagConstraints1);
        
        lblKeyword.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/add/Bundle").getString("AddParamInput.lblKeyword.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblKeyword, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 0, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbKeyword, gridBagConstraints1);
        
        lblRecursive.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/add/Bundle").getString("AddParamInput.lblRecursive.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 0, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(lblRecursive, gridBagConstraints1);
        
        cbRecursive.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/add/Bundle").getString("AddParamInput.cbRecursive.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbRecursive, gridBagConstraints1);
        
        lblRecursive2.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/add/Bundle").getString("AddParamInput.lblRecursive2.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(lblRecursive2, gridBagConstraints1);
        
    }//GEN-END:initComponents


  public void setData(Command command) {
      AddCommand addCom = (AddCommand)command;
      String message = taMessage.getText();
      if (message == null || (message.trim().equals(""))) {
         addCom.setMessage(null);
      } else {
         addCom.setMessage(message);
      }
      addCom.setKeywordSubst(cvsValues[cbKeyword.getSelectedIndex()]);
      addFsCommand.setRecursive(cbRecursive.isSelected());
  } 
  
  public void getData(Command command) {
      AddCommand addCom = (AddCommand)command;
      cbRecursive.setSelected(addFsCommand.isRecursive());
      for (int index = 0; index < cvsValues.length; index++) {
          if (cvsValues[index] == null) {
              if (addCom.getKeywordSubst() == null) {
                  cbKeyword.setSelectedIndex(index);
                  return;
              }
          }
          else {
              if (cvsValues[index].equals(addCom.getKeywordSubst())) {
                  cbKeyword.setSelectedIndex(index);
                  return;
              }    
          }
      }    
  }  

  public String getDialogTitle() {
     return NbBundle.getBundle(AddParamInput.class).getString("AddParamInput.dialogTitle");
  }
  
  public boolean requiresUI() {
      return true;
  }
  

  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JLabel lblMessage;
  private javax.swing.JScrollPane spMessage;
  private javax.swing.JTextArea taMessage;
  private javax.swing.JLabel lblKeyword;
  private javax.swing.JComboBox cbKeyword;
  private javax.swing.JLabel lblRecursive;
  private javax.swing.JCheckBox cbRecursive;
  private javax.swing.JLabel lblRecursive2;
  // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/add/Bundle");  

}
