/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.add;

import org.openide.util.*;
import org.netbeans.lib.cvsclient.command.add.AddInformation;
import org.netbeans.modules.cvsclient.commands.*;
import javax.swing.event.TableModelEvent;

import org.netbeans.modules.vcscore.util.Debug;
import java.util.*;

/**
 *
 * @author  mkleint
 */
public class AddTableInfoModel extends TableInfoModel {
    private Debug E=new Debug("AddTableInfoModel", true); // NOI18N
    private Debug D=E;
    
    private String IS_DIRECTORY;
    private String IS_FILE;
    private String TYPE_LABEL;
    private String FILE_LABEL;
    private String IS_RESURRECTED;
    
      public AddTableInfoModel() {
          super();
          IS_DIRECTORY = NbBundle.getBundle(AddTableInfoModel.class).getString("AddTableInfoModel.directory");
          IS_FILE = NbBundle.getBundle(AddTableInfoModel.class).getString("AddTableInfoModel.file");
          IS_RESURRECTED = NbBundle.getBundle(AddTableInfoModel.class).getString("AddTableInfoModel.resurrected");
          FILE_LABEL = NbBundle.getBundle(TableInfoModel.class).getString("TableInfoModel.fileName");
          TYPE_LABEL = NbBundle.getBundle(AddTableInfoModel.class).getString("AddTableInfoModel.type");
      }
      
      public int getColumnCount() {
          return 2;
      }
      
      public Object getValueAt(int row, int column) {
//          if (row < 0 || row >= getRowCount()) return "";
          AddInformation info = (AddInformation)list.get(row);
          switch (column) {
              case 0 : return getType(info);
              case 1 : return info.getFile().getName();
          }
          return "";
      }
      
      private String getType(AddInformation info) {
          if (info.isDirectory()) return IS_DIRECTORY;
          if (info.getType().equals("A")) {
              return IS_FILE;
          } 
          if (info.getType().equals("U")) {
              return IS_RESURRECTED;
          }
          return "";
      }    
      
      public java.lang.String getColumnName(int param) {
          switch (param) {
              case 1 : return FILE_LABEL;
              case 0 : return TYPE_LABEL;
          }
          return "";
          
      }
      
      
      public int compare(Object obj1, Object obj2) {
          if (!(obj1 instanceof AddInformation) ||
          !(obj2 instanceof AddInformation)) return 0;
          AddInformation rev1 = (AddInformation)obj1;
          AddInformation rev2 = (AddInformation)obj2;
          int result = 0;
          switch (getActiveColumn()) {
              case 1: // filesname
                  result = getDirection() * (rev1.getFile().getName().compareTo(rev2.getFile().getName()));
                  break;
              case 0:     //status
                  result = getDirection() * (getType(rev1).compareTo(getType(rev2)));
                  break;
          }
          return result;
      }
      
      public void addElement(Object object)
      {
          super.addElement(object);
          fireTableRowsInserted(list.size(), list.size());
      }      
      
}

