/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */



package org.netbeans.modules.cvsclient.commands.checkout;

import java.util.*;
import javax.swing.*;
import org.openide.util.*;
import org.netbeans.modules.cvsclient.util.*;
import org.netbeans.lib.cvsclient.command.checkout.*;
import org.netbeans.lib.cvsclient.command.*;
import org.netbeans.modules.cvsclient.commands.*;


/**
 *
 * @author  mkleint
 * @version
 */
public class CheckoutParamInput extends javax.swing.JPanel implements CommandParamInput {
    private Debug E=new Debug("LogParamInput", true); // NOI18N
    private Debug D=E;
    private ClientProvider provider;
    private ModuleChooser moduleChooser = null;
    
    private static final String K_NONE = NbBundle.getBundle(CheckoutParamInput.class).getString("CheckoutParamInput.NoSubstitution");
    private static final String K_BINARY = NbBundle.getBundle(CheckoutParamInput.class).getString("CheckoutParamInput.BinarySubst");
    private static final String K_KEYWORD_VALUE = NbBundle.getBundle(CheckoutParamInput.class).getString("CheckoutParamInput.KeywordValueSubst");
    private static final String K_KEYWORD_VALUE_LOCKER = NbBundle.getBundle(CheckoutParamInput.class).getString("CheckoutParamInput.KeywordValueLockerSubst");
    private static final String K_KEYWORD = NbBundle.getBundle(CheckoutParamInput.class).getString("CheckoutParamInput.Keyword");
    private static final String K_VALUE = NbBundle.getBundle(CheckoutParamInput.class).getString("CheckoutParamInput.Value");
    private static final String K_OLD = NbBundle.getBundle(CheckoutParamInput.class).getString("CheckoutParamInput.Old");
    
    private Object[] comboValues = new Object[] { K_NONE, K_BINARY, K_KEYWORD_VALUE, 
                K_KEYWORD_VALUE_LOCKER, K_KEYWORD, K_VALUE, K_OLD} ;
                
    private String[] cvsValues = new String[] { "", "b", "kv", "kvl", "k", "v", "o" };

    

    /** Creates new form CheckoutParamInput */
    public CheckoutParamInput(ClientProvider fs, String modList) {
        provider = fs;
        initComponents ();
        txRevision.setEnabled(false);
        txDates.setEnabled(false);
        cbKeyword.setModel(new DefaultComboBoxModel(comboValues));
        cbKeyword.setSelectedIndex(0);
        cbForceUpdate.setEnabled(false);
        txModule.setText(modList);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        cbLocal = new javax.swing.JCheckBox();
        jSeparator1 = new javax.swing.JSeparator();
        cbDates = new javax.swing.JCheckBox();
        txDates = new javax.swing.JTextField();
        cbRevision = new javax.swing.JCheckBox();
        txRevision = new javax.swing.JTextField();
        cbForceUpdate = new javax.swing.JCheckBox();
        cbClearSticky = new javax.swing.JCheckBox();
        cbPruneEmpty = new javax.swing.JCheckBox();
        cbPipeToOutput = new javax.swing.JCheckBox();
        jSeparator2 = new javax.swing.JSeparator();
        cbModuleNames = new javax.swing.JCheckBox();
        cbModNamesAndStatus = new javax.swing.JCheckBox();
        lblModule = new javax.swing.JLabel();
        txModule = new javax.swing.JTextField();
        btnModule = new javax.swing.JButton();
        cbKeyword = new javax.swing.JComboBox();
        lblKeyword = new javax.swing.JLabel();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        cbLocal.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbLocal.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbLocal, gridBagConstraints1);
        
        
        jSeparator1.setPreferredSize(new java.awt.Dimension(100, 2));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = 5;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 11);
        add(jSeparator1, gridBagConstraints1);
        
        
        cbDates.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbDates.text"));
        cbDates.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbDatesActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbDates, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 80;
        gridBagConstraints1.insets = new java.awt.Insets(6, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txDates, gridBagConstraints1);
        
        
        cbRevision.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbRevision.text"));
        cbRevision.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbRevisionActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbRevision, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 80;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txRevision, gridBagConstraints1);
        
        
        cbForceUpdate.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbForceUpdate.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbForceUpdate, gridBagConstraints1);
        
        
        cbClearSticky.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbClearStciky.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbClearSticky, gridBagConstraints1);
        
        
        cbPruneEmpty.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbPruneEmpty.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.insets = new java.awt.Insets(12, 0, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbPruneEmpty, gridBagConstraints1);
        
        
        cbPipeToOutput.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbPipeToOutput.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbPipeToOutput, gridBagConstraints1);
        
        
        jSeparator2.setPreferredSize(new java.awt.Dimension(100, 2));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.gridwidth = 5;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 11);
        add(jSeparator2, gridBagConstraints1);
        
        
        cbModuleNames.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/checkout/Bundle").getString("CheckoutParamInput.cbModuleNames.text"));
        cbModuleNames.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbModuleNamesActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 7;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbModuleNames, gridBagConstraints1);
        
        
        cbModNamesAndStatus.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/checkout/Bundle").getString("CheckoutParamInput.cbModNamesAndStatus.text"));
        cbModNamesAndStatus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbModNamesAndStatusActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 7;
        gridBagConstraints1.insets = new java.awt.Insets(6, 0, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbModNamesAndStatus, gridBagConstraints1);
        
        
        lblModule.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/checkout/Bundle").getString("CheckoutParamInput.lblModule.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 8;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 13, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblModule, gridBagConstraints1);
        
        
        txModule.setText("jTextField1");
        txModule.setMaximumSize(new java.awt.Dimension(200, 20));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 8;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 6);
        add(txModule, gridBagConstraints1);
        
        
        btnModule.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/checkout/Bundle").getString("CheckoutParamInput.btnModule.text"));
        btnModule.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnModuleActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 4;
        gridBagConstraints1.gridy = 8;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 11);
        add(btnModule, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbKeyword, gridBagConstraints1);
        
        
        lblKeyword.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/checkout/Bundle").getString("CheckoutParamInput.lblKeyword.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblKeyword, gridBagConstraints1);
        
    }//GEN-END:initComponents

  private void btnModuleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnModuleActionPerformed
      if (provider.isOffLine()) return;
      if (moduleChooser == null) {
          CvsCompleteModList myCom = new CvsCompleteModList(provider);
          moduleChooser = new ModuleChooser(myCom);
          moduleChooser.addChooserFinishListener(new ChooserFinishListener() {
              public void chooserFinished(ChooserFinishEvent event) {
                  pasteChosenItems(event);
              }
          });
          myCom.setOutputDisplayer(moduleChooser);
          myCom.setFixedDisplayType(true);
          myCom.addCommandErrorListener(moduleChooser);
          //        moduleChooser.displayFrameWork();
          // Do show the dialog before starting the command??
          myCom.startCommand();
      } else {
          if (moduleChooser.wasFinished()) {
              moduleChooser.displayFrameWork();
              moduleChooser.displayOutputData();
          } else if (moduleChooser.isShowingDial()) {
              moduleChooser.displayFrameWork();
          } else {
              //kinda hack to force the rereun of the command
              moduleChooser = null;
              btnModuleActionPerformed(evt);
          }
      }
  }//GEN-LAST:event_btnModuleActionPerformed
    
  private void cbModNamesAndStatusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbModNamesAndStatusActionPerformed
      // Add your handling code here:
      disableAllExceptTop(cbModNamesAndStatus, !cbModNamesAndStatus.isSelected());
  }//GEN-LAST:event_cbModNamesAndStatusActionPerformed
  
  private void cbModuleNamesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbModuleNamesActionPerformed
      // Add your handling code here:
      disableAllExceptTop(cbModuleNames, !cbModuleNames.isSelected());
  }//GEN-LAST:event_cbModuleNamesActionPerformed
  
  
  private void cbRevisionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbRevisionActionPerformed
      // Add your handling code here:
      D.deb("calling class name=" + evt.getSource().getClass().getName());
      enableRevision();
  }//GEN-LAST:event_cbRevisionActionPerformed
  
  private void cbDatesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbDatesActionPerformed
      // Add your handling code here:
     enableDate();          
  }//GEN-LAST:event_cbDatesActionPerformed
  
  public void setData(Command command) {
      CheckoutCommand updCom = (CheckoutCommand)command;
      updCom.setModules(null);
      updCom.resetCVSCommand();
      if (cbModuleNames.isSelected()) {
          updCom.setShowModules(true);
          return;
      }
      if (cbModNamesAndStatus.isSelected()) {
          updCom.setShowModulesWithStatus(true);
          return;
      }
      updCom.setModules(getModArray());
      updCom.setRecursive(!cbLocal.isSelected());
      if (cbDates.isSelected()) {
          updCom.setCheckoutByDate(txDates.getText().trim());
      }
      if (cbRevision.isSelected()) { 
          updCom.setCheckoutByRevision(txRevision.getText().trim());
      }
      updCom.setKeywordSubst(cvsValues[cbKeyword.getSelectedIndex()]);
      updCom.setResetStickyOnes(cbClearSticky.isSelected());
      updCom.setUseHeadIfNotFound(cbForceUpdate.isSelected());
      updCom.setPipeToOutput(cbPipeToOutput.isSelected());
      updCom.setPruneDirectories(cbPruneEmpty.isSelected());
  }

  public void getData(Command command) {
      CheckoutCommand updCom = (CheckoutCommand)command;
      cbModuleNames.setSelected(updCom.isShowModules());
      cbModNamesAndStatus.setSelected(updCom.isShowModulesWithStatus());
      cbLocal.setSelected(!updCom.getRecursive());
      cbDates.setSelected(false); //TODO
      cbRevision.setSelected(false); //TODO
      cbPipeToOutput.setSelected(updCom.isPipeToOutput());
      cbClearSticky.setSelected(updCom.isResetStickyOnes());
      cbForceUpdate.setSelected(updCom.isUseHeadIfNotFound());
      cbPruneEmpty.setSelected(updCom.getPruneDirectories());
      String updByDate = updCom.getCheckoutByDate();
      if (updByDate != null && (!updByDate.equals(""))) {
          cbDates.setSelected(true);
          txDates.setText(updByDate);
      }    
      String updByRev = updCom.getCheckoutByRevision();
      if (updByRev != null && (!updByRev.equals(""))) {
          cbRevision.setSelected(true);
          txRevision.setText(updByRev);
      }  
      String keyword = updCom.getKeywordSubst();
      for (int index = 0; index < cvsValues.length; index++) {
          if (cvsValues[index].equals(keyword)) {
              cbKeyword.setSelectedIndex(index);
              break;
          }    
      }    
  }

  
  private String[] getModArray() {
      String modules = txModule.getText();
      StringTokenizer tok = new StringTokenizer(modules, " ", false);
      String[] modArray = new String[tok.countTokens()];
      int index = 0;
      while (tok.hasMoreTokens()) {
          modArray[index] = tok.nextToken();
          index = index + 1;
      }
      return modArray;
  }
  
  public String getDialogTitle() {
      return NbBundle.getBundle(CheckoutParamInput.class).getString("CheckoutParamInput.dialogTitle");
  }
  
  public boolean requiresUI() {
      return true;
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JCheckBox cbLocal;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JCheckBox cbDates;
  private javax.swing.JTextField txDates;
  private javax.swing.JCheckBox cbRevision;
  private javax.swing.JTextField txRevision;
  private javax.swing.JCheckBox cbForceUpdate;
  private javax.swing.JCheckBox cbClearSticky;
  private javax.swing.JCheckBox cbPruneEmpty;
  private javax.swing.JCheckBox cbPipeToOutput;
  private javax.swing.JSeparator jSeparator2;
  private javax.swing.JCheckBox cbModuleNames;
  private javax.swing.JCheckBox cbModNamesAndStatus;
  private javax.swing.JLabel lblModule;
  private javax.swing.JTextField txModule;
  private javax.swing.JButton btnModule;
  private javax.swing.JComboBox cbKeyword;
  private javax.swing.JLabel lblKeyword;
  // End of variables declaration//GEN-END:variables

private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/Bundle");
  
  
  private void disableAllExceptTop(JCheckBox onlyOne, boolean disable) {
      cbLocal.setEnabled(disable);
      cbDates.setEnabled(disable);
      txDates.setEnabled(disable);
      cbRevision.setEnabled(disable);
      txRevision.setEnabled(disable);
      cbForceUpdate.setEnabled(disable);
      cbClearSticky.setEnabled(disable);
      cbPruneEmpty.setEnabled(disable);
      cbKeyword.setEnabled(disable);
      cbKeyword.setEnabled(disable);
      cbPipeToOutput.setEnabled(disable);
      if (!cbModuleNames.equals(onlyOne)) {
          cbModuleNames.setEnabled(disable);
      }
      if (!cbModNamesAndStatus.equals(onlyOne)) {
          cbModNamesAndStatus.setEnabled(disable);
      }
      txModule.setEnabled(disable);
      btnModule.setEnabled(disable);
      if (disable) {
        enableRevision();
        enableDate();
      }
  }

  
  private void enableDate() {
      txDates.setEnabled(cbDates.isSelected());
      if (cbDates.isSelected()) {
          cbForceUpdate.setEnabled(true);
      } else {
          if (!cbRevision.isSelected()) {
              cbForceUpdate.setSelected(false);
              cbForceUpdate.setEnabled(false);
          }
      }
  }
  
  private void enableRevision() {
      txRevision.setEnabled(cbRevision.isSelected());
      if (cbRevision.isSelected()) {
          cbForceUpdate.setEnabled(true);
      } else {
          if (!cbDates.isSelected()) {
              cbForceUpdate.setSelected(false);
              cbForceUpdate.setEnabled(false);
          }
      }
  }
  
  private void enableKeyWords() {
  }
  
  private void pasteChosenItems(ChooserFinishEvent evt) {
      String selected = (String) evt.getChooser().getValue();
      if (selected != null) {
         txModule.setText(selected);
      }
  }
  
  
}
