/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.checkout;

/**
 *
 * @author  mkleint
 * @version 
 */

import java.util.Collection;
import java.util.List;
import java.awt.Dialog;
import javax.swing.table.*;

import org.netbeans.modules.cvsclient.commands.CommandDisplayer;
import org.netbeans.modules.cvsclient.commands.FileSystemCommand;
import org.netbeans.modules.cvsclient.commands.ColumnSortListener;

import org.netbeans.modules.vcscore.util.Debug;
import org.openide.util.NbBundle;

public class ModulesListPanel extends javax.swing.JPanel implements CommandDisplayer {
    private Debug E=new Debug("ModuleListPanel", true); // NOI18N
    private Debug D=E;
    protected ModulesTableInfoModel model;
    
    /** Creates new form ModulesListPanel */
    public ModulesListPanel() {
        initComponents ();
        JTableHeader head = tblModules.getTableHeader();
        head.setUpdateTableInRealTime(true);
        ColumnSortListener listen = new ColumnSortListener(tblModules);
        head.addMouseListener(listen);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        spModules = new javax.swing.JScrollPane();
        tblModules = new javax.swing.JTable();
        setLayout(new java.awt.BorderLayout());
        
        spModules.setPreferredSize(new java.awt.Dimension(500, 200));
        
        tblModules.setModel(new javax.swing.table.DefaultTableModel (
          new Object [][] {
              {null, null, null, null},
              {null, null, null, null},
              {null, null, null, null},
              {null, null, null, null}
          },
          new String [] {
              "Title 1", "Title 2", "Title 3", "Title 4"
          }
          ) {
              Class[] types = new Class [] {
                  java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class
              };
              
              public Class getColumnClass (int columnIndex) {
                  return types [columnIndex];
              }
          });
          spModules.setViewportView(tblModules);
          
          
        add(spModules, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents

    /** in this method the displayer should use the data returned by the command to
 * produce it's own data structures/ fill in UI components
 * @param resultList - the data from the command. It is assumed the Displayer 
 * knows what command the data comes from and most important in what format. 
 * (which FileInfoContainer class is used).
 */
    public void setDataToDisplay(Collection resultList) {
        List results = (List)resultList;
        model = new ModulesTableInfoModel(results);
        tblModules.setModel(model);
        TableColumn col = tblModules.getColumnModel().getColumn(1);
        col.setPreferredWidth(40);
        col = tblModules.getColumnModel().getColumn(0);
        col.setPreferredWidth(120);
        col = tblModules.getColumnModel().getColumn(2);
        col.setPreferredWidth(80);
    }    

    /** Does the actual display - docking into the javacvs Mode, 
 *  displaying as single Dialog.. whatever.
 */
    public void displayOutputData() {
       Dialog dial = FileSystemCommand.createDialog(this, NbBundle.getBundle(ModulesListPanel.class).getString("CvsCheckout.modulesListTitle"));                    
       dial.show();
    }
    
    /** Does the actual display - docking into the javacvs Mode, 
     *  displaying as single Dialog.. whatever.
     */
    public void displayOutputData(int moment,Object data) {
       if (moment == CommandDisplayer.MOMENT_FINISHED_COMMAND) 
       {
             List lst = (List)data;
             setDataToDisplay(lst);
             displayOutputData();
       }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane spModules;
    protected javax.swing.JTable tblModules;
    // End of variables declaration//GEN-END:variables


}
