/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.checkout;

import org.openide.util.*;
import org.netbeans.lib.cvsclient.command.checkout.ModuleListInformation;
import javax.swing.event.TableModelEvent;
import org.netbeans.modules.cvsclient.commands.TableInfoModel;

import org.netbeans.modules.vcscore.util.Debug;
import java.util.*;

/**
 *
 * @author  mkleint
 */
public class ModulesTableInfoModel extends TableInfoModel {
    private Debug E=new Debug("ModulesTableInfoModel", true); // NOI18N
    private Debug D=E;
      
    private String column1;
    private String column2;
    private String column3;
    private String column4;
    
      public ModulesTableInfoModel(List modulesInfo) {
          super();
          if (modulesInfo != null) {
              list = new LinkedList(modulesInfo);
          } else {
              list = new LinkedList();
          }
          setDirection(true);
          setActiveColumn(0);
          column1 = NbBundle.getBundle(ModulesTableInfoModel.class).getString("ModulesTableInfoModel.module");
          column2 = NbBundle.getBundle(ModulesTableInfoModel.class).getString("ModulesTableInfoModel.moduleType");
          column3 = NbBundle.getBundle(ModulesTableInfoModel.class).getString("ModulesTableInfoModel.moduleStatus");
          column4 = NbBundle.getBundle(ModulesTableInfoModel.class).getString("ModulesTableInfoModel.modulePaths");
      }
      
      public int getColumnCount() {
          return 4;
      }
      
      public Object getValueAt(int row, int column) {
//          if (row < 0 || row >= getRowCount()) return "";
          ModuleListInformation info = (ModuleListInformation)list.get(row);
          switch (column) {
              case 0 : return info.getModuleName();
              case 1 : return (info.getType() == null ? "" : info.getType());
              case 2 : return (info.getModuleStatus() == null ? "" : info.getModuleStatus());
              case 3 : return (info.getPaths() == null ? "" : info.getPaths()); 
          }
          return "";
      }
      
      public java.lang.String getColumnName(int param) {
          switch (param) {
              case 0 : return column1;
              case 1 : return column2;
              case 2 : return column3;
              case 3 : return column4;
          }
          return "";
          
      }
      
      
      public int compare(Object obj1, Object obj2) {
          if (!(obj1 instanceof ModuleListInformation) ||
          !(obj2 instanceof ModuleListInformation)) return 0;
          ModuleListInformation rev1 = (ModuleListInformation)obj1;
          ModuleListInformation rev2 = (ModuleListInformation)obj2;
          int result = 0;
          switch (getActiveColumn()) {
              case 0: // module names
                  result = getDirection() * (rev1.getModuleName().compareTo(rev2.getModuleName()));
                  break;
              case 1:     //type
                  String type1 = (rev1.getType() == null ? "" : rev1.getType());
                  String type2 = (rev2.getType() == null ? "" : rev2.getType());
                  result = getDirection() * (type1.compareTo(type2));
                  break;
              case 2:     // status
                  String status1 = (rev1.getModuleStatus() == null ? "" : rev1.getModuleStatus());                  
                  String status2 = (rev2.getModuleStatus() == null ? "" : rev2.getModuleStatus());                  
                  result = getDirection() * (status1.compareTo(status2));
                  break;
          }
          return result;
      }
      
      public void addElement(Object object)
      {
          super.addElement(object);
//          fireTableRowsInserted(list.size(), list.size());
      }      
      
}

