/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.cvsclient.commands.commit;

import java.util.*;
import java.io.IOException;
import java.io.File;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.text.StyledDocument;
import java.awt.*;
import java.awt.event.*;
import org.netbeans.lib.cvsclient.command.*;
import org.netbeans.lib.cvsclient.command.commit.*;
import org.netbeans.modules.vcscore.util.Debug;
import org.netbeans.modules.vcscore.util.FileEditorSupport;
import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.modules.cvsclient.JavaCvsFileSystem;
import org.openide.util.NbBundle;
import org.openide.filesystems.*;
import org.openide.loaders.*;
import org.openide.cookies.*;
import org.openide.*;

public class CommitInfoPanel extends javax.swing.JPanel implements CommandDisplayer {
    private Debug E=new Debug("CommitInfoPanel", true); // NOI18N
    private Debug D=E;
    
    ClientProvider provider;
    CommitTableInfoModel model;
    CvsCommit command;
    DialogDescriptor dd;
    /** Creates new form UpdateInfoPanel */
    public CommitInfoPanel(ClientProvider fs, CvsCommit comm) {
        initComponents ();
        provider = fs;
        command = comm;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        pnlButtons = new javax.swing.JPanel();
        spCentral = new javax.swing.JScrollPane();
        tblUpdates = new javax.swing.JTable();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        setPreferredSize(new java.awt.Dimension(273, 170));
        setMinimumSize(new java.awt.Dimension(170, 100));
        
        pnlButtons.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 11);
        add(pnlButtons, gridBagConstraints1);
        
        
        spCentral.setPreferredSize(new java.awt.Dimension(250, 60));
        
        tblUpdates.setModel(new javax.swing.table.DefaultTableModel (
        new Object [][] {
            {null, null, null, null},
            {null, null, null, null},
            {null, null, null, null},
            {null, null, null, null}
        },
        new String [] {
            "Title 1", "Title 2", "Title 3", "Title 4"
        }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class
            };
            
            public Class getColumnClass (int columnIndex) {
                return types [columnIndex];
            }
        });
        spCentral.setViewportView(tblUpdates);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 11);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(spCentral, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void btnEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditActionPerformed
 /*       // Add your handling code here:
      if (!provider.isFileSystemClient()) return; //TODO
      JavaCvsFileSystem fileSystem = (JavaCvsFileSystem)provider;
      CommitInformation updInfo = (CommitInformation)model.getElementAt(tblUpdates.getSelectedRow());
      File file = updInfo.getFile();
      FileObject fObj = fileSystem.getFileObjectForFile(file);
      if (fObj == null) {
         //TODO display it standalone.. warn that it's not accessible from filesystem
         FileEditorSupport.FileEnvironment env = new FileEditorSupport.FileEnvironment(file, getMIMEType(file));
         FileEditorSupport edit = new FileEditorSupport(file, env);
         return;
      }
      try {
          DataObject dObj = DataObject.find(fObj);
          EditorCookie ec = (EditorCookie)(dObj.getCookie(EditorCookie.class));
          if (ec != null) {
              ec.open();
              StyledDocument doc = ec.openDocument();  
          }
      } catch (DataObjectNotFoundException exc) {
          E.err("DataObject not found");
      } catch (IOException ioExc) {
          E.err("IOException");
      }
  */
    }//GEN-LAST:event_btnEditActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel pnlButtons;
    private javax.swing.JScrollPane spCentral;
    private javax.swing.JTable tblUpdates;
    // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle");  

   
/*    private UpdatetableInfoModel createModel(ArrayList results) {
        UpdateListModel updModel = new UpdateListModel(results, fileSystem.getRootDirectory().getAbsolutePath());
        return updModel;
    }
*/
/** this method should be used with Choosers to display the dialog.. 
 * then later the displayOutputData will just present the datat gotten from server
 * Reason: to have something displayer right away..
 * This method is to be called when creating the command and Chooser.
 */
    public void displayFrameWork() {
        model = new CommitTableInfoModel();
        tblUpdates.setModel(model);
        TableColumn col = tblUpdates.getColumnModel().getColumn(0);
        col.setPreferredWidth(60);
          // HACK to set the width of column at desired size
        
        String title = NbBundle.getBundle(CommitInfoPanel.class).getString("CommitInfoPanel.dialogTitle") + " " + command.getName();
        dd = new DialogDescriptor(this, title);
        String[] options = new String[1];
        options[0] = NbBundle.getBundle(CommitInfoPanel.class).getString("CommitInfoPanel.stopButton");
        dd.setOptions(options);
        Object[] empty = new Object[1];
        dd.setClosingOptions(empty); // none are closing
        dd.setButtonListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                shutDownCommand();
            }
        });
        javax.swing.SwingUtilities.invokeLater(new Runnable () {
            public void run () {
               Dialog dial = TopManager.getDefault().createDialog(dd);
               dial.setModal(false);
               dial.show();
            }
        });        
    }
    
    private void shutDownCommand() {
        // we can do that because it's running from other thread then command and won't kill itself
        command.hardCommandStop();
   //     displayOutputData();
    }

    

    /** Does the actual display - docking into the javacvs Mode, 
 *  displaying as single Dialog.. whatever.
 */
    public void displayOutputData() {
        // forces the NbPresenter to keep the user's resizing.
        this.setPreferredSize(getSize());
        Object[] options = new Object[2];
        JButton btnClose = new JButton();
        btnClose.setText(NbBundle.getBundle(CommitInfoPanel.class).getString("CommitInfoPanel.closeButton"));
        btnClose.setDefaultCapable(true);
        options[1] = btnClose;
        dd.setValue(btnClose);
        final String log = NbBundle.getBundle(CommitInfoPanel.class).getString("CommitInfoPanel.logButton");
        options[0] = log;
        Object[] closing = new Object[1];
        closing[0] = options[1];
        dd.setOptions(options);
        dd.setClosingOptions(closing); // all are closing
        dd.setButtonListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                if (evt.getActionCommand().equals(log)) {
                    command.doShowCommandLog();
                }    
            }
        });
        JTableHeader head = tblUpdates.getTableHeader();
        head.setUpdateTableInRealTime(true);
        ColumnSortListener listen = new ColumnSortListener(tblUpdates);
        head.addMouseListener(listen);

    }  
    
    private String getMIMEType(File infoFile) {
        if (infoFile == null) return "text/plain";
        String tempStr = infoFile.getName();
        String extension = null;
        D.deb("tempStr=" + tempStr);
        int ind = tempStr.indexOf('.');
        if (ind > 0) {
            extension = tempStr.substring(ind + 1);
        }
        D.deb("extension=" + extension);
        if (extension == null) {
            extension = "text/plain";
        }
        String type = FileUtil.getMIMEType(extension);
        if (type == null) {
            type = "text/plain";
        }
        return type;
    }
    
    /** Does the actual display - docking into the javacvs Mode, 
     *  displaying as single Dialog.. whatever.
 */
    public void displayOutputData(int moment,Object data) {
        if (moment == CommandDisplayer.MOMENT_AFTER_PARAM_INPUT) {
            // display empty panel.
            displayFrameWork();
        } 
        else if (moment == CommandDisplayer.MOMENT_FILE_INFO_GENERATED) {
            // new file added. Assumes the Info generated is UpdateInformation object
            if (data instanceof CommitInformation) {
                model.addElement(data);
                tblUpdates.changeSelection(model.getRowCount(), 0, false, false);
            }
        } else if (moment == CommandDisplayer.MOMENT_FINISHED_COMMAND 
                || moment == CommandDisplayer.MOMENT_EXECUTE_FAILED) { 
            // do change the buttons.
             displayOutputData();
        }        
        
    }
    
}
