/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */



package org.netbeans.modules.cvsclient.commands.commit;

import java.util.*;
import java.io.File;
import org.openide.util.*;
import org.netbeans.modules.vcscore.util.*;
import javax.swing.JFrame;
import javax.swing.ButtonGroup;

import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.lib.cvsclient.command.DefaultFileInfoContainer;
import org.netbeans.modules.cvsclient.commands.update.*;
import org.netbeans.lib.cvsclient.command.Command;
import org.netbeans.lib.cvsclient.command.GlobalOptions;
import org.netbeans.lib.cvsclient.command.commit.*;

/**
 *
 * @author  mkleint
 * @version 
 */
public class CommitParamInput extends javax.swing.JPanel implements CommandParamInput {
    private Debug E=new Debug("CommitParamInput", true); // NOI18N
    private Debug D=E; 
    private CommitMessageChooser chooser;
    private CvsCommit currentFSCommand;
    private ClientProvider provider;
    private HashMap messageMap;
    
    /** Creates new form LogParamInput */
    public CommitParamInput(ClientProvider fs, CvsCommit current) {
        initComponents ();
        txRevision.setEnabled(false);
        ButtonGroup bg = new ButtonGroup();
        bg.add(rbFileMessage);
        bg.add(rbMessage);
//        txDates.setEnabled(false);
//        txKeyword.setEnabled(false);
//        cbForceUpdate.setEnabled(false);
        currentFSCommand = current;
        provider = fs;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        cbLocal = new javax.swing.JCheckBox();
        jSeparator1 = new javax.swing.JSeparator();
        cbRevision = new javax.swing.JCheckBox();
        txRevision = new javax.swing.JTextField();
        cbForceCommit = new javax.swing.JCheckBox();
        cbNoModule = new javax.swing.JCheckBox();
        rbFileMessage = new javax.swing.JRadioButton();
        txFileMessage = new javax.swing.JTextField();
        btnFileMessage = new javax.swing.JButton();
        rbMessage = new javax.swing.JRadioButton();
        spMessage = new javax.swing.JScrollPane();
        taMessage = new javax.swing.JTextArea();
        btnIndividualMessage = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JSeparator();
        btnClearIndividual = new javax.swing.JButton();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        cbLocal.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.cbLocal.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbLocal, gridBagConstraints1);
        
        
        jSeparator1.setPreferredSize(new java.awt.Dimension(100, 2));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 11);
        add(jSeparator1, gridBagConstraints1);
        
        
        cbRevision.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.cbRevision.text"));
        cbRevision.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbRevisionActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbRevision, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 99;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txRevision, gridBagConstraints1);
        
        
        cbForceCommit.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.cbForceUpdate.text"));
        cbForceCommit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbForceCommitActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbForceCommit, gridBagConstraints1);
        
        
        cbNoModule.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.cbNoModule.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbNoModule, gridBagConstraints1);
        
        
        rbFileMessage.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.cbFileMessage.text"));
        rbFileMessage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbFileMessageActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(rbFileMessage, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipadx = 52;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txFileMessage, gridBagConstraints1);
        
        
        btnFileMessage.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.btnFileMessage.text"));
        btnFileMessage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnFileMessageActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.insets = new java.awt.Insets(0, 5, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(btnFileMessage, gridBagConstraints1);
        
        
        rbMessage.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.cbMessage.text"));
        rbMessage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbMessageActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(rbMessage, gridBagConstraints1);
        
        
        
        spMessage.setViewportView(taMessage);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.gridheight = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        add(spMessage, gridBagConstraints1);
        
        
        btnIndividualMessage.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.btnIndividualMessage.text"));
        btnIndividualMessage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnIndividualMessageActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 7;
        gridBagConstraints1.insets = new java.awt.Insets(0, 50, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(btnIndividualMessage, gridBagConstraints1);
        
        
        jSeparator2.setPreferredSize(new java.awt.Dimension(100, 2));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 11);
        add(jSeparator2, gridBagConstraints1);
        
        
        btnClearIndividual.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle").getString("CommitParamInput.btnClearIndividual.text"));
        btnClearIndividual.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnClearIndividualActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 8;
        gridBagConstraints1.insets = new java.awt.Insets(0, 50, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(btnClearIndividual, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void cbForceCommitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbForceCommitActionPerformed
        // Add your handling code here:
        highlightButtons(!cbForceCommit.isSelected());
        if (cbForceCommit.isSelected()) {
            clearIndividual();
        }
    }//GEN-LAST:event_cbForceCommitActionPerformed

    private void btnFileMessageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnFileMessageActionPerformed
        // Add your handling code here:
        File initDir = new File(txFileMessage.getText());
        if (initDir.exists()) {
            if (initDir.isFile()) {
                initDir = initDir.getParentFile();
            }
        } else {
            initDir = new File(System.getProperty("user.home"));
        }
        ChooseFileDialog chooseDir = new ChooseFileDialog(new JFrame(), initDir, false);
        org.netbeans.modules.cvsclient.customizer.JavaCvsCustomizer.centerWindow (chooseDir);
        HelpCtx.setHelpIDString (chooseDir.getRootPane (), CommitParamInput.class.getName ());
        chooseDir.show();
        String selected=chooseDir.getSelectedFile();
        if( selected==null ){
            //D.deb("no directory selected"); // NOI18N
            return ;
        }
        txFileMessage.setText(selected);        
    }//GEN-LAST:event_btnFileMessageActionPerformed

  private void rbFileMessageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbFileMessageActionPerformed
// Add your handling code here:
      highlightFileMessage(true);
  }//GEN-LAST:event_rbFileMessageActionPerformed

  private void rbMessageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbMessageActionPerformed
// Add your handling code here:
      highlightFileMessage(false);
  }//GEN-LAST:event_rbMessageActionPerformed

  private void highlightButtons(boolean notForcing) {
      if (rbMessage.isSelected()) {
          btnClearIndividual.setEnabled(notForcing);
          btnIndividualMessage.setEnabled(notForcing);
      }
  }
  
  private void highlightFileMessage(boolean fileIsOn) {
      txFileMessage.setEnabled(fileIsOn);
      btnFileMessage.setEnabled(fileIsOn);
      taMessage.setEnabled(!fileIsOn);
      btnIndividualMessage.setEnabled(!fileIsOn);
      btnClearIndividual.setEnabled(!fileIsOn);
      highlightButtons(!cbForceCommit.isSelected());
  }      
  
  private void highlightRevision(boolean highlight) {
      txRevision.setEnabled(highlight);
  }
  
  private void btnClearIndividualActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnClearIndividualActionPerformed
// Add your handling code here:
      clearIndividual();
  }//GEN-LAST:event_btnClearIndividualActionPerformed

  private void clearIndividual() {
      currentFSCommand.transform(new HashMap());
      //TODO - clear local data structures.
      if (messageMap != null) messageMap.clear();
      messageMap = null;
  }
  
  private void btnIndividualMessageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnIndividualMessageActionPerformed
// Add your handling code here:
      if (provider.isOffLine()) return; //TODO message??
      if (chooser == null) {
        CvsUpdate myCom = new CvsUpdate(currentFSCommand.getFiles(), provider);
        try {
            GlobalOptions opt = (GlobalOptions)provider.getGlobalOptions().clone();
            opt.setDoNoChanges(true);
            myCom.setGlobalOptions(opt);
            myCom.setParamInput(new BlankParamInput());
        } catch (CloneNotSupportedException exc) { 
            return;  // should not happen.. IT IS clonable
        } 
        chooser = new CommitMessageChooser(myCom);
        chooser.setForceCommit(cbForceCommit.isSelected());
        chooser.setGeneralMessage(taMessage.getText());
        chooser.addChooserFinishListener(new ChooserFinishListener() {
          public void chooserFinished(ChooserFinishEvent event) {
              grabIndividualMessages(event);
          }
        });
        myCom.setOutputDisplayer(chooser);
        myCom.addCommandErrorListener(chooser);
//        chooser.displayFrameWork();
        // Do show the dialog before starting the command??
        myCom.startCommand();
      } else {
        if (chooser.wasFinished()) {
          chooser.setForceCommit(cbForceCommit.isSelected());
          chooser.setGeneralMessage(taMessage.getText());
          chooser.redisplay();
        } else {
            //kinda hack to force the rereun of the command
            chooser = null;
            btnIndividualMessageActionPerformed(evt);
        }
      }
  }//GEN-LAST:event_btnIndividualMessageActionPerformed


  private void cbRevisionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbRevisionActionPerformed
// Add your handling code here:
      highlightRevision(cbRevision.isSelected());
  }//GEN-LAST:event_cbRevisionActionPerformed

  public void setData(Command command) {
      CommitCommand updCom = (CommitCommand)command;
      updCom.resetCVSCommand();
      updCom.setRecursive(!cbLocal.isSelected());
      updCom.setForceCommit(cbForceCommit.isSelected());
      updCom.setNoModuleProgram(cbNoModule.isSelected());
      if (rbFileMessage.isSelected()) {
          String fileName = txFileMessage.getText();
          if (fileName.trim().length() <= 0) {
              fileName = null;
          }
          updCom.setLogMessageFromFile(fileName);
      }
      if (cbRevision.isSelected() && !txRevision.getText().equals("")) {
         updCom.setToRevisionOrBranch(txRevision.getText()); 
      }
 
      // message stuff
      if (rbMessage.isSelected()) {
          if (messageMap != null) {
              File[] fls = updCom.getFiles();
              String message = "";
              if (fls.length == 1) {
                  // all messaged commands have just 1 file
                  Object obj = messageMap.get(fls[0]);
                  if (obj != null) {
                      message = (String)obj;
                  }
              }
              updCom.setMessage(taMessage.getText() + message);
          } else {
              // no individual message settings
              updCom.setMessage(taMessage.getText());
          }
      } else updCom.setMessage(null);
      
  }
  
  public String getDialogTitle() {
      return NbBundle.getBundle(CommitParamInput.class).getString("CommitParamInput.dialogTitle");
  }
  
  public boolean requiresUI() {
      return true;
  }
  
  public void getData(Command command) {
      CommitCommand updCom = (CommitCommand)command;
      cbLocal.setSelected(!updCom.getRecursive());
      cbForceCommit.setSelected(updCom.isForceCommit());
      if (updCom.isForceCommit()) {
          highlightButtons(false);
      }
      cbNoModule.setSelected(updCom.isNoModuleProgram());
      if (updCom.getToRevisionOrBranch() != null) {
          txRevision.setText(updCom.getToRevisionOrBranch());
          cbRevision.setSelected(true);
          highlightRevision(true);
      }
      if (updCom.getLogMessageFromFile() != null) {
          txFileMessage.setText(updCom.getLogMessageFromFile());
          rbFileMessage.setSelected(true);
          highlightFileMessage(true);
      } else {
          rbMessage.setSelected(true);
          highlightFileMessage(false);
      }
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JCheckBox cbLocal;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JCheckBox cbRevision;
  private javax.swing.JTextField txRevision;
  private javax.swing.JCheckBox cbForceCommit;
  private javax.swing.JCheckBox cbNoModule;
  private javax.swing.JRadioButton rbFileMessage;
  private javax.swing.JTextField txFileMessage;
  private javax.swing.JButton btnFileMessage;
  private javax.swing.JRadioButton rbMessage;
  private javax.swing.JScrollPane spMessage;
  private javax.swing.JTextArea taMessage;
  private javax.swing.JButton btnIndividualMessage;
  private javax.swing.JSeparator jSeparator2;
  private javax.swing.JButton btnClearIndividual;
  // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/commit/Bundle");  

  private void grabIndividualMessages(ChooserFinishEvent event) {
      HashMap map = (HashMap)event.getChooser().getValue();
      currentFSCommand.transform(map);
      messageMap = new HashMap();
      Iterator it = map.keySet().iterator();
      while (it.hasNext()) {
          DefaultFileInfoContainer info = (DefaultFileInfoContainer)it.next();
          String message = (String)map.get(info);
          messageMap.put(info.getFile(), message);
      }
      //TODO add to local data structures.
  }
}
