/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.commit;

import org.openide.util.*;
import org.netbeans.lib.cvsclient.command.commit.CommitInformation;
import org.netbeans.modules.cvsclient.commands.*;
import javax.swing.event.TableModelEvent;

import org.netbeans.modules.vcscore.util.Debug;
import java.util.*;

/**
 *
 * @author  mkleint
 */
public class CommitTableInfoModel extends TableInfoModel {
    private Debug E=new Debug("CommitTableInfoModel", true); // NOI18N
    private Debug D=E;
      
      public CommitTableInfoModel() {
          super();
      }
      
      public int getColumnCount() {
          return 3;
      }
      
      public Object getValueAt(int row, int column) {
//          if (row < 0 || row >= getRowCount()) return "";
          CommitInformation info = (CommitInformation)list.get(row);
          switch (column) {
              case 0 : return info.getType();
              case 1 : return info.getFile().getName();
              case 2 : return info.getRevision();
          }
          return "";
      }
      
      public java.lang.String getColumnName(int param) {
          switch (param) {
              case 1 : return NbBundle.getBundle(TableInfoModel.class).getString("TableInfoModel.fileName");
              case 0 : return NbBundle.getBundle(CommitTableInfoModel.class).getString("CommitTableInfoModel.type");
              case 2 : return NbBundle.getBundle(CommitTableInfoModel.class).getString("CommitTableInfoModel.revision");
          }
          return "";
          
      }
      
      
      public int compare(Object obj1, Object obj2) {
          if (!(obj1 instanceof CommitInformation) ||
          !(obj2 instanceof CommitInformation)) return 0;
          CommitInformation rev1 = (CommitInformation)obj1;
          CommitInformation rev2 = (CommitInformation)obj2;
          int result = 0;
          switch (getActiveColumn()) {
              case 1: // filesname
                  result = getDirection() * (rev1.getFile().getName().compareTo(rev2.getFile().getName()));
                  break;
              case 0:     //status
                  result = getDirection() * (rev1.getType().compareTo(rev2.getType()));
                  break;
              case 2: // revision
                  result = getDirection() * compareVersions(rev1.getRevision(), rev2.getRevision());
                  break;
          }
          return result;
      }
      
      public void addElement(Object object)
      {
          super.addElement(object);
          fireTableRowsInserted(list.size(), list.size());
      }      
      
}

