/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.log;

import org.openide.util.*;
import org.netbeans.lib.cvsclient.command.log.LogInformation;
import org.netbeans.lib.cvsclient.command.log.LogCommand;
import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.modules.vcscore.util.Debug;
import java.util.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.event.*;

/**
 *
 * @author  mkleint
 * @version 
 */
public class LogSymNamesModel extends TableInfoModel {
    private Debug E=new Debug("LogSymNamesModel", true); // NOI18N
    private Debug D=E;
      
      private static final int NUM_COLUMNS = 2;
      
      public LogSymNamesModel(List logInfoList) {
          list = new LinkedList(logInfoList);
          D.deb("getRowCount()=" + list.size());
          setDirection(true);
          setActiveColumn(0);
          
      }
      
      public int getColumnCount() {
          return 2;
      }
      
      public Object getValueAt(int row, int column) {
//          if (row < 0 && row >= getRowCount()) return "";
          LogInformation.SymName rev = (LogInformation.SymName)list.get(row);
          switch (column) {
              case 0 : return rev.getName();
              case 1 : return rev.getRevision();
          }
          return "";
      }
      
      public java.lang.String getColumnName(int param) {
          switch (param) {
              case 0 : return NbBundle.getBundle(LogSymNamesModel.class).getString("LogInfoPanel.SymNamesColumn");
              case 1 : return NbBundle.getBundle(LogSymNamesModel.class).getString("LogInfoPanel.Rev2Column");
          }
          return "";
          
      }
      
      public LogInformation.SymName getSymName(int row) {
          return (LogInformation.SymName)list.get(row);
      }    
      
      public int compare(Object obj1, Object obj2) {
          if (!(obj1 instanceof LogInformation.SymName) ||
          !(obj2 instanceof LogInformation.SymName)) return 0;
          LogInformation.SymName rev1 = (LogInformation.SymName)obj1;
          LogInformation.SymName rev2 = (LogInformation.SymName)obj2;
          int result = 0;
          switch (getActiveColumn()) {
              case 1: // revision
                  result = getDirection() * compareVersions(rev1.getRevision(), rev2.getRevision());
                  break;
              case 0: // tag, symbolic name
                  result = getDirection() * (rev1.getName().compareTo(rev2.getName()));
                  break;
          }
          return result;
      }
      

}

