/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.cvsclient.commands.remove;

import java.util.*;
import java.io.IOException;
import java.io.File;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import org.netbeans.modules.vcscore.util.Debug;
import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.lib.cvsclient.command.remove.RemoveInformation;
import org.netbeans.modules.cvsclient.JavaCvsFileSystem;
import org.openide.util.NbBundle;
import org.openide.filesystems.*;
import org.openide.loaders.*;
import org.openide.cookies.*;
import org.openide.*;

public class RemoveInfoPanel extends javax.swing.JPanel implements CommandDisplayer {
    private Debug E=new Debug("UpdateInfoPanel", true); // NOI18N
    private Debug D=E;
    
    ArrayList listeners;
    RemoveTableInfoModel model;
    CvsRemove command;
    DialogDescriptor dd;
    private boolean stopped;
    
    /** Creates new form UpdateInfoPanel */
    public RemoveInfoPanel(FileSystemCommand comm) {
        initComponents ();
        setPreferredSize(new java.awt.Dimension(450, 200));
        setMinimumSize(new java.awt.Dimension(450, 200));        
        
        stopped = false;        
        command = (CvsRemove)comm;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        pnlButtons = new javax.swing.JPanel();
        spCentral = new javax.swing.JScrollPane();
        tblRemoved = new javax.swing.JTable();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        pnlButtons.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 11);
        add(pnlButtons, gridBagConstraints1);
        
        
        spCentral.setPreferredSize(new java.awt.Dimension(250, 60));
        
        tblRemoved.setModel(new javax.swing.table.DefaultTableModel (
        new Object [][] {
            {null, null, null, null},
            {null, null, null, null},
            {null, null, null, null},
            {null, null, null, null}
        },
        new String [] {
            "Title 1", "Title 2", "Title 3", "Title 4"
        }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class
            };
            
            public Class getColumnClass (int columnIndex) {
                return types [columnIndex];
            }
        });
        spCentral.setViewportView(tblRemoved);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 11);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(spCentral, gridBagConstraints1);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel pnlButtons;
    private javax.swing.JScrollPane spCentral;
    private javax.swing.JTable tblRemoved;
    // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle");  
/** this method should be used with Choosers to display the dialog..
 * then later the displayOutputData will just present the datat gotten from server
 * Reason: to have something displayer right away..
 * This method is to be called when creating the command and Chooser.
 */
    public void displayFrameWork() {
        model = new RemoveTableInfoModel();
        tblRemoved.setModel(model);
        TableColumn col = tblRemoved.getColumnModel().getColumn(0);
        col.setPreferredWidth(100);
          // HACK to set the width of column at desired size
        
        String title = NbBundle.getBundle(RemoveInfoPanel.class).getString("RemoveInfoPanel.dialogTitle");
        dd = new DialogDescriptor(this, title);
        String[] options = new String[1];
        options[0] = NbBundle.getBundle(RemoveInfoPanel.class).getString("RemoveInfoPanel.stopButton");
        dd.setOptions(options);
        Object[] empty = new Object[1];
        dd.setClosingOptions(empty); // none are closing
        dd.setButtonListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                shutDownCommand();
            }
        });
        javax.swing.SwingUtilities.invokeLater(new Runnable () {
            public void run () {
                Dialog dial = TopManager.getDefault().createDialog(dd);
                dial.setModal(false);
                dial.show();
            }
        });
    }
    
    private void shutDownCommand() {
        // we can do that because it's running from other thread then command and won't kill itself
        command.hardCommandStop();
        stopped = true;
//        displayOutputData();
    }
    
    /** Does the actual display - docking into the javacvs Mode,
     *  displaying as single Dialog.. whatever.
     */
    public void displayOutputData() {
        int size;
        if (stopped) size = 2;
        else size = 3;
        // forces the NbPresenter to keep the user's resizing.
        this.setPreferredSize(getSize());

        Object[] options = new Object[size];
        final String log = NbBundle.getBundle(RemoveInfoPanel.class).getString("RemoveInfoPanel.logButton");
        JButton btnClose = new JButton(NbBundle.getBundle(RemoveInfoPanel.class)
                                   .getString("RemoveInfoPanel.closeButton")); 
        btnClose.setDefaultCapable(true);
        final String commit = NbBundle.getBundle(RemoveInfoPanel.class).getString("RemoveInfoPanel.commitButton");
        options[size - 1] = btnClose;
        options[size - 2] = log;
        if (!stopped) {
            options[0] = commit;
        }
        Object[] closing = new Object[size - 1];
        if (!stopped) closing[0] = options[0];
        closing[size - 2] = options[size - 1];
        dd.setValue(btnClose); //HACK
        dd.setOptions(options);
        dd.setClosingOptions(closing); // all are closing
        dd.setButtonListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                if (evt.getActionCommand().equals(commit)) {
                    performCommit();
                }
                if (evt.getActionCommand().equals(log)) {
                    showLog();
                }    
            }
        });
        JTableHeader head = tblRemoved.getTableHeader();
        head.setUpdateTableInRealTime(true);
        ColumnSortListener listen = new ColumnSortListener(tblRemoved);
        head.addMouseListener(listen);
    }

    private void performCommit() {
        //TODO after commit is implemented
    }
    
    private void showLog() {
        command.doShowCommandLog();
    }    
    
    /** Does the actual display - docking into the javacvs Mode, 
     *  displaying as single Dialog.. whatever.
     */
    public void displayOutputData(int moment, Object data) {
        if (moment == CommandDisplayer.MOMENT_AFTER_PARAM_INPUT) {
            // display empty panel.
            displayFrameWork();
        } 
        else if (moment == CommandDisplayer.MOMENT_FILE_INFO_GENERATED) {
            // new file added. Assumes the Info generated is AddInformation object
            if (data instanceof RemoveInformation) {
                model.addElement(data);
                tblRemoved.changeSelection(model.getRowCount(), 0, false, false);
            }
        } else if (moment == CommandDisplayer.MOMENT_FINISHED_COMMAND 
                || moment == CommandDisplayer.MOMENT_EXECUTE_FAILED) { 
            // do change the buttons.
             displayOutputData();
        }
    }      

}
