/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */



package org.netbeans.modules.cvsclient.commands.remove;

import java.util.*;
import javax.swing.*;
import org.openide.util.*;
import org.netbeans.modules.vcscore.util.Debug;

import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.lib.cvsclient.command.Command;
import org.netbeans.lib.cvsclient.command.remove.RemoveCommand;


/**
 *
 * @author  mkleint
 * @version 
 */
public class RemoveParamInput extends javax.swing.JPanel implements CommandParamInput {
    private Debug E=new Debug("LogParamInput", true); // NOI18N
    private Debug D=E; 
    
    
    /** Creates new form LogParamInput */
    public RemoveParamInput() {
        initComponents ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jSeparator1 = new javax.swing.JSeparator();
        cbLocally = new javax.swing.JCheckBox();
        cbDeleteBeforeRemove = new javax.swing.JCheckBox();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jSeparator1.setPreferredSize(new java.awt.Dimension(100, 2));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        add(jSeparator1, gridBagConstraints1);
        
        
        cbLocally.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/remove/Bundle").getString("RemoveParamInput.cbLocally.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbLocally, gridBagConstraints1);
        
        
        cbDeleteBeforeRemove.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/remove/Bundle").getString("RemoveParamInput.cbDeleteBeforeRemove.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbDeleteBeforeRemove, gridBagConstraints1);
        
    }//GEN-END:initComponents


  public void setData(Command comm) {
      RemoveCommand removeCom = (RemoveCommand)comm;
      removeCom.setRecursive(!cbLocally.isSelected());
      removeCom.setDeleteBeforeRemove(cbDeleteBeforeRemove.isSelected());
  } 
  
  public void getData(Command comm) {
      RemoveCommand removeCom = (RemoveCommand)comm;
      cbLocally.setSelected(!removeCom.getRecursive());
      cbDeleteBeforeRemove.setSelected(removeCom.isDeleteBeforeRemove());
  }  

  public String getDialogTitle() {
     return NbBundle.getBundle(RemoveParamInput.class).getString("RemoveParamInput.dialogTitle");
  }
  
  public boolean requiresUI() {
      return true;
  }
  

  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JCheckBox cbLocally;
  private javax.swing.JCheckBox cbDeleteBeforeRemove;
  // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/remove/Bundle");  

}
