/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.status;

import javax.swing.table.*;
import javax.swing.*;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.util.*;
import java.io.File;
import org.openide.util.*;
import org.openide.*;
import java.lang.reflect.Method;


import org.netbeans.modules.vcscore.util.Debug;
import org.netbeans.modules.cvsclient.caching.CvsCacheFile;
import org.netbeans.lib.cvsclient.command.status.*;
import org.netbeans.lib.cvsclient.command.diff.*;
import org.netbeans.modules.cvsclient.commands.diff.*;
import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.lib.cvsclient.file.FileStatus;
import org.netbeans.modules.cvsclient.JavaCvsFileSystem;
import org.netbeans.modules.cvsclient.JavaCvsStatusManager;
import org.netbeans.lib.cvsclient.command.Command;

/**
 *
 * @author  mkleint
 * @version
 */
public class StatusInfoPanel extends javax.swing.JPanel 
                             implements CommandParamInput, PersistentCommandDisplayer {
    
    private transient Debug E=new Debug("StatusInfoPanel", true); // NOI18N
    private transient Debug D=E; //transient??
    java.awt.Color oldColor;
    private ClientProvider provider;
    private StatusInformation statusInfo;
    private StatusCommand defaultCommand;
    private Class fsCommand;
    
    private GridBagConstraints spExistingTagsConstraints;
    private GridBagConstraints lblExistingTagsConstraints;
    private GridBagLayout gridBag;
    
    /** Creates new form StatusInfoPanel */
    public StatusInfoPanel(ClientProvider fs, StatusCommand currentCommand) {
        initComponents ();
        oldColor = txRepRev.getForeground();
        provider = fs;
        defaultCommand = currentCommand;
        // after setting the components unvisible, the layout gets forgotten :(
        gridBag  = (GridBagLayout)getLayout();
        spExistingTagsConstraints = gridBag.getConstraints(spExistingTags);
        lblExistingTagsConstraints = gridBag.getConstraints(lblExistingTags);
        JTableHeader head = tblExistingTags.getTableHeader();
        head.setUpdateTableInRealTime(true);
        ColumnSortListener listen = new ColumnSortListener(tblExistingTags);
        head.addMouseListener(listen);
        setPreferredSize(new java.awt.Dimension(700, 450));
        setMinimumSize(new java.awt.Dimension(700, 450));        
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        lblFileName = new javax.swing.JLabel();
        lblWorkRev = new javax.swing.JLabel();
        lblStatus = new javax.swing.JLabel();
        lblRepRev = new javax.swing.JLabel();
        btnDiff = new javax.swing.JButton();
        lblRepFile = new javax.swing.JLabel();
        lblTag = new javax.swing.JLabel();
        lblDate = new javax.swing.JLabel();
        lblOptions = new javax.swing.JLabel();
        txFileName = new javax.swing.JLabel();
        txStatus = new javax.swing.JLabel();
        txWorkRev = new javax.swing.JLabel();
        txRepRev = new javax.swing.JLabel();
        txTag = new javax.swing.JLabel();
        txDate = new javax.swing.JLabel();
        txOptions = new javax.swing.JLabel();
        spExistingTags = new javax.swing.JScrollPane();
        tblExistingTags = new javax.swing.JTable();
        lblExistingTags = new javax.swing.JLabel();
        txRepFile = new javax.swing.JTextField();
        btnAdvanced = new javax.swing.JButton();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setMaximumSize(new java.awt.Dimension(354, 203));
        lblFileName.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblFileName.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblFileName, gridBagConstraints1);
        
        lblWorkRev.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblWorkRev.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblWorkRev, gridBagConstraints1);
        
        lblStatus.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblStatus.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(12, 17, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblStatus, gridBagConstraints1);
        
        lblRepRev.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblRepRev.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.insets = new java.awt.Insets(12, 17, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblRepRev, gridBagConstraints1);
        
        btnDiff.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.btnDiff.text"));
        btnDiff.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDiffActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 4;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.ipadx = 1;
        gridBagConstraints1.insets = new java.awt.Insets(10, 5, 0, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(btnDiff, gridBagConstraints1);
        
        lblRepFile.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblRepFile.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(5, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblRepFile, gridBagConstraints1);
        
        lblTag.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblTag.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblTag, gridBagConstraints1);
        
        lblDate.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblDate.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.insets = new java.awt.Insets(5, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblDate, gridBagConstraints1);
        
        lblOptions.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblOptions.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(12, 17, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblOptions, gridBagConstraints1);
        
        txFileName.setText("text - filename");
        txFileName.setForeground(java.awt.Color.black);
        txFileName.setBackground(java.awt.Color.gray);
        txFileName.setPreferredSize(new java.awt.Dimension(120, 16));
        txFileName.setMinimumSize(new java.awt.Dimension(120, 16));
        txFileName.setMaximumSize(new java.awt.Dimension(150, 16));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.ipadx = 100;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txFileName, gridBagConstraints1);
        
        txStatus.setText("text - status");
        txStatus.setForeground(java.awt.Color.blue);
        txStatus.setBackground(java.awt.Color.gray);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipadx = 36;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txStatus, gridBagConstraints1);
        
        txWorkRev.setText("work. rev.");
        txWorkRev.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.ipadx = 23;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txWorkRev, gridBagConstraints1);
        
        txRepRev.setText("rep. revis.");
        txRepRev.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.ipadx = 6;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txRepRev, gridBagConstraints1);
        
        txTag.setText("tag");
        txTag.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.ipadx = 51;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txTag, gridBagConstraints1);
        
        txDate.setText("date");
        txDate.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.ipadx = 81;
        gridBagConstraints1.insets = new java.awt.Insets(5, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txDate, gridBagConstraints1);
        
        txOptions.setText("options");
        txOptions.setForeground(java.awt.Color.black);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 3;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txOptions, gridBagConstraints1);
        
        spExistingTags.setPreferredSize(new java.awt.Dimension(200, 200));
        spExistingTags.setMinimumSize(new java.awt.Dimension(100, 100));
        tblExistingTags.setModel(new javax.swing.table.DefaultTableModel (
        new Object [][] {
            {null, null, null, null},
            {null, null, null, null},
            {null, null, null, null},
            {null, null, null, null}
        },
        new String [] {
            "Title 1", "Title 2", "Title 3", "Title 4"
        }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.Object.class, java.lang.Object.class, java.lang.Object.class
            };
            
            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        spExistingTags.setViewportView(tblExistingTags);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(2, 12, 11, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(spExistingTags, gridBagConstraints1);
        
        lblExistingTags.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.lblExistingTags.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.insets = new java.awt.Insets(14, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblExistingTags, gridBagConstraints1);
        
        txRepFile.setEditable(false);
        txRepFile.setForeground(new java.awt.Color(102, 102, 158));
        txRepFile.setText("repFile");
        txRepFile.setDisabledTextColor(new java.awt.Color(102, 102, 153));
        txRepFile.setPreferredSize(new java.awt.Dimension(300, 20));
        txRepFile.setMinimumSize(new java.awt.Dimension(100, 20));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 4;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipadx = 40;
        gridBagConstraints1.insets = new java.awt.Insets(2, 12, 0, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(txRepFile, gridBagConstraints1);
        
        btnAdvanced.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusInfoPanel.btnAdvanced.text"));
        btnAdvanced.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAdvancedActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        add(btnAdvanced, gridBagConstraints1);
        
    }//GEN-END:initComponents
    
  private void btnAdvancedActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAdvancedActionPerformed
      // Add your handling code here:
//      if (!(provider.isFileSystemClient()) || provider.isOffLine()) return;
      if (provider.isOffLine()) return;
      File[] files = new File[1];
      files[0] = statusInfo.getFile();
      if (files[0].exists() == false) return;
      CvsStatus myStat = new CvsStatus(files, provider);
      myStat.setParamInput(new ParserParamInput("-v"));
      myStat.setOutputDisplayer(new TagsDisplayer(null));
      myStat.startCommand();
//      btnAdvanced.setEnabled(false);
//      add(spExistingTags);
//      add(lblExistingTags);
      
  }//GEN-LAST:event_btnAdvancedActionPerformed
  
  private void btnDiffActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDiffActionPerformed
      // Add your handling code here:
      if (provider.isOffLine()) return;
      File[] files = new File[1];
      files[0] = statusInfo.getFile();
      CvsDiff myStat = new CvsDiff(files, provider);
      myStat.setParamInput(this);
      myStat.startCommand();
  
      
  }//GEN-LAST:event_btnDiffActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel lblFileName;
  private javax.swing.JLabel lblWorkRev;
  private javax.swing.JLabel lblStatus;
  private javax.swing.JLabel lblRepRev;
  private javax.swing.JButton btnDiff;
  private javax.swing.JLabel lblRepFile;
  private javax.swing.JLabel lblTag;
  private javax.swing.JLabel lblDate;
  private javax.swing.JLabel lblOptions;
  private javax.swing.JLabel txFileName;
  private javax.swing.JLabel txStatus;
  private javax.swing.JLabel txWorkRev;
  private javax.swing.JLabel txRepRev;
  private javax.swing.JLabel txTag;
  private javax.swing.JLabel txDate;
  private javax.swing.JLabel txOptions;
  private javax.swing.JScrollPane spExistingTags;
  private javax.swing.JTable tblExistingTags;
  private javax.swing.JLabel lblExistingTags;
  private javax.swing.JTextField txRepFile;
  private javax.swing.JButton btnAdvanced;
  // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle");  

  public void setData(StatusInformation info) {
      statusInfo = info;
      txFileName.setText(info.getFile().getName());
      JavaCvsStatusManager manager = JavaCvsStatusManager.getInstance();
      txStatus.setText(manager.getStatus(manager.convertStatus(info.getStatus())));
      String work = info.getWorkingRevision();
      txWorkRev.setText(work);
      String repo = info.getRepositoryRevision();
      txRepFile.setText(info.getRepositoryFileName());
      txRepRev.setText(repo);
      if (work != null && repo != null) {
          if (!repo.equals(work)) { //possible stuff that can be done with the display
              txRepRev.setForeground(java.awt.Color.red);
              txWorkRev.setForeground(java.awt.Color.red);
          } else {
              txRepRev.setForeground(oldColor);
              txWorkRev.setForeground(oldColor);
          }
      }
      boolean uptodate = (info.getStatus() == FileStatus.UP_TO_DATE || info.getStatus() == FileStatus.UNKNOWN);
      btnDiff.setEnabled(!uptodate);
      txDate.setText(info.getStickyDate());
      txTag.setText(info.getStickyTag());
      txOptions.setText(info.getStickyOptions());
      
      StatusSymNamesModel model = new StatusSymNamesModel(info.getAllExistingTags());
      tblExistingTags.setModel(model);
  }
  
  public void setCommand(StatusCommand comm) {
      defaultCommand = comm;
  }
  
  public void setFileSystemCommand(FileSystemCommand com) {
      fsCommand = com.getClass();
      provider = com.getClientProvider();
  }
  
  public void setProvider(ClientProvider prov) {
      provider = prov;
  }
  
  //-- for calling Diff command from the dialog  -methods from the CommandParamInput interface
  
  public void setData(Command command) {
      // sets data for the diff command run from the status info dialog.
      DiffCommand diffCom = (DiffCommand) command;
      diffCom.setRevision1(statusInfo.getRepositoryRevision());
      // TODO?? add also sticky options corresponding to -k switch??
      
  }
  
  public String getDialogTitle() {
      // NOT needed for this implementation of non-UI paramInput
      return "";
  }
  
  public boolean requiresUI() {
      return false;
  }
  
    /** in this method the displayer should use the data returned by the command to
     * produce it's own data structures/ fill in UI components
     * @param resultList - the data from the command. It is assumed the Displayer
     *  knows what command the data comes from and most important in what format.
     * (which FileInfoContainer class is used).
     */
  public void setDataToDisplay(StatusInformation info) {
      setData(info);
  }
  
    /** Does the actual display - docking into the javacvs Mode,
     *   displaying as single Dialog.. whatever.
     */
  public void displayOutputData() {
      // in case the paraminput dialog won't trigger.. not nessesary to have this condition -> always disable
      spExistingTags.setEnabled(defaultCommand.isIncludeTags());
      lblExistingTags.setEnabled(defaultCommand.isIncludeTags());          
 
      FileSystemCommand.displayOutputPanel(NbBundle.getBundle(CvsStatus.class).getString("CvsStatus.dialogTitle")
      + statusInfo.getFile().getName(), this);
  }
  
  public void getData(Command command) {
  }
  
  /** Does the actual display - docking into the javacvs Mode, 
   *  displaying as single Dialog.. whatever.
 */
  public void displayOutputData(int moment,Object data) {
      if (moment == CommandDisplayer.MOMENT_FILE_INFO_GENERATED) {
          StatusInformation info = (StatusInformation)data;
/* temp          StatusInfoPanel clonedOne = new StatusInfoPanel(provider, defaultCommand);
          clonedOne.setDataToDisplay(info);
          clonedOne.displayOutputData();
 */
          setDataToDisplay(info);
          displayOutputData();
      }
  }
  
  // --------------------------------------------
  // persistantDisplayer stuff..
  // --------------------------------------------
  
  public boolean equalDisplayedData(File file, Class type, Object comparisonData) {
      if (!getClass().equals(type)) return false;
      if (statusInfo == null || statusInfo.getFile() == null
                || !statusInfo.getFile().equals(file)) {
          return false;
      }
      return true;
  }

  public File getFileDisplayed() {
      return statusInfo.getFile();
  }
   
  public Object getComparisonData() {
      return statusInfo;
  }
   
  public JComponent getComponent() {
      return this;
  }

  public Class getFileSystemCommandClass() {
      return fsCommand;
  }  
  
  public String getCommandSwitches() {
      return defaultCommand.getCVSArguments();
  }
  
  public ClientProvider getClientProvider() {
      return provider;
  }
  
  class TagsDisplayer implements CommandDisplayer {
      private StatusCommand tagsCommand;
      
      public TagsDisplayer(StatusCommand comm) {
          tagsCommand = comm;
      }
      public void displayOutputData() {
          // DO nothing since it already displays.??
/*          spExistingTags.setVisible(true);
          gridBag.setConstraints(spExistingTags, spExistingTagsConstraints);
          lblExistingTags.setVisible(true);          
          gridBag.setConstraints(lblExistingTags, lblExistingTagsConstraints);
 */
      }
      
      public void setDataToDisplay(StatusInformation info) {
              // we need to copy the information to the old statusInfo 
              // because of preserving info when looking at the status tree..
              // we'll copy everything just for the sake of it.. in case something changes over time
              statusInfo.setFile(info.getFile());
              statusInfo.setRepositoryFileName(info.getRepositoryFileName());
              statusInfo.setRepositoryRevision(info.getRepositoryRevision());
              statusInfo.setStatus(info.getStatus());
              statusInfo.setStickyDate(info.getStickyDate());
              statusInfo.setStickyOptions(info.getStickyOptions());
              statusInfo.setStickyTag(info.getStickyTag());
              statusInfo.setWorkingRevision(info.getWorkingRevision());
              statusInfo.setAllExistingTags(info.getAllExistingTags());
              setData(statusInfo);
      }
     /** Does the actual display - docking into the javacvs Mode, 
      *  displaying as single Dialog.. whatever.
      */
     public void displayOutputData(int moment,Object data) {
        if (moment == CommandDisplayer.MOMENT_FILE_INFO_GENERATED) {
            StatusInformation info = (StatusInformation)data;
            if (info.getAllExistingTags().size() == 0) {
                String noTags = NbBundle.getBundle(StatusInfoPanel.class)
                              .getString("StatusInfoPanel.noTags");
                TopManager.getDefault().notify(new NotifyDescriptor.Message(noTags));
            } else {
                setDataToDisplay(info);
                displayOutputData();
            }
        }
     }
      
  }
  
}
