/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.status;


import java.util.*;
import org.openide.util.*;
import org.netbeans.modules.vcscore.util.Debug;
import org.netbeans.lib.cvsclient.command.status.StatusCommand;
import org.netbeans.lib.cvsclient.command.Command;
import org.netbeans.modules.cvsclient.commands.*;

/**
 *
 * @author  mkleint
 * @version 
 */
public class StatusParamInput extends javax.swing.JPanel implements CommandParamInput {
    private Debug E=new Debug("StatusParamInput", true); // NOI18N
    private Debug D=E;
    /** Creates new form StatusParamInput */
    public StatusParamInput() {
        initComponents ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        cbLocal = new javax.swing.JCheckBox();
        cbIncludeTags = new javax.swing.JCheckBox();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        cbLocal.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusParamInput.cbLocal.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 11, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbLocal, gridBagConstraints1);
        
        
        cbIncludeTags.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle").getString("StatusParamInput.cbIncludeTags.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbIncludeTags, gridBagConstraints1);
        
    }//GEN-END:initComponents

    public void setData(Command command) {
      StatusCommand statCom = (StatusCommand)command;
      statCom.setRecursive(!cbLocal.isSelected());
      statCom.setIncludeTags(cbIncludeTags.isSelected());
      D.deb("include tags? " + statCom.isIncludeTags());
    }    

    public String getDialogTitle() {
       return NbBundle.getBundle(StatusParamInput.class).getString("StatusParamInput.dialogTitle");
    }
    
    public boolean requiresUI() {
        return true;
    }
    
    public void getData(Command command) {
       StatusCommand statCom = (StatusCommand)command;
       cbLocal.setSelected(!statCom.getRecursive());
       cbIncludeTags.setSelected(statCom.isIncludeTags());
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox cbLocal;
    private javax.swing.JCheckBox cbIncludeTags;
    // End of variables declaration//GEN-END:variables

    private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/status/Bundle");    

}
