/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.status;

import org.openide.util.*;
import org.netbeans.lib.cvsclient.command.status.StatusInformation;
import org.netbeans.lib.cvsclient.command.status.StatusCommand;
import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.modules.vcscore.util.Debug;
import java.util.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.table.*;

/**
 *
 * @author  mkleint
 * @version 
 */
public class StatusSymNamesModel extends TableInfoModel {
    private Debug E=new Debug("StatusSymNamesModel", true); // NOI18N
    private Debug D=E;
      
      private static final int NUM_COLUMNS = 2;
      private static final String REVISION = "revision:";
      private static final String BRANCH   = "branch:";
      
      public StatusSymNamesModel(List statInfoList) {
          list = new LinkedList(statInfoList);
          D.deb("getRowCount()=" + list.size());
          setDirection(true);
          setActiveColumn(0);
          
      }
      
      public int getColumnCount() {
          return 2;
      }
      
      public Object getValueAt(int row, int column) {
//          if (row < 0 && row >= getRowCount()) return "";
          StatusInformation.SymName rev = (StatusInformation.SymName)list.get(row);
          switch (column) {
              case 0 : return rev.getTag();
              case 1 : return rev.getRevision();
          }
          return "";
      }
      
      public java.lang.String getColumnName(int param) {
          switch (param) {
              case 0 : return NbBundle.getBundle(StatusSymNamesModel.class).getString("StatusInfoPanel.SymNamesColumn");
              case 1 : return NbBundle.getBundle(StatusSymNamesModel.class).getString("StatusInfoPanel.Rev2Column");
          }
          return "";
          
      }
      
      public StatusInformation.SymName getSymName(int row) {
          return (StatusInformation.SymName)list.get(row);
      }    
      
      public int compare(Object obj1, Object obj2) {
          if (!(obj1 instanceof StatusInformation.SymName) ||
          !(obj2 instanceof StatusInformation.SymName)) return 0;
          StatusInformation.SymName rev1 = (StatusInformation.SymName)obj1;
          StatusInformation.SymName rev2 = (StatusInformation.SymName)obj2;
          int result = 0;
          switch (getActiveColumn()) {
              case 1: // revision
                  // needed for soritng out branch/revision..
                  String revStr1 = rev1.getRevision();
                  String revStr2 = rev2.getRevision();
                  String substr1 = revStr1.substring(0, revStr1.indexOf(':'));
                  String substr2 = revStr2.substring(0, revStr2.indexOf(':'));
                  result = getDirection() * substr1.compareTo(substr2);
                  if (result == 0) {
                      String numb1 = revStr1.substring(substr1.length() + 1).trim();
                      String numb2 = revStr2.substring(substr2.length() + 1).trim();
                      result = compareVersions(numb1, numb2);
                  }  
                  break;
              case 0: // tag, symbolic name
                  result = getDirection() * (rev1.getTag().compareTo(rev2.getTag()));
                  break;
          }
          return result;
      }
      

}

