/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.status;

import org.openide.util.*;
import org.netbeans.lib.cvsclient.command.status.StatusInformation;
import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.modules.cvsclient.JavaCvsStatusManager;


import org.netbeans.modules.vcscore.util.Debug;
import java.util.*;

/**
 *
 * @author  mkleint
 */
public class StatusTableInfoModel extends TableInfoModel {
    private Debug E=new Debug("StatusTableInfoModel", true); // NOI18N
    private Debug D=E;
      
      public StatusTableInfoModel() {
          super();
      }
      
      public int getColumnCount() {
          return 2;
      }
      
      public Object getValueAt(int row, int column) {
//          if (row < 0 || row >= getRowCount()) return "";
          StatusInformation info = (StatusInformation)list.get(row);
          switch (column) {
              case 0 : return JavaCvsStatusManager.convertStatus(info.getStatus());
              case 1 : return info.getFile().getName();
          }
          return "";
      }
      
      public java.lang.String getColumnName(int param) {
          switch (param) {
              case 1 : return NbBundle.getBundle(TableInfoModel.class).getString("TableInfoModel.fileName");
              case 0 : return NbBundle.getBundle(StatusTableInfoModel.class).getString("StatusTableInfoModel.status");
          }
          return "";
          
      }
      
      
      public int compare(Object obj1, Object obj2) {
          if (!(obj1 instanceof StatusInformation) ||
          !(obj2 instanceof StatusInformation)) return 0;
          StatusInformation rev1 = (StatusInformation)obj1;
          StatusInformation rev2 = (StatusInformation)obj2;
          int result = 0;
          switch (getActiveColumn()) {
              case 1: // filesname
                  result = getDirection() * (rev1.getFile().getName().compareTo(rev2.getFile().getName()));
                  break;
              case 0:     //status
                  String stat1 = JavaCvsStatusManager.convertStatus(rev1.getStatus());
                  String stat2 = JavaCvsStatusManager.convertStatus(rev2.getStatus()); 
                  result = getDirection() * (stat1.compareTo(stat2));
                  break;
          }
          return result;
      }
      
}

