/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */



package org.netbeans.modules.cvsclient.commands.tag;

import java.util.*;
import javax.swing.*;
import org.openide.util.*;
import org.netbeans.modules.vcscore.util.Debug;

import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.lib.cvsclient.command.tag.*;
import org.netbeans.lib.cvsclient.command.*;


/**
 *
 * @author  mkleint
 * @version 
 */
public class TagParamInput extends javax.swing.JPanel implements CommandParamInput {
    private Debug E=new Debug("TagParamInput", true); // NOI18N
    private Debug D=E; 

/** Creates new form TagParamInput */
    public TagParamInput() {
        initComponents ();
        txRevision.setEnabled(false);
        txDate.setEnabled(false);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        lblTag = new javax.swing.JLabel();
        txTag = new javax.swing.JTextField();
        jSeparator1 = new javax.swing.JSeparator();
        cbLocal = new javax.swing.JCheckBox();
        cbCheckUnmodified = new javax.swing.JCheckBox();
        cbForceTag = new javax.swing.JCheckBox();
        cbBranch = new javax.swing.JCheckBox();
        cbDeleteTag = new javax.swing.JCheckBox();
        cbDate = new javax.swing.JCheckBox();
        txDate = new javax.swing.JTextField();
        cbRevision = new javax.swing.JCheckBox();
        txRevision = new javax.swing.JTextField();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        lblTag.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle").getString("TagParamInput.lblTag.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(6, 0, 0, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        add(lblTag, gridBagConstraints1);
        
        txTag.setPreferredSize(new java.awt.Dimension(100, 21));
        txTag.setMinimumSize(new java.awt.Dimension(50, 21));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txTag, gridBagConstraints1);
        
        jSeparator1.setPreferredSize(new java.awt.Dimension(100, 2));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 11);
        add(jSeparator1, gridBagConstraints1);
        
        cbLocal.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle").getString("TagParamInput.cbLocal.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbLocal, gridBagConstraints1);
        
        cbCheckUnmodified.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle").getString("TagParamInput.cbCheckUnmodified.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbCheckUnmodified, gridBagConstraints1);
        
        cbForceTag.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle").getString("TagParamInput.cbForceTag.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbForceTag, gridBagConstraints1);
        
        cbBranch.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle").getString("TagParamInput.cbBranch.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 0, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbBranch, gridBagConstraints1);
        
        cbDeleteTag.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle").getString("TagParamInput.cbDeleteTag.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 0, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbDeleteTag, gridBagConstraints1);
        
        cbDate.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle").getString("TagParamInput.cbDates.text"));
        cbDate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbDateActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbDate, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipadx = 80;
        gridBagConstraints1.insets = new java.awt.Insets(6, 6, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txDate, gridBagConstraints1);
        
        cbRevision.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle").getString("TagParamInput.cbRevision.text"));
        cbRevision.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbRevisionActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 7;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbRevision, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 7;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipadx = 80;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txRevision, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void cbRevisionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbRevisionActionPerformed
        // Add your handling code here:
        txRevision.setEnabled(cbRevision.isSelected());
    }//GEN-LAST:event_cbRevisionActionPerformed

    private void cbDateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbDateActionPerformed
        // Add your handling code here:
        txDate.setEnabled(cbDate.isSelected());        
    }//GEN-LAST:event_cbDateActionPerformed


  
  public void setData(Command command) {
      TagCommand updCom = (TagCommand)command;
      updCom.resetCVSCommand();
      updCom.setRecursive(!cbLocal.isSelected());
      updCom.setTag(txTag.getText());
      updCom.setCheckThatUnmodified(cbCheckUnmodified.isSelected());
      updCom.setDeleteTag(cbDeleteTag.isSelected());
      updCom.setMakeBranchTag(cbBranch.isSelected());
      updCom.setOverrideExistingTag(cbForceTag.isSelected());
      if (cbDate.isSelected()) {
          updCom.setTagByDate(txDate.getText().trim());
      }
      if (cbRevision.isSelected()) { 
          updCom.setTagByRevision(txRevision.getText().trim());
      }
  }  

  public String getDialogTitle() {
     return NbBundle.getBundle(TagParamInput.class).getString("TagParamInput.dialogTitle");
  }
  
  public boolean requiresUI() {
      return true;
  }
  
  public void getData(Command command) {
      TagCommand updCom = (TagCommand)command;
      txTag.setText(updCom.getTag());
      cbLocal.setSelected(!updCom.getRecursive());
      cbBranch.setSelected(updCom.doesMakeBranchTag());
      cbCheckUnmodified.setSelected(updCom.doesCheckThatUnmodified());
      cbDeleteTag.setSelected(updCom.doesDeleteTag());
      cbForceTag.setSelected(updCom.doesOverrideExistingTag());
      String updByDate = updCom.getTagByDate();
      if (updByDate != null && (!updByDate.equals(""))) {
          cbDate.setSelected(true);
          txDate.setText(updByDate);
      }    
      String updByRev = updCom.getTagByRevision();
      if (updByRev != null && (!updByRev.equals(""))) {
          cbRevision.setSelected(true);
          txRevision.setText(updByRev);
      }  
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel lblTag;
  private javax.swing.JTextField txTag;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JCheckBox cbLocal;
  private javax.swing.JCheckBox cbCheckUnmodified;
  private javax.swing.JCheckBox cbForceTag;
  private javax.swing.JCheckBox cbBranch;
  private javax.swing.JCheckBox cbDeleteTag;
  private javax.swing.JCheckBox cbDate;
  private javax.swing.JTextField txDate;
  private javax.swing.JCheckBox cbRevision;
  private javax.swing.JTextField txRevision;
  // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/tag/Bundle");  

}
