/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */



package org.netbeans.modules.cvsclient.commands.update;

import java.util.*;
import javax.swing.*;
import org.openide.util.*;
import org.netbeans.modules.vcscore.util.Debug;

import org.netbeans.modules.cvsclient.commands.*;
import org.netbeans.lib.cvsclient.command.update.*;
import org.netbeans.lib.cvsclient.command.*;


/**
 *
 * @author  mkleint
 * @version 
 */
public class UpdateParamInput extends javax.swing.JPanel implements CommandParamInput {
    private Debug E=new Debug("LogParamInput", true); // NOI18N
    private Debug D=E; 

    private static final String K_NONE = NbBundle.getBundle(UpdateParamInput.class).getString("UpdateParamInput.NoSubstitution");
    private static final String K_BINARY = NbBundle.getBundle(UpdateParamInput.class).getString("UpdateParamInput.BinarySubst");
    private static final String K_KEYWORD_VALUE = NbBundle.getBundle(UpdateParamInput.class).getString("UpdateParamInput.KeywordValueSubst");
    private static final String K_KEYWORD_VALUE_LOCKER = NbBundle.getBundle(UpdateParamInput.class).getString("UpdateParamInput.KeywordValueLockerSubst");
    private static final String K_KEYWORD = NbBundle.getBundle(UpdateParamInput.class).getString("UpdateParamInput.Keyword");
    private static final String K_VALUE = NbBundle.getBundle(UpdateParamInput.class).getString("UpdateParamInput.Value");
    private static final String K_OLD = NbBundle.getBundle(UpdateParamInput.class).getString("UpdateParamInput.Old");
    
    private Object[] comboValues = new Object[] { K_NONE, K_BINARY, K_KEYWORD_VALUE, 
                K_KEYWORD_VALUE_LOCKER, K_KEYWORD, K_VALUE, K_OLD} ;
                
    private String[] cvsValues = new String[] { "", "b", "kv", "kvl", "k", "v", "o" };

    
/** Creates new form LogParamInput */
    public UpdateParamInput() {
        initComponents ();
        txRevision.setEnabled(false);
        txDates.setEnabled(false);
        cbKeyword.setModel(new DefaultComboBoxModel(comboValues));
        cbKeyword.setSelectedIndex(0);
        cbForceUpdate.setEnabled(false);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        cbLocal = new javax.swing.JCheckBox();
        cbClearSticky = new javax.swing.JCheckBox();
        cbPruneEmpty = new javax.swing.JCheckBox();
        cbDOption = new javax.swing.JCheckBox();
        cbCleanCopy = new javax.swing.JCheckBox();
        cbPipeToOutput = new javax.swing.JCheckBox();
        jSeparator1 = new javax.swing.JSeparator();
        cbDates = new javax.swing.JCheckBox();
        txDates = new javax.swing.JTextField();
        cbRevision = new javax.swing.JCheckBox();
        txRevision = new javax.swing.JTextField();
        cbForceUpdate = new javax.swing.JCheckBox();
        jSeparator2 = new javax.swing.JSeparator();
        cbMergeWithCurrent = new javax.swing.JCheckBox();
        txMergeRev1 = new javax.swing.JTextField();
        cbMerge2Revisions = new javax.swing.JCheckBox();
        txMergeRev2 = new javax.swing.JTextField();
        lblKeyword = new javax.swing.JLabel();
        cbKeyword = new javax.swing.JComboBox();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        cbLocal.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbLocal.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbLocal, gridBagConstraints1);
        
        
        cbClearSticky.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbClearStciky.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbClearSticky, gridBagConstraints1);
        
        
        cbPruneEmpty.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbPruneEmpty.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(12, 6, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbPruneEmpty, gridBagConstraints1);
        
        
        cbDOption.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbDOption.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbDOption, gridBagConstraints1);
        
        
        cbCleanCopy.setText("Get Clean Copy");
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbCleanCopy, gridBagConstraints1);
        
        
        cbPipeToOutput.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbPipeToOutput.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbPipeToOutput, gridBagConstraints1);
        
        
        jSeparator1.setPreferredSize(new java.awt.Dimension(100, 2));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 11);
        add(jSeparator1, gridBagConstraints1);
        
        
        cbDates.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbDates.text"));
        cbDates.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbDatesActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbDates, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 80;
        gridBagConstraints1.insets = new java.awt.Insets(6, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txDates, gridBagConstraints1);
        
        
        cbRevision.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbRevision.text"));
        cbRevision.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbRevisionActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbRevision, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 80;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txRevision, gridBagConstraints1);
        
        
        cbForceUpdate.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbForceUpdate.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 6;
        gridBagConstraints1.insets = new java.awt.Insets(0, 6, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbForceUpdate, gridBagConstraints1);
        
        
        jSeparator2.setPreferredSize(new java.awt.Dimension(100, 2));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 7;
        gridBagConstraints1.gridwidth = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 12, 6, 11);
        add(jSeparator2, gridBagConstraints1);
        
        
        cbMergeWithCurrent.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbMergeWithCurrent.text"));
        cbMergeWithCurrent.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbMergeWithCurrentActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 8;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbMergeWithCurrent, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 8;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 80;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txMergeRev1, gridBagConstraints1);
        
        
        cbMerge2Revisions.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.cbMerge2Revisions.text"));
        cbMerge2Revisions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbMerge2RevisionsActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 9;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbMerge2Revisions, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 9;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.ipadx = 80;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txMergeRev2, gridBagConstraints1);
        
        
        lblKeyword.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateParamInput.lblKeyword.text"));
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 6, 6);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(lblKeyword, gridBagConstraints1);
        
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(cbKeyword, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void cbMerge2RevisionsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbMerge2RevisionsActionPerformed
        // Add your handling code here:
        enableMergeButtons();
    }//GEN-LAST:event_cbMerge2RevisionsActionPerformed

    private void cbMergeWithCurrentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbMergeWithCurrentActionPerformed
        // Add your handling code here:
        enableMergeButtons();        
    }//GEN-LAST:event_cbMergeWithCurrentActionPerformed


  private void cbRevisionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbRevisionActionPerformed
// Add your handling code here:
      D.deb("calling class name=" + evt.getSource().getClass().getName());
      txRevision.setEnabled(cbRevision.isSelected());
      if (cbRevision.isSelected()) {
          cbForceUpdate.setEnabled(true);
      } else {
          if (!cbDates.isSelected()) {
              cbForceUpdate.setSelected(false);
              cbForceUpdate.setEnabled(false);
          }
      }
  }//GEN-LAST:event_cbRevisionActionPerformed

  private void cbDatesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbDatesActionPerformed
// Add your handling code here:
      txDates.setEnabled(cbDates.isSelected());
      if (cbDates.isSelected()) {
          cbForceUpdate.setEnabled(true);
      } else {
          if (!cbRevision.isSelected()) {
              cbForceUpdate.setSelected(false);
              cbForceUpdate.setEnabled(false);
          }
      }
      
  }//GEN-LAST:event_cbDatesActionPerformed

  private void enableMergeButtons() {
      cbMergeWithCurrent.setEnabled(!cbMerge2Revisions.isSelected());
      txMergeRev1.setEnabled(cbMerge2Revisions.isSelected());
      txMergeRev2.setEnabled(cbMerge2Revisions.isSelected());
      if (!cbMerge2Revisions.isSelected()) {
          txMergeRev1.setEnabled(cbMergeWithCurrent.isSelected());
          txMergeRev2.setEnabled(false);
      }
  }
  
  public void setData(Command command) {
      UpdateCommand updCom = (UpdateCommand)command;
      updCom.resetCVSCommand();
      updCom.setRecursive(!cbLocal.isSelected());
      if (cbDates.isSelected()) {
          updCom.setUpdateByDate(txDates.getText().trim());
      }
      if (cbRevision.isSelected()) { 
          updCom.setUpdateByRevision(txRevision.getText().trim());
      }
      updCom.setPipeToOutput(cbPipeToOutput.isSelected());
      updCom.setPruneDirectories(cbPruneEmpty.isSelected());
      updCom.setBuildDirectories(cbDOption.isSelected());
      updCom.setResetStickyOnes(cbClearSticky.isSelected());
      updCom.setKeywordSubst(cvsValues[cbKeyword.getSelectedIndex()]);      
      updCom.setUseHeadIfNotFound(cbForceUpdate.isSelected());
      updCom.setCleanCopy(cbCleanCopy.isSelected());
      if (cbMergeWithCurrent.isSelected()) {
          updCom.setMergeRevision1(txMergeRev1.getText().trim());
      }
      if (cbMerge2Revisions.isSelected()) {
          updCom.setMergeRevision1(txMergeRev1.getText().trim());
          updCom.setMergeRevision2(txMergeRev2.getText().trim());
      }
  }  

  public String getDialogTitle() {
     return NbBundle.getBundle(UpdateParamInput.class).getString("UpdateParamInput.dialogTitle");
  }
  
  public boolean requiresUI() {
      return true;
  }
  
  public void getData(Command command) {
      UpdateCommand updCom = (UpdateCommand)command;
      cbLocal.setSelected(!updCom.getRecursive());
      cbPipeToOutput.setSelected(updCom.isPipeToOutput());
      cbPruneEmpty.setSelected(updCom.getPruneDirectories());
      cbDOption.setSelected(updCom.getBuildDirectories());
      cbClearSticky.setSelected(updCom.isResetStickyOnes());
      cbForceUpdate.setSelected(updCom.isUseHeadIfNotFound());
      cbCleanCopy.setSelected(updCom.getCleanCopy());
      String updByDate = updCom.getUpdateByDate();
      if (updByDate != null && (!updByDate.equals(""))) {
          cbDates.setSelected(true);
          txDates.setText(updByDate);
      }    
      String updByRev = updCom.getUpdateByRevision();
      if (updByRev != null && (!updByRev.equals(""))) {
          cbRevision.setSelected(true);
          txRevision.setText(updByRev);
      }  
      String merge1 = updCom.getMergeRevision1();
      String merge2 = updCom.getMergeRevision2();
      if (merge2 != null && (!merge2.equals(""))) {
          txMergeRev1.setText(merge1);
          txMergeRev2.setText(merge2);
          cbMerge2Revisions.setSelected(true);
      } else if (merge1 != null && (!merge1.equals(""))) {
          txMergeRev1.setText(merge1);
          cbMergeWithCurrent.setSelected(true);
      }
      String keyword = updCom.getKeywordSubst();
      for (int index = 0; index < cvsValues.length; index++) {
          if (cvsValues[index].equals(keyword)) {
              cbKeyword.setSelectedIndex(index);
              break;
          }    
      }          
      enableMergeButtons();
  }
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JCheckBox cbLocal;
  private javax.swing.JCheckBox cbClearSticky;
  private javax.swing.JCheckBox cbPruneEmpty;
  private javax.swing.JCheckBox cbDOption;
  private javax.swing.JCheckBox cbCleanCopy;
  private javax.swing.JCheckBox cbPipeToOutput;
  private javax.swing.JSeparator jSeparator1;
  private javax.swing.JCheckBox cbDates;
  private javax.swing.JTextField txDates;
  private javax.swing.JCheckBox cbRevision;
  private javax.swing.JTextField txRevision;
  private javax.swing.JCheckBox cbForceUpdate;
  private javax.swing.JSeparator jSeparator2;
  private javax.swing.JCheckBox cbMergeWithCurrent;
  private javax.swing.JTextField txMergeRev1;
  private javax.swing.JCheckBox cbMerge2Revisions;
  private javax.swing.JTextField txMergeRev2;
  private javax.swing.JLabel lblKeyword;
  private javax.swing.JComboBox cbKeyword;
  // End of variables declaration//GEN-END:variables

  private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle");  

}
