/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.commands.update;

/**
 *
 * @author  mkleint
 * @version
 */

import org.netbeans.lib.cvsclient.command.checkout.*;
import org.netbeans.lib.cvsclient.command.*;
import org.netbeans.modules.vcscore.util.Debug;
import org.netbeans.modules.cvsclient.commands.*;
import org.openide.filesystems.FileUtil;
import javax.swing.text.*;
import javax.swing.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.io.IOException;
import java.io.File;
import java.util.*;
import org.openide.util.NbBundle;

public class UpdateStdOutPanel extends javax.swing.JPanel 
                               implements PersistentCommandDisplayer {
    private Debug E=new Debug("UpdateStdOutPanel", true); // NOI18N
    private Debug D=E;
    private Command currentCommand;
    private Class fsCommand;
    private ClientProvider provider;
    private PipedFileInformation currentInfo;
    
    /** Creates new form UpdateStdOutPanel */
    public UpdateStdOutPanel(Command comm) {
        initComponents ();
        currentCommand = comm;
        epFile.setEditable(false);
    }
    
    public void setCommand(org.netbeans.lib.cvsclient.command.Command comm) {
        currentCommand = comm;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        spFile = new javax.swing.JScrollPane();
        epFile = new javax.swing.JEditorPane();
        pnlHeader = new javax.swing.JPanel();
        lblFileName = new javax.swing.JLabel();
        txFileName = new javax.swing.JLabel();
        lblRevNumber = new javax.swing.JLabel();
        txRevNumber = new javax.swing.JLabel();
        lblRevFile = new javax.swing.JLabel();
        txRevFile = new javax.swing.JTextField();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        
        spFile.setViewportView(epFile);
          
          
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 11, 11);
        gridBagConstraints1.weighty = 1.0;
        add(spFile, gridBagConstraints1);
        
        
        pnlHeader.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        lblFileName.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateStdOutPanel.lblFileName.text"));
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 6, 6);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          gridBagConstraints2.weightx = 1.0;
          pnlHeader.add(lblFileName, gridBagConstraints2);
          
          
        txFileName.setText("jLabel2");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 6, 0);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          gridBagConstraints2.weightx = 4.0;
          pnlHeader.add(txFileName, gridBagConstraints2);
          
          
        lblRevNumber.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateStdOutPanel.lblRevNumber.text"));
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 6, 6);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          pnlHeader.add(lblRevNumber, gridBagConstraints2);
          
          
        txRevNumber.setText("jLabel4");
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 1;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 6, 0);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          pnlHeader.add(txRevNumber, gridBagConstraints2);
          
          
        lblRevFile.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle").getString("UpdateStdOutPanel.lblRevFile.text"));
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 0;
          gridBagConstraints2.gridy = 2;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 6, 6);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          pnlHeader.add(lblRevFile, gridBagConstraints2);
          
          
        txRevFile.setPreferredSize(new java.awt.Dimension(400, 20));
          txRevFile.setEditable(false);
          txRevFile.setText("jTextField1");
          txRevFile.setMinimumSize(new java.awt.Dimension(60, 20));
          gridBagConstraints2 = new java.awt.GridBagConstraints();
          gridBagConstraints2.gridx = 1;
          gridBagConstraints2.gridy = 2;
          gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
          gridBagConstraints2.insets = new java.awt.Insets(0, 0, 6, 0);
          gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
          pnlHeader.add(txRevFile, gridBagConstraints2);
          
          
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 6, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(pnlHeader, gridBagConstraints1);
        
    }//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane spFile;
    private javax.swing.JEditorPane epFile;
    private javax.swing.JPanel pnlHeader;
    private javax.swing.JLabel lblFileName;
    private javax.swing.JLabel txFileName;
    private javax.swing.JLabel lblRevNumber;
    private javax.swing.JLabel txRevNumber;
    private javax.swing.JLabel lblRevFile;
    private javax.swing.JTextField txRevFile;
    // End of variables declaration//GEN-END:variables

    private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/commands/update/Bundle");    
    
    public void setData(PipedFileInformation info, Command comm) {
        currentInfo = info;
        txFileName.setText(info.getFile().getAbsolutePath());
        txRevNumber.setText(info.getRepositoryRevision());
        txRevFile.setText(info.getRepositoryFileName());
        //setting up editor kit
        if (info.getTempFile().exists()) {
            String mime = getMIMEType(info);
            epFile.setContentType(mime);
            EditorKit kit = JEditorPane.createEditorKitForContentType(mime);
            D.deb("MIME = "+mime+": I have kit = "+kit); // NOI18N
            if (kit != null) epFile.setEditorKit(kit);
            Document doc = kit.createDefaultDocument();
            try {
                URL flURL = info.getTempFile().toURL();
                try {
                    kit.read(flURL.openStream(), doc, 0);
                    kit.install(epFile);
                    epFile.setDocument(doc);
                } catch (javax.swing.text.BadLocationException e) {
                    E.err("BadLocationException");
                    return;
                } catch (IOException ex) {
                    E.err("IOException");
                    return;
                }
                
            } catch (MalformedURLException exc) {
                E.err("malformed URL");
            }
            epFile.setDocument(doc);
        }
        
    }
    
    private String getMIMEType(PipedFileInformation info) {
        File infoFile = info.getFile();
        if (infoFile == null) return "text/plain";
        String tempStr = infoFile.getName();
        String extension = null;
        D.deb("tempStr=" + tempStr);
        int ind = tempStr.indexOf('.');
        if (ind > 0) {
            extension = tempStr.substring(ind + 1);
        }
        D.deb("extension=" + extension);
        if (extension == null) {
            extension = "text/plain";
        }
        String type = FileUtil.getMIMEType(extension);
        if (type == null) {
            type = "text/plain";
        }
        return type;
    }
    
    
    /** Does the actual display - docking into the javacvs Mode, 
 *  displaying as single Dialog.. whatever.
 */
    public void displayOutputData() {
       FileSystemCommand.displayOutputPanel(NbBundle.getBundle(UpdateStdOutPanel.class).getString("CvsUpdate.pipedOutDialogTitle") 
               + currentInfo.getFile().getName() + ":" + currentInfo.getRepositoryRevision(), 
                 this);                    
    }
    
    /** Does the actual display - docking into the javacvs Mode, 
     *  displaying as single Dialog.. whatever.
     */
    public void displayOutputData(int moment, Object data) {
        if (moment == CommandDisplayer.MOMENT_FILE_INFO_GENERATED) {
            if (data != null && data instanceof PipedFileInformation) {
                // we clone the default displayer, because each file should have it's 
                // own displayer.
                PipedFileInformation pfInfo = (PipedFileInformation) data;
//                UpdateStdOutPanel clonedOne = new UpdateStdOutPanel(currentCommand);
                setData(pfInfo, currentCommand);
                displayOutputData();
            }
        } else if (moment == CommandDisplayer.MOMENT_BEFORE_EACH_EXECUTE) {
            if (data != null && data instanceof Command) {
                currentCommand = (Command)data;
            }
        }
    }    
    
   // --------------------------------------------
  // persistantDisplayer stuff..
  // --------------------------------------------
   public void setFileSystemCommand(FileSystemCommand com) {
      fsCommand = com.getClass();
      provider = com.getClientProvider();
   }
    
  public boolean equalDisplayedData(File file, Class type, Object comparisonData) {
      if (!getClass().equals(type)) return false;
      if (currentInfo == null || currentInfo.getFile() == null
                || !currentInfo.getFile().equals(file)) {
          return false;
      }
      PipedFileInformation info = (PipedFileInformation)comparisonData;
      if (info == null) {
          return false;
      }
      if (!currentInfo.getRepositoryRevision().equals(info.getRepositoryRevision())) {
          return false;
      }
      return true;
  }

  public File getFileDisplayed() {
      return currentInfo.getFile();
  }
   
  public Object getComparisonData() {
      return currentInfo;
  }
   
  public JComponent getComponent() {
      return this;
  }

  public Class getFileSystemCommandClass() {
      return fsCommand;
  }  
    
  public String getCommandSwitches() {
      return currentCommand.getCVSArguments();
  }
  
  public ClientProvider getClientProvider() {
      return provider;
  }
  
}
