/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.customizer;

import org.openide.util.*;
import org.openide.*;

import org.netbeans.modules.vcscore.util.*;
import org.netbeans.modules.cvsclient.JavaCvsFileSystem;

import javax.swing.event.*;
import javax.swing.ButtonGroup;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.JFileChooser;

/** The first panel in the wizard.
 * 
 *
 * @author mkleint
 * @version 1.0
 */
public class Cust1WorkPanel extends javax.swing.JPanel implements WizardDescriptor.Panel{
    private ArrayList listeners = new ArrayList ();
    
    private JavaCvsFileSystem fs;
    
/** Creates the panel.
 */
    public Cust1WorkPanel() {
        initComponents ();
        btnWorking.setMnemonic (java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("JavaCvsCustomizer.btnWorking.mnemonic").charAt (0));
        lbWorking.setDisplayedMnemonic (java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("JavaCvsCustomizer.lbWorking.mnemonic").charAt (0));
        lbWorking.setLabelFor (txWorking);
        rbNewSources.setMnemonic (java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("Cust1WorkPanel.cbNewSources.mnemonic").charAt (0));
        rbExistingSources.setMnemonic (java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("Cust1WorkPanel.cbExistingSources.mnemonic").charAt (0));
        ButtonGroup bg = new ButtonGroup();
        bg.add(rbExistingSources);
        bg.add(rbNewSources);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        lbWorking = new javax.swing.JLabel();
        txWorking = new javax.swing.JTextField();
        btnWorking = new javax.swing.JButton();
        rbNewSources = new javax.swing.JRadioButton();
        rbExistingSources = new javax.swing.JRadioButton();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        setPreferredSize(new java.awt.Dimension(450, 325));
        setMinimumSize(new java.awt.Dimension(450, 325));
        lbWorking.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("JavaCvsCustomizer.lbWorking.text"));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(4, 0, 5, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(lbWorking, gridBagConstraints1);
        
        txWorking.setColumns(20);
        txWorking.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                txWorkingKeyReleased(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipady = 7;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 5, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        add(txWorking, gridBagConstraints1);
        
        btnWorking.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("JavaCvsCustomizer.btnWorking.label"));
        btnWorking.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnWorkingActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 2;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.insets = new java.awt.Insets(0, 5, 5, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(btnWorking, gridBagConstraints1);
        
        rbNewSources.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("Cust1WorkPanel.cbNewSources.text"));
        rbNewSources.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbNewSourcesActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.insets = new java.awt.Insets(7, 0, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        add(rbNewSources, gridBagConstraints1);
        
        rbExistingSources.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("Cust1WorkPanel.cbExistingSources.text"));
        rbExistingSources.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbExistingSourcesActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.ipadx = 5;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weighty = 1.0;
        add(rbExistingSources, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void rbExistingSourcesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbExistingSourcesActionPerformed
        // Add your handling code here:
        String[] content = JavaCvsCustomizer.setContentData(false);
        putClientProperty("WizardPanel_contentData", content);
    }//GEN-LAST:event_rbExistingSourcesActionPerformed

    private void rbNewSourcesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbNewSourcesActionPerformed
        String[] content = JavaCvsCustomizer.setContentData(true);
        putClientProperty("WizardPanel_contentData", content);
        // Add your handling code here:
    }//GEN-LAST:event_rbNewSourcesActionPerformed

  private void txWorkingKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txWorkingKeyReleased
// Add your handling code here:
      fireChangeState();
  }//GEN-LAST:event_txWorkingKeyReleased


  private void btnWorkingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnWorkingActionPerformed
// Add your handling code here:
        JFileChooser fd = new JFileChooser ();
        fd.setFileFilter ( new javax.swing.filechooser.FileFilter () {
            
            public boolean accept (File file) {
                if (file.exists() && file.isDirectory())
                    return true;
                else
                    return false;
            }
            
            public String getDescription () {
                return NbBundle.getBundle ("org/netbeans/modules/vcscore/wizard/mountcvs/Bundle").getString("TXT_Directory");
            }
        });
        fd.setFileSelectionMode (JFileChooser.DIRECTORIES_ONLY);
        File dir = org.netbeans.modules.vcscore.wizard.mountcvs.util.Utilities.findDirectory (this.txWorking.getText());
        if (dir != null)
            fd.setCurrentDirectory (dir);
        if (fd.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            this.txWorking.setText (fd.getSelectedFile().getAbsolutePath());
        }
        fireChangeState();
      
  }//GEN-LAST:event_btnWorkingActionPerformed


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel lbWorking;
  private javax.swing.JTextField txWorking;
  private javax.swing.JButton btnWorking;
  private javax.swing.JRadioButton rbNewSources;
  private javax.swing.JRadioButton rbExistingSources;
  // End of variables declaration//GEN-END:variables

static final long serialVersionUID = -7632627368102894471L;
    
private static final java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle");


    
/** name of the panel.
 * @return the name of the current panel.
 */
    public String getName() {
      return org.openide.util.NbBundle.getBundle(JavaCvsCustomizer.class).getString("Cust1WorkPanel.workDialogLabel");        
    }
    
/** Get the component displayed in this panel.
 * @return the component
 */
    public java.awt.Component getComponent() {
        return this;
    }
    /** Help for this panel.
 * When the panel is active, this is used as the help for the wizard dialog.
 * @return the help or <code>null</code> if no help is supplied
 */
    public HelpCtx getHelp() {
        return null;
    }
    /** Provides the wizard panel with the current data--either
 * the default data or already-modified settings, if the user used the previous and/or next buttons.
 * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
 * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
 */
    public void readSettings(Object settings) {
        // this is first panel so highlight first step in the content
       putClientProperty("WizardPanel_contentSelectedIndex", new Integer(0));

        JavaCvsCustomizer customizer = (JavaCvsCustomizer)settings;
        fs = customizer.getFileSystem();
        if (customizer.getWorkingDir() != null) {
            txWorking.setText(customizer.getWorkingDir().getAbsolutePath());
        }
        if (customizer.isNewSources()) {
           rbNewSources.setSelected(true); 
        } else {
           rbExistingSources.setSelected(true);
        }
        String[] content = JavaCvsCustomizer.setContentData(rbNewSources.isSelected());
        putClientProperty("WizardPanel_contentData", content);
        
    }
    /** Provides the wizard panel with the opportunity to update the
 * settings with its current customized state.
 * Rather than updating its settings with every change in the GUI, it should collect them,
 * and then only save them when requested to by this method.
 * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
 * rather, the (copy) passed in here should be mutated according to the collected changes.
 * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
 * @param settings the object representing a settings of the wizard
 */
    public void storeSettings(Object settings) {
//        System.out.println("Storing panel1");
        JavaCvsCustomizer customizer = (JavaCvsCustomizer)settings;
        File newWorking = new File(txWorking.getText());
        if (customizer.getWorkingDir() == null || !customizer.getWorkingDir().equals(newWorking)) {
          customizer.setRelMount("");  
        }
        customizer.setWorkingDir(newWorking);
        customizer.setNewSources(rbNewSources.isSelected());
    }
    /** Test whether the panel is finished and it is safe to proceed to the next one.
 * If the panel is valid, the "Next" (or "Finish") button will be enabled.
 * @return <code>true</code> if the user has entered satisfactory information
 */
    public boolean isValid() {
        if (txWorking.getText().trim().equals("")) return false;
        File dir = new File(txWorking.getText());
        // error handling.. when error -> returns the same panel, forcing the user to redo..
        if (!dir.exists()) {
/*            javax.swing.SwingUtilities.invokeLater(new Runnable () {
                public void run () {
                        TopManager.getDefault ().notify (new NotifyDescriptor.Message(org.openide.util.NbBundle.getBundle(JavaCvsCustomizer.class).getString("Cust1WorkPanel.dirNotExists")));
                }
            });
 */
            return false; 
        }
        if (!dir.isDirectory()) {
            /*
            javax.swing.SwingUtilities.invokeLater(new Runnable () {
                public void run () {
                        TopManager.getDefault ().notify (new NotifyDescriptor.Message(org.openide.util.NbBundle.getBundle(JavaCvsCustomizer.class).getString("Cust1WorkPanel.notDirectory")));
                }
            });
           */
            return false; 
        }
        return true;
    }
    /** Add a listener to changes of the panel's validity.
 * @param l the listener to add
 * @see #isValid
 */
    public void addChangeListener(ChangeListener l) {
        if (listeners == null) {
          listeners = new ArrayList ();
        }
        listeners.add (l);        
    }
    /** Remove a listener to changes of the panel's validity.
 * @param l the listener to remove
 */
    public void removeChangeListener(ChangeListener l) {
        if (listeners != null) {
            listeners.remove (l);
        }
    }
    
    private void fireChangeState() {
        ArrayList list;
        synchronized (this) {
            list = (ArrayList) this.listeners.clone();
        }
        ChangeEvent event = new ChangeEvent (this);
        for (int i=0; i<list.size(); i++)
            ((ChangeListener)list.get (i)).stateChanged (event);
    }      
    
}
