/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.customizer;

import org.openide.util.*;
import org.openide.*;

import javax.swing.event.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import org.netbeans.modules.cvsclient.util.*;


import org.netbeans.modules.cvsclient.JavaCvsFileSystem;
import org.netbeans.modules.cvsclient.JavaCvsSettings;
import org.netbeans.modules.cvsclient.IndependantClient;
import org.netbeans.modules.cvsclient.commands.CommandErrorListener;
import org.netbeans.modules.cvsclient.commands.CommandErrorEvent;
import org.netbeans.modules.cvsclient.commands.checkout.CvsCheckout;
/**
 *
 * @author  mkleint
 * @version 
 */
public class Cust4MountPanel extends org.netbeans.modules.vcscore.cmdline.RelativeMountPanel 
                             implements  WizardDescriptor.Panel, TreeSelectionListener,
                                         CommandErrorListener {
    private Debug E=new Debug("Cust4RelMountPanel", true); // NOI18N
    private Debug D=E;                 
//    private JavaCvsFileSystem fs;
    private JavaCvsCustomizer customizer;
    private ArrayList listeners = new ArrayList ();
    private String workingDir;
    private JButton btnCheckout;
    
    static final long serialVersionUID = 5574652503187921114L;
    
    public Cust4MountPanel() {
        super();
        //initComponents ();
   //     isValid = false;
        //trRelMount.addTreeSelectionListener(this);
        JPanel buttnPanel = new JPanel();
        buttnPanel.setLayout(new BoxLayout(buttnPanel, BoxLayout.Y_AXIS));
        btnCheckout = new javax.swing.JButton();
        btnCheckout.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("RelativeMountPanel.btnCheckout.text"));
        btnCheckout.setMnemonic (java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("RelativeMountPanel.btnCheckout.mnemonic").charAt (0));
        btnCheckout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCheckoutActionPerformed(evt);
            }
        });
        buttnPanel.add(btnCheckout);
        buttnPanel.add(javax.swing.Box.createVerticalStrut(12));
        add(buttnPanel, BorderLayout.NORTH);
    }
    
    
  private void btnCheckoutActionPerformed(java.awt.event.ActionEvent evt) {
// Add your handling code here:
      performCheckout();
  }

    public String getName() {
        return org.openide.util.NbBundle.getBundle(Cust4MountPanel.class).getString("Cust4MountPanel.mountDialogLabel");
    }
    
/** last panel check.
 * @return true if last else false.
 */    
    
    public boolean isLast() {
//        if (iter.isNewSources()) return true;
//        else return false;
        return false;
/*        D("is last");
        return isLastPanel;
 */
    }
    
    public int getNext() {
//        if (!iter.isNewSources()) return 3;
        return 2;
    }
/** Get the component displayed in this panel.
 * @return the component
 */
    public java.awt.Component getComponent() {
        return this;
    }
/** Help for this panel.
 * When the panel is active, this is used as the help for the wizard dialog.
 * @return the help or <code>null</code> if no help is supplied
 */
    public HelpCtx getHelp() {
        return null;
    }
/** Provides the wizard panel with the current data--either
 * the default data or already-modified settings, if the user used the previous and/or next buttons.
 * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
 * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
 */
    public void readSettings(Object settings) {
        customizer = (JavaCvsCustomizer)settings;
        //        isValid = false;
        if (customizer.isNewSources()) {
           putClientProperty("WizardPanel_contentSelectedIndex", new Integer(2));            
        } else {
           putClientProperty("WizardPanel_contentSelectedIndex", new Integer(1));            
        }        
        setTreeModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
        setEnabledTree(false);
        //   waitForCheckout();
        workingDir = customizer.getWorkingDir().getAbsolutePath();
        initTree(workingDir, customizer.getRelMount());
//        isValid = true;
        setEnabledTree(true);
        if (!customizer.isNewSources()) {
            btnCheckout.setEnabled(false);
        } else {
            btnCheckout.setEnabled(true);
        }
    }
/** Provides the wizard panel with the opportunity to update the
 * settings with its current customized state.
 * Rather than updating its settings with every change in the GUI, it should collect them,
 * and then only save them when requested to by this method.
 * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
 * rather, the (copy) passed in here should be mutated according to the collected changes.
 * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
 * @param settings the object representing a settings of the wizard
 */
    public void storeSettings(Object settings) {
        customizer = (JavaCvsCustomizer)settings;
        customizer.setRelMount(getRelMount());
        if (!customizer.isNewSources()) {
            fillTextFields();
        }
    }
/** Test whether the panel is finished and it is safe to proceed to the next one.
 * If the panel is valid, the "Next" (or "Finish") button will be enabled.
 * @return <code>true</code> if the user has entered satisfactory information
 */
    public boolean isValid() {
 /*       
        if (isValid) {
            if (customizer != null)
                customizer.setWait(false);
        }
        return isValid;
  */
        return true;
    }
/** Add a listener to changes of the panel's validity.
 * @param l the listener to add
 * @see #isValid
 */
    public void addChangeListener(ChangeListener l) {
        if (listeners == null) {
            listeners = new ArrayList ();
        }
        listeners.add (l);
    }
/** Remove a listener to changes of the panel's validity.
 * @param l the listener to remove
 */
    public void removeChangeListener(ChangeListener l) {
        if (listeners != null) {
            listeners.remove (l);
        }
    }
    
    private void fireChangeState() {
        ArrayList list;
        synchronized (this) {
            list = (ArrayList) this.listeners.clone();
        }
        ChangeEvent event = new ChangeEvent (this);
        for (int i=0; i<list.size(); i++)
            ((ChangeListener)list.get (i)).stateChanged (event);
    }
    
   private void fillTextFields() {
     BufferedReader buff = null;  
     if (customizer.getServerName() != null ||
         customizer.getRepository() != null ||
         customizer.getUserName() != null) {
             return;
     }     
     String dirName = customizer.getWorkingDir().getAbsolutePath();
     String relMount = customizer.getRelMount();
     dirName = dirName + (relMount.equals("") ? "" 
                           : (File.separator + relMount));
     if (relMount.equals("")) {
         //no relative mount point.. just working dir..
         File current = new File(dirName);
         if (!current.exists()) return;
         File[] files = current.listFiles(new FileFilter()  {
              public boolean accept(File f) {
                 if (f.isDirectory() && f.getName().equalsIgnoreCase("CVS")) return true;
                 return false;
              }
          });
          if (files.length == 0) { //not found cvs dir in directory
             files = current.listFiles(); 
             if (files.length == 0) {
                // no subdir.. don't fill anything out..
                 return;
             }
             File sub = files[0]; // no matter which we pick.. all should be the same..
             dirName = sub.getAbsolutePath();
          }
     }
     dirName = dirName + File.separator + "CVS" + File.separator + "Root";
     File dirFile = new File(dirName);
     if (dirFile.exists()) {
        try { 
          buff = new BufferedReader(new InputStreamReader(new FileInputStream(dirFile.getAbsolutePath())));
          String line = buff.readLine();
          if (line.startsWith(":")) {
            line = line.substring(1);
            StringTokenizer token = new StringTokenizer(line, ":",false);
            if (token.hasMoreTokens()) {
              String typeStr = token.nextToken();  
              if (typeStr.equals("local"))  {
                 return; //not filling anything for local fs..
              } else {   //some kind of server..
                customizer.setServerType(typeStr);
                if (token.hasMoreTokens()) {
                   String userServer =  token.nextToken();   
                   customizer.setUserName(userServer.substring(0,userServer.indexOf('@')));
                   customizer.setServerName(userServer.substring(userServer.indexOf('@') + 1));
                }                          
                StringBuffer temp = new StringBuffer("");
                while (token.hasMoreTokens()) {
                    temp.append(token.nextToken());
                    if (token.hasMoreTokens())
                        temp.append(':');
                }
                customizer.setRepository(temp.toString());
              }  
            }      
          }    
        } catch (IOException exc) { //doesn't matter - nothing will be filled in
            D.deb("An error occurred!");
            customizer.setUserName("");
            customizer.setServerName("");
            customizer.setServerType("pserver");
            customizer.setRepository("");
        }              
        finally {
          if (buff != null) {
             try { 
               buff.close(); 
             } catch (IOException eIO) {}  
          }    
        }    
     } 
     else {
            customizer.setUserName("");
            customizer.setServerName("");
            customizer.setServerType("pserver");
            customizer.setRepository("");
     }
   }
    
    private static void D(String debug) {
//        System.out.println("Cust4MountPanel(): "+debug);
    }
    
    
    protected void performCheckout() {
        String root = ":" + customizer.getServerType() + ":" + customizer.getUserName() + "@" +
                      customizer.getServerName() + ":" + customizer.getRepository();
        if (customizer.getServerType().equalsIgnoreCase("pserver")) {
            //TODO check for password.. if not present, prompt for login.
        }
        IndependantClient client = new IndependantClient(root);
        JavaCvsSettings settings = (JavaCvsSettings)SharedClassObject.findObject(
                                                JavaCvsSettings.class, true);         
        client.setUiMode(settings.getUiMode());
        client.setDisplayType(settings.getDisplayType());
        client.setLocalPath(customizer.getWorkingDir().getAbsolutePath());
        CvsCheckout command = new CvsCheckout(client);
        command.setLocalPath(customizer.getWorkingDir().getAbsolutePath());
        command.setForceParamInput(true);
        command.setLoadDefaultSwitches(false);
        command.addCommandErrorListener(this);
        command.startCommand();
    }
    
    public void errorGenerated(CommandErrorEvent event) {
        // wheater the checkout ended with error or not, perform refresh of the tree..
        setEnabledTree(false);
        //   waitForCheckout();
        initTree(workingDir, getRelMount());
//        isValid = true;
        setEnabledTree(true);
    }
    
}
