/*
 * CustomIterator.java
 *
 * Created on December 18, 2000, 12:31 PM
 */

package org.netbeans.modules.cvsclient.customizer;

import org.openide.*;
import org.openide.util.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import javax.swing.event.ChangeListener;
import javax.swing.event.*;

/**
 *
 * @author  mkleint
 * @version 
 */
    class CustomIterator implements WizardDescriptor.Iterator {
        private int[] workflowExisting = {1, 2, 3};
        private int[] workflowNew      = {1, 3, 2};
        private int[] workflowCurrent;
        private int currentIndex;
    private WizardDescriptor.Panel working;
    private WizardDescriptor.Panel server;
    private WizardDescriptor.Panel mount;
        private EventListenerList listeners;

        
        public CustomIterator() {
            currentIndex = 0;
            workflowCurrent = workflowNew;
        }
        
        public void chooseWorkflow(boolean isNewSources) {
            if (isNewSources) {
                workflowCurrent = workflowNew;
            } else {
                workflowCurrent = workflowExisting;
            }
            
        }
        
    private WizardDescriptor.Panel getServPanel() {
        if (server == null) {
            server = new Cust2ServerPanel();
        }
        return server;
    }
    private WizardDescriptor.Panel getWorkPanel() {
        if (working == null) {
            working = new Cust1WorkPanel();
        }
        return working;
    }
    private WizardDescriptor.Panel getMountPanel() {
        if (mount == null) {
            mount = new Cust4MountPanel();
        }
        return mount;
    }        
        
        
    /** Get the current panel.
     * @return the panel
     */
        public WizardDescriptor.Panel current() {
//            System.out.println("current=" + currentIndex);
            switch (workflowCurrent[currentIndex]) {
                case 1 : return getWorkPanel();
                case 2 : return getMountPanel();
                case 3 : return getServPanel();
            }
            return null;
        }
        
    /** Get the name of the current panel.
     * @return the name
     */
        public String name() {
            // TODO different names for different panels.
            return org.openide.util.NbBundle.getBundle(JavaCvsCustomizer.class).getString("JavaCvsCustomizer.wizardName");
        }
        
    /** Test whether there is a next panel.
     * @return <code>true</code> if so
     */
        public boolean hasNext() {
            if (currentIndex <= 1) return true;
            return false;
        }
        
    /** Test whether there is a previous panel.
     * @return <code>true</code> if so
     */
        public boolean hasPrevious() {
            if (currentIndex >= 1) return true;
            return false;
        }
        
    /** Move to the next panel.
     * I.e. increment its index, need not actually change any GUI itself.
     * @exception NoSuchElementException if the panel does not exist
     */
        public void nextPanel() {
            currentIndex = currentIndex + 1;
        }
        
    /** Move to the previous panel.
     * I.e. decrement its index, need not actually change any GUI itself.
     * @exception NoSuchElementException if the panel does not exist
     */
        public void previousPanel() {
            currentIndex = currentIndex - 1;
        }
        
/** Add a change listener to the iterator
 * @param l the listener to be added
 */
        public void addChangeListener(ChangeListener l) {
            if (listeners == null) {
                listeners = new EventListenerList ();
            }
            listeners.add (ChangeListener.class, l);
        }
        
/** removes the listener from the list.
 * @param l the listener to be removed.
 */
        public void removeChangeListener(ChangeListener l) {
            if (listeners != null) {
                listeners.remove (ChangeListener.class, l);
            }
        }
        
        
        private void fireChangeState() {
            Object[] list = listeners.getListenerList();
            ChangeEvent event = null;
            event = new ChangeEvent(this);
            for (int i=0; i< list.length - 1; i++){
                Object listen = list[i];
                if (listen == null) continue;
                if (listen.getClass() == ChangeListener.class) {
                    ChangeListener listener = (ChangeListener) list[i];
                    listener.stateChanged(event);
                }
                
            }
        }
    }
