/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.cvsclient.customizer;

import java.util.ArrayList;
import javax.swing.SwingUtilities;

import org.netbeans.modules.cvsclient.JavaCvsFileSystem;
import org.netbeans.modules.cvsclient.passwd.*;

/**
 *
 * @author  Milos Kleint
 * @version 
 */
public class LoginDialog extends javax.swing.JDialog {

    public final Object STATUS_CONNECTING = new Integer(0);
    public final Object STATUS_FAILED = new Integer(1);
    
    private static ArrayList lastSuccessfullLoggings = new ArrayList();

    private String connectStr = "";
    private PasswdEntry entry = null;
    private boolean loggedIn = false;
    private boolean offline = false;
    private Thread loginThread = null;
    private CVSPasswd passwd = null;
    /** Creates new form LoginDialog */
    public LoginDialog(java.awt.Frame parent, boolean modal, String cvsRoot, CVSPasswd pass) {
        super (parent, modal);
        initComponents ();
        connectStr = cvsRoot;
        passwd = pass;
        setTitle(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("LoginDialog.title"));
        lblLogin.setText(java.text.MessageFormat.format(org.openide.util.NbBundle.getBundle(LoginDialog.class).getString("LoginDialog.lblLogin.text"), new Object[] { cvsRoot }));
        lblPasswd.setDisplayedMnemonic (java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("LoginDialog.lblPasswd.mnemonic").charAt (0));
        lblPasswd.setLabelFor (txPasswd);
        btnLogin.setMnemonic (java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("LoginDialog.btnLogin.mnemonic").charAt (0));
        btnCancel.setMnemonic (java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("LoginDialog.btnCancel.mnemonic").charAt (0));
        pack();
        getRootPane().setDefaultButton(btnLogin);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        loginPanel = new javax.swing.JPanel();
        lblLogin = new javax.swing.JLabel();
        lblPasswd = new javax.swing.JLabel();
        txPasswd = new javax.swing.JPasswordField();
        buttonPanel = new javax.swing.JPanel();
        btnLogin = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        statusPanel = new javax.swing.JPanel();
        statusLabel = new javax.swing.JLabel();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });
        
        loginPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        lblLogin.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("LoginDialog.lblLogin.text"));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 2;
        gridBagConstraints2.insets = new java.awt.Insets(0, 0, 5, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        loginPanel.add(lblLogin, gridBagConstraints2);
        
        lblPasswd.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("LoginDialog.lblPasswd.text"));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(0, 0, 0, 12);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        loginPanel.add(lblPasswd, gridBagConstraints2);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.weightx = 1.0;
        loginPanel.add(txPasswd, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 12, 11);
        gridBagConstraints1.weightx = 1.0;
        getContentPane().add(loginPanel, gridBagConstraints1);
        
        buttonPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        btnLogin.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("LoginDialog.btnLogin.text"));
        btnLogin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loginButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints3.weightx = 1.0;
        buttonPanel.add(btnLogin, gridBagConstraints3);
        
        btnCancel.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/cvsclient/customizer/Bundle").getString("LoginDialog.btnCancel.text"));
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                offlineButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.insets = new java.awt.Insets(0, 5, 0, 0);
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.EAST;
        buttonPanel.add(btnCancel, gridBagConstraints3);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 12, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints1.weightx = 1.0;
        getContentPane().add(buttonPanel, gridBagConstraints1);
        
        statusPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints4;
        
        statusPanel.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        statusLabel.setText(" ");
        statusLabel.setEnabled(false);
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints4.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints4.weightx = 1.0;
        statusPanel.add(statusLabel, gridBagConstraints4);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 17, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        getContentPane().add(statusPanel, gridBagConstraints1);
        
    }//GEN-END:initComponents

  private void offlineButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_offlineButtonActionPerformed
// Add your handling code here:
      loggedIn = false;
      if (loginThread != null) {
          if (loginThread.isAlive()) {
              loginThread.interrupt();
          }
      }
      offline = true;
      closeDialog(null);
  }//GEN-LAST:event_offlineButtonActionPerformed

  private void loginButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loginButtonActionPerformed
// Add your handling code here:
      loginThread = new Thread("CVS_AUTHORIZING_THREAD") {
          public void run() {
              //entry = new PasswdEntry();
//              passwd.remove(connectStr);
//              pasFile.add(connectStr, password); //CVSPasswd.scramble(password));
//              pasFile.savePassFile();
              //boolean setRight = entry.setEntry(connectStr + " " + CVSPasswd.scramble(password));
              //if (!setRight) {D("wrongly set entry.");}
              checkLogin();
          }
      };
      loginThread.start();
  }//GEN-LAST:event_loginButtonActionPerformed

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible (false);
        dispose ();
    }//GEN-LAST:event_closeDialog
/*
    private boolean wasLoggedIn() {
        return lastSuccessfullLoggings.contains(connectStr);
    }
  */  
    /**
     * Show the login dialog and start the login process immediately.
     */
    public void showLogging() {
/*
 if (wasLoggedIn()) {
            loggedIn = true; // believe, that the user is still correctly logged in
            return;
        }
 */
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                SwingUtilities.invokeLater(new Runnable() {
                    public void run() {
                        Runnable login = new Runnable() {
                            public void run() {
                                checkLogin(); // this should be called after show();
                            }
                        };
                        new Thread(login, "CVS_AUTHORIZING_THREAD").start();
                    }
                });
            }
        });
        show();
    }
    
    private void checkLogin() {
        lastSuccessfullLoggings.remove(connectStr);
        txPasswd.setEnabled(false);
        btnLogin.setEnabled(false);
        setStatus(STATUS_CONNECTING, null);
        StringBuffer message = new StringBuffer();
        String password = null;
        loggedIn = false;
        try {
            PasswdEntry entry = new PasswdEntry();
            password = new String (txPasswd.getPassword());
            entry.setEntry(connectStr + " " + CVSPasswd.scramble(password));
            loggedIn = passwd.checkServer(entry);
        } catch (org.netbeans.lib.cvsclient.connection.AuthenticationException exc1) {
            if (exc1.getUnderlyingThrowable() instanceof java.net.UnknownHostException) {
                setStatus(org.openide.util.NbBundle.getBundle(LoginDialog.class).getString(
                                "LoginDialog.unknownHost"));
                return;
            }
            if (exc1.getUnderlyingThrowable() instanceof java.io.IOException) {
                setStatus(org.openide.util.NbBundle.getBundle(LoginDialog.class).getString(
                                         "LoginDialog.connectionIOError"));
                return;
            }
        } finally {
            txPasswd.setEnabled(true);
            btnLogin.setEnabled(true);
        }
        if (!loggedIn) {
            setStatus(STATUS_FAILED, message.toString());
        } else {
 //           lastSuccessfullLoggings.add(connectStr);
//            closeDialog(null);
            setStatus(org.openide.util.NbBundle.getBundle(LoginDialog.class).getString(
                                        "LoginDialog.status.succeeded"));
            passwd.add(connectStr, new String(txPasswd.getPassword()));
            passwd.savePassFile();
        }
    }
    
    public void setConnectString(String connectStr) {
        this.connectStr = connectStr;
    }
    
    public void setPserverName(String pserverName) {
        lblLogin.setText(java.text.MessageFormat.format(org.openide.util.NbBundle.getBundle(LoginDialog.class).getString("LoginDialog.loginLabel.text"), new Object[] { pserverName }));
        pack();
    }
    
    public void setStatus(Object status) {
        setStatus(status, null);
    }
    
    public void setStatus(Object status, String message) {
        if (status.equals(STATUS_FAILED)) {
            statusLabel.setText(org.openide.util.NbBundle.getBundle(LoginDialog.class).getString("LoginDialog.status.failed"));
            if (message != null) statusLabel.setToolTipText(message);
        } else if (status.equals(STATUS_CONNECTING)) {
            statusLabel.setText(org.openide.util.NbBundle.getBundle(LoginDialog.class).getString("LoginDialog.status.connecting"));
        } else if (status instanceof String) {
            statusLabel.setText((String) status);
//            statusLabel.setText();
        }
    }
    
    public boolean isLoggedIn() {
        return loggedIn;
    }
    
    public boolean isOffline() {
        return offline;
    }
    
    public String getPassword() {
        return new String(txPasswd.getPassword());
    }
    
    public static LoginDialog createDialog(String cvsRoot, CVSPasswd pass) {
        LoginDialog dialog = new LoginDialog (new javax.swing.JFrame (), true, cvsRoot, pass);
        return dialog;
    }
    
    /**
     * @param args the command line arguments
     *
     * public static void main (String args[]) {
     * new LoginDialog (new javax.swing.JFrame (), true, null).show ();
     * }
     */
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel loginPanel;
    private javax.swing.JLabel lblLogin;
    private javax.swing.JLabel lblPasswd;
    private javax.swing.JPasswordField txPasswd;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton btnLogin;
    private javax.swing.JButton btnCancel;
    private javax.swing.JPanel statusPanel;
    private javax.swing.JLabel statusLabel;
    // End of variables declaration//GEN-END:variables

}
