/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.javadoc.settings;

import java.awt.Image;
import java.beans.*;
import java.util.ResourceBundle;

import org.openide.util.NbBundle;
import org.openide.explorer.propertysheet.editors.FileOnlyEditor;
import org.openide.explorer.propertysheet.editors.DirectoryOnlyEditor;


/** BeanInfo for standard doclet settings
*
* @author Petr Hrebejk
*/
public class StdDocletSettingsServiceBeanInfo extends SimpleBeanInfo {
    /** Icons for compiler settings objects. */
    static Image icon;
    static Image icon32;
    /** bean descriptor field */
    private static BeanDescriptor descr;
    /** Array of property descriptors. */
    private static PropertyDescriptor[] desc;

    static {
        descr = new BeanDescriptor(org.netbeans.modules.javadoc.search.Jdk12SearchType.class);
        descr.setName(ResourceUtils.getBundledString("PROP_DocletService")); // NOI18N
        descr.setValue ("version", "1.1"); // NOI18N            
    }

    // initialization of the array of descriptors
    static {
        try {
            desc = new PropertyDescriptor[] {
                       new PropertyDescriptor("directory", StdDocletSettingsService.class),       // 0 // NOI18N
                       new PropertyDescriptor("use", StdDocletSettingsService.class),             // 1 // NOI18N
                       new PropertyDescriptor("version", StdDocletSettingsService.class),         // 2 // NOI18N
                       new PropertyDescriptor("author", StdDocletSettingsService.class),          // 3 // NOI18N
                       new PropertyDescriptor("splitindex", StdDocletSettingsService.class),      // 4 // NOI18N
                       new PropertyDescriptor("windowtitle", StdDocletSettingsService.class),     // 5 // NOI18N
                       new PropertyDescriptor("doctitle", StdDocletSettingsService.class),        // 6 // NOI18N
                       new PropertyDescriptor("header", StdDocletSettingsService.class),          // 7 // NOI18N
                       new PropertyDescriptor("footer", StdDocletSettingsService.class),          // 8 // NOI18N
                       new PropertyDescriptor("bottom", StdDocletSettingsService.class),          // 9 // NOI18N
                       new PropertyDescriptor("link", StdDocletSettingsService.class),            // 10 // NOI18N
                       new PropertyDescriptor("group", StdDocletSettingsService.class),           // 11 // NOI18N
                       new PropertyDescriptor("nodeprecated", StdDocletSettingsService.class),    // 12 // NOI18N
                       new PropertyDescriptor("nodeprecatedlist", StdDocletSettingsService.class),// 13 // NOI18N
                       new PropertyDescriptor("notree", StdDocletSettingsService.class),          // 14 // NOI18N
                       new PropertyDescriptor("noindex", StdDocletSettingsService.class),         // 15 // NOI18N
                       new PropertyDescriptor("nohelp", StdDocletSettingsService.class),          // 16 // NOI18N
                       new PropertyDescriptor("nonavbar", StdDocletSettingsService.class),        // 17 // NOI18N
                       new PropertyDescriptor("helpfile", StdDocletSettingsService.class),        // 18 // NOI18N
                       new PropertyDescriptor("stylesheetfile", StdDocletSettingsService.class),  // 19 // NOI18N
                       new PropertyDescriptor("charset", StdDocletSettingsService.class),         // 20 // NOI18N
                   };

            desc[0].setDisplayName(ResourceUtils.getBundledString("PROP_Directory"));
            desc[0].setShortDescription(ResourceUtils.getBundledString("HINT_Directory"));
            desc[0].setPropertyEditorClass( DirectoryOnlyEditor.class );
            desc[1].setDisplayName(ResourceUtils.getBundledString("PROP_Use"));
            desc[1].setShortDescription(ResourceUtils.getBundledString("HINT_Use"));
            desc[2].setDisplayName(ResourceUtils.getBundledString("PROP_Version"));
            desc[2].setShortDescription(ResourceUtils.getBundledString("HINT_Version"));
            desc[3].setDisplayName(ResourceUtils.getBundledString("PROP_Author"));
            desc[3].setShortDescription(ResourceUtils.getBundledString("HINT_Author"));
            desc[4].setDisplayName(ResourceUtils.getBundledString("PROP_Splitindex"));
            desc[4].setShortDescription(ResourceUtils.getBundledString("HINT_Splitindex"));
            desc[5].setDisplayName(ResourceUtils.getBundledString("PROP_Windowtitle"));
            desc[5].setShortDescription(ResourceUtils.getBundledString("HINT_Windowtitle"));
            desc[6].setDisplayName(ResourceUtils.getBundledString("PROP_Doctitle"));
            desc[6].setShortDescription(ResourceUtils.getBundledString("HINT_Doctitle"));
            desc[7].setDisplayName(ResourceUtils.getBundledString("PROP_Header"));
            desc[7].setShortDescription(ResourceUtils.getBundledString("HINT_Header"));
            desc[8].setDisplayName(ResourceUtils.getBundledString("PROP_Footer"));
            desc[8].setShortDescription(ResourceUtils.getBundledString("HINT_Footer"));
            desc[9].setDisplayName(ResourceUtils.getBundledString("PROP_Bottom"));
            desc[9].setShortDescription(ResourceUtils.getBundledString("HINT_Bottom"));
            desc[10].setDisplayName(ResourceUtils.getBundledString("PROP_Link"));
            desc[10].setShortDescription(ResourceUtils.getBundledString("HINT_Link"));
            desc[11].setDisplayName(ResourceUtils.getBundledString("PROP_Group"));
            desc[11].setShortDescription(ResourceUtils.getBundledString("HINT_Group"));
            desc[11].setPropertyEditorClass(StdDocletSettingsService.GroupEditor.class);
            desc[12].setDisplayName(ResourceUtils.getBundledString("PROP_Nodeprecated"));
            desc[12].setShortDescription(ResourceUtils.getBundledString("HINT_Nodeprecated"));
            desc[13].setDisplayName(ResourceUtils.getBundledString("PROP_Nodeprecatedlist"));
            desc[13].setShortDescription(ResourceUtils.getBundledString("HINT_Nodeprecatedlist"));
            desc[14].setDisplayName(ResourceUtils.getBundledString("PROP_Notree"));
            desc[14].setShortDescription(ResourceUtils.getBundledString("HINT_Notree"));
            desc[15].setDisplayName(ResourceUtils.getBundledString("PROP_Noindex"));
            desc[15].setShortDescription(ResourceUtils.getBundledString("HINT_Noindex"));
            desc[16].setDisplayName(ResourceUtils.getBundledString("PROP_Nohelp"));
            desc[16].setShortDescription(ResourceUtils.getBundledString("HINT_Nohelp"));
            desc[17].setDisplayName(ResourceUtils.getBundledString("PROP_Nonavbar"));
            desc[17].setShortDescription(ResourceUtils.getBundledString("HINT_Nonavbar"));
            desc[18].setDisplayName(ResourceUtils.getBundledString("PROP_Helpfile"));
            desc[18].setShortDescription(ResourceUtils.getBundledString("HINT_Helpfile"));
            desc[18].setPropertyEditorClass( FileOnlyEditor.class );
            desc[19].setDisplayName(ResourceUtils.getBundledString("PROP_Stylesheetfile"));
            desc[19].setShortDescription(ResourceUtils.getBundledString("HINT_Stylesheetfile"));
            desc[19].setPropertyEditorClass( FileOnlyEditor.class );
            desc[20].setDisplayName(ResourceUtils.getBundledString("PROP_Charset"));
            desc[20].setShortDescription(ResourceUtils.getBundledString("HINT_Charset"));

            //desc[0].setPropertyEditorClass(FileOnlyEditor.class);
            //desc[0].setPropertyEditorClass(StringArrayCustomEditor.class);

        } catch (IntrospectionException ex) {
            //throw new InternalError ();
            ex.printStackTrace ();
        }
    }

     /** @retrun BeanDescriptor for this class */
     public BeanDescriptor getBeanDescriptor () {
         return descr;
     }

     /** Returns the ExternalCompilerSettings' icon */
    public Image getIcon(int type) {
        if ((type == java.beans.BeanInfo.ICON_COLOR_16x16) || (type == java.beans.BeanInfo.ICON_MONO_16x16)) {
            if (icon == null)
                icon = loadImage("/org/netbeans/modules/javadoc/resources/JavaDoclet.gif"); // NOI18N
            return icon;
        } else {
            if (icon32 == null)
                icon32 = loadImage ("/org/netbeans/modules/javadoc/resources/JavadocSettings32.gif"); // NOI18N
            return icon32;
        }
    }

    /** Descriptor of valid properties
    * @return array of properties
    */
    public PropertyDescriptor[] getPropertyDescriptors () {
        return desc;
    }
}

/*
 * Log
 *  8    Gandalf   1.7         1/13/00  Petr Hrebejk    i18n mk3  
 *  7    Gandalf   1.6         1/12/00  Petr Hrebejk    i18n
 *  6    Gandalf   1.5         1/3/00   Petr Hrebejk    Bugfix 4747
 *  5    Gandalf   1.4         10/23/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  4    Gandalf   1.3         9/15/99  Petr Hrebejk    Option -docencoding 
 *       changed to -charset
 *  3    Gandalf   1.2         6/30/99  Ian Formanek    Reflecting package 
 *       changes of some property editors
 *  2    Gandalf   1.1         6/9/99   Ian Formanek    ---- Package Change To 
 *       org.openide ----
 *  1    Gandalf   1.0         4/23/99  Petr Hrebejk    
 * $
 */
