/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.jndi.gui;

import org.netbeans.modules.jndi.JndiRootNode;
/**
 *
 * @author  tzezula
 * @version 
 */
public class CreateAttributePanel extends javax.swing.JPanel {

    /** Creates new form CreateAttributePanel */
    public CreateAttributePanel() {
        initComponents ();
    }

    /** Returns the name of the Attribute
     *  @return String name
     */
    public String getName(){
        return this.name.getText();
    }

    /** Returns the value of the Attribute
     *  @return String value
     */
    public String getValue(){
        return this.value.getText();
    }

    /** Sets the value of the name field
     *  @param String name
     */
    public void setName (String name){
        this.name.setText(name);
    }

    /** Sets the value of the value field
     *  @param String name
     */
    public void setValue(String value){
        this.value.setText(value);
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents () {//GEN-BEGIN:initComponents
        nameLabel = new javax.swing.JLabel ();
        name = new javax.swing.JTextField ();
        valueLabel = new javax.swing.JLabel ();
        value = new javax.swing.JTextField ();
        setLayout (new java.awt.GridBagLayout ());
        java.awt.GridBagConstraints gridBagConstraints1;

        nameLabel.setText (JndiRootNode.getLocalizedString("TXT_AttributeName"));


        gridBagConstraints1 = new java.awt.GridBagConstraints ();
        gridBagConstraints1.insets = new java.awt.Insets (8, 8, 4, 4);
        add (nameLabel, gridBagConstraints1);

        name.setColumns (16);


        gridBagConstraints1 = new java.awt.GridBagConstraints ();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 0;
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets (8, 4, 4, 8);
        add (name, gridBagConstraints1);

        valueLabel.setText (JndiRootNode.getLocalizedString("TXT_AttributeValue"));


        gridBagConstraints1 = new java.awt.GridBagConstraints ();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.insets = new java.awt.Insets (4, 8, 8, 4);
        add (valueLabel, gridBagConstraints1);

        value.setColumns (16);


        gridBagConstraints1 = new java.awt.GridBagConstraints ();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets (4, 4, 8, 8);
        add (value, gridBagConstraints1);

    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel nameLabel;
    private javax.swing.JTextField name;
    private javax.swing.JLabel valueLabel;
    private javax.swing.JTextField value;
    // End of variables declaration//GEN-END:variables

}