/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package test;

import java.util.*;
import org.openide.nodes.*;

/**
 *
 * @author  jtulach
 * @version 
 */
public class ChildrenArrayTest extends Children.SortedArray
    implements NodeListener, Comparator {
    private static Node n;
    private static Node n1;
    private static Node n2;

    private static void print (int i) {
        Node[] arr = n.getChildren ().getNodes ();
        System.out.println(
            "arr (" + i + "): " + Arrays.asList (arr) +
            " n1: " + n1.getParentNode () + " n2: " + n2.getParentNode ()
        );
    }


    public int compare (Object o1, Object o2) {
        Node n1 = (Node)o1;
        Node n2 = (Node)o2;

        return n1.getName ().compareTo (n2.getName ());
    }

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {

        ChildrenArrayTest ch = new ChildrenArrayTest ();
        ch.setComparator (ch);
        n = new AbstractNode (ch);
        n.addNodeListener (ch);

        n = new FilterNode (n);

        n1 = new AbstractNode (Children.LEAF);
        n1.setName ("n1");

        n2 = new AbstractNode (Children.LEAF);
        n2.setName ("n2");
        //print(1);
        ch.add (new Node[] {
                    n1, n2
                });
        print(2);
        ch.add (new Node[] { n1 });
        /*
        print(3);
              ch.remove (new Node[] { n1 });
        print(4);      
              ch.add (new Node[] { n1 });
        print(5);
              ch.nodes = Arrays.asList (new Node[] {
                n1, n2
              });
              ch.refresh ();
        print(6);
        */
    }

    /** Fired when a set of new children is added.
       * @param ev event describing the action
       */
    public void childrenAdded(NodeMemberEvent ev) {
        System.out.println("added: " + ev);
    }
    /** Fired when a set of children is removed.
     * @param ev event describing the action
     */
    public void childrenRemoved(NodeMemberEvent ev) {
        System.out.println("removed: " + ev);
    }
    /** Fired when the order of children is changed.
     * @param ev event describing the change
     */
    public void childrenReordered(NodeReorderEvent ev) {
        System.out.println("reordered: " + ev);
    }
    /** Fired when the node is deleted.
     * @param ev event describing the node
     */
    public void nodeDestroyed(NodeEvent ev) {
        System.out.println("destroyed: " + ev);
    }
    public void propertyChange(final java.beans.PropertyChangeEvent ev) {
        System.out.println("property change: " + ev);
    }
}

/*
 * Log
 *  2    Gandalf   1.1         10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  1    Gandalf   1.0         9/2/99   Jaroslav Tulach 
 * $
 */
