/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package test;

import java.util.*;
import org.openide.nodes.*;

/**
 *
 * @author  jtulach
 * @version 
 */
public class ChildrenKeysTest extends Children.Keys {

    /** Creates new ChildrenKeysTest */
    public ChildrenKeysTest() {
    }

    protected void addNotify () {
        System.out.println("Add notify");
    }

    protected void removeNotify () {
        System.out.println("remove notify");
    }

    static boolean noChildren;

    protected Node[] createNodes (Object key) {
        if (noChildren) {
            return new Node[0];
        } else {
            return new Node[] { new AbstractNode (Children.LEAF) };
        }
    }

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        if (args.length == 1 && args[0].equals ("no")) {
            noChildren = true;
        }

        ChildrenKeysTest ch = new ChildrenKeysTest ();
        AbstractNode an = new AbstractNode (ch);
        ch.setKeys (new Object[] { "kuk" });

        Node[] arr = an.getChildren ().getNodes ();

        System.out.println("Nodes: " + Arrays.asList (arr));
        for (int i = 0; i < arr.length; i++) {
            System.out.println("parent: " + arr[i].getParentNode ());
        }

        for (;;) {
            arr = null;
            System.gc ();
            Runtime.getRuntime ().runFinalization ();

            noChildren = !noChildren;

            System.out.println("Ok no children: " + noChildren);
            ch.setKeys (new Object[] { "ahoj", "kuk", "kukuc" });

            arr = an.getChildren ().getNodes ();

            System.out.println("Nodes: " + Arrays.asList (arr));
            for (int i = 0; i < arr.length; i++) {
                System.out.println("parent: " + arr[i].getParentNode ());
            }
        }

    }

}

/*
 * Log
 *  2    Gandalf   1.1         10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  1    Gandalf   1.0         9/2/99   Jaroslav Tulach 
 * $
 */
