/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package test;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class CompareFolders extends Object {
    static HashMap stFolders;
    static HashMap diskFolders;

    static void runit(String args[], String pass) throws Exception {
        System.out.println ("Scanning Starteam....");
        StringBuffer buf = new StringBuffer(args[0]);
        buf.append("stcmd list -nologo -p ");
        buf.append(args[1]);
        buf.append(":");
        buf.append(pass);
        buf.append("@nbteamsrv\\Corona\\Gandalf\\Development\\ -rp w:\\ -is");
        Process proc = Runtime.getRuntime().exec(buf.toString());
        BufferedReader reader = new BufferedReader(new InputStreamReader(proc.getInputStream()));
        String line;
        while ((line = reader.readLine()) != null) {
            int index = line.indexOf("(working dir:");
            if (index != -1) {
                line = line.substring(index + 14, line.length() - 1).toUpperCase();
                System.out.println (line);
                stFolders.put(line, line);
            }
        }
        reader.close();

        System.out.println ("Scanning Disk....");
        scanDisk(new File("w:\\Development\\"));

        compare();
    }

    static void scanDisk(File dir) {
        try {
            String path = dir.getCanonicalPath().toUpperCase();
            diskFolders.put(path, path);
            System.out.println ("'"+path+"'");
            String[] files = dir.list();
            for (int i = 0; i < files.length; i++) {
                File f = new File(path + File.separator + files[i]);
                if (f.isDirectory())
                    scanDisk(f);
            }
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    static void compare() {
        compareTables("disk", stFolders, diskFolders);
        compareTables("StarTeam", diskFolders, stFolders);
    }

    static void compareTables(String where, HashMap src, HashMap dest) {
        System.out.println ();
        System.out.println ("Folders not in "+where);
        System.out.println ("=============================================");
        Iterator it = src.keySet().iterator();

        TreeSet list = new TreeSet();
        while (it.hasNext()) {
            String key = (String) it.next();
            if (dest.get(key) == null) {
                list.add(key);
            }
        }
        it = list.iterator();
        while (it.hasNext()) {
            System.out.println (it.next());
        }
    }

    public static void main(final String[] args) throws Exception {
        stFolders = new HashMap();
        diskFolders = new HashMap();

        /*
        BufferedReader reader = new BufferedReader(new FileReader("w:\\st_folders.txt"));
        String line = null;
        while ((line = reader.readLine()) != null) {
          line = line.toUpperCase();
          stFolders.put(line, line);
    } */

        final Frame dlg = new Frame();
        dlg.add(new Label("Password"), "North");
        final TextField txt = new TextField(30);
        txt.setEchoChar('M'); // :-)
        dlg.add(txt, "Center");
        final Button ok = new Button("Ok");
        dlg.add(ok, "East");
        dlg.pack();
        ok.addActionListener(new ActionListener() {
                                 public void actionPerformed(ActionEvent evt) {
                                     dlg.hide();
                                     dlg.dispose();
                                     try {
                                         runit(args, txt.getText());
                                     }
                                     catch (Exception e) {
                                         e.printStackTrace();
                                     }
                                     System.exit(0);
                                 }
                             });
        dlg.show();
    }
}


/*
 * Log
 *  2    Gandalf   1.1         10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  1    Gandalf   1.0         8/19/99  Petr Hamernik   
 * $
 */
