/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package test;

import java.awt.*;
import java.awt.event.*;

/**
* Test for debugger.
* Tou may test:
*   setting breakp. in innerclasses, initialiers..
*   creating, susponding threads + refresh threads properties & callstack & local var.
*   member, static, local variables + changing it's values, inspecting them
*   changing variables to fields and back.
*   static & nonstatic initializations
*
* @author Jan Jancura
* @version
*/
public class DebuggerTest extends Object {

    int             v = 0, x = 10, y = 10;
    static int      staticIntV = 22;

    static String   staticStringV = "jedna";
    Boolean         booleanV = new Boolean (true);
    Frame           frameV = null;
    Point           pointV = new Point (10, 11);

    ThreadGroup     tgSpec = new ThreadGroup ("Special group");
    Thread          producerThread;
    Thread          innerThread;


    static {
        staticStringV += " a dvje";
    }

    static {
        staticIntV ++;
    }

    {v ++;}

    public DebuggerTest(int i) {
        this ();
        System.out.println ("DebuggerTest (int i) end");
    }

    public DebuggerTest() {

        int localIntV = 0;
        System.out.println ("DebuggerTest() start");

        innerThread = new Thread (tgSpec, new Runnable () {
                                      public void run () {
                                          for (int i = 0;; i++) {
                                              try {
                                                  Thread.sleep (6000);
                                              } catch (InterruptedException ex) {
                                              }

                                              Tester tt = new Tester ("inner thread (" + staticIntV + ") ");
                                              tt.test ();
                                              Tester1 tt1 = new Tester1 ("inner thread (" + staticIntV + ") ");
                                              staticIntV ++;
                                          }
                                      }
                                  }, "inner thread");
        System.out.println("inner thread start");
        innerThread.start();

        staticIntV = 33;
        pointV.setLocation (1, 12);
        localIntV++;
        booleanV = new Boolean (false);
        Object o;

        // producer thread ....................................................................
        producerThread = new Thread (new Runnable () {
                                         public void run () {
                                             System.out.println ("producer thread started");
                                             for (int i = 0;; i++) {
                                                 try {
                                                     Thread.sleep (8000);
                                                 } catch (InterruptedException ex) {
                                                 }

                                                 Thread fooThread = new Thread (new Runnable () {
                                                                                    public void run () {
                                                                                        System.out.println (Thread.currentThread ().getName () + " created");
                                                                                        for (int ii = 0;; ii++) {
                                                                                            try {
                                                                                                Thread.sleep (8000);
                                                                                            } catch (InterruptedException ex) {
                                                                                            }
                                                                                            System.out.println (Thread.currentThread ().getName () + ": " + ii);
                                                                                        }
                                                                                    }}, "foo Thread " + i);
                                                 fooThread.start ();
                                                 System.out.println (fooThread.getName () + ": prepared");

                                                 f2 ();
                                                 frameV.setLocation (x, y);
                                             }
                                         }}, "producer thread");
        System.out.println ("producer thread start");
        producerThread.start ();
        // producer thread ....................................................................

        o = new String ("value");

        staticStringV = "!@##$$";
        int we = 11;
        f1 ();

        startGraphics ();
        System.out.println ("DebuggerTest end");
    }

    /* public static void main (int i) {
       System.out.println ("main (int i) starting...");
       new DebuggerTest ();
     }*/

    public static void main (String[] arg) {
        System.out.println ("main (String[] arg) starting...");
        new DebuggerTest ();
    }

    /*
      public static void main () {
        System.out.println ("main () starting...");
        new DebuggerTest ();
      }
    */

    void f1 () {   // test changing of we value
        Object r = "asd";
        String [] we = new String [] {
                           "asd", "qwe", "zxc" , "sdf"
                       };
        System.out.println ("f1 end");
    }

    void f2 () {
        staticIntV++;
    }

    void startGraphics () {
        frameV = new Frame ("Debugger test");
        frameV.setLayout (new FlowLayout ());
        Button b = new Button ("Suspend inner thread");
        b.addActionListener (new ActionListener () {
                                 public void actionPerformed (ActionEvent e) {
                                     System.out.println("inner thread suspend");
                                     innerThread.suspend();
                                 }
                             });
        frameV.add (b);
        b = new Button ("Stop producer thread");
        b.addActionListener (new ActionListener () {
                                 public void actionPerformed (ActionEvent e) {
                                     producerThread.stop ();
                                     producerThread = null;
                                     System.gc ();
                                 }
                             });
        frameV.add (b);
        frameV.pack ();
        frameV.show ();
    }

    // innerclasses ............................................................................

    class Tester {
        private String str;
        Tester (String ss) {
            str = ss;
        }

        void test () {
            System.out.println (str);
        }
    }
}

class Tester1 {
    // unavaiable to set breakpoint here...
    private String str;
    Tester1 (String ss) {
        str = ss;
    }

    void test () {
        System.out.println (str);
    }
}

/*
 * Log
 *  6    Gandalf   1.4.1.0     10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  5    Tuborg    1.4         12/2/98  Jan Jancura     
 *  4    Tuborg    1.3         9/29/98  Jan Jancura     
 *  3    Tuborg    1.2         9/29/98  Jan Jancura     
 *  2    Tuborg    1.1         9/15/98  Jan Jancura     
 *  1    Tuborg    1.0         9/3/98   Jan Jancura     
 * $
 */
