/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package test;

import java.io.*;

public class DocGen {
    static PrintStream log;

    private static void javadocFolders(String dir) {
        int index = dir.indexOf("com\\netbeans");
        if (index == -1) {
            index = dir.indexOf("org\\openide");
            if (index == -1) {
                return;
            }
        }
        if (dir.indexOf("com\\netbeans\\examples") != -1)
            return;

        dir = dir.substring(index).replace('\\','.');
        System.out.println (dir);
        if (log != null) {
            log.println (dir);
        }
    }

    private static void list(File dir) {
        try {
            String path = dir.getCanonicalPath();
            String[] files = dir.list();
            boolean hasJava = false;
            for (int i = 0; i < files.length; i++) {
                File f = new File(path + File.separator + files[i]);
                hasJava |= files[i].endsWith(".java");
                if (f.isDirectory())
                    list(f);
            }
            if (hasJava) {
                javadocFolders(dir.getCanonicalPath());
            }
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        log = null;
        try {
            log = new PrintStream(new FileOutputStream("w:\\packages.txt"));
        }
        catch (IOException e) {
        }
        list(new File("w:\\Development\\src"));
        list(new File("w:\\Development\\src_modules"));
        if (log != null)
            log.close();
    }
}

/*
 * Log
 *  5    Gandalf   1.4         1/7/00   Petr Hamernik   
 *  4    Gandalf   1.3         10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  3    Gandalf   1.2         6/9/99   Petr Hamernik   
 *  2    Gandalf   1.1         5/16/99  Petr Hamernik   
 *  1    Gandalf   1.0         4/19/99  Petr Hamernik   
 * $
 */
