/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package test;

import java.io.*;
import java.util .*;
import org.openide.filesystems.*;
import org.openide.util.enum.*;

/**
 *
 * @author  jtulach
 * @version 
 */
public class MFS extends Object {
    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) throws Exception {
        LocalFileSystem fs1 = new LocalFileSystem ();
        fs1.setRootDirectory (new File ("z:/Mirror"));
        LocalFileSystem fs2 = new LocalFileSystem ();
        fs2.setRootDirectory (new File ("z:/Java"));

        MultiFileSystem mfs = new MultiFileSystem (new org.openide.filesystems.FileSystem[] {
                                  fs1, fs2
                              });

        org.openide.TopManager.getDefault ().getRepository ().addFileSystem (mfs);

        /*
            FileObject fo = mfs.findResource ("GJ.java");

            print (fo);
                
            FileLock lock = fo.lock ();
            fo.rename (lock, "DJ", "john");
            list (mfs);
        */

        /* Delete test:
            OutputStream os = fo.getOutputStream (lock);
            
            PrintStream ps = new PrintStream (os);
            ps.println ("Rewriten");
            ps.close ();
            
            lock.releaseLock ();
            
            print (fo);
        */    
        //    System.exit (0);
        /*
            en = mfs.getRoot ().getChildren (true);
            System.out.println("begin: ");
            while (en.hasMoreElements ()) {
              System.out.println(en.nextElement ());
            }
            System.out.println("end");
        */        
    }

    /** Print resource.
    */
    private static void print (FileObject fo) throws IOException {
        InputStream is = fo.getInputStream ();
        byte[] b = new byte[80];
        int len = is.read (b);
        System.out.println("R: " + new String (b, 0, len));
    }

    private static void list (org.openide.filesystems.FileSystem fs) throws IOException {
        Enumeration en = fs.getRoot ().getChildren (true);
        while (en.hasMoreElements ()) {
            FileObject fo = (FileObject)en.nextElement ();
            System.out.println (fo + " size: " + fo.getSize ());
        }
    }
}

/*
 * Log
 *  4    Gandalf   1.3         10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  3    Gandalf   1.2         6/21/99  Jaroslav Tulach 
 *  2    Gandalf   1.1         5/31/99  Jaroslav Tulach Write/rename/delete
 *  1    Gandalf   1.0         5/20/99  Jaroslav Tulach 
 * $
 */
