/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package test;

import java.util.*;
import org.openide.filesystems.*;

/** Aby vam sla tahle trida zkompilovat, musite si odkomentovat oznacenou cast
 * ve tridach LocalFileSystem a FileLock. Pak spustte tohle interni exekuci.
 *
 * @author  phamernik
 * @version 
 */
public class OpenedStreamsPrinter extends Object {
    public static void print(String co, Iterator it) {
        System.out.println("====================== "+co+" ======================");
        while (it.hasNext()) {
            Exception e = (Exception) it.next();
            e.printStackTrace();
        }
    }

    public static void main (String args[]) {
        System.out.println("OPENED STREAMS");
        print("Input", LocalFileSystem.openedIS.values().iterator());
        print("Output", LocalFileSystem.openedOS.values().iterator());
        System.out.println("*********************");
        System.out.println("OPENED LOCKS");
        Iterator it = FileLock.locks.values().iterator();
        while (it.hasNext()) {
            Exception e = (Exception) it.next();
            e.printStackTrace();
        }
    }

}

/*
 * Log
 *  3    Gandalf   1.2         10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  2    Gandalf   1.1         10/10/99 Petr Hamernik   monitoring locks added
 *  1    Gandalf   1.0         10/8/99  Petr Hamernik   
 * $
 */
