/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.examples.modules.audioloader;
import org.openide.actions.ViewAction;
import org.openide.loaders.*;
import org.openide.nodes.*;
import org.openide.util.NbBundle;
import org.openide.util.actions.SystemAction;
public class AudioDataNode extends DataNode {
    public AudioDataNode (AudioDataObject obj) {
        super (obj, Children.LEAF);
        setIconBase ("/org/netbeans/examples/modules/audioloader/audioIcon");
    }
    public SystemAction getDefaultAction () {
        return SystemAction.get (ViewAction.class);
    }
    protected Sheet createSheet () {
        Sheet sheet = super.createSheet ();
        Sheet.Set set = sheet.get (Sheet.PROPERTIES);
        if (set == null) {
            set = Sheet.createPropertiesSet ();
            sheet.put (set);
        }
        DataObject obj = (DataObject) getCookie (DataObject.class);
        Node.Property prop = new ClipLengthProperty (this, obj.getPrimaryFile ());
        set.put (prop);
        return sheet;
    }
    void fireClipLengthChange () {
        firePropertyChange ("clipLength", null, null);
    }
}
