/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.examples.modules.audioloader;
import java.io.InputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;
import org.openide.TopManager;
import org.openide.filesystems.FileLock;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataFolder;
import org.openide.loaders.DataObject;
import org.openide.loaders.TemplateWizard;
import org.openide.modules.ModuleDescription;
import org.openide.modules.ModuleInstall;
public class Installer extends ModuleInstall {
    public void installed () {
        try {
            ModuleDescription.class.getField ("TAG_LAYER"); // NOI18N
            // OK, Layer.xml will do what it needs to.
        } catch (NoSuchFieldException nsfe) {
            // Need to install manually.
            try {
                FileObject prim = DataFolder.create (TopManager.getDefault ().getPlaces ().folders ().templates (), "Other") // NOI18N
                    .getPrimaryFile ().createData ("audiofile", "au"); // NOI18N
                FileLock lock = prim.lock ();
                try {
                    OutputStream os = prim.getOutputStream (lock);
                    try {
                        URLConnection conn = new URL ("nbrescurrloc:/org/netbeans/examples/modules/audioloader/sample.au").openConnection (); // NOI18N
                        conn.connect ();
                        InputStream is = conn.getInputStream ();
                        try {
                            byte[] buf = new byte[1024];
                            int read;
                            while ((read = is.read (buf)) != -1) {
                                os.write (buf, 0, read);
                            }
                        } finally {
                            is.close ();
                        }
                    } finally {
                        os.close ();
                    }
                } finally {
                    lock.releaseLock ();
                }
                DataObject nue = DataObject.find (prim);
                nue.setTemplate (true);
                TemplateWizard.setDescription (nue, new URL ("nbrescurrloc:/org/netbeans/examples/modules/audioloader/sampledescription.html")); // NOI18N
                prim.setAttribute ("SystemFileSystem.localizingBundle", "org.netbeans.examples.modules.audioloader.Bundle"); // NOI18N
            } catch (IOException ioe) {
                TopManager.getDefault ().notifyException (ioe);
            }
        }
    }
}
