/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.examples.modules.globalactions;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;
import org.openide.windows.TopComponent;

/** Simple action. Opens up a new window and displays a message. */
public class TestAction extends CallableSystemAction {

    // generated
    private static final long serialVersionUID = 6101321673293585672L;

    public String getName () {
        return NbBundle.getBundle (TestAction.class).getString ("LBL_TestAction");
    }

    public HelpCtx getHelpCtx () {
        // In a real situation could map to installed JavaHelp...
        return HelpCtx.DEFAULT_HELP;
    }

    protected String iconResource () {
        return "/org/netbeans/examples/modules/globalactions/testAction.gif";
    }

    public void performAction () {
        TopComponent comp = new TopComponent ();
        comp.setName (NbBundle.getBundle (TestAction.class).getString ("LBL_test_window_title"));
        comp.setLayout (new BorderLayout ());
        JLabel label = new JLabel (NbBundle.getBundle (TestAction.class).getString ("LBL_jlabel_text"));
        label.setFont (new Font ("Serif", Font.ITALIC | Font.BOLD, 24));
        label.setHorizontalAlignment (SwingConstants.CENTER);
        comp.add (label, BorderLayout.CENTER);
        comp.setPreferredSize (new Dimension (500, 200));
        comp.open ();
        comp.requestFocus ();
    }

}
