/*
* TestFormExecutorBeanInfo.java
*/ 

package org.netbeans.examples.modules.testforms;

import java.awt.Image;
import java.beans.*;

import org.openide.execution.ThreadExecutor;
import org.openide.util.NbBundle;

/** Description of the executor.
 *
 * @author jglick
 */
public class TestFormExecutorBeanInfo extends SimpleBeanInfo {

    // Inherit properties and so on from Executor.
    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] {
                       Introspector.getBeanInfo (ThreadExecutor.class)
                   };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }

    public BeanDescriptor getBeanDescriptor () {
        // Here is where to include a customizer class if you have one:
        BeanDescriptor desc = new BeanDescriptor (TestFormExecutor.class);
        // Display name also serves as default for instances:
        desc.setDisplayName ("Test Forms");
        desc.setShortDescription ("Tests forms.");
        return desc;
    }

    public PropertyDescriptor[] getPropertyDescriptors () {
//        try {
            /*
            PropertyDescriptor myProp = new PropertyDescriptor ("myProp", TestFormExecutor.class);
            myProp.setDisplayName (NbBundle.getBundle (TestFormExecutorBeanInfo.class).getString ("PROP_myProp"));
            myProp.setShortDescription (NbBundle.getBundle (TestFormExecutorBeanInfo.class).getString ("HINT_myProp"));
            */
            return new PropertyDescriptor[] { };
//        } catch (IntrospectionException ie) {
//            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
//                ie.printStackTrace ();
//            return null;
//        }
    }

    private static Image icon, icon32;
    public Image getIcon (int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            if (icon == null)
            icon = loadImage ("TestFormExecutorIcon.gif");
            return icon;
        } else {
            if (icon32 == null)
              icon32 = loadImage ("TestFormExecutorIcon32.gif");
            return icon32;
        }
    }

}
