/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.openide.execution;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;
import java.util.ResourceBundle;

import org.openide.util.NbBundle;

/**This is a URLStreamHandlerClass for Nbfs URL.
*
* @author Ales Novak, Petr Hamernik
*/
class NbfsURLStreamHandler extends URLStreamHandler {

    /**
    * @param u - URL to open connection to.
    * @return new URLConnection.
    */
    public URLConnection openConnection(URL u) throws IOException {
        if (u.getProtocol().equals(NbfsURLConnection.PROTOCOL)) {
            
            return new NbfsURLConnection(u);
        }
        else {
            throw new IOException (NbBundle.getMessage (NbfsURLStreamHandler.class, "EXC_UnrecognizedProtocol"));
        }
    }
}
