/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.openide.src.nodes;

/** Resource string constants for element node icons.
*
* @author Dafe Simonek, Petr Hamernik
*/
interface IconStrings {

    public static final String FIELD_PUBLIC =
        "/org/openide/resources/src/variablePublic"; // NOI18N

    public static final String FIELD_PROTECTED =
        "/org/openide/resources/src/variableProtected"; // NOI18N

    public static final String FIELD_PRIVATE =
        "/org/openide/resources/src/variablePrivate"; // NOI18N

    public static final String FIELD_PACKAGE =
        "/org/openide/resources/src/variablePackage"; // NOI18N

    public static final String FIELD_ST_PUBLIC =
        "/org/openide/resources/src/variableStPublic"; // NOI18N

    public static final String FIELD_ST_PROTECTED =
        "/org/openide/resources/src/variableStProtected"; // NOI18N

    public static final String FIELD_ST_PRIVATE =
        "/org/openide/resources/src/variableStPrivate"; // NOI18N

    public static final String FIELD_ST_PACKAGE =
        "/org/openide/resources/src/variableStPackage"; // NOI18N

    public static final String CONSTRUCTOR_PUBLIC =
        "/org/openide/resources/src/constructorPublic"; // NOI18N

    public static final String CONSTRUCTOR_PROTECTED =
        "/org/openide/resources/src/constructorProtected"; // NOI18N

    public static final String CONSTRUCTOR_PRIVATE =
        "/org/openide/resources/src/constructorPrivate"; // NOI18N

    public static final String CONSTRUCTOR_PACKAGE =
        "/org/openide/resources/src/constructorPackage"; // NOI18N

    public static final String METHOD_PUBLIC =
        "/org/openide/resources/src/methodPublic"; // NOI18N

    public static final String METHOD_PROTECTED =
        "/org/openide/resources/src/methodProtected"; // NOI18N

    public static final String METHOD_PRIVATE =
        "/org/openide/resources/src/methodPrivate"; // NOI18N

    public static final String METHOD_PACKAGE =
        "/org/openide/resources/src/methodPackage"; // NOI18N

    public static final String METHOD_ST_PUBLIC =
        "/org/openide/resources/src/methodStPublic"; // NOI18N

    public static final String METHOD_ST_PROTECTED =
        "/org/openide/resources/src/methodStProtected"; // NOI18N

    public static final String METHOD_ST_PRIVATE =
        "/org/openide/resources/src/methodStPrivate"; // NOI18N

    public static final String METHOD_ST_PACKAGE =
        "/org/openide/resources/src/methodStPackage"; // NOI18N

    public static final String INITIALIZER =
        "/org/openide/resources/src/initializer"; // NOI18N

    public static final String INITIALIZER_ST =
        "/org/openide/resources/src/initializerSt"; // NOI18N

    public static final String CLASS =
        "/org/openide/resources/src/class"; // NOI18N

    public static final String INTERFACE =
        "/org/openide/resources/src/interface"; // NOI18N

    public static final String WAIT =
        "/org/openide/resources/src/wait"; // NOI18N

    public static final String ERROR =
        "/org/openide/resources/src/error"; // NOI18N

    public static final String FIELDS_CATEGORY =
        "/org/openide/resources/src/variables"; // NOI18N

    public static final String CONSTRUCTORS_CATEGORY =
        "/org/openide/resources/src/constructors"; // NOI18N

    public static final String METHODS_CATEGORY =
        "/org/openide/resources/src/methods"; // NOI18N
}

/*
* Log
*  10   src-jtulach1.9         1/12/00  Petr Hamernik   i18n using perl script 
*       (//NOI18N comments added)
*  9    src-jtulach1.8         10/22/99 Ian Formanek    NO SEMANTIC CHANGE - Sun 
*       Microsystems Copyright in File Comment
*  8    src-jtulach1.7         6/25/99  Petr Hamernik   Categories nodes icons 
*       added
*  7    src-jtulach1.6         6/9/99   Ian Formanek    Fixed resources for 
*       package change
*  6    src-jtulach1.5         6/8/99   Ian Formanek    ---- Package Change To 
*       org.openide ----
*  5    src-jtulach1.4         3/15/99  Petr Hamernik   
*  4    src-jtulach1.3         3/15/99  Petr Hamernik   
*  3    src-jtulach1.2         3/12/99  Petr Hamernik   Icons moving
*  2    src-jtulach1.1         2/12/99  Petr Hamernik   
*  1    src-jtulach1.0         2/9/99   David Simonek   
* $
*/
