/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.openidex.filesystems;

import java.io.File;
import org.openide.filesystems.FileSystem.Environment;

/**
*  This subclass of FileSystem.Environment provides an information
* where the filesystem stores class files.
* An ExternalCompilerType can use the information.
*/
public final class ExternalCompilerEnvironment extends Environment {

    /** Target directory for class files */
    File target;

    /** Creates new ExternalCompilerEnvironment */
    public ExternalCompilerEnvironment() {
    }

    /** A FileSystem which wishes to store class files in
    * some specific location can provide the location by
    * calling the method.
    */
    public void setClassFileDirectory(File dir)  {
        target = dir;
    }

    /** A compiler type calls this method to find out
    * where to generate class files.
    */
    public File getClassFileDirectory() {
        return target;
    }
}

/*
* Log
* $
*/