/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.openidex.jarpackager;

import org.openide.nodes.Node;

/** Interface for controlling packaging process. Anyone interested in
* controlling packaging process in any way should implement this interface
* and register the implementation via JarCreater.addPreController or
* addPostController methods.
*
* @author Dafe Simonek
* @deprecated Note that the interfaces and classes contained in 
* org.openidex.jarpackager are for use with version 1 of the jarpackager 
* module.  Starting with version 2, use the versions in 
* org.netbeans.modules.jarpackager.api .
*/
public interface ArchiveController extends Node.Cookie {

    /** Notifies controller that archive is being processed
     * (either pre-processed if registered via JarCreater.addPreController or
     * post-processed if registered via JarCreater.addPostController).
     * @param driver 'context' object that provides both informations about
     * archive and methods to manipulate and customize archive being created
     * @see ArchiveDriver
     */
    public void processArchive (ArchiveDriver driver);

}

/*
* Log
*  1    Jaga      1.0         4/14/00  David Simonek   
* $
*/
