/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.openidex.jarpackager;

import org.openide.filesystems.FileObject;

/** Interface for filtering file objects. Implementations
* can decide which file objects to accept.
*
* @author Dafe Simonek
* @deprecated Note that the interfaces and classes contained in 
* org.openidex.jarpackager are for use with version 1 of the jarpackager 
* module.  Starting with version 2, use the versions in 
* org.netbeans.modules.jarpackager.api .
*/
public interface ArchiveFilter {

    /** Accepts or refuses given file object.
    * @param fo File object to accept of refuse
    * @return true if given file object can be accepted, false otherwise.
    */
    public boolean accept (FileObject fo);

}

/*
* Log
*  1    Jaga      1.0         4/14/00  David Simonek   
* $
*/
