/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.openidex.jarpackager;

import java.util.Iterator;

import org.openide.filesystems.FileObject;
import org.openide.loaders.DataObject;

import org.openidex.jarpackager.*;


/** Default controller. Takes data objects, gets all their file objects,
* filters them using filter and adds them as an entries to the entry list.
*
* @author Dafe Simonek
* @deprecated Note that the interfaces and classes contained in 
* org.openidex.jarpackager are for use with version 1 of the jarpackager 
* module.  Starting with version 2, use the versions in 
* org.netbeans.modules.jarpackager.api .
*/
public class DefaultController implements ArchiveController {

    /** Processes archive in a way described in class' description.
     * @param driver 'context' object that provides both informations about
     * archive and methods to manipulate and customize archive being created
     * @see ArchiveDriver
     */
    public void processArchive (ArchiveDriver driver) {
        // obtain info from driver
        FileObject curFo = null;
        ArchiveFilter filter = driver.getFilter();
        // process all data objects in default way
        for (Iterator iter = driver.getDataObjects().iterator(); iter.hasNext(); ) {
            for (Iterator iter2 = ((DataObject)iter.next()).files().iterator();
                    iter2.hasNext(); ) {
                curFo = (FileObject)iter2.next();
                if (filter.accept(curFo)) {
                    driver.addEntry(new FOArchiveEntry(curFo));
                }
            }
        }
    }

}

/*
* <<Log>>
*  2    Jaga      1.1         4/20/00  David Simonek   
*  1    Jaga      1.0         4/14/00  David Simonek   
* $
*/
