/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.projects;

import java.util.*;

import org.openide.*;
import org.openide.loaders.*;
import org.openide.nodes.*;

import org.netbeans.modules.projects.settings.ProjectOption;

/**
 *
 * @author  mryzl
 */

public class ProjectRootFilterNode extends FilterNode {

    /** Creates new ProjectFilterNode. */
    public ProjectRootFilterNode(Node node,Children children) {
        super(node, children);
    }

    public Handle getHandle() {
        return new RootHandle();
    }

    static class RootHandle implements Node.Handle {
        static final long serialVersionUID = 1907300072945111595L;

        /** Return a node for the current project.
        */
        public Node getNode() {
            return org.openide.TopManager.getDefault().getPlaces().nodes().projectDesktop();
        }
    }
}

/*
* Log
*  1    Jaga      1.0         3/27/00  Martin Ryzl     
* $ 
*/ 
