/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.projects.importing;

import java.io.File;
import javax.swing.filechooser.FileFilter;

import org.openide.util.NbBundle;

/**
 * Class which perform loading Netbeans project.
 *
 * @author Martin Ryzl
 * @version 1.0
 */
public class ProjectInfoNetbeans extends ProjectInfo {
    
    /** Load project from file
     * 
     * @param projectFile  input file
     * @return ImportProject
     */
    public ImportProject load (java.io.File projectFile) throws Exception {
        return new ImportNetbeansProject(projectFile);
    }
    
    /** Get file filter for File dialog.
     * 
     * @return filter for filename of project
     */
    public javax.swing.filechooser.FileFilter getFileFilter () {
        return new NetbeansFileFilter();
    }
    
    /** Filter for importing Netbeans projects. */
    static class NetbeansFileFilter extends FileFilter {

        private static String filterString = "cpanel.xml"; // NOI18;
        
        /**
         */
        public boolean accept(File f) {
            return f.isDirectory() || (filterString.compareToIgnoreCase(f.getName()) == 0);
        }

        /**
         */
        public String getDescription() {
            return NbBundle.getBundle(ProjectInfoNetbeans.class).getString("CTL_NetbeansFileFilterDescription"); // NOI18N
        }
    }
}
