/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.projects.test;

import java.io.*;

import org.openide.util.SharedClassObject;

/**
 *
 * @author  mryzl
 */
public class ErrorSharedClassObject extends SharedClassObject {

    /** Holds value of property exception. */
    static private Throwable exception;
    
    /** Holds value of property write. */
    static private boolean write;
    
    /** Creates new ErrorSharedClassObject */
    public ErrorSharedClassObject() {
    }

    /** Getter for property exception.
     * @return Value of property exception.
     */
    public Throwable getException() {
        return exception;
    }
    
    /** Setter for property exception.
     * @param exception New value of property exception.
     */
    public void setException(Throwable exception) {
        this.exception = exception;
    }
    
    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
        exception = (Throwable) in.readObject();
        if (exception != null) {
            if (exception instanceof RuntimeException) throw (RuntimeException) exception;
            if (exception instanceof Error) throw (Error) exception;
            if (exception instanceof ClassNotFoundException) throw (ClassNotFoundException) exception;
            if (exception instanceof IOException) throw (IOException) exception;
            throw new java.rmi.RemoteException("internal error - should be detected by the compiler", exception);
        }
    }

    public void writeExternal(ObjectOutput out) throws IOException {
        if (isWrite() && (exception != null)) {
            if (exception instanceof RuntimeException) throw (RuntimeException) exception;
            if (exception instanceof Error) throw (Error) exception;
            if (exception instanceof IOException) throw (IOException) exception;
            throw new java.rmi.RemoteException("internal error - should be detected by the compiler", exception);
        }
        out.writeObject(exception);
    }
    
    /** Getter for property write.
     * @return Value of property write.
     */
    public boolean isWrite() {
        return write;
    }
    
    /** Setter for property write.
     * @param write New value of property write.
     */
    public void setWrite(boolean write) {
        this.write = write;
    }
    
}
