/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.projects.test;

import java.io.*;

import org.openide.util.SharedClassObject;

/**
 *
 * @author  mryzl
 */
public class TestSharedClassObject extends SharedClassObject {

    /** Holds value of property message. */
    static private String message;
    
    /** Creates new TestSharedClassObject */
    public TestSharedClassObject() {
    }

    /** Getter for property message.
     * @return Value of property message.
     */
    public String getMessage() {
        return message;
    }
    
    /** Setter for property message.
     * @param message New value of property message.
     */
    public void setMessage(String message) {
        this.message = message;
    }
    
    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
        message = (String) in.readObject();
    }

    public void writeExternal(ObjectOutput out) throws IOException {
        out.writeObject(message);
    }
}
