/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.properties.syntax;


import java.beans.*;
import java.awt.Image;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.netbeans.modules.editor.options.OptionSupport;

import org.netbeans.modules.properties.PropertiesModule;

import org.openide.util.NbBundle;

/** BeanInfo for plain options
 *
 * @author Petr Jiricka, Libor Kramolis
 */
public class PropertiesOptionsBeanInfo extends org.netbeans.modules.editor.options.PlainOptionsBeanInfo {

    public PropertiesOptionsBeanInfo () {
        super ("/org/netbeans/modules/editor/resources/htmlOptions");
    }

    protected Class getBeanClass() {
        return PropertiesOptions.class;
    }

    protected String[] getPropNames() {
        return OptionSupport.mergeStringArrays(super.getPropNames(),
            PropertiesOptions.PROPERTIES_PROP_NAMES);
    }

    /** @return localized string */
    protected String getString(String s) {
        try {
            return NbBundle.getBundle(PropertiesModule.class).getString(s);
        } catch (MissingResourceException mre) {
            return super.getString(s);
        }
    }

}