/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.rmi.activation;

/**
 * Panel to find out the activation system identification.
 * @author Jan Pokorsky
 */
public class ActivationPanel extends javax.swing.JPanel {

  /** Initializes the Form */
  public ActivationPanel() {
    initComponents ();
    jTextField1.setText("localhost");
    jTextField1.selectAll();
    jTextField2.setText(String.valueOf(java.rmi.activation.ActivationSystem.SYSTEM_PORT));
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents() {//GEN-BEGIN:initComponents
      jLabel1 = new javax.swing.JLabel();
      jTextField1 = new javax.swing.JTextField();
      jLabel2 = new javax.swing.JLabel();
      jTextField2 = new javax.swing.JTextField();
      setLayout(new java.awt.GridBagLayout());
      java.awt.GridBagConstraints gridBagConstraints1;
      setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
      
      jLabel1.setText(getString("LBL_ActivationPanel.Host"));
      jLabel1.setDisplayedMnemonic(getMnemonic("LBL_ActivationPanel.Host"));
      jLabel1.setLabelFor(jTextField1);
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 0;
      gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 0);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
      add(jLabel1, gridBagConstraints1);
      
      
      jTextField1.setColumns(30);
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridy = 0;
      gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints1.insets = new java.awt.Insets(12, 12, 0, 11);
      gridBagConstraints1.weightx = 1.0;
      add(jTextField1, gridBagConstraints1);
      
      
      jLabel2.setText(getString("LBL_ActivationPanel.Port"));
      jLabel2.setDisplayedMnemonic(getMnemonic("LBL_ActivationPanel.Port"));
      jLabel2.setLabelFor(jTextField2);
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 0;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.insets = new java.awt.Insets(11, 12, 17, 0);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
      add(jLabel2, gridBagConstraints1);
      
      
      jTextField2.setColumns(7);
      
      gridBagConstraints1 = new java.awt.GridBagConstraints();
      gridBagConstraints1.gridx = 1;
      gridBagConstraints1.gridy = 1;
      gridBagConstraints1.insets = new java.awt.Insets(11, 12, 17, 11);
      gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
      add(jTextField2, gridBagConstraints1);
      
  }//GEN-END:initComponents


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jLabel1;
  private javax.swing.JTextField jTextField1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JTextField jTextField2;
  // End of variables declaration//GEN-END:variables
  
  /** Get port number of activation system.
   * @throws NumberFormatException if port is not 1-65535
   */
  public int getPort() throws NumberFormatException {
    String portStr = jTextField2.getText();
    int port = java.rmi.activation.ActivationSystem.SYSTEM_PORT;
    if (portStr != null && portStr.length() > 0) port = Integer.parseInt(portStr);
    if (port < 1 || port > 65535) throw new NumberFormatException();

    return port;
  }

  public String getHost() {
    return jTextField1.getText();
  } 
  
  /** Localization. */
  private String getString(java.lang.String key) {
     return org.openide.util.NbBundle.getBundle (ActivationPanel.class).getString(key);
  }    
  
  private static final String mnemonic_suffix = ".mnemonic"; // NOI18N
  
  private char getMnemonic(java.lang.String key) {
     return org.openide.util.NbBundle.getBundle (ActivationPanel.class).getString(key + mnemonic_suffix).charAt(0);
  }
  
}
