/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.rmi.wizard;

import java.beans.*;
import java.lang.ref.Reference;
import java.lang.ref.WeakReference;
import java.text.MessageFormat;
import java.util.StringTokenizer;
import java.util.Enumeration;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

import org.openide.WizardDescriptor;
import org.openide.explorer.*;
import org.openide.filesystems.*;
import org.openide.loaders.DataObject;
import org.openide.loaders.DataFolder;
import org.openide.loaders.DataFilter;
import org.openide.nodes.*;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.enum.*;

/**
 *
 * @author  mryzl
 * @version 
 */
public class RMIWizard1 extends javax.swing.JPanel implements WizardDescriptor.Panel, 
DataFilter, PropertyChangeListener, VetoableChangeListener{

        /** format to for default package */
    private static MessageFormat defaultPackageName;

    /** Change listener. */
    private ChangeListener listener;

    /** Root node. */
    private Node rootNode;
    
   /** Reference to target */
    private DataFolder target;
    
    /** Creates new form RMIWizard1 */
    public RMIWizard1() {
        initComponents ();
        packagesPanel.setBorder (new javax.swing.border.CompoundBorder(
        new javax.swing.border.TitledBorder(org.openide.util.NbBundle.getBundle(RMIWizard1.class).getString("LAB_SelectPackageBorder")),
        new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)))
        );
        rootNode = createPackagesNode ();

        packagesPanel.getExplorerManager ().setRootContext (rootNode);
        packagesPanel.getExplorerManager ().addPropertyChangeListener (this);
        packagesPanel.getExplorerManager ().addVetoableChangeListener (this);

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        packagesPanel = new org.openide.explorer.ExplorerPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        packageName = new javax.swing.JTextField();
        beanTreeView1 = new org.openide.explorer.view.BeanTreeView();
        jLabel3 = new javax.swing.JLabel();
        setLayout(new java.awt.BorderLayout());
        setPreferredSize(new java.awt.Dimension(400, 535));
        setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        setName(getString("RMIWizard1.Form.name"));
        
        packagesPanel.setLayout(new java.awt.BorderLayout(0, 8));
        packagesPanel.setPreferredSize(new java.awt.Dimension(400, 456));
        
        jPanel2.setLayout(new java.awt.GridBagLayout());
          java.awt.GridBagConstraints gridBagConstraints1;
          
          jLabel1.setText(getString("RMIWizard1.jLabel1.text"));
            gridBagConstraints1 = new java.awt.GridBagConstraints();
            jPanel2.add(jLabel1, gridBagConstraints1);
            
            
          packageName.setEditable(false);
            packageName.addFocusListener(new java.awt.event.FocusAdapter() {
                public void focusGained(java.awt.event.FocusEvent evt) {
                    packageNameFocusGained(evt);
                }
            }
            );
            gridBagConstraints1 = new java.awt.GridBagConstraints();
            gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
            gridBagConstraints1.insets = new java.awt.Insets(0, 8, 0, 0);
            gridBagConstraints1.weightx = 1.0;
            jPanel2.add(packageName, gridBagConstraints1);
            
            packagesPanel.add(jPanel2, java.awt.BorderLayout.SOUTH);
          
          
        beanTreeView1.setPopupAllowed(false);
          packagesPanel.add(beanTreeView1, java.awt.BorderLayout.CENTER);
          
          
        jLabel3.setText(getString("RMIWizard1.jLabel3.text"));
          packagesPanel.add(jLabel3, java.awt.BorderLayout.NORTH);
          
          
        add(packagesPanel, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents

  private void packageNameFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_packageNameFocusGained
      // Add your handling code here:
      packageName.selectAll();
  }//GEN-LAST:event_packageNameFocusGained


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private org.openide.explorer.ExplorerPanel packagesPanel;
  private javax.swing.JPanel jPanel2;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JTextField packageName;
  private org.openide.explorer.view.BeanTreeView beanTreeView1;
  private javax.swing.JLabel jLabel3;
  // End of variables declaration//GEN-END:variables

    /** Creates node that displays all packages.
    */
    private Node createPackagesNode () {
        return org.openide.TopManager.getDefault().getPlaces().nodes ().repository(
            this
        );
    }
    
    /** Presets a target folder.
    * @param f the folder
    * @return true if succeeded
    */
    private boolean setTargetFolder (final DataFolder f) {
        boolean exact;
        Node n;
        String name;

        target = f;

        if (f != null) {
            FileObject fo = f.getPrimaryFile ();
            name = fo.getPackageName('.');

            StringTokenizer st = new StringTokenizer (name, "."); // NOI18N
            try {
                FileSystem fs = fo.getFileSystem ();

                if (fo.isRoot ()) {
                    name = defaultPackageName (fs);
                }


                Enumeration en = new SequenceEnumeration (
                                     new SingletonEnumeration (fs.getSystemName()),
                                     st
                                 );

                n = NodeOp.findPath (rootNode, en);
                exact = true;
            } catch (FileStateInvalidException ex) {
                // invalid state of file system => back to root
                n = rootNode;
                name = ""; // NOI18N
                exact = false;
            } catch (NodeNotFoundException ex) {
                n = ex.getClosestNode();
                DataFolder df = (DataFolder)n.getCookie (DataFolder.class);
                if (df != null) {
                    name = df.getPrimaryFile ().getPackageName ('.');
                } else {
                    name = ""; // NOI18N
                }
                exact = false;
            }


        } else {
            // null folder => use root
            n = rootNode;
            name = null;
            exact = true;
        }

        // remove listener + do change + add listener
        ExplorerManager em = packagesPanel.getExplorerManager ();
        em.removePropertyChangeListener (this);
//        packageName.getDocument ().removeDocumentListener (this);

        try {
            em.setSelectedNodes (new Node[] { n });
        } catch (PropertyVetoException ex) {
            throw new InternalError ();
        }

        packageName.setText (name);

//        packageName.getDocument ().addDocumentListener (this);
        em.addPropertyChangeListener (this);

        fireStateChanged ();

        return exact;
    }
    
    /** Fires info to listener.
    */
    private void fireStateChanged () {
        if (listener != null) {
            listener.stateChanged (new ChangeEvent (this));
        }
    }
    
    
    /** Creates default package name for given file system.
    * @param fs the file system
    * @return localized name of default package
    */
    private static String defaultPackageName (FileSystem fs) {
        if (defaultPackageName == null) {
            defaultPackageName = new MessageFormat (NbBundle.getBundle(RMIWizard1.class).getString ("FMT_TemplateDefaultPackageName")); // NOI18N
        }

        String n = fs == null ? "" : fs.getDisplayName (); // NOI18N

        return defaultPackageName.format (new Object[] { n });
    }    
    
    

    // Implementation of WizardDescriptor.Panel

    /** Get the component displayed in this panel.
    * @return the component
    */
    public java.awt.Component getComponent() {
        return this;
    }

    /** Help for this panel.
     * When the panel is active, this is used as the help for the wizard dialog.
     * @return the help or <code>null</code> if no help is supplied
     */
    public HelpCtx getHelp() {
        return org.openide.util.HelpCtx.DEFAULT_HELP;
    }

    /** Provides the wizard panel with the current data--either
     * the default data or already-modified settings, if the user used the previous and/or next buttons.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
     */
    public void readSettings(Object settings) {
        DataFolder targetFolder = ((RMIWizard) settings).getTargetFolder();
        setTargetFolder(targetFolder);
    }
    
    /** Provides the wizard panel with the opportunity to update the
     * settings with its current customized state.
     * Rather than updating its settings with every change in the GUI, it should collect them,
     * and then only save them when requested to by this method.
     * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
     * rather, the (copy) passed in here should be mutated according to the collected changes.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing a settings of the wizard
     */
    public void storeSettings(Object settings) {
        ((RMIWizard) settings).setTargetFolder(target);
    }

    /** Test whether the panel is finished and it is safe to proceed to the next one.
     * If the panel is valid, the "Next" (or "Finish") button will be enabled.
     * @return <code>true</code> if the user has entered satisfactory information
     */
    public boolean isValid() {
        return target != null;
    }

    /** Add a listener to changes of the panel's validity.
     * @param l the listener to add
     * @see #isValid
     */
    public void addChangeListener(ChangeListener l) {
        if (listener != null) throw new IllegalStateException ();
        listener = l;
    }

    /** Remove a listener to changes of the panel's validity.
     * @param l the listener to remove
     */
    public void removeChangeListener(ChangeListener l) {
        listener = null;
    }

    
    
    /** Should the data object be displayed or not?
     * @param obj the data object
     * @return <CODE>true</CODE> if the object should be displayed,
     *   <CODE>false</CODE> otherwise
     */
    public boolean acceptDataObject(DataObject obj) {
        return obj instanceof DataFolder;
    }

    public void propertyChange(final java.beans.PropertyChangeEvent ev) {
        if (ExplorerManager.PROP_SELECTED_NODES.equals (ev.getPropertyName ())) {
            Node[] arr = packagesPanel.getExplorerManager ().getSelectedNodes ();
            if (arr.length == 1) {
                DataFolder df = (DataFolder)arr[0].getCookie (DataFolder.class);
                if (df != null) {
                    setTargetFolder (df);
                    return;
                }
            }
            setTargetFolder ((DataFolder)null);
        }
    }

    public void vetoableChange(final java.beans.PropertyChangeEvent ev) throws java.beans.PropertyVetoException {
        if (ExplorerManager.PROP_SELECTED_NODES.equals (ev.getPropertyName ())) {
            Node[] arr = packagesPanel.getExplorerManager ().getSelectedNodes ();

            if (arr.length > 1) {
                throw new PropertyVetoException ("Only single selection allowed", ev); // NOI18N
            }
        }
    }
    
    /** Localization.
     */
    private static String getString(String key) {
        return org.openide.util.NbBundle.getBundle(RMIWizard1.class).getString(key);
    }
}
/* 
 * <<Log>>
 * $ 
 */ 