/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * RMIWizard1_2.java
 *
 * Created on June 12, 2000, 5:56 PM
 */

package org.netbeans.modules.rmi.wizard;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

import org.openide.WizardDescriptor;
import org.openide.explorer.propertysheet.PropertyPanel;
import org.openide.explorer.propertysheet.PropertyModel;
import org.openide.explorer.propertysheet.DefaultPropertyModel;
import org.openide.util.HelpCtx;

/**
 *
 * @author  mryzl, Jan Pokorsky
 * @version 
 */
public class RMIWizard1_2 extends javax.swing.JPanel implements WizardDescriptor.Panel,
    PropertyChangeListener {

    /** Change listener. */
    private ChangeListener listener;
    
    /** Wizard data. */
    private RMIWizard wizard;
    
    /** Creates new form RMIWizard3 */
    public RMIWizard1_2() {
        initComponents ();
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(RMIWizard.RMIWIZARD1_2)); // NOI18N
        setName(getString("RMIWizard1.Form.subtitle")); // NOI18N
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        propertyPanel1 = new org.openide.explorer.propertysheet.PropertyPanel();
        setLayout(new java.awt.BorderLayout());
        setPreferredSize(RMIWizard.DIM);
        
        
        add(propertyPanel1, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private org.openide.explorer.propertysheet.PropertyPanel propertyPanel1;
    // End of variables declaration//GEN-END:variables

    /** Get the component displayed in this panel.
     * @return the component
     */
    public java.awt.Component getComponent() {
        return this;
    }
    
    /** Help for this panel.
     * When the panel is active, this is used as the help for the wizard dialog.
     * @return the help or <code>null</code> if no help is supplied
     */
    public HelpCtx getHelp() {
        return new HelpCtx(RMIWizard.class);
    }

    private PropertyModel model;
        
    /** Provides the wizard panel with the current data--either
     * the default data or already-modified settings, if the user used the previous and/or next buttons.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
     */
    public void readSettings(Object settings) {
        wizard = (RMIWizard) settings;
        wizard.addPropertyChangeListener(this);
        try {
            if (model == null) {
                model = new DefaultPropertyModel(wizard, wizard.PROP_TARGET_FOLDER);
                propertyPanel1.setPreferences(PropertyPanel.PREF_CUSTOM_EDITOR);
                propertyPanel1.setModel(model);
                model = null;
            }
        } catch (IllegalArgumentException ex) {
            ex.printStackTrace();
        }
    }
    
    /** Provides the wizard panel with the opportunity to update the
     * settings with its current customized state.
     * Rather than updating its settings with every change in the GUI, it should collect them,
     * and then only save them when requested to by this method.
     * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
     * rather, the (copy) passed in here should be mutated according to the collected changes.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing a settings of the wizard
     */
    public void storeSettings(Object settings) {
    }
    
    /** Test whether the panel is finished and it is safe to proceed to the next one.
     * If the panel is valid, the "Next" (or "Finish") button will be enabled.
     * @return <code>true</code> if the user has entered satisfactory information
     */
    public boolean isValid() {
        return (wizard != null) && (wizard.getTargetFolder() != null);
    }

    /** Add a listener to changes of the panel's validity.
     * @param l the listener to add
     * @see #isValid
     */
    public void addChangeListener(ChangeListener l) {
        if (listener != null) throw new IllegalStateException ();
        listener = l;
    }

    /** Remove a listener to changes of the panel's validity.
     * @param l the listener to remove
     */
    public void removeChangeListener(ChangeListener l) {
        listener = null;
    }
    
    /** Fires info to listener.
     */
    private void fireStateChanged () {
        if (listener != null) {
            listener.stateChanged (new ChangeEvent (this));
        }
    }

    /** Used for notification on RMIWizard. 
    */
    public void propertyChange(final java.beans.PropertyChangeEvent p1) {
        if (p1.getPropertyName().equals(RMIWizard.PROP_TARGET_FOLDER)) fireStateChanged();
    }

    /** Localization.
     */
    private static String getString(String key) {
        return org.openide.util.NbBundle.getBundle(RMIWizard1_2.class).getString(key);
    }
}