/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.rmi.wizard;

import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

import org.openide.WizardDescriptor;
import org.openide.explorer.propertysheet.PropertyPanel;
import org.openide.explorer.propertysheet.DefaultPropertyModel;
import org.openide.loaders.DataObject;
import org.openide.nodes.Node;
import org.openide.nodes.NodeAcceptor;
import org.openide.src.*;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.UserCancelException;

/**
 *
 * @author  mryzl, Jan Pokorsky
 * @version 
 */
public class RMIWizard2 extends javax.swing.JPanel implements WizardDescriptor.Panel, WizardDescriptor.FinishPanel {

    /** Change listener. */
    private ChangeListener listener;
    
    /** */
    private javax.swing.ButtonGroup buttons;

    /** */
    private transient javax.swing.event.DocumentListener dl;
    
    /** Cached data. */
    private transient RMIWizard wizard;
    
    /** Creates new form RMIWizard2 */
    public RMIWizard2() {
        initComponents ();
        
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(RMIWizard.RMIWIZARD2)); // NOI18N
        setName(getString("RMIWizard2.Form.subtitle")); // NOI18N
        
        buttons = new javax.swing.ButtonGroup();
        buttons.add(jRadioButton1);
        buttons.add(jRadioButton2);
        buttons.setSelected(jRadioButton1.getModel(), true);

        java.util.ResourceBundle bundle2 = NbBundle.getBundle(org.openide.loaders.TemplateWizard.class);

        noBrowser.setText (bundle2.getString("MSG_NoDescription")); // NOI18N

        java.awt.CardLayout card = (java.awt.CardLayout)browserPanel.getLayout();
        card.show (browserPanel, "noBrowser"); // NOI18N
        
        // localization
        jLabel2.setText(getString("RMIWizard2.jLabel2.text")); // NOI18N
        jLabel3.setText(getString("RMIWizard2.jLabel3.text")); // NOI18N
        jLabel4.setText(getString("RMIWizard2.jLabel4.text")); // NOI18N
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jRadioButton1 = new javax.swing.JRadioButton();
        jPanel4 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox(getInterfaceData());
        browserPanel = new javax.swing.JPanel();
        noBrowser = new javax.swing.JLabel();
        browser = new org.openide.awt.HtmlBrowser();
        jLabel3 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        setPreferredSize(RMIWizard.DIM);
        
        jRadioButton1.setText(getString("RMIWizard2.jRadioButton1.text"));
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.weightx = 1.0;
        add(jRadioButton1, gridBagConstraints1);
        
        
        jPanel4.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        jLabel1.setText(getString("RMIWizard2.jLabel1.text"));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(0, 0, 0, 12);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel1, gridBagConstraints2);
        
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel4.add(jTextField1, gridBagConstraints2);
        
        
        jLabel4.setText("Template:");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.insets = new java.awt.Insets(6, 0, 0, 12);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel4, gridBagConstraints2);
        
        
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(6, 0, 0, 0);
        gridBagConstraints2.weightx = 1.0;
        jPanel4.add(jComboBox1, gridBagConstraints2);
        
        
        browserPanel.setLayout(new java.awt.CardLayout());
        browserPanel.setBorder(new javax.swing.border.EtchedBorder());
        browserPanel.setPreferredSize(new java.awt.Dimension(600, 80));
        
        noBrowser.setText("jLabel3");
        noBrowser.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        browserPanel.add(noBrowser, "noBrowser");
        
        
        browser.setStatusLineVisible(false);
        browser.setName("browser");
        browser.setToolbarVisible(false);
        browserPanel.add(browser, "browser");
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(6, 0, 6, 0);
        gridBagConstraints2.weightx = 1.0;
        gridBagConstraints2.weighty = 1.0;
        jPanel4.add(browserPanel, gridBagConstraints2);
        
        
        jLabel3.setText("Superinterface:");
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.insets = new java.awt.Insets(0, 0, 0, 12);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel4.add(jLabel3, gridBagConstraints2);
        
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.weightx = 1.0;
        jPanel4.add(jTextField2, gridBagConstraints2);
        
        
        jButton1.setText("...");
        jButton1.setMargin(new java.awt.Insets(0, 2, 0, 2));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        jPanel4.add(jButton1, gridBagConstraints2);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 20, 10, 0);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel4, gridBagConstraints1);
        
        
        jRadioButton2.setText(getString("RMIWizard2.jRadioButton2.text"));
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        }
        );
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(11, 0, 0, 0);
        gridBagConstraints1.weightx = 1.0;
        add(jRadioButton2, gridBagConstraints1);
        
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        jLabel2.setText("Existing Interface:");
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.insets = new java.awt.Insets(0, 0, 0, 12);
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jLabel2, gridBagConstraints3);
        
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints3.weightx = 1.0;
        jPanel1.add(jTextField3, gridBagConstraints3);
        
        
        jButton2.setText("...");
        jButton2.setMargin(new java.awt.Insets(0, 2, 0, 2));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridwidth = 0;
        jPanel1.add(jButton2, gridBagConstraints3);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(6, 20, 17, 0);
        add(jPanel1, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // Add your handling code here:
        Node place = org.openide.TopManager.getDefault().getPlaces().nodes().repository();
        try {
            Node[] selected = org.openide.TopManager.getDefault().getNodeOperation().select(
                NbBundle.getBundle(RMIWizard2.class).getString("LBL_InterfaceSelect"), // NOI18N
                NbBundle.getBundle(RMIWizard2.class).getString("LBL_LookIn"), // NOI18N
                place, 
                new JDOAcceptor() // should return exactly one node
            );
            Node.Cookie cookie = null;
            cookie = selected[0].getCookie(ClassElement.class);
            if (cookie != null) {
                ClassElement el = (ClassElement) cookie;
                jTextField3.setText(el.getName().getFullName());
                return;
            }
            cookie = selected[0].getCookie(org.netbeans.modules.java.JavaDataObject.class);
            if (cookie != null) {
                org.openide.loaders.DataObject dobj = (org.openide.loaders.DataObject) cookie;
                jTextField3.setText(dobj.getPrimaryFile().getPackageName('.'));
                return;
            }

        } catch (UserCancelException ex) {
              // can be ignored
        }
        
    }//GEN-LAST:event_jButton2ActionPerformed

  private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
// Add your handling code here:
        RMIWizard.DataObjectListModel model = (RMIWizard.DataObjectListModel) jComboBox1.getModel();
        updateDescription(model.getSelectedDataObject());
  }//GEN-LAST:event_jComboBox1ActionPerformed

  private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
// Add your handling code here:
      fireStateChanged();
  }//GEN-LAST:event_jRadioButton2ActionPerformed

  private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
// Add your handling code here:
      fireStateChanged();
  }//GEN-LAST:event_jRadioButton1ActionPerformed

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
    // Select a java data object from filesystems
    Node place = org.openide.TopManager.getDefault().getPlaces().nodes().repository();
    try {
        Node[] selected = org.openide.TopManager.getDefault().getNodeOperation().select(
            NbBundle.getBundle(RMIWizard2.class).getString("LBL_InterfaceSelect"), // NOI18N
            NbBundle.getBundle(RMIWizard2.class).getString("LBL_LookIn"), // NOI18N
            place, 
            new JDOAcceptor() // should return exactly one node
        );
        Node.Cookie cookie = null;
        cookie = selected[0].getCookie(ClassElement.class);
        if (cookie != null) {
            ClassElement el = (ClassElement) cookie;
            jTextField2.setText(el.getName().getFullName());
            return;
        }
        cookie = selected[0].getCookie(org.netbeans.modules.java.JavaDataObject.class);
        if (cookie != null) {
            org.openide.loaders.DataObject dobj = (org.openide.loaders.DataObject) cookie;
            jTextField2.setText(dobj.getPrimaryFile().getPackageName('.'));
            return;
        }
        
    } catch (UserCancelException ex) {
          // can be ignored
    }
  }//GEN-LAST:event_jButton1ActionPerformed


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JRadioButton jRadioButton1;
  private javax.swing.JPanel jPanel4;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JTextField jTextField1;
  private javax.swing.JLabel jLabel4;
  private javax.swing.JComboBox jComboBox1;
  private javax.swing.JPanel browserPanel;
  private javax.swing.JLabel noBrowser;
  private org.openide.awt.HtmlBrowser browser;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JTextField jTextField2;
  private javax.swing.JButton jButton1;
  private javax.swing.JRadioButton jRadioButton2;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JTextField jTextField3;
  private javax.swing.JButton jButton2;
  // End of variables declaration//GEN-END:variables

    /** Request focus.
    */
    public void requestFocus () {
        jTextField1.requestFocus();
        jTextField1.selectAll ();
    }
    
   /** Updates description to reflect the one associated with given object.
    * @param obj object
    */
    private void updateDescription (DataObject obj) {
        java.net.URL url = null;
        if (obj != null) {
            url = org.openide.loaders.TemplateWizard.getDescription (obj);
        }

        java.awt.CardLayout card = (java.awt.CardLayout)browserPanel.getLayout();
        if (url != null) {
            browser.setURL(url);
            card.show (browserPanel, "browser"); // NOI18N
        } else {
            card.show (browserPanel, "noBrowser"); // NOI18N
        }
    }
  
    /** Get items for combo box.
    * @return an array of data objects.
    */
    protected javax.swing.ComboBoxModel getInterfaceData() {
        return new RMIWizard.DataObjectListModel(RMIWizard.getInterfaceTemplates());
    }
    
    /** Get the component displayed in this panel.
     * @return the component
     */
    public java.awt.Component getComponent() {
        return this;
    }
    
    /** Help for this panel.
     * When the panel is active, this is used as the help for the wizard dialog.
     * @return the help or <code>null</code> if no help is supplied
     */
    public HelpCtx getHelp() {
        return new HelpCtx(RMIWizard2.class);
    }
    
    /** Provides the wizard panel with the current data--either
     * the default data or already-modified settings, if the user used the previous and/or next buttons.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
     */
    public void readSettings(Object settings) {
        wizard = (RMIWizard) settings;
        
        RMIWizard.DataObjectListModel model = (RMIWizard.DataObjectListModel) jComboBox1.getModel();
        DataObject dobj = wizard.getInterfaceTemplate();
        model.setSelectedDataObject(dobj);
        updateDescription(dobj);

        if (dl != null) {
            jTextField1.getDocument().removeDocumentListener(dl);
            jTextField2.getDocument().removeDocumentListener(dl);
            jTextField3.getDocument().removeDocumentListener(dl);
        }
        
        String name;
        if (wizard.isNewInterface()) {
            name = wizard.getInterfaceName();
            if (name != null) jTextField1.setText(name);
            else jTextField1.setText(RMIWizard.DEFAULT_INTERFACE);
            jTextField2.setText(wizard.getSuperInterfaceName());
            jTextField3.setText(null);
            jRadioButton1.setSelected(true);
        } else {
            jTextField1.setText(RMIWizard.DEFAULT_INTERFACE);
            jTextField2.setText(null);
            jTextField3.setText(wizard.getInterfaceName());
            jRadioButton2.setSelected(true);
        }
        
        if (dl == null) dl = new javax.swing.event.DocumentListener() {
            public void changedUpdate(javax.swing.event.DocumentEvent e) {
                fireStateChanged();
            }
            public void removeUpdate(javax.swing.event.DocumentEvent e) {
                fireStateChanged();
            }
            public void insertUpdate(javax.swing.event.DocumentEvent e) {
                fireStateChanged();
            }
        };
        jTextField1.getDocument().addDocumentListener(dl);
        jTextField2.getDocument().addDocumentListener(dl);
        jTextField3.getDocument().addDocumentListener(dl);
        
    }
    
    /** Provides the wizard panel with the opportunity to update the
     * settings with its current customized state.
     * Rather than updating its settings with every change in the GUI, it should collect them,
     * and then only save them when requested to by this method.
     * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
     * rather, the (copy) passed in here should be mutated according to the collected changes.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing a settings of the wizard
     */
    public void storeSettings(Object settings) {
        RMIWizard wizard = (RMIWizard) settings;
        String name;
        
        if (jRadioButton1.isSelected()) { // new interface
            wizard.setNewInterface(true);
            wizard.setInterfaceName(jTextField1.getText().trim());
            RMIWizard.DataObjectListModel model = (RMIWizard.DataObjectListModel) jComboBox1.getModel();
            wizard.setInterfaceTemplate(model.getSelectedDataObject());
            name = jTextField2.getText().trim();
            if (name.length() > 0)  wizard.setSuperInterfaceName(name);
            else wizard.setSuperInterfaceName(null);
        } else { // existing interface
            wizard.setNewInterface(false);
            wizard.setInterfaceName(jTextField3.getText().trim());
            wizard.setInterfaceTemplate(null);
            wizard.setSuperInterfaceName(null);
        }
        
    }
    
    /** Test whether the panel is finished and it is safe to proceed to the next one.
     * If the panel is valid, the "Next" (or "Finish") button will be enabled.
     * @return <code>true</code> if the user has entered satisfactory information
     */
    public boolean isValid() {
        boolean valid = false;
        String name;
        
        if (jRadioButton1.isSelected()) { // new interface
            name = jTextField1.getText().trim();
            if (org.openide.util.Utilities.isJavaIdentifier(name) &&
                wizard != null && name.length() > 0) {
                valid = !wizard.isFileExist(name, org.netbeans.modules.rmi.RMIDataLoader.JAVA_EXTENSION);
            }
            
            name = jTextField2.getText().trim();
            if (name.length() > 0) {
                ClassElement el = ClassElement.forName(name);
                if (el != null) valid &= el.isInterface();
                else valid = false;
            }
        } else { // existing interface
            name = jTextField3.getText().trim();
            ClassElement el = ClassElement.forName(name);
            if (el != null) valid = el.isInterface();
            else valid = false;
        }
        
        return valid;
    }
    
    /** Is new interface selected? */
    public boolean isNewSelected() {
        return jRadioButton1.isSelected();
    }
    
    /** Add a listener to changes of the panel's validity.
     * @param l the listener to add
     * @see #isValid
     */
    public void addChangeListener(ChangeListener l) {
        if (listener != null) throw new IllegalStateException ();
        listener = l;
    }

    /** Remove a listener to changes of the panel's validity.
     * @param l the listener to remove
     */
    public void removeChangeListener(ChangeListener l) {
        listener = null;
    }
    
    /** Fires info to listener.
     */
    private void fireStateChanged () {
        if (listener != null) {
            listener.stateChanged (new ChangeEvent (this));
        }
    }

    
    // inner classes
    
    static class JDOAcceptor implements NodeAcceptor {
        
        /** Is the set of nodes acceptable? This implementation should
         * return true iff only one node is selected.
         * @param nodes the nodes to consider
         * @return <CODE>true</CODE> if so
         */
        public boolean acceptNodes(Node[] nodes) {
            if ((nodes == null) || (nodes.length != 1)) return false;
            return (nodes[0].getCookie(org.netbeans.modules.java.JavaDataObject.class) != null) ||
                   (nodes[0].getCookie(org.openide.src.ClassElement.class) != null);
        }
    }
    
    /** Localization.
     */
    private static String getString(String key) {
        return org.openide.util.NbBundle.getBundle(RMIWizard2.class).getString(key);
    }
}

/* 
 * <<Log>>
 * $ 
 */ 