/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.rmi.wizard;

import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

import org.openide.WizardDescriptor;
import org.openide.explorer.propertysheet.PropertyPanel;
import org.openide.explorer.propertysheet.DefaultPropertyModel;
import org.openide.loaders.DataObject;
import org.openide.nodes.Node;
import org.openide.nodes.NodeAcceptor;
import org.openide.src.*;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.UserCancelException;

/**
 *
 * @author  mryzl, Jan Pokorsky
 * @version 
 */
public class RMIWizard3 extends javax.swing.JPanel implements WizardDescriptor.Panel, WizardDescriptor.FinishPanel {

    /** Change listener. */
    private ChangeListener listener;

    /** */
    private transient javax.swing.event.DocumentListener dl;
    
    /** Cached copy of data. */
    RMIWizard wizard;
    
    /** Creates new form RMIWizard3 */
    public RMIWizard3() {
        initComponents ();

        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(RMIWizard.RMIWIZARD3)); // NOI18N
        setName(getString("RMIWizard3.Form.subtitle")); // NOI18N
        
        java.util.ResourceBundle bundle2 = NbBundle.getBundle(org.openide.loaders.TemplateWizard.class);
        jPanel3.setBorder (new javax.swing.border.CompoundBorder(
                           new javax.swing.border.TitledBorder(getString("RMIWizard3.jLabel2.text")), // NOI18N
                               new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8))
                           )
                          );
        noBrowser.setText (bundle2.getString("MSG_NoDescription")); // NOI18N

        java.awt.CardLayout card = (java.awt.CardLayout)browserPanel.getLayout();
        card.show (browserPanel, "noBrowser"); // NOI18N
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jComboBox1 = new javax.swing.JComboBox();
        browserPanel = new javax.swing.JPanel();
        noBrowser = new javax.swing.JLabel();
        browser = new org.openide.awt.HtmlBrowser();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        setPreferredSize(RMIWizard.DIM);
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(2, 2, 2, 2)));
        
        jLabel1.setText(getString("RMIWizard3.jLabel1.text"));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.insets = new java.awt.Insets(0, 0, 0, 8);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jLabel1, gridBagConstraints2);
        
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.weightx = 1.0;
        jPanel1.add(jTextField1, gridBagConstraints2);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints1.weightx = 1.0;
        add(jPanel1, gridBagConstraints1);
        
        
        jPanel3.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridwidth = 0;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints3.weightx = 1.0;
        jPanel3.add(jComboBox1, gridBagConstraints3);
        
        
        browserPanel.setLayout(new java.awt.CardLayout());
        browserPanel.setPreferredSize(new java.awt.Dimension(600, 80));
        
        noBrowser.setText("jLabel3");
        noBrowser.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        browserPanel.add(noBrowser, "noBrowser");
        
        
        browser.setStatusLineVisible(false);
        browser.setName("browser");
        browser.setToolbarVisible(false);
        browserPanel.add(browser, "browser");
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridwidth = 0;
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.insets = new java.awt.Insets(8, 0, 0, 0);
        gridBagConstraints3.weightx = 1.0;
        gridBagConstraints3.weighty = 1.0;
        jPanel3.add(browserPanel, gridBagConstraints3);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = 0;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel3, gridBagConstraints1);
        
    }//GEN-END:initComponents

  private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
// Add your handling code here:
        RMIWizard.DataObjectListModel model = (RMIWizard.DataObjectListModel) jComboBox1.getModel();
        updateDescription(model.getSelectedDataObject());
  }//GEN-LAST:event_jComboBox1ActionPerformed


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel jPanel1;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JTextField jTextField1;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JComboBox jComboBox1;
  private javax.swing.JPanel browserPanel;
  private javax.swing.JLabel noBrowser;
  private org.openide.awt.HtmlBrowser browser;
  // End of variables declaration//GEN-END:variables

    /**
    */
    public javax.swing.ComboBoxModel getImplementationData() {
        return new RMIWizard.DataObjectListModel(RMIWizard.getImplementationTemplates());
    }
    
   /** Updates description to reflect the one associated with given object.
    * @param obj object
    */
    private void updateDescription (DataObject obj) {
        java.net.URL url = null;
        if (obj != null) {
            url = org.openide.loaders.TemplateWizard.getDescription (obj);
        }

        java.awt.CardLayout card = (java.awt.CardLayout)browserPanel.getLayout();
        if (url != null) {
            browser.setURL(url);
            card.show (browserPanel, "browser"); // NOI18N
        } else {
            card.show (browserPanel, "noBrowser"); // NOI18N
        }
    }
    
    /** Get the component displayed in this panel.
     * @return the component
     */
    public java.awt.Component getComponent() {
        return this;
    }
    
    /** Help for this panel.
     * When the panel is active, this is used as the help for the wizard dialog.
     * @return the help or <code>null</code> if no help is supplied
     */
    public HelpCtx getHelp() {
        return new HelpCtx(RMIWizard3.class);
    }
    
    /** Create implementation name from interface (full) name.
     * @param interfaceName name of interface
     * @return implementation class name (without package)
     */
    private String createImplementationName(String interfaceName) {
//        String fmt = "{0}Impl";
        String fmt = NbBundle.getBundle("org/netbeans/modules/rmi/wizard/Local").getString("FMT_DefaultImplementationName"); // NOI18N // Non localized bundle
        int index = interfaceName.lastIndexOf('.');
        if (index > 0) interfaceName = interfaceName.substring(index + 1);
        return java.text.MessageFormat.format(fmt, new Object[] { interfaceName });
    }
    
    /** Provides the wizard panel with the current data--either
     * the default data or already-modified settings, if the user used the previous and/or next buttons.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
     */
    public void readSettings(Object settings) {
        jComboBox1.setModel(getImplementationData());
        wizard = (RMIWizard) settings;
        String name = wizard.getImplementationName();
        if (name == null) name = createImplementationName(wizard.getInterfaceName());
        jTextField1.setText(name);
        RMIWizard.DataObjectListModel model = (RMIWizard.DataObjectListModel) jComboBox1.getModel();
        DataObject dobj = wizard.getImplementationTemplate();
        model.setSelectedDataObject(dobj);
        updateDescription(dobj);

        if (dl == null) dl = new javax.swing.event.DocumentListener() {
            public void changedUpdate(javax.swing.event.DocumentEvent e) {
                fireStateChanged();
            }
            public void removeUpdate(javax.swing.event.DocumentEvent e) {
                fireStateChanged();
            }
            public void insertUpdate(javax.swing.event.DocumentEvent e) {
                fireStateChanged();
            }
        };
        jTextField1.getDocument().addDocumentListener(dl);
    }
    
    /** Provides the wizard panel with the opportunity to update the
     * settings with its current customized state.
     * Rather than updating its settings with every change in the GUI, it should collect them,
     * and then only save them when requested to by this method.
     * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
     * rather, the (copy) passed in here should be mutated according to the collected changes.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing a settings of the wizard
     */
    public void storeSettings(Object settings) {
        RMIWizard wizard = (RMIWizard) settings;
        wizard.setImplementationName(jTextField1.getText());
        RMIWizard.DataObjectListModel model = (RMIWizard.DataObjectListModel) jComboBox1.getModel();
        wizard.setImplementationTemplate(model.getSelectedDataObject());
    }
    
    /** Test whether the panel is finished and it is safe to proceed to the next one.
     * If the panel is valid, the "Next" (or "Finish") button will be enabled.
     * @return <code>true</code> if the user has entst ered satisfactory information
     */
    public boolean isValid() {
        String name = jTextField1.getText();
        if ((name != null) && (org.openide.util.Utilities.isJavaIdentifier(name))) {
            name = name.trim();
            if (name.length() > 0) {
                if (wizard != null) return !wizard.isFileExist(name, org.netbeans.modules.rmi.RMIDataLoader.JAVA_EXTENSION);
            } 
        }
        return false;
    }
    
    /** Add a listener to changes of the panel's validity.
     * @param l the listener to add
     * @see #isValid
     */
    public void addChangeListener(ChangeListener l) {
        if (listener != null) throw new IllegalStateException ();
        listener = l;
    }

    /** Remove a listener to changes of the panel's validity.
     * @param l the listener to remove
     */
    public void removeChangeListener(ChangeListener l) {
        listener = null;
    }
    
    /** Fires info to listener.
     */
    private void fireStateChanged () {
        if (listener != null) {
            listener.stateChanged (new ChangeEvent (this));
        }
    }
    
    /** Localization.
     */
    private static String getString(String key) {
        return org.openide.util.NbBundle.getBundle(RMIWizard3.class).getString(key);
    }    
}