/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.rmi.wizard;

import java.beans.*;
import java.util.Vector;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

import org.openide.*;
import org.openide.cookies.SourceCookie;
import org.openide.explorer.propertysheet.PropertyPanel;
import org.openide.explorer.propertysheet.DefaultPropertyModel;
import org.openide.nodes.Node;
import org.openide.nodes.NodeAcceptor;
import org.openide.src.*;
import org.openide.src.nodes.*;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.UserCancelException;

/**
 *
 * @author  mryzl, Jan Pokorsky
 * @version 
 */
public class RMIWizard4 extends javax.swing.JPanel implements WizardDescriptor.Panel, WizardDescriptor.FinishPanel {

    /** Remote exceptions. */
    static Identifier[] REMOTE_EXCEPTIONS = new Identifier[] {
        Identifier.create("java.rmi.RemoteException"), // NOI18N
        Identifier.create("java.io.IOException"), // NOI18N
        Identifier.create("java.lang.Exception"), // NOI18N
    };

    /** Change listener. */
    private ChangeListener listener;
    
    /** Methods. */
    private javax.swing.DefaultListModel methods;
    
    /** Holds value of property method. */
    private org.openide.src.MethodElement method;
    
    /** Class for validating new methods adding. */
    private ClassElement clazz;
    
    /** Creates new form RMIWizard4 */
    public RMIWizard4() {
        initComponents ();
        
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(RMIWizard.RMIWIZARD4)); // NOI18N
        setName(getString("RMIWizard4.Form.subtitle")); // NOI18N
        
        jList1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jScrollPane1 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();
        jPanel1 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        setLayout(new java.awt.BorderLayout());
        setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        setPreferredSize(RMIWizard.DIM);
        
        
        jScrollPane1.setViewportView(jList1);
        
        
        add(jScrollPane1, java.awt.BorderLayout.CENTER);
        
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 0, 0, 0)));
        
        add(jPanel1, java.awt.BorderLayout.SOUTH);
        
        
        jPanel3.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(0, 8, 0, 0)));
        
        jButton2.setText(getString("RMIWizard4.jButton2.text"));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(jButton2, gridBagConstraints2);
        
        
        jButton3.setText(getString("RMIWizard4.jButton3.text"));
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(jButton3, gridBagConstraints2);
        
        
        jButton4.setText(getString("RMIWizard4.jButton4.text"));
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(jButton4, gridBagConstraints2);
        
        
        jButton1.setText(getString("RMIWizard4.jButton1.text"));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(8, 0, 0, 0);
        jPanel3.add(jButton1, gridBagConstraints2);
        
        
        jButton5.setText(getString("RMIWizard4.jButton5.text"));
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        }
        );
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 0;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel3.add(jButton5, gridBagConstraints2);
        
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.weightx = 1.0;
        gridBagConstraints2.weighty = 1.0;
        jPanel3.add(jPanel4, gridBagConstraints2);
        
        
        add(jPanel3, java.awt.BorderLayout.EAST);
        
    }//GEN-END:initComponents

  private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
// Add your handling code here:
      int index = jList1.getSelectedIndex();
      if ((index > -1) && (index < (methods.size() - 1))) {
          Object obj = methods.get(index);
          obj = methods.set(index + 1, obj);
          methods.set(index, obj);
          index++;
          jList1.setSelectedIndex(index);
      }      
  }//GEN-LAST:event_jButton5ActionPerformed

  private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// Add your handling code here:
      int index = jList1.getSelectedIndex();
      if (index > 0) {
          Object obj = methods.get(index);
          obj = methods.set(index - 1, obj);
          methods.set(index, obj);
          index--;
          jList1.setSelectedIndex(index);
      }      
  }//GEN-LAST:event_jButton1ActionPerformed

  private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
// Add your handling code here:
      int index = jList1.getSelectedIndex();
      if (index > -1) {
          MethodElement me = (MethodElement) methods.remove(index);
          removeFromCheck(me);
          if (index >= methods.size()) index = methods.size() - 1;
          jList1.setSelectedIndex(index);
      }      
  }//GEN-LAST:event_jButton4ActionPerformed

  private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
// Add your handling code here:
      int index = jList1.getSelectedIndex();
      if (index > -1) {
          MethodElement el = (MethodElement) methods.get(index);
          editMethod(el);
          methods.set(index, el); // ensure the list is notified
      }      
  }//GEN-LAST:event_jButton3ActionPerformed

  private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
// Add your handling code here:
      
      /* Add action. Create method allways return non-duplicit method.
       */
      try {
          MethodElement el = createRemoteMethod();
          editMethod(el);
          methods.addElement(el);
      } catch (Exception ex) {
          if (Boolean.getBoolean("netbeans.debug.exceptions")) ex.printStackTrace(); // NOI18N
      }
  }//GEN-LAST:event_jButton2ActionPerformed


  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JList jList1;
  private javax.swing.JPanel jPanel1;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JButton jButton2;
  private javax.swing.JButton jButton3;
  private javax.swing.JButton jButton4;
  private javax.swing.JButton jButton1;
  private javax.swing.JButton jButton5;
  private javax.swing.JPanel jPanel4;
  // End of variables declaration//GEN-END:variables

    
    /**
    */
    protected void editMethod(MethodElement el) {
        MethodElementNode men = new MethodElementNode(el, true);
        do {
            removeFromCheck(el);
            do {
                org.openide.TopManager.getDefault().getNodeOperation().customize(men);
            } while (checkMethodExist(el));
        } while (!checkMethod(el, true));
    }
    
    /** Creates a remote method. It also checks whether the method
     * can be added to a class (mainly because of duplicity)
     *
     * @return the remote method
     */
    protected MethodElement createRemoteMethod() throws SourceException {
        MethodElement el = null;
        String name = RMIWizard.DEFAULT_METHOD;
        for(int i = 1; i < Integer.MAX_VALUE; i++) {
            el = new MethodElement();
            if (i > 1) {
                name = RMIWizard.DEFAULT_METHOD + i;
            } 
            el.setName(Identifier.create(name));
            el.setModifiers(java.lang.reflect.Modifier.PUBLIC);
            el.setExceptions(new Identifier[] { Identifier.create("java.rmi.RemoteException") } ); // NOI18N
            if (!methodExistMark(el)) break;
        }
        return el;
    }
    
    /** Get the component displayed in this panel.
     * @return the component
     */
    public java.awt.Component getComponent() {
        return this;
    }
    
    /** Help for this panel.
     * When the panel is active, this is used as the help for the wizard dialog.
     * @return the help or <code>null</code> if no help is supplied
     */
    public HelpCtx getHelp() {
        return new HelpCtx(RMIWizard4.class);
    }
    
    /** Provides the wizard panel with the current data--either
     * the default data or already-modified settings, if the user used the previous and/or next buttons.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
     */
    public void readSettings(Object settings) {
        RMIWizard wizard = (RMIWizard) settings;
        MethodElement[] els = wizard.getRemoteMethods();
        if (methods == null) {
            methods = new javax.swing.DefaultListModel();
            jList1.setModel(methods);
        } else {
            methods.clear();
        }
        /*
        if (els == null) {
            System.err.println("RMIWizard4:els = " + els);
            // add methods from template
            els = getTemplateMethods(wizard.getInterfaceTemplate());
        }
         */
        
        clazz = new ClassElement();
        
        try {
            if (els != null) {
                clazz.addMethods(els);
                for(int i = 0; i < els.length; i++) {
                    methods.addElement(els[i]);
                }
            }
        } catch (SourceException ex) {
            clazz = new ClassElement(); // should be reinitialized
            TopManager.getDefault().notifyException(ex);
        }
        
    }
    
    /** Provides the wizard panel with the opportunity to update the
     * settings with its current customized state.
     * Rather than updating its settings with every change in the GUI, it should collect them,
     * and then only save them when requested to by this method.
     * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
     * rather, the (copy) passed in here should be mutated according to the collected changes.
     * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
     * @param settings the object representing a settings of the wizard
     */
    public void storeSettings(Object settings) {
        RMIWizard wizard = (RMIWizard) settings;
        MethodElement[] els = new MethodElement[methods.size()];
        methods.copyInto(els);
        wizard.setRemoteMethods(els);
        clazz = null;
    }
    
    /** Test whether the panel is finished and it is safe to proceed to the next one.
     * If the panel is valid, the "Next" (or "Finish") button will be enabled.
     * @return <code>true</code> if the user has entered satisfactory information
     */
    public boolean isValid() {
        return true;
    }

    
    
    /** Add a listener to changes of the panel's validity.
     * @param l the listener to add
     * @see #isValid
     */
    public void addChangeListener(ChangeListener l) {
        if (listener != null) throw new IllegalStateException ();
        listener = l;
    }

    /** Remove a listener to changes of the panel's validity.
     * @param l the listener to remove
     */
    public void removeChangeListener(ChangeListener l) {
        listener = null;
    }
    
    /** Fires info to listener.
     */
    private void fireStateChanged () {
        if (listener != null) {
            listener.stateChanged (new ChangeEvent (this));
        }
    }

    /** Getter for property method.
     * @return Value of property method.
     */
    public org.openide.src.MethodElement getMethod() {
        return method;
    }
    /** Setter for property method.
     * @param method New value of property method.
     */
    public void setMethod(org.openide.src.MethodElement method) {
        this.method = method;
    }
    
    /** Check remote method. It display a message if the method is
     * not valid asking user if he wants to correct it or not.
     * @param withDialog - if true and the method is not valid ask the user
     * @return true if the method is considered (either by check or by user) valid
     */
    protected boolean checkMethod(MethodElement el, boolean withDialog) {
        boolean valid = checkMethod(el);
        if (!valid) { // display a dialog
            Object result = TopManager.getDefault().notify(new NotifyDescriptor.Confirmation(
                NbBundle.getBundle(RMIWizard4.class).getString("MSG_NotRemoteMethod"), // NOI18N
                NotifyDescriptor.YES_NO_OPTION
            ));
            if (result.equals(NotifyDescriptor.YES_OPTION)) valid = true;
        }
        return valid;
    }
    
    
    /** Test if it is possible to add the method. The method
     * will display a dialog when it is not possible to
     * add the method.
     * @param el - the method
     * @return true - if the method exists
     */
    private boolean checkMethodExist(MethodElement el) {
        boolean b = methodExistMark(el);
        if (b) {
            TopManager.getDefault().notify(new NotifyDescriptor.Message(
                NbBundle.getMessage(RMIWizard4.class, "RMIWizard4.MethodExist", el.getName().getName()), // NOI18N
                NotifyDescriptor.ERROR_MESSAGE)
            );
        }
        return b;
    }
    
    /** Removes the method from clazz which is used for detection
     * whether the method can be added or updated.
     *
     * @param me - the method
     */
    private void removeFromCheck(MethodElement me) {
        try {
            if (clazz != null) {
                MethodElement[] mes = clazz.getMethods();
                MethodElement.Key mek = new MethodElement.Key(me);
                for(int i = 0; i < mes.length; i++) {
                    if (mek.equals(new MethodElement.Key(mes[i]))) {
                      clazz.removeMethod(mes[i]);
                      break;
                    }
                }
            }
        } catch (Exception ex) {
          // ignore
        }
    }
    
    /** Test if it is possible to add the method.
     * WARNING: the second call always return true unless
     * the method has not been previously removed from clazz.
     * And remove is done only by Remove action. So far,
     * it is consistent but be carefull.
     * 
     * @return true - method already exists
     */
    protected boolean methodExistMark(MethodElement el) {
        try {
            clazz.addMethod(el);
            return false;
        } catch (SourceException ex) {
        }
        return true;
    }

    /** Check remote method. 
     * @return true if the method is valid remote method
     */
    protected boolean checkMethod(MethodElement el) {
        // methods must be public, with serializable arguments and throw
        // java.rmi.RemoteException or java.io.IOException or java.lang.Exception
        // I don't know how to test serializable arguments but the rest will
        // be OK
        int mod = el.getModifiers();
        if ((mod & java.lang.reflect.Modifier.PUBLIC) == 0) return false; // it isn't public
        Identifier[] excs = el.getExceptions();
        
        for(int i = 0; i < excs.length; i++) {
            for(int j = 0; j < REMOTE_EXCEPTIONS.length; j++) {
                if (excs[i].equals(REMOTE_EXCEPTIONS[j])) return true; 
            }
        }
        return false; 
    }
    
    /** Localization.
     */
    private static String getString(String key) {
        return org.openide.util.NbBundle.getBundle(RMIWizard1.class).getString(key);
    }
}