/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.rmi.wizard;

import org.openide.*;
import org.openide.util.HelpCtx;

/** Summary panel.
 *
 * @author  Jan Pokorsky
 */
public final class RMIWizardFinish extends javax.swing.JPanel implements WizardDescriptor.FinishPanel {

    /** Creates new form RMIWizardFinish */
    public RMIWizardFinish() {
        initComponents();
        jTextArea1.setBackground(getBackground());
        
        putClientProperty("WizardPanel_contentSelectedIndex", new Integer(RMIWizard.RMIWIZARDFINISH)); // NOI18N
        setName(getString("RMIWizardFinish.Form.subtitle")); // NOI18N
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        setLayout(new java.awt.BorderLayout());
        
        jScrollPane1.setBorder(null);
        
        jTextArea1.setEditable(false);
        jTextArea1.setDisabledTextColor(new java.awt.Color (102, 102, 153));
        jTextArea1.setEnabled(false);
        jScrollPane1.setViewportView(jTextArea1);
        
        
        add(jScrollPane1, java.awt.BorderLayout.CENTER);
        
    }//GEN-END:initComponents
    public java.awt.Component getComponent() {
        return this;
    }    
    
    public boolean isValid() {
        return true;
    }    
    
    public HelpCtx getHelp() {
        return new HelpCtx(RMIWizardFinish.class);
    }    
    
    public void readSettings(java.lang.Object obj) {
        RMIWizard wizard = (RMIWizard) obj;
        String pkgName = wizard.getTargetFolder().getPrimaryFile().getPackageName('.');
        if (pkgName.length() > 0) pkgName += '.';
        // init
        jTextArea1.setText(null);
        // target location
        try {
            jTextArea1.append(getString(
                "RMIWFinish.Target.fmt", // NOI18N
                wizard.getTargetFolder().getPrimaryFile().getFileSystem().getDisplayName())
            );
        } catch (org.openide.filesystems.FileStateInvalidException ex) {
        }
        
        // interface template
        jTextArea1.append("\n"); // NOI18N
        org.openide.loaders.DataObject templateDO = wizard.getInterfaceTemplate();
        String template;
        if (templateDO != null) template = templateDO.getName();
        else template = getString("RMIWFinish.Templ.None"); // NOI18N
        jTextArea1.append("\n"); // NOI18N
        jTextArea1.append(getString("RMIWFinish.Interface.Templ.fmt", template)); // NOI18N
        
        // interface to extend
        String superInterface = wizard.getSuperInterfaceName();
        if (superInterface != null) {
            jTextArea1.append("\n"); // NOI18N
            jTextArea1.append(getString("RMIWFinish.Interface.Extend.fmt", superInterface)); // NOI18N
        }
        
        // interface name
        jTextArea1.append("\n"); // NOI18N
        String interfaceName = wizard.getInterfaceName();
        if (wizard.isNewInterface()) interfaceName = pkgName + interfaceName;
        jTextArea1.append(getString("RMIWFinish.Interface.Name.fmt", interfaceName )); // NOI18N
        
        // implementation template
        jTextArea1.append("\n"); // NOI18N
        templateDO = wizard.getImplementationTemplate();
        if (templateDO != null) template = templateDO.getName();
        else template = getString("RMIWFinish.Templ.None"); // NOI18N
        jTextArea1.append("\n"); // NOI18N
        jTextArea1.append(getString("RMIWFinish.Impl.Templ.fmt", template)); // NOI18N
        
        // implementation name
        jTextArea1.append("\n"); // NOI18N
        jTextArea1.append(getString("RMIWFinish.Impl.Name.fmt", pkgName + wizard.getImplementationName())); // NOI18N
        
        // remote methods
        jTextArea1.append("\n"); // NOI18N
        org.openide.src.MethodElement[] methods = wizard.getRemoteMethods();
        if (methods != null && methods.length > 0) {
            jTextArea1.append("\n"); // NOI18N
            jTextArea1.append(getString("RMIWFinish.Methods")); // NOI18N
            for (int i = 0; i < methods.length; i++)
                jTextArea1.append('\n' + methods[i].toString());
        }
    }    
    
    public void storeSettings(java.lang.Object obj) {
    }    
    
    public void addChangeListener(javax.swing.event.ChangeListener changeListener) {
    }    
    
    public void removeChangeListener(javax.swing.event.ChangeListener changeListener) {
    }    

    /** Localization.
     */
    private static String getString(String key) {
        return org.openide.util.NbBundle.getMessage(RMIWizardFinish.class, key);
    }
    
    private static String getString(String key, String param) {
        return org.openide.util.NbBundle.getMessage(RMIWizardFinish.class, key, param);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables

}
