/*
 * __NAME__.java
 *
 * Created on __DATE__, __TIME__
 */

package Templates.RMI;

import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.net.MalformedURLException;

/** Unicast remote object implementing __NAME$Impl$$java.rmi.Remote__ interface.
 *
 * @author __USER__
 * @version 1.0
 */
public class UnicastRemoteObject__Impl extends UnicastRemoteObject
    implements __NAME$Impl$$java.rmi.Remote__ {

    /** Constructs __NAME__ object and exports it on default port.
     */
    public UnicastRemoteObject__Impl () throws RemoteException {
        super();
    }

    /** Constructs __NAME__ object and exports it on specified port.
     * @param port The port for exporting
     */
    public UnicastRemoteObject__Impl (int port) throws RemoteException {
        super(port);
    }

    /** Register __NAME__ object with the RMI registry.
     * @param name - name identifying the service in the RMI registry
     * @param create - create local registry if necessary
     * @throw RemoteException if cannot be exported or bound to RMI registry
     * @throw MalformedURLException if name cannot be used to construct a valid URL
     * @throw IllegalArgumentException if null passed as name
     */
    public static void registerToRegistry(String name, Remote obj, boolean create) throws RemoteException, MalformedURLException{

        if (name == null) throw new IllegalArgumentException("registration name can not be null");

        try {
            Naming.rebind(name, obj);
        } catch (RemoteException ex){
            if (create) {
                Registry r = LocateRegistry.createRegistry(Registry.REGISTRY_PORT);
                r.rebind(name, obj);
            } else throw ex;
        }
    }

    /** Main method.
     */
    public static void main(String[] args) {
        System.setSecurityManager(new RMISecurityManager());

        try {
            __NAME__ obj = new __NAME__ ();
            registerToRegistry(__QUOTES____NAME____QUOTES__, obj, true);
        } catch (RemoteException ex) {
            ex.printStackTrace();
        } catch (MalformedURLException ex) {
            ex.printStackTrace();
        }
    }
}
