/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.scripting;

import java.beans.*;

import org.openide.nodes.*;
import org.openide.util.actions.*;
import org.openide.TopManager;

/** 
 *  A node object associated with an instance of EvaluateConsole.
 * @author  dstrupl
 * @version 
 */
public class EvaluateNode extends AbstractNode {
    private EvaluateConsole console;
    /** Creates new EvaluateNode */
    public EvaluateNode(EvaluateConsole console) {
        super(Children.LEAF);
        this.console = console;
        CookieSet set = getCookieSet();
        set.add(console);
        setCookieSet(set);
    }
    /** Adds a property for change of scriting language.
     */
    protected Sheet createSheet() {
        Sheet s = Sheet.createDefault();
        try {
            PropertySupport.Reflection p = new PropertySupport.Reflection (
                console, 
                String.class, 
                "scriptLanguage"
            );
            p.setName("scriptLanguage");
            p.setDisplayName("Scripting language");
            p.setShortDescription("Sample short description");
            p.setPropertyEditorClass(LanguageSelectionPropertyEditor.class);
            s.get (Sheet.PROPERTIES).put(p);
        } catch (Exception ex) {
            TopManager.getDefault().getErrorManager ().notify (ex);
        }
        return s;
    }
    
    public static class LanguageSelectionPropertyEditor extends PropertyEditorSupport {
        public String[] getTags() {
            return ScriptUtils.getLanguages();
        }
    }
}