/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.scripting;

import java.beans.*;
import java.awt.Image;

import org.openide.*;
/** BeanInfo for AbstracScriptType.
*
* @author David Strupl
*/
public final class JPythonScriptTypeBeanInfo extends SimpleBeanInfo {

    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (AbstractScriptType.class) };
        } catch (IntrospectionException ie) {
            TopManager.getDefault().getErrorManager().notify(ErrorManager.INFORMATIONAL, ie);
            return null;
        }
    }
    
    public Image getIcon(int type) {
        try {
            return Introspector.getBeanInfo(AbstractScriptType.class).getIcon(type);
        } catch (IntrospectionException ie) {
            TopManager.getDefault().getErrorManager().notify(ErrorManager.INFORMATIONAL, ie);
            return null;
        }
    }

}
