/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.scripting;

import java.beans.*;
import java.awt.Image;

import org.openide.loaders.MultiFileLoader;
import org.openide.*;

/** 
 * BeanInfo for script loader.
 * @author David Strupl
 */
public final class ScriptLoaderBeanInfo extends SimpleBeanInfo {

    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (MultiFileLoader.class) };
        } catch (IntrospectionException ie) {
            TopManager.getDefault().getErrorManager().notify(ErrorManager.INFORMATIONAL, ie);
            return null;
        }
    }

    /** Icons for compiler settings objects. */
    private static Image icon;

    /** @param type Desired type of the icon
    * @return returns the loader's icon
    */
    public Image getIcon(final int type) {
        if (icon == null) {
            icon = loadImage("/org/netbeans/modules/scripting/script.gif"); // NOI18N
        }
        return icon;
    }

}
