/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.scripting;

import java.beans.*;
import java.awt.Image;

import org.openide.loaders.*;
import org.openide.nodes.*;
import org.openide.util.NbBundle;
import org.openide.TopManager;
import org.openide.ErrorManager;

/** 
 *
 * @author Jaroslav Tulach
 */

final class ScriptNode extends DataNode {

    /** Creates new ScriptNode. */
    public ScriptNode(ScriptObject obj,Children ch) {
        super(obj, ch);
    }
  
    /** Script data object.
     */
    public ScriptObject getScriptObject () {
        return (ScriptObject)getDataObject();
    }
  
  /** Getter for an icon.
  */
  public Image getIcon(int type) {
    try {
        return Introspector.getBeanInfo(ScriptLoader.class).getIcon(type);
    } catch (IntrospectionException ie) {
        TopManager.getDefault().getErrorManager().notify(ErrorManager.INFORMATIONAL, ie);
    }
    return super.getIcon(type);
  }
  
  /** Adds a property for change of scriting language.
  */
    protected Sheet createSheet() {
        Sheet s = super.createSheet ();
        Sheet.Set ps = s.get(Sheet.PROPERTIES);
        getScriptObject().addProperties(ps);
/*    
    try {
      PropertySupport.Reflection p = new PropertySupport.Reflection (
        getScriptObject (), ScriptType.class, ScriptObject.PROP_SCRIPT_TYPE
      );
      p.setName(ScriptObject.PROP_SCRIPT_TYPE);
      p.setDisplayName(NbBundle.getBundle(ScriptNode.class).getString (
        "PROP_ScriptType"
      ));
      p.setShortDescription (NbBundle.getBundle(ScriptNode.class).getString (
        "HINT_ScriptType"
      ));
      s.get (Sheet.PROPERTIES).put(p);
    } catch (Exception ex) {
      ex.printStackTrace();
    }
*/    
        return s;
    }
}

/* 
* $Log: 
*  3    Jaga      1.2         04/12/00 Jaroslav Tulach Removed all imports of
*       ScriptType.
*  2    Jaga      1.1         04/11/00 Jaroslav Tulach Rewritten to use Bean
*       Scripting Framework
*  1    Jaga      1.0         03/13/00 Jaroslav Tulach 
* $ 
*/ 
  