/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.search;

import org.openide.*;
import org.openide.nodes.*;
import org.openide.util.actions.*;
import org.openide.util.*;


import org.netbeans.modules.search.res.*;

/**
 *
 * @author  Petr Kuzel
 * @version 
 */
public class RepositorySearchAction extends CallableSystemAction {

    public static final long serialVersionUID = 1;

    /** Creates new RepositorySearchAction */
    public RepositorySearchAction() {        
    }

    protected String iconResource() {
        return Res.iconResource("SEARCH"); // NOI18N
    }
    
    /** @return human readable name of action */
    public String getName() {
        return Res.text("ACTION_REPOSITORY_SEARCH"); // NOI18N
    }

    public HelpCtx getHelpCtx() {
        return new HelpCtx (RepositorySearchAction.class);
    }

    /** Where to search */
    public Node[] getNodes() {
        return new Node[] {TopManager.getDefault().getPlaces().nodes().repository()};
    }

    /** Perform this action. */
    public void performAction() {
        new SearchPerformer().performAction(this);
    }

}
