/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.search;

import org.openide.nodes.*;

import org.openidex.search.*;


/**
 * Singleton representing search engine.
 * It spawns search task threads.
 *
 * @author  Petr Kuzel
 * @version 1.0
 */
public class SearchEngineImpl extends SearchEngine {

    /** Creates new SearchEngineImpl */
    public SearchEngineImpl() {
    }

    /** Delegate it on search task and executes it in new thread.
    * @return SearchTask can be tested on end using addTaskListener()
    */
    public SearchTask search ( Node[] nodes, SearchType[] types, NodeAcceptor na ) {
        SearchTask task = new SearchTaskImpl(nodes, types, na);

        Thread t = new Thread(task, "SearchTaskImpl"); // NOI18N

        t.setDaemon(true);
        t.start();

        return task;
    }

}
