/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.search.res;

import java.util.*;
import java.awt.*;

import javax.swing.*;

import org.openide.util.*;



/**
 * Utility class for loading resources: texts and icons.
 *
 * Due to behaviour of NbBundle can not be named Bundle.class!!
 *
 * @author  Petr Kuzel
 * @version 1.0
 */
public class Res extends Object {

    private static final Class THIS_CLASS = Res.class;
    static final String ICON_BASE = "/org/netbeans/modules/search/res/";  //NOI18N

    private static String res(String id) {
        try {
            return NbBundle.getMessage(THIS_CLASS, id);
        } catch (MissingResourceException ex) {
            return "?_" + id; // NOI18N
        }
    }

    public static String text(String id) {
        return res("TEXT_" + id); // NOI18N
    }

    public static String hint(String id) {
        return res("HINT_" + id); // NOI18N
    }

    public static String iconResource(String id) {
        return ICON_BASE + res("ICON_" + id);
    }
    
    public static ImageIcon icon(String id) {
        return new ImageIcon(THIS_CLASS.getResource(iconResource(id))); // NOI18N
    }

    public static Image image(String id) {
        return icon(id).getImage();
    }

    public static void main(String args[]) {
        System.err.println("Returned: " + new Res().text("STOP"));
    }

}
