/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.search.types;

import org.openide.loaders.DataObject;


/** Interface for classes that want to present some details
  * about search hits.
  *
  * @author Tomas Pavek
  */
public interface DetailHandler
{
    // how to show detail
    public final int DH_SHOW = 1;
    public final int DH_GOTO = 2;
    public final int DH_HIDE = 3;
    
    /** Show found detail on DataObject. */
    public void showDetail(int how);

    /** Get full description of the detail (e.g. the whole matching string,
      * name of file, number of line and column). */
    public String getDescription();
    
    /** Get short description of the detail (e.g. line number only). */
    public String getShortDescription();
}
