/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.search.types;

import org.openide.util.*;
import org.openide.loaders.*;

import org.netbeans.modules.search.res.*;

/**
 * Test DataObject name. Reuse TextType.
 *
 * @author  Petr Kuzel
 * @version 1.0
 */
public class ObjectNameType extends TextType {

    public static final long serialVersionUID = 1L;

    /** Creates new FullTextType */
    public ObjectNameType() {
    }

    /**
    * @return true if object passes the test.
    */
    public boolean test (DataObject dobj) {
        return match(dobj.getName());
    }

    /** @return string desribing current state.
    */
    public String toString() {
        return "ObjectNameType: substring:" + matchString + " REstring:" + reString + " re:" + re; // NOI18N
    }

    public HelpCtx getHelpCtx() {
        return new HelpCtx (ObjectNameType.class);
    }

    public String getTabText() {
        return Res.text("OBJECTNAME_CRITERION"); // NOI18N
    }

}
