/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.search.types;

import java.awt.*;
import java.beans.*;

import javax.swing.*;

import org.openide.*;

import org.openidex.search.*;

import org.netbeans.modules.search.res.*;


/**
 * Customizer of TextType beans.
 *
 * @author  Petr Kuzel
 * @version 1.0
 */
public class TextCustomizer extends javax.swing.JPanel implements Customizer {

    private TextType peer;
    private String lastSubstring = "";
    private String lastRegexp = "";

    /** Creates new form FullTextCustomizer */
    public TextCustomizer() {
        initComponents ();
        javax.swing.border.TitledBorder tb = new javax.swing.border.TitledBorder(getBorderLabel());
        tb.setBorder(new javax.swing.border.CompoundBorder());
        setBorder (tb);

        ButtonGroup group = new ButtonGroup();
        group.add(substringRadioButton);
        group.add(regexpRadioButton);

    }

    /** Allow derived customizers.
    */
    protected String getBorderLabel() {
        return null;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        substringRadioButton = new javax.swing.JRadioButton();
        substringTextField = new javax.swing.JTextField();
        regexpRadioButton = new javax.swing.JRadioButton();
        regexpTextField = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        caseSensitiveCheckBox = new javax.swing.JCheckBox();
        wholeWordsCheckBox = new javax.swing.JCheckBox();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        substringRadioButton.setMnemonic((Res.text("LABEL_SUBSTRING_MNEM")).charAt(0));
        substringRadioButton.setText(Res.text("LABEL_SUBSTRING"));
        substringRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                substringRadioButtonActionPerformed(evt);
            }
        });
        
        substringRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                substringRadioButtonStateChanged(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(5, 12, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(substringRadioButton, gridBagConstraints1);
        
        substringTextField.setColumns(20);
        substringTextField.setPreferredSize(new java.awt.Dimension (100, substringTextField.getPreferredSize ().height));
        substringTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                substringTextFieldKeyReleased(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(5, 12, 0, 11);
        gridBagConstraints1.weightx = 1.0;
        add(substringTextField, gridBagConstraints1);
        
        regexpRadioButton.setMnemonic((Res.text("LABEL_RE_MNEM")).charAt(0));
        regexpRadioButton.setText(Res.text("LABEL_RE"));
        regexpRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                regexpRadioButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 5, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(regexpRadioButton, gridBagConstraints1);
        
        regexpTextField.setColumns(20);
        regexpTextField.setPreferredSize(new java.awt.Dimension (100, regexpTextField.getPreferredSize ().height));
        regexpTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                regexpTextFieldKeyReleased(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 5, 11);
        gridBagConstraints1.weightx = 1.0;
        add(regexpTextField, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel1, gridBagConstraints1);
        
        caseSensitiveCheckBox.setMnemonic(Res.text("BUTTON_CASE_SENSITIVE_MNEM").charAt(0));
        caseSensitiveCheckBox.setText(Res.text("LABEL_CASE_SENSITIVE"));
        caseSensitiveCheckBox.setBorder(null);
        caseSensitiveCheckBox.setEnabled(false);
        caseSensitiveCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                caseSensitiveCheckBoxActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(2, 30, 0, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(caseSensitiveCheckBox, gridBagConstraints1);
        
        wholeWordsCheckBox.setMnemonic(Res.text("BUTTON_WHOLE_WORDS_MNEM").charAt(0));
        wholeWordsCheckBox.setText(Res.text("LABEL_WHOLE_WORDS"));
        wholeWordsCheckBox.setBorder(null);
        wholeWordsCheckBox.setEnabled(false);
        wholeWordsCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                wholeWordsCheckBoxActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(5, 30, 0, 11);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(wholeWordsCheckBox, gridBagConstraints1);
        
    }//GEN-END:initComponents

    private void substringRadioButtonStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_substringRadioButtonStateChanged
        caseSensitiveCheckBox.setEnabled(substringRadioButton.isSelected());
        wholeWordsCheckBox.setEnabled(substringRadioButton.isSelected());
    }//GEN-LAST:event_substringRadioButtonStateChanged

    private void wholeWordsCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_wholeWordsCheckBoxActionPerformed
        peer.setWholeWords(wholeWordsCheckBox.isSelected());
    }//GEN-LAST:event_wholeWordsCheckBoxActionPerformed

    private void caseSensitiveCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_caseSensitiveCheckBoxActionPerformed
        peer.setCaseSensitive(caseSensitiveCheckBox.isSelected());
    }//GEN-LAST:event_caseSensitiveCheckBoxActionPerformed

    private void regexpRadioButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_regexpRadioButtonActionPerformed

        String text = regexpTextField.getText();
        try {
            peer.setRe(text);
        } catch (IllegalArgumentException ex) {
        }

    }//GEN-LAST:event_regexpRadioButtonActionPerformed

    private void substringRadioButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_substringRadioButtonActionPerformed

        peer.setMatchString(substringTextField.getText());

    }//GEN-LAST:event_substringRadioButtonActionPerformed

    private void substringTextFieldKeyReleased (java.awt.event.KeyEvent evt) {//GEN-FIRST:event_substringTextFieldKeyReleased
        String text = substringTextField.getText();
        if (!text.equals(lastSubstring)) {
            peer.setMatchString(text);
            substringRadioButton.setSelected(true);
            lastSubstring = text;
        }
    }//GEN-LAST:event_substringTextFieldKeyReleased

    private void regexpTextFieldKeyReleased (java.awt.event.KeyEvent evt) {//GEN-FIRST:event_regexpTextFieldKeyReleased
        String text = regexpTextField.getText();
        if (!text.equals(lastRegexp)) {
            regexpRadioButton.setSelected(true);
            try {
                peer.setRe(text);
                regexpTextField.setForeground(Color.black);
            } catch (IllegalArgumentException ex) {
                regexpTextField.setForeground(Color.red);
            }
            lastRegexp = text;
        }
    }//GEN-LAST:event_regexpTextFieldKeyReleased

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton substringRadioButton;
    private javax.swing.JTextField substringTextField;
    private javax.swing.JRadioButton regexpRadioButton;
    private javax.swing.JTextField regexpTextField;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JCheckBox caseSensitiveCheckBox;
    private javax.swing.JCheckBox wholeWordsCheckBox;
    // End of variables declaration//GEN-END:variables

    /** Initialize customizer with proper values.
    */
    public void setObject(final Object obj) {

        peer = (TextType) obj;

        // set default coloring
        regexpTextField.setForeground(Color.black);
        substringTextField.setForeground(Color.black);

        /* Display in customizer. */

        substringTextField.setText(peer.getMatchString());
        lastSubstring = peer.getMatchString();
        caseSensitiveCheckBox.setSelected(peer.getCaseSensitive());
        wholeWordsCheckBox.setSelected(peer.getWholeWords());
        regexpTextField.setText(peer.getRe());
        lastRegexp = peer.getRe();

        if ( ! peer.getRe().equals(peer.WILDCARD))
            regexpRadioButton.setSelected(true);
        if ( ! peer.getMatchString().equals(peer.WILDCARD))
            substringRadioButton.setSelected(true);
    }

    public void addPropertyChangeListener(final java.beans.PropertyChangeListener p1) {
    }

    public void removePropertyChangeListener(final java.beans.PropertyChangeListener p1) {
    }

    public void requestFocus() {
        JTextField tf = regexpRadioButton.isSelected() ?
                          regexpTextField : substringTextField;
        int n = tf.getText().length();
        if (n > 0) {
            tf.setCaretPosition(0);
            tf.moveCaretPosition(n);
        }
        tf.requestFocus();
    }
}
