/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.modules.vcscore.cache;

/**
 *
 * @author  mkleint
 */

import java.util.EventObject;

public class CacheHandlerEvent extends java.util.EventObject {

    private boolean recursive = false;
    
    /** Creates new CacheHandlerEvent */
    public CacheHandlerEvent(CacheFile cacheFile) {
        this(cacheFile, false);
    }
    
    public CacheHandlerEvent(CacheFile cacheFile, boolean recursive) {
        super(cacheFile);
        this.recursive = recursive;
    }
    
    public CacheFile getCacheFile() {
       return (CacheFile) getSource(); 
    }
    
    public boolean isRecursive() {
        return recursive;
    }
    
}
