/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.cache;

/**
 *
 * @author  mkleint
 * @version 
 */

import java.lang.ref.*;
import org.netbeans.modules.vcscore.util.Debug;
import java.io.*;

public class CacheReference extends java.lang.ref.WeakReference {
    private Debug E=new Debug("CacheReference", false); // NOI18N
    private Debug D=E;
    
    private File cacheFile;
    private String name;
    /** Creates new CacheReference */
    public CacheReference(Object referent, ReferenceQueue q, File file, String cacheName) {
        super(referent, q);
        D.deb("reference created=" + file.getName());
        cacheFile = file;
        name = cacheName;
    }
    
    public File getCacheFile() {
        return cacheFile;
    }
    
    public String getCacheName() {
        return name;
    }

}
