/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.cache;

/** Interface that all cached filesystems should implement in order to work smoothly with the cache.
 *
 * @author  mkleint
 * @version 
 */
public interface CachedFileSystem {

    /** returns the fielsystem's id string that makes sure the right cache instance is found for the filesystem.
     * If more filesystems share same cache, one string is to be returned. Otherwise each fs needs to return it's own value.
     * Reccomendation: construct the ID in the following manner:
     *  <name for filesystem type>[<id of filesystem>]
     */
    public String getCacheId();
    
}

