/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.caching;

import org.netbeans.modules.vcscore.util.Debug;
import org.netbeans.modules.vcscore.cache.CacheFile;

/**
 * File in the cache.
 * @author  Martin Entlicher
 */
public class VcsCacheFile extends CacheFile {

    private Debug E=new Debug("VcsFile", false); // NOI18N
    private Debug D=E;
    
    // true if the file is not in VCS
    private boolean local = false;
    
    public VcsCacheFile(String memberOfCache) {
        super(memberOfCache);
    }

    public VcsCacheFile(String memberOfCache, String name) {
        super(memberOfCache, name);
    }

    public VcsCacheFile(String memberOfCache, String name, boolean local) {
        super(memberOfCache, name);
        this.local = local;
    }

    public void setLocal (boolean local) {
        this.local = local;
    }

    public boolean isLocal () {
        return local;
    }

    public static CacheFile readFileCache(String line, String cacheName, java.io.File parent) {
        //VcsCacheFile file = new VcsCacheFile(cacheName);
        //System.out.println("VcsCacheFile.readFileCache("+line+", "+cacheName+", "+parent+")");
        CacheFile file =
            RefreshCommandSupport.matchToFile(RefreshCommandSupport.getElementsFromLine(line),
                                              cacheName, parent);
        if (file instanceof VcsCacheFile) ((VcsCacheFile) file).setLocal(false);
        if (file instanceof VcsCacheDir) ((VcsCacheDir) file).setLocal(false);
        return file;
    }
    
    public String writeLineToDisk() {
        return RefreshCommandSupport.getLineFromElements(RefreshCommandSupport.makeElements(this));
        /*
        StringBuffer buff = new StringBuffer("/");
        buff.append(getName());
        buff.append("/");
        buff.append(getStatus());
        buff.append("///"); //TODO - temporary
        //TODO
        return buff.toString();
         */
    }

    public String toString(){
        return "VcsFile["+ // NOI18N
               "name='"+name+"'"+ // NOI18N
               ",status="+status+ // NOI18N
               ",locker="+locker+ // NOI18N
               ",revision="+revision+ // NOI18N
               ",attr="+attr+ // NOI18N
               ",size="+size+ // NOI18N
               ",date="+date+ // NOI18N
               ",time="+time+ // NOI18N
               ",local="+local+ // NOI18N
               "]"; // NOI18N
    }

}
