/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.commands;

import java.util.ArrayList;
import javax.swing.*;

import org.openide.util.NbBundle;

/**
 * Default display of output from VCS commands.
 * @author  Martin Entlicher
 */
public class CommandOutputPanel extends javax.swing.JPanel {
    
    private ArrayList killActionListeners = new ArrayList();
    private boolean isFinished = false; // whether the command is finished
    private boolean activated = false; // whether the component is activated

    /** Creates new form CommandOutputPanel */
    public CommandOutputPanel() {
        initComponents ();
        initTabs();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        headPanel = new javax.swing.JPanel();
        execStringLabel = new javax.swing.JLabel();
        execStringTextField = new javax.swing.JTextField();
        outputPanel = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        stdOutputPanel = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        stdOutputTextArea = new javax.swing.JTextArea();
        errOutputPanel = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        errOutputTextArea = new javax.swing.JTextArea();
        stdDataOutputPanel = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        stdDataTextArea = new javax.swing.JTextArea();
        errDataOutputPanel = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        errDataTextArea = new javax.swing.JTextArea();
        statusPanel = new javax.swing.JPanel();
        statusLabel = new javax.swing.JLabel();
        statusValueLabel = new javax.swing.JLabel();
        killButton = new javax.swing.JButton();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        setPreferredSize(new java.awt.Dimension(450, 400));
        
        headPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        execStringLabel.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcscore/commands/Bundle").getString("CommandOutputPanel.execStringLabel.text"));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.insets = new java.awt.Insets(0, 0, 0, 12);
        headPanel.add(execStringLabel, gridBagConstraints2);
        
        
        execStringTextField.setEditable(false);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.weightx = 1.0;
        headPanel.add(execStringTextField, gridBagConstraints2);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(12, 12, 12, 12);
        gridBagConstraints1.weightx = 1.0;
        add(headPanel, gridBagConstraints1);
        
        
        outputPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        jTabbedPane1.setTabPlacement(3);
        
        stdOutputPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints4;
        
        
        stdOutputTextArea.setEditable(false);
        jScrollPane1.setViewportView(stdOutputTextArea);
        
        gridBagConstraints4 = new java.awt.GridBagConstraints();
        gridBagConstraints4.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints4.weightx = 1.0;
        gridBagConstraints4.weighty = 1.0;
        stdOutputPanel.add(jScrollPane1, gridBagConstraints4);
        
        jTabbedPane1.addTab("Standard Output", stdOutputPanel);
        
        
        errOutputPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints5;
        
        
        errOutputTextArea.setEditable(false);
        jScrollPane2.setViewportView(errOutputTextArea);
        
        gridBagConstraints5 = new java.awt.GridBagConstraints();
        gridBagConstraints5.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints5.weightx = 1.0;
        gridBagConstraints5.weighty = 1.0;
        errOutputPanel.add(jScrollPane2, gridBagConstraints5);
        
        jTabbedPane1.addTab("Standard Error", errOutputPanel);
        
        
        stdDataOutputPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints6;
        
        
        stdDataTextArea.setEditable(false);
        jScrollPane3.setViewportView(stdDataTextArea);
        
        gridBagConstraints6 = new java.awt.GridBagConstraints();
        gridBagConstraints6.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints6.weightx = 1.0;
        gridBagConstraints6.weighty = 1.0;
        stdDataOutputPanel.add(jScrollPane3, gridBagConstraints6);
        
        jTabbedPane1.addTab("Data Output", stdDataOutputPanel);
        
        
        errDataOutputPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints7;
        
        
        errDataTextArea.setEditable(false);
        jScrollPane4.setViewportView(errDataTextArea);
        
        gridBagConstraints7 = new java.awt.GridBagConstraints();
        gridBagConstraints7.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints7.weightx = 1.0;
        gridBagConstraints7.weighty = 1.0;
        errDataOutputPanel.add(jScrollPane4, gridBagConstraints7);
        
        jTabbedPane1.addTab("Data Error", errDataOutputPanel);
        
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints3.weightx = 1.0;
        gridBagConstraints3.weighty = 1.0;
        outputPanel.add(jTabbedPane1, gridBagConstraints3);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(0, 12, 12, 12);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(outputPanel, gridBagConstraints1);
        
        
        statusPanel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints8;
        
        statusLabel.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcscore/commands/Bundle").getString("CommandOutputPanel.statusLabel.text"));
        gridBagConstraints8 = new java.awt.GridBagConstraints();
        statusPanel.add(statusLabel, gridBagConstraints8);
        
        
        gridBagConstraints8 = new java.awt.GridBagConstraints();
        gridBagConstraints8.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints8.weightx = 1.0;
        statusPanel.add(statusValueLabel, gridBagConstraints8);
        
        
        killButton.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcscore/commands/Bundle").getString("CommandOutputPanel.killButton.text"));
        gridBagConstraints8 = new java.awt.GridBagConstraints();
        statusPanel.add(killButton, gridBagConstraints8);
        
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(5, 12, 11, 12);
        gridBagConstraints1.weightx = 1.0;
        add(statusPanel, gridBagConstraints1);
        
    }//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel headPanel;
    private javax.swing.JLabel execStringLabel;
    private javax.swing.JTextField execStringTextField;
    private javax.swing.JPanel outputPanel;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JPanel stdOutputPanel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea stdOutputTextArea;
    private javax.swing.JPanel errOutputPanel;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea errOutputTextArea;
    private javax.swing.JPanel stdDataOutputPanel;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea stdDataTextArea;
    private javax.swing.JPanel errDataOutputPanel;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTextArea errDataTextArea;
    private javax.swing.JPanel statusPanel;
    private javax.swing.JLabel statusLabel;
    private javax.swing.JLabel statusValueLabel;
    private javax.swing.JButton killButton;
    // End of variables declaration//GEN-END:variables

    private void initTabs() {
        jTabbedPane1.setEnabledAt(0, false);
        jTabbedPane1.setEnabledAt(1, false);
        jTabbedPane1.setEnabledAt(2, false);
        jTabbedPane1.setEnabledAt(3, false);
        jTabbedPane1.setComponentAt(0, getNoOutputComponent());
        jTabbedPane1.setComponentAt(1, getNoOutputComponent());
        jTabbedPane1.setComponentAt(2, getNoOutputComponent());
        jTabbedPane1.setComponentAt(3, getNoOutputComponent());
        jTabbedPane1.setTitleAt(0, NbBundle.getBundle(CommandOutputPanel.class).getString("CommandOutputPanel.tab.stdOut"));
        jTabbedPane1.setTitleAt(1, NbBundle.getBundle(CommandOutputPanel.class).getString("CommandOutputPanel.tab.errOut"));
        jTabbedPane1.setTitleAt(2, NbBundle.getBundle(CommandOutputPanel.class).getString("CommandOutputPanel.tab.stdDataOut"));
        jTabbedPane1.setTitleAt(3, NbBundle.getBundle(CommandOutputPanel.class).getString("CommandOutputPanel.tab.errDataOut"));
    }
    
    void addKillActionListener(java.awt.event.ActionListener l) {
        killButton.addActionListener(l);
        killActionListeners.add(l);
    }
    
    void removeKillActionListener(java.awt.event.ActionListener l) {
        killButton.removeActionListener(l);
        killActionListeners.remove(l);
    }
    
    private JPanel getNoOutputComponent() {
        JPanel panel = new JPanel();
        panel.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.CENTER;
        panel.add(new JLabel(NbBundle.getBundle(CommandOutputPanel.class).getString("CommandOutputPanel.label.noOutput.text")), gridBagConstraints);
        return panel;
    }
    
    private void setEnabledOutput(int index) {
        jTabbedPane1.setEnabledAt(index, true);
        if (!jTabbedPane1.isEnabledAt(jTabbedPane1.getSelectedIndex())) {
            jTabbedPane1.setSelectedIndex(index);
        }
    }
    
    public javax.swing.JTextArea getStdOutputArea() {
        jTabbedPane1.setComponentAt(0, stdOutputPanel);
        setEnabledOutput(0);
        return stdOutputTextArea;
    }
    
    public javax.swing.JTextArea getErrOutputArea() {
        jTabbedPane1.setComponentAt(1, errOutputPanel);
        setEnabledOutput(1);
        return errOutputTextArea;
    }
    
    public javax.swing.JTextArea getStdDataOutputArea() {
        jTabbedPane1.setComponentAt(2, stdDataOutputPanel);
        setEnabledOutput(2);
        return stdDataTextArea;
    }

    public javax.swing.JTextArea getErrDataOutputArea() {
        jTabbedPane1.setComponentAt(3, errDataOutputPanel);
        setEnabledOutput(3);
        return errDataTextArea;
    }
    
    public void setExec(String exec) {
        if (exec == null) {
            headPanel.setVisible(false);
        } else {
            execStringTextField.setText(exec);
        }
    }
    
    public void setStatus(String status) {
        statusValueLabel.setText(status);
    }
    
    void componentActivated() {
        this.activated = true;
        if (isFinished) {
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    getRootPane().setDefaultButton(killButton);
                }
            });
        }
    }
    
    void componentDeactivated() {
        this.activated = false;
    }
    
    public void commandFinished(boolean isFinished) {
        if (isFinished) {
            this.isFinished = true;
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    killButton.setText(NbBundle.getBundle(CommandOutputPanel.class).getString("CommandOutputPanel.killButton.close.text"));
                    while (killActionListeners.size() > 0) {
                        killButton.removeActionListener((java.awt.event.ActionListener) killActionListeners.remove(0));
                    }
                    killButton.addActionListener(new java.awt.event.ActionListener() {
                        public void actionPerformed(java.awt.event.ActionEvent evt) {
                            ((org.openide.windows.TopComponent) CommandOutputPanel.this.getParent()).close();
                        }
                    });
                    if (activated) getRootPane().setDefaultButton(killButton);
                }
            });
        }
    }
}
