/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.revision;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.tree.DefaultTreeCellRenderer;

import org.openide.explorer.view.*;

/**
 *
 * @author  Martin Entlicher
 */
public class RevisionTreeView extends BeanTreeView {

    private static final String DEFAULT_FOLDER = "/org/openide/resources/defaultFolder.gif";
    private static final String DEFAULT_OPEN_FOLDER = "/org/openide/resources/defaultFolderOpen.gif";
    private static final String DEFAULT_REVISION_ICON = "revision.gif";

    /** Creates new RevisionTreeView */
    public RevisionTreeView() {
        DefaultTreeCellRenderer revisionRenderer = new DefaultTreeCellRenderer();
        revisionRenderer.setClosedIcon(new ImageIcon(this.getClass().getResource(DEFAULT_FOLDER)));
        revisionRenderer.setOpenIcon(new ImageIcon(this.getClass().getResource(DEFAULT_OPEN_FOLDER)));
        revisionRenderer.setLeafIcon(new ImageIcon(this.getClass().getResource(DEFAULT_REVISION_ICON)));
        tree.setCellRenderer(revisionRenderer);
    }

}
