/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.settings;

import java.beans.*;

import org.openide.util.NbBundle;

public class VcsSettingsBeanInfo extends SimpleBeanInfo {

    private static PropertyDescriptor[] properties = null; //GEN-FIRST:Properties

    // Here you can add code for customizing the properties array.

    //GEN-LAST:Properties

    private static EventSetDescriptor[] eventSets = null; //GEN-FIRST:Events

    // Here you can add code for customizing the event sets array.

    //GEN-LAST:Events

    private static MethodDescriptor[] methods = null; //GEN-FIRST:Methods

    // Here you can add code for customizing the methods array.
    
    //GEN-LAST:Methods

    private static java.awt.Image iconColor16 = null; //GEN-BEGIN:IconsDef
    private static java.awt.Image iconColor32 = null;
    private static java.awt.Image iconMono16 = null;
    private static java.awt.Image iconMono32 = null; //GEN-END:IconsDef
    private static String iconNameC16 = null; //GEN-BEGIN:Icons
    private static String iconNameC32 = null;
    private static String iconNameM16 = null;
    private static String iconNameM32 = null; //GEN-END:Icons

    static {
        iconNameC16 = "/org/netbeans/modules/vcscore/settings/vcsSettings.gif";   // NOI18N
        iconNameC32 = "/org/netbeans/modules/vcscore/settings/vcsSettings32.gif"; // NOI18N
    }
    
    private static int defaultPropertyIndex = -1; //GEN-BEGIN:Idx
    private static int defaultEventIndex = -1; //GEN-END:Idx


    /**
     * Gets the bean's <code>PropertyDescriptor</code>s.
     * 
     * @return An array of PropertyDescriptors describing the editable
     * properties supported by this bean.  May return null if the
     * information should be obtained by automatic analysis.
     * <p>
     * If a property is indexed, then its entry in the result array will
     * belong to the IndexedPropertyDescriptor subclass of PropertyDescriptor.
     * A client of getPropertyDescriptors can use "instanceof" to check
     * if a given PropertyDescriptor is an IndexedPropertyDescriptor.
     */
    public PropertyDescriptor[] getPropertyDescriptors() {
        if (properties == null) {
            try {
                properties = new PropertyDescriptor[] {
                    new PropertyDescriptor (VcsSettings.PROP_USE_GLOBAL, VcsSettings.class),  // [0]
                    new PropertyDescriptor (VcsSettings.PROP_OFFLINE, VcsSettings.class),    // [1]
                    new PropertyDescriptor (VcsSettings.PROP_AUTO_REFRESH, VcsSettings.class), // [2]
                    new PropertyDescriptor (VcsSettings.PROP_HOME, VcsSettings.class) // [3]
                    //new PropertyDescriptor (VcsSettings.PROP_HIDE_SHADOW_FILES, VcsSettings.class) // [4]            
                };
                properties[0].setDisplayName(NbBundle.getBundle(VcsSettingsBeanInfo.class).getString("PROP_useGlobal"));
                properties[0].setShortDescription(NbBundle.getBundle(VcsSettingsBeanInfo.class).getString("HINT_useGlobal"));
                properties[1].setDisplayName(NbBundle.getBundle(VcsSettingsBeanInfo.class).getString("PROP_offline"));
                properties[1].setShortDescription(NbBundle.getBundle(VcsSettingsBeanInfo.class).getString("HINT_offline"));
                properties[2].setDisplayName(NbBundle.getBundle(VcsSettingsBeanInfo.class).getString("PROP_autoRefresh"));
                properties[2].setShortDescription(NbBundle.getBundle(VcsSettingsBeanInfo.class).getString("HINT_autoRefresh"));
                properties[2].setPropertyEditorClass(RefreshModePropertyEditor.class);
                properties[3].setDisplayName(NbBundle.getBundle(VcsSettingsBeanInfo.class).getString("PROP_home"));
                properties[3].setShortDescription(NbBundle.getBundle(VcsSettingsBeanInfo.class).getString("HINT_home"));
                //properties[4].setDisplayName (NbBundle.getMessage (VcsSettingsBeanInfo.class, "PROP_hideShadowFiles"));
                //properties[4].setShortDescription (NbBundle.getMessage (VcsSettingsBeanInfo.class, "HINT_hideShadowFiles"));            
            } catch (java.beans.IntrospectionException intrexc) {
                if (Boolean.getBoolean("netbeans.debug.exceptions")) // NOI18N
                    intrexc.printStackTrace ();
            }
        }
        return properties;
    }

    /**
     * Gets the bean's <code>EventSetDescriptor</code>s.
     * 
     * @return  An array of EventSetDescriptors describing the kinds of 
     * events fired by this bean.  May return null if the information
     * should be obtained by automatic analysis.
     */
    public EventSetDescriptor[] getEventSetDescriptors() {
        return eventSets;
    }

    /**
     * Gets the bean's <code>MethodDescriptor</code>s.
     * 
     * @return  An array of MethodDescriptors describing the methods 
     * implemented by this bean.  May return null if the information
     * should be obtained by automatic analysis.
     */
    public MethodDescriptor[] getMethodDescriptors() {
        return methods;
    }

    /**
     * A bean may have a "default" property that is the property that will
     * mostly commonly be initially chosen for update by human's who are 
     * customizing the bean.
     * @return  Index of default property in the PropertyDescriptor array
     * 		returned by getPropertyDescriptors.
     * <P>	Returns -1 if there is no default property.
     */
    public int getDefaultPropertyIndex() {
        return defaultPropertyIndex;
    }

    /**
     * A bean may have a "default" event that is the event that will
     * mostly commonly be used by human's when using the bean. 
     * @return Index of default event in the EventSetDescriptor array
     *		returned by getEventSetDescriptors.
     * <P>	Returns -1 if there is no default event.
     */
    public int getDefaultEventIndex() {
        return defaultPropertyIndex;
    }

    /**
     * This method returns an image object that can be used to
     * represent the bean in toolboxes, toolbars, etc.   Icon images
     * will typically be GIFs, but may in future include other formats.
     * <p>
     * Beans aren't required to provide icons and may return null from
     * this method.
     * <p>
     * There are four possible flavors of icons (16x16 color,
     * 32x32 color, 16x16 mono, 32x32 mono).  If a bean choses to only
     * support a single icon we recommend supporting 16x16 color.
     * <p>
     * We recommend that icons have a "transparent" background
     * so they can be rendered onto an existing background.
     *
     * @param  iconKind  The kind of icon requested.  This should be
     *    one of the constant values ICON_COLOR_16x16, ICON_COLOR_32x32, 
     *    ICON_MONO_16x16, or ICON_MONO_32x32.
     * @return  An image object representing the requested icon.  May
     *    return null if no suitable icon is available.
     */
    public java.awt.Image getIcon(int iconKind) {
        if (iconNameC16 == null) {
            return null;
        } else {
            if (iconColor16 == null)
                iconColor16 = loadImage(iconNameC16);
            return iconColor16;
        }
    }

}

