/*
 * AbstractWizardPanel.java
 *
 * Created on 1. bezen 2001, 17:22
 */

package org.netbeans.modules.vcscore.wizard.mountcvs;

/**
 *
 * @author  root
 * @version 
 */
public abstract class AbstractWizardPanel extends javax.swing.JPanel implements org.openide.WizardDescriptor.Panel{

    private java.util.ArrayList listeners_;
    
    /** Creates new AbstractWizardPanel */
    public AbstractWizardPanel() {
        this.listeners_ = new java.util.ArrayList ();
    }
    
    
    public synchronized void addChangeListener(javax.swing.event.ChangeListener listener) {
        this.listeners_.add (listener);
    }

    public synchronized void removeChangeListener (javax.swing.event.ChangeListener listener) {
        this.listeners_.remove (listener);
    }
    
    public void readSettings(java.lang.Object data) {
        if (data instanceof CvsWizardData)
            readCvsWizardSettings ((CvsWizardData)data);
    }
    
    public void storeSettings(java.lang.Object data) {
        if (data instanceof CvsWizardData)
            storeCvsWizardSettings ((CvsWizardData)data);
    }
    
    public java.awt.Component getComponent() {
        return this;
    }    
    
    protected abstract void storeCvsWizardSettings (CvsWizardData data);
    protected abstract void readCvsWizardSettings (CvsWizardData data);
    
    protected void fireChange () {
        javax.swing.event.ChangeEvent event = new javax.swing.event.ChangeEvent (this);
        java.util.Iterator iterator;
        synchronized (this) {
            iterator = ((java.util.ArrayList)listeners_.clone()).iterator();
        }
        while (iterator.hasNext ()) {
            ((javax.swing.event.ChangeListener)iterator.next()).stateChanged (event);
        }
    }
}
