/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.wizard.mountcvs;

import org.openide.WizardDescriptor;

/**
 *
 * @author  Martin Entlicher
 */
public class CheckoutPanel extends AbstractWizardPanel {

    /** Creates new form CheckoutPanel */
    public CheckoutPanel() {
        initComponents();
        setName(org.openide.util.NbBundle.getBundle(CMPanel.class).getString("CheckoutPanel.title"));
        this.putClientProperty (CvsWizardData.SELECTED_INDEX, new Integer(6));
        this.descriptionTextArea.setFont (javax.swing.UIManager.getFont ("Label.font"));
        this.descriptionTextArea.setDisabledTextColor (javax.swing.UIManager.getColor ("Label.foreground"));
    }
    
    public void readCvsWizardSettings (CvsWizardData data) {
            this.checkoutCheckBox.setSelected (data.getPerformInitialCheckout());
    }
    
    public void storeCvsWizardSettings (CvsWizardData data) {
            data.setPerformInitialCheckout (this.checkoutCheckBox.isSelected());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        checkoutCheckBox = new javax.swing.JCheckBox();
        descriptionTextArea = new javax.swing.JTextArea();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        checkoutCheckBox.setMnemonic(org.openide.util.NbBundle.getBundle (CheckoutPanel.class).getString ("CheckoutPanel.checkoutCheckBox_Mnemonic").charAt (0));
        checkoutCheckBox.setSelected(true);
        checkoutCheckBox.setText(org.openide.util.NbBundle.getBundle(CheckoutPanel.class).getString("CheckoutPanel.checkoutCheckBox"));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints2.weightx = 1.0;
        jPanel1.add(checkoutCheckBox, gridBagConstraints2);
        
        descriptionTextArea.setWrapStyleWord(true);
        descriptionTextArea.setLineWrap(true);
        descriptionTextArea.setEditable(false);
        descriptionTextArea.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcscore/wizard/mountcvs/Bundle").getString("TIP_InitialCheckOutPanel"));
        descriptionTextArea.setBackground(java.awt.Color.lightGray);
        descriptionTextArea.setDisabledTextColor(java.awt.Color.black);
        descriptionTextArea.setEnabled(false);
        descriptionTextArea.setOpaque(false);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints2.insets = new java.awt.Insets(17, 0, 0, 0);
        gridBagConstraints2.weightx = 1.0;
        gridBagConstraints2.weighty = 1.0;
        jPanel1.add(descriptionTextArea, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel1, gridBagConstraints1);
        
    }//GEN-END:initComponents

    
    public org.openide.util.HelpCtx getHelp() {
        return org.openide.util.HelpCtx.DEFAULT_HELP;
    }
        
    public boolean isValid() {
        return true;
    }
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JCheckBox checkoutCheckBox;
    private javax.swing.JTextArea descriptionTextArea;
    // End of variables declaration//GEN-END:variables

}
