/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.wizard.mountcvs;

import org.openide.WizardDescriptor;

/**
 *
 * @author  Martin Entlicher
 */
public class LoginClientPanel extends javax.swing.JPanel implements WizardDescriptor.Panel {

    /** Creates new form LoginClientPanel */
    public LoginClientPanel() {
        initComponents();
        jTextArea1.setFont (javax.swing.UIManager.getFont ("Label.font"));
        setName(org.openide.util.NbBundle.getBundle(CMPanel.class).getString("LoginClientPanel.title"));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jPanel2 = new javax.swing.JPanel();
        loginRadioButton = new javax.swing.JRadioButton();
        userNameLabel = new javax.swing.JLabel();
        userNameValueLabel = new javax.swing.JLabel();
        passwordLabel = new javax.swing.JLabel();
        passwordField = new javax.swing.JPasswordField();
        loginButton = new javax.swing.JButton();
        jTextArea1 = new javax.swing.JTextArea();
        offlineRadioButton = new javax.swing.JRadioButton();
        jSeparator1 = new javax.swing.JSeparator();
        jPanel1 = new javax.swing.JPanel();
        clientLabel = new javax.swing.JLabel();
        cmdlineRadioButton = new javax.swing.JRadioButton();
        javaRadioButton = new javax.swing.JRadioButton();
        
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        jPanel2.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints2;
        
        loginRadioButton.setMnemonic(org.openide.util.NbBundle.getBundle (LoginClientPanel.class).getString ("LoginClientPanel.loginRadioButton_Mnemonic").charAt (0));
        loginRadioButton.setSelected(true);
        loginRadioButton.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcscore/wizard/mountcvs/Bundle").getString("LoginClientPanel.loginRadioButton"));
        buttonGroup1.add(loginRadioButton);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridwidth = 3;
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints2.weightx = 1.0;
        jPanel2.add(loginRadioButton, gridBagConstraints2);
        
        userNameLabel.setText(org.openide.util.NbBundle.getBundle(LoginClientPanel.class).getString("LoginClientPanel.userNameLabel"));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(0, 24, 0, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(userNameLabel, gridBagConstraints2);
        
        userNameValueLabel.setText("guest");
        userNameValueLabel.setForeground(java.awt.Color.black);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 1;
        gridBagConstraints2.insets = new java.awt.Insets(0, 12, 0, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(userNameValueLabel, gridBagConstraints2);
        
        passwordLabel.setText(org.openide.util.NbBundle.getBundle(LoginClientPanel.class).getString("LoginClientPanel.passwordLabel"));
        passwordLabel.setLabelFor(passwordField);
        passwordLabel.setDisplayedMnemonic (org.openide.util.NbBundle.getBundle (LoginClientPanel.class).getString ("LoginClientPanel.passwordLabel_Mnemonic").charAt (0));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 2;
        gridBagConstraints2.insets = new java.awt.Insets(3, 24, 0, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(passwordLabel, gridBagConstraints2);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 2;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(3, 12, 0, 0);
        gridBagConstraints2.weightx = 1.0;
        jPanel2.add(passwordField, gridBagConstraints2);
        
        loginButton.setMnemonic(org.openide.util.NbBundle.getBundle (LoginClientPanel.class).getString ("LoginClientPanel.loginButton_Mnemonic").charAt (0));
        loginButton.setText(org.openide.util.NbBundle.getBundle(LoginClientPanel.class).getString("LoginClientPanel.loginButton"));
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 2;
        gridBagConstraints2.insets = new java.awt.Insets(3, 5, 0, 0);
        jPanel2.add(loginButton, gridBagConstraints2);
        
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setLineWrap(true);
        jTextArea1.setEditable(false);
        jTextArea1.setRows(3);
        jTextArea1.setText("Login successfull.");
        jTextArea1.setBackground(java.awt.Color.lightGray);
        jTextArea1.setDisabledTextColor(java.awt.Color.black);
        jTextArea1.setEnabled(false);
        jTextArea1.setOpaque(false);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 3;
        gridBagConstraints2.gridwidth = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(11, 24, 0, 0);
        jPanel2.add(jTextArea1, gridBagConstraints2);
        
        offlineRadioButton.setMnemonic(org.openide.util.NbBundle.getBundle (LoginClientPanel.class).getString ("LoginClientPanel.offlineRadioButton_Mnemonic").charAt (0));
        offlineRadioButton.setText(org.openide.util.NbBundle.getBundle(LoginClientPanel.class).getString("LoginClientPanel.offlineRadioButton"));
        buttonGroup1.add(offlineRadioButton);
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 4;
        gridBagConstraints2.gridwidth = 3;
        gridBagConstraints2.insets = new java.awt.Insets(9, 0, 0, 0);
        gridBagConstraints2.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(offlineRadioButton, gridBagConstraints2);
        
        gridBagConstraints2 = new java.awt.GridBagConstraints();
        gridBagConstraints2.gridy = 5;
        gridBagConstraints2.gridwidth = 3;
        gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints2.insets = new java.awt.Insets(12, 0, 12, 0);
        gridBagConstraints2.weightx = 1.0;
        jPanel2.add(jSeparator1, gridBagConstraints2);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints1.weightx = 1.0;
        add(jPanel2, gridBagConstraints1);
        
        jPanel1.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints3;
        
        clientLabel.setText(org.openide.util.NbBundle.getBundle(LoginClientPanel.class).getString("LoginClientPanel.clientLabel"));
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(clientLabel, gridBagConstraints3);
        
        cmdlineRadioButton.setMnemonic(org.openide.util.NbBundle.getBundle (LoginClientPanel.class).getString ("LoginClientPanel.cmdlineRadioButton_Mnemonic").charAt (0));
        cmdlineRadioButton.setSelected(true);
        cmdlineRadioButton.setText(org.openide.util.NbBundle.getBundle(LoginClientPanel.class).getString("ClientPanel.cmdlineRadioButton"));
        buttonGroup2.add(cmdlineRadioButton);
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridy = 1;
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints3.weightx = 1.0;
        jPanel1.add(cmdlineRadioButton, gridBagConstraints3);
        
        javaRadioButton.setMnemonic(org.openide.util.NbBundle.getBundle (LoginClientPanel.class).getString ("LoginClientPanel.javaRadioButton_Mnemonic").charAt (0));
        javaRadioButton.setText(org.openide.util.NbBundle.getBundle(LoginClientPanel.class).getString("ClientPanel.javaRadioButton"));
        buttonGroup2.add(javaRadioButton);
        gridBagConstraints3 = new java.awt.GridBagConstraints();
        gridBagConstraints3.gridy = 2;
        gridBagConstraints3.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints3.weightx = 1.0;
        jPanel1.add(javaRadioButton, gridBagConstraints3);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTH;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jPanel1, gridBagConstraints1);
        
    }//GEN-END:initComponents

    public java.awt.Component getComponent() {
        return this;
    }    

    public void readSettings(java.lang.Object p1) {
    }
    
    public org.openide.util.HelpCtx getHelp() {
        return null;
    }
    
    public void addChangeListener(javax.swing.event.ChangeListener p1) {
    }
    
    public void storeSettings(java.lang.Object p1) {
    }
    
    public boolean isValid() {
        return true;
    }
    
    public void removeChangeListener(javax.swing.event.ChangeListener p1) {
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JRadioButton loginRadioButton;
    private javax.swing.JLabel userNameLabel;
    private javax.swing.JLabel userNameValueLabel;
    private javax.swing.JLabel passwordLabel;
    private javax.swing.JPasswordField passwordField;
    private javax.swing.JButton loginButton;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JRadioButton offlineRadioButton;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel clientLabel;
    private javax.swing.JRadioButton cmdlineRadioButton;
    private javax.swing.JRadioButton javaRadioButton;
    // End of variables declaration//GEN-END:variables

}
