/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcscore.wizard.mountcvs;

import javax.swing.tree.*;

import org.openide.WizardDescriptor;

/**
 *
 * @author  Martin Entlicher
 */
public class RMPanel extends AbstractWizardPanel implements java.beans.PropertyChangeListener {

    private TreeNode rootNode;
    /** Creates new form RMPanel */
    public RMPanel() {
        initComponents();
        setName(org.openide.util.NbBundle.getBundle(CMPanel.class).getString("RMPanel.title"));
        rmLabel.setVisible(false);
        this.mountPanel.addTreePropertyChangeListener (this);
        this.putClientProperty (CvsWizardData.SELECTED_INDEX, new Integer(1));
        this.jTextArea1.setFont (javax.swing.UIManager.getFont ("Label.font"));
        this.jTextArea1.setDisabledTextColor (javax.swing.UIManager.getColor ("Label.foreground"));
    }
    
    public void readCvsWizardSettings (CvsWizardData data) {
        String rootDir = data.getWorkingDir ();
        String[] relMounts = data.getMountPoints();
        mountPanel.initTree(rootDir, relMounts);
    }
    
    public void storeCvsWizardSettings (CvsWizardData data) {
        data.setMountPoints(mountPanel.getRelMounts());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        rmLabel = new javax.swing.JLabel();
        jTextArea1 = new javax.swing.JTextArea();
        mountPanel = new org.netbeans.modules.vcscore.cmdline.RelativeMountPanel();
        
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        rmLabel.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcscore/wizard/mountcvs/Bundle").getString("RMPanel.rmLabel"));
        rmLabel.setLabelFor(mountPanel);
        rmLabel.setDisplayedMnemonic (org.openide.util.NbBundle.getBundle (RMPanel.class).getString ("RMPanel.rmLabel_Mnemonic").charAt (0));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 5, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        add(rmLabel, gridBagConstraints1);
        
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setLineWrap(true);
        jTextArea1.setEditable(false);
        jTextArea1.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcscore/wizard/mountcvs/Bundle").getString("TIP_RelativeMountPointPanel"));
        jTextArea1.setBackground(java.awt.Color.lightGray);
        jTextArea1.setDisabledTextColor(java.awt.Color.black);
        jTextArea1.setEnabled(false);
        jTextArea1.setOpaque(false);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(17, 0, 0, 0);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jTextArea1, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(mountPanel, gridBagConstraints1);
        
    }//GEN-END:initComponents

/*    
    private TreeNode setTestTree() {
        DefaultMutableTreeNode root = new DefaultMutableTreeNode("nb_all");
        DefaultMutableTreeNode rootOpenide = new DefaultMutableTreeNode("openide");
        DefaultMutableTreeNode src = new DefaultMutableTreeNode("src");
        DefaultMutableTreeNode org = new DefaultMutableTreeNode("org");
        DefaultMutableTreeNode openide = new DefaultMutableTreeNode("openide");
        DefaultMutableTreeNode util = new DefaultMutableTreeNode("util");
        DefaultMutableTreeNode www = new DefaultMutableTreeNode("www");
        DefaultMutableTreeNode doc = new DefaultMutableTreeNode("doc");
        root.add(rootOpenide);
        rootOpenide.add(src);
        src.add(org);
        org.add(openide);
        openide.add(util);
        rootOpenide.add(www);
        www.add(doc);
        //DefaultTreeModel model = new DefaultTreeModel(root);
        //jTree1.setModel(model);
        //model.nodeStructureChanged(root);
        //System.out.println("root = "+root);
        return root;
    }*/
    
    public org.openide.util.HelpCtx getHelp() {
        return org.openide.util.HelpCtx.DEFAULT_HELP;
    }
        
    public boolean isValid() {
        return true;
    }

    public void propertyChange(java.beans.PropertyChangeEvent event) {
        fireChange();
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel rmLabel;
    private javax.swing.JTextArea jTextArea1;
    private org.netbeans.modules.vcscore.cmdline.RelativeMountPanel mountPanel;
    // End of variables declaration//GEN-END:variables

}
