/*
 * CvsCustomPanel.java
 *
 * Created on June 15, 2000, 10:27 AM
 */

package org.netbeans.modules.vcs.cmdline;

/** Each panel in the NewCvsCustomizer wizard needs to implement this interface.
 * The panel can tell the WizardDescriptor.Iterator about the current way of progress.
 * @author mkleint
 * @version 1.0
 */
public interface CvsCustomPanel {
    
/** Tells the name of the Panel.
 * @return The label used in the title of the dialog.
 */
    public String getName();
/** Indicates wheather this Panel is the last one.
 * @return When true, it's the last one.
 */
    public boolean isLast();
/** Tells the iterator which panel is next.
 * Iterator then assigns a Panel to the number and adds it to the list of pevoius panels.
 * If the returned number is the same as the current one, The panel is re-displayed and not added to the list.
 * @return number of next panel.
 */
    public int getNext();

}
