/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcs.cmdline.commands;

import java.awt.Dialog;
import java.util.Hashtable;

import org.openide.TopManager;

import org.netbeans.modules.vcscore.VcsFileSystem;
import org.netbeans.modules.vcscore.commands.*;
import org.netbeans.modules.vcscore.cmdline.VcsAdditionalCommand;

import org.netbeans.modules.vcs.cmdline.CvsCustomizer;

/**
 * This command invokes the customizer of the CVS filesystem.
 * @author  Martin Entlicher
 */
public class CvsCustomizerCommand implements VcsAdditionalCommand {

    private VcsFileSystem fileSystem = null;

    /** Creates new CvsCustomizer */
    public CvsCustomizerCommand() {
    }

    public void setFileSystem(VcsFileSystem fileSystem) {
        this.fileSystem = fileSystem;
    }

    public boolean exec(Hashtable vars, String[] args,
                        CommandOutputListener stdoutNRListener, CommandOutputListener stderrNRListener,
                        CommandDataOutputListener stdoutListener, String dataRegex,
                        CommandDataOutputListener stderrListener, String errorRegex) {
        //CvsCustomizer cust = new CvsCustomizer();
        CvsCustomizer.Dialog cust = new CvsCustomizer.Dialog();
        cust.setObject(fileSystem);
        final Dialog dlg = TopManager.getDefault().createDialog(cust);
        cust.setCloseListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent ev) {
                dlg.dispose();
            }
        });
        dlg.setVisible(true);
        return true;
    }
}
