/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcs.cmdline.passwd;

/** This class is run externally from Netbeans in order to find the right
 * HOME or HOMEDRIVE+HOMEPATH enviroment variables, that the cvs.exe uses.
 * Used on Windoze OS only dues to the dual nature of the system. (Win/DOS).
 * We need to find these in order to locate the right .cvspass file.
 * @author Milos Kleint
 * @version 1.0
 */
public class ExternalCheckHome extends Object {
    private static String home = "";
    private static String homeDrive = "";
    private static String homePath = "";
    /** Creates new ExternalCheckHome */
    public ExternalCheckHome() {
        
    }

    /** Does all the work.. Reads the env variables, 
 * decides which one to return. (HOME x HOMEDRIVE+HOMEPATH). HOME is preffered.
 * The reuslt is written to Standard output.
 * @param args the command line arguments
 */
    public static void main (String args[]) {
       if (System.getProperty("HOME").equals("%HOME%") != true) {
           home = System.getProperty("HOME");
       }    
       homePath = System.getProperty("HOMEPATH");
       homeDrive = System.getProperty("HOMEDRIVE");
       if (!home.equals("")) {
         System.out.println(home);  
       } else {
         System.out.println(homeDrive + homePath);    
       }         
    }

}