/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2001 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.vcs.advanced;

import java.beans.*;
import java.util.*;

import org.openide.TopManager;
import org.openide.nodes.Node;
import org.openide.nodes.Children;
import org.openide.nodes.AbstractNode;

import org.netbeans.modules.vcscore.*;
import org.netbeans.modules.vcscore.cmdline.*;

import org.netbeans.modules.vcs.advanced.commands.UserCommandIOCompat;
import org.netbeans.modules.vcs.advanced.commands.UserCommandIO;
//import org.netbeans.modules.vcs.advanced.commands.EditCommandsSupport;
//import org.netbeans.modules.vcs.advanced.commands.CommandExplorer;

/**
 *
 * @author  Pavel Buzek
 */
public class CommandLineVcsAdvancedCustomizer extends Object {

    /** Creates new CommandLineVcsAdvancedCustomizer */
    private CommandLineVcsAdvancedCustomizer() {
    }

    /*
     * @deprecated
     *
    public void writeConfig(java.util.Properties props,Object config) {
        //UserCommand.writeConfiguration (props, (java.util.Vector) config);
    }
     */

    /**
     * @deprecated
     * Read the configuration file. For compatibility with older versions.
     */
    public static Object readConfig (java.util.Properties props) {
        return UserCommandIOCompat.readCommands(props);
    }
    
    public static Object readConfig(org.w3c.dom.Document doc) {
        try {
            return UserCommandIO.readCommands(doc);
        } catch (org.w3c.dom.DOMException exc) {
            TopManager.getDefault().notifyException(exc);
        }
        return new AbstractNode(Children.LEAF);
    }
    
    public static void writeConfig(org.w3c.dom.Document doc, Object config) {
        if (!(config instanceof org.openide.nodes.Node)) throw new IllegalArgumentException("Param config has to be of type Node"); // NOI18N
        try {
            UserCommandIO.writeCommands(doc, (org.openide.nodes.Node) config);
        } catch (org.w3c.dom.DOMException exc) {
            TopManager.getDefault().notifyException(exc);
        }
    }

    public static PropertyEditor getEditor(VcsFileSystem fileSystem) {
        UserCommandsEditor commandEditor = new UserCommandsEditor();
        commandEditor.setValue( ((CommandLineVcsFileSystem) fileSystem).getCommands () );
        return commandEditor;
    }

    public static javax.swing.JPanel getPanel(PropertyEditor pe) {
        /*
            commandEditor.addPropertyChangeListener
              (new PropertyChangeListener() {
        	public void propertyChange(PropertyChangeEvent e){
        	  //D.deb("commands - propertyChange()");
        	  fs.setCommands ((Vector) commandEditor.getValue() );
        	}
              });
        */
        
        return new UserCommandsPanel ( (UserCommandsEditor) pe);
        /*
        EditCommandsSupport ecs = new EditCommandsSupport(pe);
        CommandExplorer explorer = ecs.createExplorer();
         */
        /*
        javax.swing.JPanel panel = new javax.swing.JPanel(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints constraints = new java.awt.GridBagConstraints();
        constraints.fill = java.awt.GridBagConstraints.BOTH;
        constraints.weightx = 1.0;
        constraints.weighty = 1.0;
        panel.add(explorer.getComponent(), constraints);
        return panel;
         */
        /*
        explorer.open();
        return explorer.getComponent();
         */
    }
    
}
/*
 * <<Log>>
 *  5    Gandalf   1.4         10/25/99 Pavel Buzek     copyright
 *  4    Gandalf   1.3         10/23/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  3    Gandalf   1.2         9/30/99  Pavel Buzek     
 *  2    Gandalf   1.1         9/8/99   Pavel Buzek     
 *  1    Gandalf   1.0         9/8/99   Pavel Buzek     
 * $
 */
