/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.core;

import java.beans.*;
import java.awt.Component;

/** 
 *
 * @author  pjiricka
 * @version 
 */
public class LanguageEditor extends PropertyEditorSupport {

    private LanguageDescriptor descriptors[];

    /** Creates new WebBrowserEditor */
    public LanguageEditor(LanguageDescriptor[] descriptors) {
        this.descriptors = descriptors;
    }
    
    public static LanguageDescriptor findDescriptor(String mimeType, LanguageDescriptor descriptors[]) {
        for (int i = 0; i < descriptors.length; i++) {
            if (mimeType.equals(descriptors[i].getMIMEType()))
                return descriptors[i];
        }
        return null;
    }
  
    public String getAsText() {
        LanguageDescriptor desc = findDescriptor((String)getValue(), descriptors);
        return (desc == null) ? (String)getValue() : desc.getDisplayName();
    }

    public void setAsText(String text) {
        for (int i = 0; i < descriptors.length; i++) {
            if (text.equals(descriptors[i].getMIMEType())) {
                setValue(descriptors[i].getMIMEType());
                return;
            }
            if (text.equals(descriptors[i].getDisplayName())) {
                setValue(descriptors[i].getMIMEType());
                return;
            }
        }
    }

    public String[] getTags() {
        String tags[] = new String[descriptors.length];
        for (int i = 0; i < descriptors.length; i++) {
            tags[i] = descriptors[i].getDisplayName();
        }
        return tags;
    }
  
  
}