/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.core;

import java.awt.Image;
import java.beans.*;

import org.openide.util.NbBundle;


/** BeanInfo for Servlet settings
*
* @author Petr Jiricka
*/
public class ServletSettingsBeanInfo extends SimpleBeanInfo {

    /** Icons for compiler settings objects. */
    static Image icon;
    static Image icon32;

    static final java.util.ResourceBundle bundle =
        NbBundle.getBundle(ServletSettingsBeanInfo.class);

    /** Array of property descriptors. */
    private static PropertyDescriptor[] desc;

    // initialization of the array of descriptors
    static {
        try {
            desc = new PropertyDescriptor[] {
                       new PropertyDescriptor (ServletSettings.PROP_COMPILER, ServletSettings.class), // 0
                       new PropertyDescriptor (ServletSettings.PROP_COMPILE_ERRORPAGE, ServletSettings.class), // 1
                       new PropertyDescriptor (ServletSettings.PROP_COMPILE_INCL_FORW, ServletSettings.class), // 2
                       new PropertyDescriptor (ServletSettings.PROP_WWWBROWSER, ServletSettings.class, "getWWWBrowser", "setWWWBrowser") // 3
                   };
            desc[0].setDisplayName (bundle.getString("PROP_COMPILER"));
            desc[0].setShortDescription (bundle.getString("HINT_COMPILER"));
            desc[1].setDisplayName (bundle.getString("PROP_COMPILE_ERRORPAGE"));
            desc[1].setShortDescription (bundle.getString("HINT_COMPILE_ERRORPAGE"));
            desc[2].setDisplayName (bundle.getString("PROP_COMPILE_INCL_FORW"));
            desc[2].setShortDescription (bundle.getString("HINT_COMPILE_INCL_FORW"));
            desc[3].setDisplayName(bundle.getString("PROP_WWWBrowser"));
            desc[3].setShortDescription(bundle.getString("HINT_WWWBrowser"));
            // desc[3].setPropertyEditorClass (WebBrowserEditor.class);

        } catch (IntrospectionException ex) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions")) // NOI18N
                ex.printStackTrace ();
        } catch (java.util.MissingResourceException ex) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions")) // NOI18N
                ex.printStackTrace ();
        }
    }

    /**
    * loads icons
    */
    public ServletSettingsBeanInfo () {
    }

    /** @return the ServletSettings icon */
    public Image getIcon(int type) {
        if ((type == java.beans.BeanInfo.ICON_COLOR_16x16) || (type == java.beans.BeanInfo.ICON_MONO_16x16)) {
            if (icon == null)
                icon = loadImage("/org/netbeans/modules/web/core/resources/servletSettings.gif"); // NOI18N
            return icon;
        } else {
            if (icon32 == null)
                icon32 = loadImage ("/org/netbeans/modules/web/core/resources/servletSettings32.gif"); // NOI18N
            return icon32;
        }
    }

    /** Descriptor of valid properties
    * @return array of properties
    */
    public PropertyDescriptor[] getPropertyDescriptors () {
        return desc;
    }

}

/*
 * Log
 *  8    Jaga      1.5.1.1     3/29/00  Petr Jiricka    Optional compilation of 
 *       included/forwarded/error pages
 *  7    Jaga      1.5.1.0     3/29/00  Petr Jiricka    Compilation fixes and 
 *       enhancements.
 *  6    Gandalf   1.5         1/13/00  Petr Jiricka    More i18n
 *  5    Gandalf   1.4         1/12/00  Petr Jiricka    i18n phase 1
 *  4    Gandalf   1.3         10/23/99 Ian Formanek    NO SEMANTIC CHANGE - Sun
 *       Microsystems Copyright in File Comment
 *  3    Gandalf   1.2         10/12/99 Petr Jiricka    Removed debug messages
 *  2    Gandalf   1.1         10/10/99 Petr Jiricka    Fixed Javadoc
 *  1    Gandalf   1.0         8/3/99   Petr Jiricka    
 * $
 */
