/*
 *                 Sun Public License Notice
 *
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 *
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.core;

import java.beans.*;
import java.awt.Component;
import java.lang.reflect.Method;
import java.util.ArrayList;

import org.openide.TopManager;
import org.openide.awt.HtmlBrowser;
import org.openide.cookies.InstanceCookie;
import org.openide.filesystems.FileObject;
import org.openide.loaders.DataFolder;
import org.openide.loaders.DataObject;
import org.openide.nodes.Node;
import org.openide.util.NbBundle;
/**
 *
 * @author  pjiricka
 * @version
 */
public class WebBrowserEditor extends PropertyEditorSupport {
    
  /** Creates new WebBrowserEditor */
    public WebBrowserEditor () {
    }
    
    public String getAsText () {
        try {
            HtmlBrowser.Factory f = (HtmlBrowser.Factory)getValue ();
            if (f == null)
                return NbBundle.getBundle(ServletSettings.class).getString("CTL_defaultBrowser");
            
            FileObject fo = TopManager.getDefault ().getRepository ()
                .getDefaultFileSystem ().findResource ("Services/Browsers");   // NOI18N
            DataFolder folder = DataFolder.findFolder (fo);
            DataObject [] dobjs = folder.getChildren ();
            for (int i = 0; i<dobjs.length; i++) {
                Object o = ((InstanceCookie)dobjs[i].getCookie (InstanceCookie.class)).instanceCreate ();
                if (f.equals (o))
                    return dobjs[i].getNodeDelegate ().getDisplayName ();
            }
        }
        catch (Exception ex) {
            TopManager.getDefault ().notifyException (ex);
        }
        return NbBundle.getBundle(ServletSettings.class).getString("CTL_defaultBrowser");
    }
    
    public boolean supportsCustomEditor () {
        return false;
    }
    
    public void setAsText (java.lang.String str) throws java.lang.IllegalArgumentException {
        try {
            if (NbBundle.getBundle(ServletSettings.class).getString("CTL_defaultBrowser").equals (str)) {
                setValue (null);
                return;
            }
            FileObject fo = TopManager.getDefault ().getRepository ()
                .getDefaultFileSystem ().findResource ("Services/Browsers");   // NOI18N
            DataFolder folder = DataFolder.findFolder (fo);
            DataObject [] dobjs = folder.getChildren ();
            for (int i = 0; i<dobjs.length; i++) {
                if (str.equals (dobjs[i].getNodeDelegate ().getDisplayName ())) {
                    Object o = ((InstanceCookie)dobjs[i].getCookie (InstanceCookie.class)).instanceCreate ();
                    setValue (o);
                    return;
                }
            }
        }
        catch (Exception ex) {
            TopManager.getDefault ().notifyException (ex);
            return;
        }
    }
    
    public java.lang.String[] getTags () {
        ArrayList list = new ArrayList ();
        list.add (NbBundle.getBundle(ServletSettings.class).getString("CTL_defaultBrowser"));
        FileObject fo = TopManager.getDefault ().getRepository ()
            .getDefaultFileSystem ().findResource ("Services/Browsers");   // NOI18N
        DataFolder folder = DataFolder.findFolder (fo);
        DataObject [] dobjs = folder.getChildren ();
        for (int i = 0; i<dobjs.length; i++) {
            list.add (dobjs[i].getNodeDelegate ().getDisplayName ());
        }
        String[] retValue = new String[list.size ()];
        
        list.toArray (retValue);
        return retValue;
    }
    
  /*
  public Component getCustomEditor() {
      return new WebBrowserCustomEditor((Node.Handle)getValue());
  }
   */
    
}