/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.core.execution;

import org.apache.tomcat.core.*;
import org.apache.tomcat.core.Constants;
import org.apache.tomcat.request.*;
import org.apache.tomcat.util.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.http.*;

import org.apache.tomcat.logging.*;

/** Sets the IDE JspServlet org.netbeans.modules.web.core.execution.JspServlet
 * instead of the default org.apache.jasper.servlet.JspServlet.
 *
 * PENDING : When must this be called ? Before or after WebXMLReader ?
 *
 * @author Petr Jiricka
 */
public class IDEJspInterceptor extends BaseInterceptor {

    public IDEJspInterceptor() {
    }

    private ServletWrapper addServlet( Context ctx, String name, String classN )
	throws TomcatException
    {
	ServletWrapper sw=new ServletWrapper();
	sw.setContext(ctx);
	sw.setServletName( name );
	sw.setServletClass( classN);
	ctx.addServlet( sw );
	sw.setLoadOnStartUp( -2147483646 );
	return sw;
    }
    
    private void setDefaults( Context ctx )
	throws TomcatException
    {
	ServletWrapper sw=addServlet( ctx, "jsp", "org.netbeans.modules.web.core.execution.JspServlet");
        sw.addInitParam("mappedfile", "true");
	ctx.addServletMapping( "*.jsp", "jsp");
    }

    public void contextInit( Context ctx) throws TomcatException {
        setDefaults(ctx);
    }

}
