package org.netbeans.modules.web.core.execution;

import java.beans.*;
import java.util.ResourceBundle;
import java.util.Enumeration;

import org.openide.execution.ProcessExecutor;
import org.openide.execution.Executor;
import org.openide.util.NbBundle;

public class JakartaExecutorBeanInfo extends SimpleBeanInfo {

    private static BeanDescriptor descr;
    static PropertyDescriptor[] prop = null;
    static {
        descr = new BeanDescriptor (JakartaExecutor.class);
        ResourceBundle bundle = NbBundle.getBundle(JakartaExecutorBeanInfo.class);
        descr.setName (bundle.getString("CTL_Exec_Name"));
    }

    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] { Introspector.getBeanInfo (ProcessExecutor.class) };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions")) // NOI18N
                ie.printStackTrace ();
            return null;
        }
    }

    public BeanDescriptor getBeanDescriptor () {
        return descr;
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
        if (prop == null)
            initializePropertyDescriptors();
        return prop;
    }
    
    private void initializePropertyDescriptors() {
        // find the first JakartaExecutor and get its ExecParams
        ExecParams params = null;
        Enumeration executors = Executor.executors();
        for (; executors.hasMoreElements(); ) {
            Object exec = executors.nextElement();
            if (exec instanceof JakartaExecutor) {
                params = ((JakartaExecutor)exec).getExecParams();
                break;
            }
        }
        if (params != null) {
            try {
                BeanInfo paramsBeanInfo = Introspector.getBeanInfo(params.getClass());
                PropertyDescriptor[] paramsProp = paramsBeanInfo.getPropertyDescriptors();
                prop = new PropertyDescriptor[paramsProp.length];
                for (int i = 0; i < paramsProp.length; i++) {
                    
                    prop[i] = new PropertyDescriptor(paramsProp[i].getName(), 
                        JakartaExecutor.class, 
                        paramsProp[i].getReadMethod().getName(), 
                        paramsProp[i].getWriteMethod().getName());
                    prop[i].setBound(paramsProp[i].isBound());
                    prop[i].setConstrained(paramsProp[i].isConstrained());
                    prop[i].setExpert(paramsProp[i].isExpert());
                    prop[i].setHidden(paramsProp[i].isHidden());
                    prop[i].setPreferred(paramsProp[i].isPreferred());
                    prop[i].setDisplayName(paramsProp[i].getDisplayName());
                    prop[i].setShortDescription(paramsProp[i].getShortDescription());
                    prop[i].setPropertyEditorClass(paramsProp[i].getPropertyEditorClass());
                }
            } 
            catch (IntrospectionException e) {
                if (Boolean.getBoolean("netbeans.debug.exceptions"))
                    e.printStackTrace();
            }
        }
    }

    public java.awt.Image getIcon(int type) {
        return getAdditionalBeanInfo()[0].getIcon(type);
        /*if (icon == null)
          icon = loadImage("/org/netbeans/modules/web/core/resources/servletExecution.gif"); // NOI18N
        return icon;*/
    }

}
