/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.core.execution;

import java.io.*;
/**
 *
 * @author  pjiricka
 * @version 
 */
public class ServerProcess extends Process {
    
    Process realProcess;
    String config;
    String home;
    JakartaExecutor executor;

    /** Creates new ServerProcess */
    public ServerProcess(JakartaExecutor exec, Process realProcess, String config, String home) {
        this.executor = exec;
        this.realProcess = realProcess;
        this.config = config;
        this.home = home;
    }

    public OutputStream getOutputStream() {
        return realProcess.getOutputStream();
    }

    public InputStream getInputStream() {
        return realProcess.getInputStream();
    }

    public InputStream getErrorStream() {
        return realProcess.getErrorStream();
    }

    public int waitFor() throws InterruptedException {
        return realProcess.waitFor();
    }

    public int exitValue() {
        return realProcess.exitValue();
    }

    public void destroy() {
        // try to call a service which destroys the process (by RMI, for example), if that fails, destroy it
        if (JakartaExecutor.getServerProcess() == this) {
            try {
                WebAppStop.main(new String[] {config, home});
            }
            catch (Exception e) {
                // do nothing, still can stop the server forcefully
                if (Boolean.getBoolean("netbeans.debug.exceptions")) {
                    e.printStackTrace();
                }
            }
            realProcess.destroy();
            executor.cleanServerInstance(this);
        }
        else {
            realProcess.destroy();
        }
    	
    }
}
