/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.core.jsploader;


import java.io.File;
import java.io.IOException;

import org.apache.jasper.Options;
//import org.apache.jasper.JspC;

/**
 * A class to hold all init parameters specific to the JSP engine. 
 *
 * @author Anil K. Vijendran
 * @author Hans Bergsten
 */
public class OptionsImpl implements Options {

    public static final String DEFAULT_IE_CLASS_ID =
        "clsid:8AD9C840-044E-11D1-B3E9-00805F499D93";

    private File scratchDir;

    public OptionsImpl(JspDataObject jspdo) throws IOException {
        scratchDir = new File(JspCompileUtil.getFileObjectFileName(
                                  JspCompileUtil.getContextOutputRoot(jspdo.getPrimaryFile())));
    }

    /**
     * Are we keeping generated code around?
     */
    public boolean getKeepGenerated() {
        throw new UnsupportedOperationException();
    }

    /**
     * Are we supporting HTML mapped servlets?
     */
    public boolean getMappedFile() {
        // PENDING
        return true;
    }

    /**
     * Are we supporting large files?
     */
    public boolean getLargeFile() {
        // PENDING
        return false;
    }

    /**
     * Should errors be sent to client or thrown into stderr?
     */
    public boolean getSendErrorToClient() {
        throw new UnsupportedOperationException();
    }

    /**
     * Class ID for use in the plugin tag when the browser is IE. 
     */
    public String getIeClassId() {
        return DEFAULT_IE_CLASS_ID;
    }

    /**
     * What is my scratch dir? (Directory for the generated .class file)
     */
    public File getScratchDir() {
        return scratchDir;
    }

    /**
     * What classpath should I use while compiling the servlets
     * generated from JSP files?
     */
    public String getClassPath() {
        throw new UnsupportedOperationException();
    }

    /**
     * What compiler plugin should I use to compile the servlets
     * generated from JSP files?
     */
    public Class getJspCompilerPlugin() {
        return null;
    }

    /**
     * Path of the compiler to use for compiling JSP pages.
     */
    public String getJspCompilerPath() {
        throw new UnsupportedOperationException();
    }

    /**
     * ProtectionDomain for this JSP Context when using a SecurityManager
     */
    public final Object getProtectionDomain() {
        return null;
    }
    
}
