/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.core.syntax;

import org.netbeans.editor.TokenID;
import org.netbeans.editor.TokenContext;
import org.netbeans.editor.TokenContextPath;
import org.netbeans.editor.BaseTokenID;
import org.netbeans.editor.ext.java.JavaLayerTokenContext;

/** Helper class for token context for Java methods (layer above the lexical layer provided by the JavaSyntax class.
* This is necessary to make java method coloring work properly in JSP
*
* @author Petr Jiricka
* @version 1.00
*/

public class JspJavaLayerTokenContext extends TokenContext {

    private JspJavaLayerTokenContext() {
        super("jsp-", new TokenContext[] { JavaLayerTokenContext.context } );
    }

    public static final JspJavaLayerTokenContext context = new JspJavaLayerTokenContext();

    public static final TokenContextPath contextPath = context.getContextPath();

}

