/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.templates;

import java.util.Enumeration;
import java.util.MissingResourceException;
import java.io.*;

import org.openide.modules.ModuleInstall;
import org.openide.util.NbBundle;
import org.openide.TopManager;
import org.openide.NotifyDescriptor;


import org.netbeans.modules.web.wizards.beanjsp.ide.JSPPageWizardModule;
import org.netbeans.modules.web.templates.nbcontrol.DWModuleInstaller;

/**
* Module installation class for JSP wizard
*
* @author Petr Jiricka
*/
public class JSPWizardModule extends ModuleInstall {

    /** serialVersionUID */
    private static final long serialVersionUID = -4736324822902413381L;

    JSPPageWizardModule wizardModule = new JSPPageWizardModule();
    DWModuleInstaller dwModule = new DWModuleInstaller();

    /** Module installed for the first time. */
    public void installed() {

        try {
            wizardModule.installed(this);
            dwModule.installed(this);
        }
        catch (MissingResourceException e) {
            TopManager.getDefault().notifyException(e);
        }

        restored ();
    }

    /** Module installed again.
    * Add applet executor
    */
    public void restored() {

        wizardModule.restored(this);
        dwModule.restored(this);
    }

    /** Module was uninstalled. */
    public void uninstalled() {

        wizardModule.uninstalled(this);
        dwModule.uninstalled(this);
    }

    /** Module is being closed. */
    public boolean closing () {

        if (!wizardModule.closing(this))
            return false;
        if (!dwModule.closing(this))
            return false;

        return true; // agree to close
    }

    /** Module is being closed. */
    public void close () {

        wizardModule.close(this);
        dwModule.close(this);
    }

}

