/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.templates.nbcontrol;

import java.beans.*;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.util.ResourceBundle;
import org.openide.util.NbBundle;

public class DWEditorPropertyEditor extends PropertyEditorSupport {

    private static final String i18nBundle =          // NOI18N
	"org.netbeans.modules.web.templates.resources.Bundle";
    private static ResourceBundle resBundle = NbBundle.getBundle(i18nBundle);

    // internal editor string
    private final static String INTERNAL_EDITOR =
	resBundle.getString("EI_DWInternalEditor");

    // external editor string
    private final static String EXTERNAL_EDITOR =
	resBundle.getString("EI_DWExternalEditor");

    // array of editors 
    private static final String[] editorNames = {INTERNAL_EDITOR, EXTERNAL_EDITOR};

    /** @return names of the supported LookAndFeels */
    public String[] getTags() {
	return editorNames;
    }

    /** @return text for the current value */
    public String getAsText () {
	String editor = (String) getValue();
	if (editor.equals(INTERNAL_EDITOR)) {
	    return INTERNAL_EDITOR;
	}
	else {
	    return EXTERNAL_EDITOR;
	}
    }

    /** @param text A text for the current value. */
    public void setAsText (String text) {
	if (text.equals(INTERNAL_EDITOR)) {
	    setValue(INTERNAL_EDITOR);
	    return;
	}
	if (text.equals(EXTERNAL_EDITOR)) {
	    setValue(EXTERNAL_EDITOR);
	    return;
	}

	throw new IllegalArgumentException ();
    }

    public void setValue(Object value) {
	super.setValue(value);
    }
}

