/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.templates.nbcontrol;

import java.util.ResourceBundle;
import org.openide.util.NbBundle;
import org.openide.options.SystemOption;
import org.openide.execution.NbProcessDescriptor;

public class DWEditorSettings extends SystemOption {

    private static String editorName;
    private static String editorPath;
    private static String editorExecName;

    /** Dreamweaver Option Settings */
    public final static DWEditorSettings OPTIONS = new DWEditorSettings();

    // ------------------------
    public DWEditorSettings() {
    }

    /** human presentable name */
    public String displayName() {
	return NbBundle.getBundle("org.netbeans.modules.web.templates.resources.Bundle").
            getString("EI_DWHtmlEditorSettings");
    }

    /** This is a project option. */
    private boolean isGlobal() {
	return false;
    }

    // ------------------------

    /**
     * getter for editor name
     */
    public String getEditorName() {
        if (editorName == null) {
	    editorName = NbBundle.getBundle("org.netbeans.modules.web.templates.resources.Bundle").
                getString("EI_DWInternalEditor");
        }
	return editorName;
    }

    /**
     * getter for editor path 
     */
    public String getEditorPath() {
	return editorPath;
    }

    /**
     * getter for editor exec name
     */
    public String getEditorExecName() {
	return editorExecName;
    }

    // ------------------------

    /**
     * setter for editor Name
     */
    public void setEditorName(String ed) {
	editorName = ed;
	firePropertyChange("editorName", null, editorName);
    }

    /**
     * setter for editor path 
     */
    public void setEditorPath(String edPath) {
	editorPath = edPath;
	firePropertyChange("editorPath", null, editorPath);
    }

    /**
     * setter for editor exec name 
     */
    public void setEditorExecName(String edExecName) {
	editorExecName = edExecName;
	firePropertyChange("editorExecName", null, editorExecName);
    }
}

