/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.templates.nbcontrol;

import java.awt.Image;
import java.beans.*;
import java.util.ResourceBundle;
import org.openide.util.NbBundle;

public class DWEditorSettingsBeanInfo extends SimpleBeanInfo {

    public static Image icon;

    private static final String i18nBundle =          // NOI18N
	"org.netbeans.modules.web.templates.resources.Bundle";
    private static ResourceBundle resBundle = NbBundle.getBundle(i18nBundle);

    /** Array of property descriptors. */
    private static PropertyDescriptor[] desc;

    // initialization of the array of descriptors
    static {
	try {
	    desc = new PropertyDescriptor[] {
		new PropertyDescriptor("editorName",
				       DWEditorSettings.class), // 0 // NOI18N
		new PropertyDescriptor("editorPath",
				       DWEditorSettings.class), // 1 // NOI18N
		new PropertyDescriptor("editorExecName",
				       DWEditorSettings.class), // 2 // NOI18N
	    };
	    desc[0].setDisplayName(resBundle.getString("EI_DWEditorName"));
	    desc[0].setShortDescription(resBundle.getString("EI_DWEditorNameHint"));
	    desc[0].setPropertyEditorClass(DWEditorPropertyEditor.class);
	    desc[1].setDisplayName(resBundle.getString("EI_DWExecPath"));
	    desc[1].setShortDescription(resBundle.getString("EI_DWExecPathHint"));
	    desc[2].setDisplayName(resBundle.getString("EI_DWExecName"));
	    desc[2].setShortDescription(resBundle.getString("EI_DWExecNameHint"));

	} catch (IntrospectionException ex) {

	    if (Boolean.getBoolean ("netbeans.debug.exceptions")) // NOI18N
		ex.printStackTrace ();
	} catch (java.util.MissingResourceException ex) {
	    if (Boolean.getBoolean ("netbeans.debug.exceptions")) // NOI18N
		ex.printStackTrace ();
	}
    }

    public DWEditorSettingsBeanInfo() {
    }

    /**
     * loads the icon
     */
    public Image getIcon(int type) {
	if (icon == null) {
	    icon = loadImage(resBundle.getString("EI_DWIntegrationToolIcon"));
	}
	return icon;
    }

    /** Descriptor of valid properties
     * @return array of properties
     */
    public PropertyDescriptor[] getPropertyDescriptors() {
	return desc;
    }
}

