/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.templates.nbcontrol;

import java.awt.event.*;
import java.util.HashSet;
import java.util.ResourceBundle;
import java.sql.*;

import org.openide.loaders.DataFolder;
import org.openide.util.NbBundle;
import org.openide.util.HelpCtx;
import org.openide.util.actions.CookieAction;
import org.openide.util.actions.CallableSystemAction;
import org.openide.nodes.Node;

import org.netbeans.modules.web.templates.ui.*;

public class DWIntegrationAction extends CallableSystemAction {

    // --------------------
    /** Name of the action. */
    public String getName () {
	ResourceBundle resBundle = NbBundle.getBundle(
						      DWIntegrationToolDialog.i18nBundle);
        return resBundle.getString("EI_DWToolMenuOptionName");
    }

    // --------------------
    /** No help yet. */
    public HelpCtx getHelpCtx () {
	return new HelpCtx (DWIntegrationAction.class);
    }

    // --------------------
    protected String iconResource () {
	ResourceBundle resBundle = NbBundle.getBundle(
						      DWIntegrationToolDialog.i18nBundle);
	return resBundle.getString("EI_DWIntegrationToolIcon");
    }

    // --------------------
    // Open the view
    public void performAction() {
        DWIntegrationToolDialog.showDialog();
    }
}

