/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.templates.nbcontrol;

import org.openide.loaders.DataNode;
import org.openide.actions.OpenAction;
import org.openide.util.*;
import org.openide.util.actions.*;
import java.util.ResourceBundle;
import org.openide.nodes.Node;
import org.openide.nodes.Children;

public class DWTNode extends DataNode {

    private final static String i18nBundle =          // NOI18N
	"org.netbeans.modules.web.templates.resources.Bundle";
    private static ResourceBundle resBundle = NbBundle.getBundle(i18nBundle);

    // Icon base for the DWTNode node
    private static final String DWT_ICON_BASE =
	resBundle.getString("EI_DWTemplateIcon");

    // Default constructor, constructs node
    public DWTNode (final DWTDataObject dataObject) {

	super(dataObject, Children.LEAF);
	DWTCookie cookie = new DWTCookie();
	cookie.setDWTNode(this);
	cookie.setDWTDataObject(dataObject);
	getCookieSet().add(cookie);
	setIconBase(DWT_ICON_BASE);
    }

    /**
     * Overrides default action from DataNode.
     * Instantiate a template, if isTemplate() returns true.
     * Opens otherwise.
     */
    public SystemAction getDefaultAction () {
	return SystemAction.get(DWTOpenAction.class);
    }

}
