/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package  org.netbeans.modules.web.wizards.beanjsp.model;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.swing.border.*;

import org.netbeans.modules.web.wizards.beanjsp.ide.*;

import org.netbeans.modules.web.wizards.util.*;
import org.netbeans.modules.web.wizards.beanjsp.util.*;

import org.openide.util.*;

  
public class JSPBeanPropInitTableModel extends JSPItemTableModel { 
    

    public static final int PROP_COL = 0;
    public static final int SEPERATOR_COL_1 = 1;	
    public static final int CREATE_INIT_CHK_COL = 2;
    public static final int CREATE_INIT_OPT_COL = 3;	
    public static final int CREATE_INIT_DATA_COL = 4;	
    public static final int SEPERATOR_COL_2 = 5;
    public static final int ACCESS_INIT_CHK_COL = 6;	
    public static final int ACCESS_INIT_OPT_COL = 7;
    public static final int ACCESS_INIT_DATA_COL = 8;	
    public static final int NUM_COLUMNS = 9;
	
    private String propColName;		
    private String createInitChkColName;	
    private String createInitOptColName;
    private String createInitDataColName;	
    private String accessInitChkColName;	
    private String accessInitOptColName;
    private String accessInitDataColName;		
	
    public JSPBeanPropInitTableModel(JSPVector jspBeanMethods) {
	
	super(jspBeanMethods);		
	columnCount = NUM_COLUMNS;		
	// i18n initialization
	java.util.ResourceBundle resBundle =
	    NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle); 

	propColName = resBundle.getString("JBW_PITC_Property");			 // NOI18N		
	createInitChkColName = resBundle.getString("JBW_PITC_CreateInitCheck");			 // NOI18N
	createInitOptColName = resBundle.getString("JBW_PITC_CreateInitOption");		 // NOI18N
	createInitDataColName =
	    resBundle.getString("JBW_PITC_CreateInitData"); // NOI18N
	
	accessInitChkColName = resBundle.getString("JBW_PITC_AccessInitCheck");			 // NOI18N		

	accessInitOptColName =
	    resBundle.getString("JBW_PITC_AccessInitOption");	// NOI18N		

	accessInitDataColName = resBundle.getString("JBW_PITC_AccessInitData");			 // NOI18N
		
    }	

    //// table model handling
	
    public String getColumnName(int column) {
	switch (column) {
        case PROP_COL: 
	    return propColName;			        
	    // case CREATE_INIT_CHK_COL: 
	    //	return createInitChkColName;        
	case CREATE_INIT_OPT_COL: 
	    return createInitOptColName;
        case CREATE_INIT_DATA_COL: 
	    return createInitDataColName;			
	    //case ACCESS_INIT_CHK_COL: 
	    //	return accessInitChkColName;			
        case ACCESS_INIT_OPT_COL: 
	    return accessInitOptColName; 
	    
	case ACCESS_INIT_DATA_COL: 
	    return accessInitDataColName;			
        default: 
	    return "";			 // NOI18N
	}
    }
	
    public Class getColumnClass(int column) {
	switch (column) {
        case PROP_COL: 
	    return Object.class;        
	case CREATE_INIT_CHK_COL: 
	    return Boolean.class;        
	case CREATE_INIT_OPT_COL: 
	    return Integer.class;
        case CREATE_INIT_DATA_COL: 
	    return String.class;
        case ACCESS_INIT_CHK_COL: 
	    return Boolean.class;
        case ACCESS_INIT_OPT_COL: 
	    return Integer.class;        
	case ACCESS_INIT_DATA_COL: 
	    return String.class;
        default: 
	    return Object.class;
	}
    }
	
	
    public boolean isCellEditable(int row, int column) {  	  
	JSPBeanField jspBeanField = (JSPBeanField) items.get(row);
	switch (column) {        
	case PROP_COL: 
	    return false;        
	case CREATE_INIT_CHK_COL: 
	    return true;        
	case CREATE_INIT_OPT_COL: 			
	    // return jspBeanField.isCreateInit(); 
	    // 
	    return true;
	case CREATE_INIT_DATA_COL: 
	    // return jspBeanField.isCreateInit(); 
	    // 
	    return true;
	case ACCESS_INIT_CHK_COL: 
	    return true;
	case ACCESS_INIT_OPT_COL: 
	    // return jspBeanField.isAccessInit();
	    return true;        
	case ACCESS_INIT_DATA_COL: 
	    // return jspBeanField.isAccessInit();		
	    return true;
	default: 
	    return false;
	}
    }
	
    public Object getValueAt(int row, int column) {	  

	JSPBeanField jspBeanField = (JSPBeanField) items.get(row);
	switch (column) { 
	case PROP_COL: 
	    return jspBeanField.toString();        
	case CREATE_INIT_CHK_COL: 
	    return new Boolean(jspBeanField.isCreateInit());        
	case CREATE_INIT_OPT_COL: 
	    return new Integer(jspBeanField.getCreateInitOption());
	case CREATE_INIT_DATA_COL: 
	    //if(jspBeanField.getCreateInitOption() == JSPBeanField.PARAM)
	    //	return jspBeanField.getParamAtCreate();
	    //else		
	    //	return jspBeanField.getValueAtCreate(); 
	    //	
	    return jspBeanField.getCreateInitData();
	case ACCESS_INIT_CHK_COL: 
	    return new Boolean(jspBeanField.isAccessInit());
	case ACCESS_INIT_OPT_COL: 
	    return new Integer(jspBeanField.getAccessInitOption()); 
	    
	case ACCESS_INIT_DATA_COL: 
	    // if(jspBeanField.getAccessInitOption() == JSPBeanField.PARAM)
	    //	return jspBeanField.getParamAtAccess();
	    // else			//	return
	    // jspBeanField.getValueAtAccess();			
	    return jspBeanField.getAccessInitData();
	default: 
	    return "";			 // NOI18N
	}
    }
	
    public void setValueAt(Object aValue, int row, int column) {	
	JSPBeanField jspBeanField = (JSPBeanField) items.get(row); 
	

	switch (column) {
        case PROP_COL: 
	    break;       
	case CREATE_INIT_CHK_COL: 
	    jspBeanField.setCreateInit(((Boolean)aValue).booleanValue());
	    break;        
	case CREATE_INIT_OPT_COL: 
	    jspBeanField.setCreateInitOption(((Integer)aValue).intValue());
	    break;  
        case CREATE_INIT_DATA_COL: 
	    //if(jspBeanField.getCreateInitOption() == JSPBeanField.PARAM)
	    //	jspBeanField.setParamAtCreate((String)aValue);
	    //else			//	jspBeanField.setValueAtCreate((String)aValue);
	    jspBeanField.setCreateInitData((String)aValue);
	    break;
        case ACCESS_INIT_CHK_COL: 
	    jspBeanField.setAccessInit(((Boolean)aValue).booleanValue());
	    break;
        case ACCESS_INIT_OPT_COL: 
	    jspBeanField.setAccessInitOption(((Integer)aValue).intValue());
	    break;        
	case ACCESS_INIT_DATA_COL: 
	    //if(jspBeanField.getAccessInitOption() == JSPBeanField.PARAM)
	    //	jspBeanField.setParamAtAccess((String)aValue);
	    //else
	    //	jspBeanField.setValueAtAccess((String)aValue);			jspBeanField.setCreateInitData((String)aValue);
	    break;	
	default: 
	    break;
	}
    }	 
}

