/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package  org.netbeans.modules.web.wizards.beanjsp.model;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;

import org.netbeans.modules.web.wizards.beanjsp.util.*;
import org.netbeans.modules.web.wizards.util.*;


public class JSPItemTableModel extends javax.swing.table.AbstractTableModel {	
    protected JSPVector items;
    protected int columnCount = 1;	
    public JSPItemTableModel() {
	this(new JSPVector());
    }
	
    public JSPItemTableModel(JSPVector items) {
	this.items = items;	
    }		//// table model handling
	
    public int getColumnCount() { return columnCount; }
	
    public int getRowCount() { return items.size(); }
	
    public String getColumnName(int column) {
	return "";			 // NOI18N
    }
	
    public Class getColumnClass(int column) {
	return Object.class;
    }
	
	
    public boolean isCellEditable(int rowIndex, int columnIdx) {
	return false;
    }
	
    public Object getValueAt(int row, int column) {	  return items.get(row);
    }
	
    public void setValueAt(Object aValue, int row, int column) {		 // do nothing
    }		//// helper methods
    //// USE BEAN Method MODEL methos
	
    public void add(Object item) {
	items.add(item);
	int idx = items.size()-1;
	this.fireTableRowsInserted(idx,idx);
    }
	
    public Object remove(int idx) {
	Object item = items.remove(idx);
	this.fireTableRowsDeleted(idx,idx);
	return item;
    }
	
    public int moveUp(int idx) {
	int newIdx = items.moveUp(idx);
	this.fireTableDataChanged();
	return newIdx;
    }
	
    public int moveDown(int idx) {
	int newIdx = items.moveDown(idx);
	this.fireTableDataChanged();
	return newIdx;
    }
	
    public void removeAll() {
	int idx = items.size()-1;
	items.removeAllElements();
	if(idx >= 0 )
	    this.fireTableRowsDeleted(0,idx);
    }
	
    public boolean removeAll(Object key) {
	boolean itemsRemoved = items.removeAllByKey(key);
		
	if(itemsRemoved) {
	    this.fireTableDataChanged();
	}
		
	return itemsRemoved;
    }
	
    public void addItems(JSPVector newItems) {
	if(newItems.size() <= 0)
	    return;
	int idx = items.size()-1;
	items.addAll(newItems);
	if(idx < 0 )
	    idx = 0;
	this.fireTableRowsInserted(idx, idx+newItems.size());		
    }
	
    public int getSize() { return items.size();}
	
    public JSPVector getItems() { return items; }
    
}

	
