/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package  org.netbeans.modules.web.wizards.beanjsp.ui;

import javax.swing.*;
import javax.swing.event.*;
import java.beans.*;

import java.awt.*;
import java.awt.event.*;

import org.netbeans.modules.web.wizards.beanjsp.model.*;
import org.netbeans.modules.web.wizards.wizardfw.*;
import org.netbeans.modules.web.wizards.beanjsp.ide.*;

import org.netbeans.modules.web.wizards.util.*;
import org.netbeans.modules.web.wizards.beanjsp.util.*;

import org.openide.util.*;import org.openide.*;
import org.openide.text.*;import javax.swing.text.*;import java.io.*;

public class JSPBeanMethodEditor extends StandardWizardPanel {

    // ---------------------------------------------------------------------------------------
    // WizardPanel initialization
    public java.awt.Dimension getPreferredSize () {
	return new java.awt.Dimension (400,500);
    }
	
    public JSPBeanMethodEditor() {
	super();	  initComponents ();
    }
	
    private void initComponents () {

	java.util.ResourceBundle resBundle = NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle);
	  
	methodEditorMsg =
	    resBundle.getString("JBW_MethodEditorMsg");  // NOI18N	  

	this.setTopMessage(methodEditorMsg);
	  
	//// create components
	  
	beginScriptMsg = new MultiLineLabel(resBundle.getString("JBW_ME_BeginScriptMsg"));		 // NOI18N

	beginScriptLabel = new JLabel(resBundle.getString("JBW_ME_BeginScriptLabel")); 			 // NOI18N

	beginScriptEP = new javax.swing.JEditorPane();

	javax.swing.text.EditorKit kit = JEditorPane.createEditorKitForContentType("text/x-java");

	beginScriptEP.setEditorKit(kit);
	  
	beginScriptEPSP = new JScrollPane(beginScriptEP);
	beginScriptEPSP.setPreferredSize (new java.awt.Dimension(100, 75));
	beginScriptEPSP.setMinimumSize (new java.awt.Dimension(100, 50));
	beginScriptEPSP.setMaximumSize (new java.awt.Dimension(100, 75));
	  
	retVarMsg = new
	    MultiLineLabel(resBundle.getString("JBW_ME_RetVarMsg"));  // NOI18N	  
	retVarLabel = new JLabel(resBundle.getString("JBW_ME_RetVarLabel")); 			 // NOI18N

	retVarTF = new javax.swing.JTextField();
	  
	methodSigLabel = new JLabel(resBundle.getString("JBW_ME_MethodSigLabel")); 			 // NOI18N
	  
	methodSigTF = new javax.swing.JTextField();
	methodSigTF.setEditable(false);
	methodSigTF.setBackground (java.awt.Color.lightGray);
	  	  
	paramsMsg = new MultiLineLabel(resBundle.getString("JBW_ME_ParamsMsg"));		 // NOI18N
	  
	paramsLabel = new JLabel(resBundle.getString("JBW_ME_ParamsLabel")); 			 // NOI18N
	  
	paramsTable = new javax.swing.JTable();
	paramsTableSP = new JScrollPane(paramsTable);
	paramsTableSP.setPreferredSize (new java.awt.Dimension(100, 75));
	paramsTableSP.setMinimumSize (new java.awt.Dimension(100, 50));
	paramsTableSP.setMaximumSize (new java.awt.Dimension(100, 75));
	paramsTable.setPreferredScrollableViewportSize(new Dimension(100,75));
	  
	endScriptMsg = new MultiLineLabel(resBundle.getString("JBW_ME_EndScriptMsg"));		 // NOI18N
	endScriptLabel = new JLabel(resBundle.getString("JBW_ME_EndScriptLabel")); 			 // NOI18N
	endScriptEP = new javax.swing.JEditorPane();
	kit = JEditorPane.createEditorKitForContentType("text/x-java");
	endScriptEP.setEditorKit(kit);
	  
	endScriptEPSP = new JScrollPane(endScriptEP);
	endScriptEPSP.setPreferredSize (new java.awt.Dimension(100, 75));
	endScriptEPSP.setMinimumSize (new java.awt.Dimension(100, 50));
	endScriptEPSP.setMaximumSize (new java.awt.Dimension(100, 75));
	  
	previewMsg = new MultiLineLabel(resBundle.getString("JBW_ME_PreviewMsg"));		 // NOI18N	  
	previewLabel = new JLabel(resBundle.getString("JBW_ME_PreviewLabel")); 			 // NOI18N
	previewEP = new javax.swing.JEditorPane();
	// previewEP.setEditable(false);
	kit = JEditorPane.createEditorKitForContentType("text/x-jsp");
	previewEP.setEditorKit(kit);
	  
	previewEPSP = new JScrollPane(previewEP);
	previewEPSP.setPreferredSize (new java.awt.Dimension(100, 75));
	previewEPSP.setMinimumSize (new java.awt.Dimension(100, 50));
	previewEPSP.setMaximumSize (new java.awt.Dimension(100, 75));

	//// setup models	  	  

	paramsTableModel = new ParamsTableModel();	  
	paramsTable.setModel(paramsTableModel);
	  
	/* ***	  paramsTableModel.addTableModelListener(new TableModelListener() {
	   public void tableChanged(TableModelEvent evt) {			  processParamTableChange(evt);
	   }	  });	  *** */
	  
	//// layout components
	arrangeComponents();
	this.setDefaults();
    }

    //// layout components in 
    private void arrangeComponents() {
	arrangeCompsWithGridBag();
    }
	
    private void arrangeCompsWithGridBag() {
	
	// this.contentPane.setLayout(new GridBagLayout());

	int gridy = 0;
		
	// Component topGlue = Box.createGlue();
		
	Component bottomGlue = Box.createGlue();
				/* ***
				   addGridBagComponent(this.contentPane,topGlue,
				   0,gridy,2,1,
				   100,100,
				   GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				   new Insets(2,2,2,2),5,5	);
				   * *** */ 
	    

	addGridBagComponent(this.contentPane,methodSigLabel,
			    0,gridy,1,1,
			    0,0,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,methodSigTF,
			    1,gridy,1,1,
			    100,0,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.HORIZONTAL, 
			    new Insets(2,2,2,2),5,5	);
		
	/* ***		addGridBagComponent(this.contentPane,beginScriptMsg,
	   0,++gridy,2,1,
	   0,0,
	   GridBagConstraints.CENTER, GridBagConstraints.BOTH,
	   new Insets(2,2,2,2),5,5	);		addGridBagComponent(this.contentPane,beginScriptLabel,
	   0,++gridy,2,1,
	   0,0,
	   GridBagConstraints.CENTER, GridBagConstraints.BOTH,
	   new Insets(2,2,2,2),5,5	);
	       
		
	   addGridBagComponent(this.contentPane,beginScriptEPSP,
	   0,++gridy,2,1,
	   0,0,
	   GridBagConstraints.WEST, GridBagConstraints.BOTH,
	   new Insets(2,2,2,2),5,5	);
	   *** */		

	/* ***						
	   addGridBagComponent(this.contentPane,retVarMsg,
	   0,++gridy,2,1,
	   0,0,
	   GridBagConstraints.CENTER, GridBagConstraints.BOTH,
	   new Insets(2,2,2,2),5,5	);
	   addGridBagComponent(this.contentPane,retVarLabel,
	   0,++gridy,1,1,
	   0,0,
	   GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
	   new Insets(2,2,2,2),5,5	);
	   addGridBagComponent(this.contentPane,retVarTF,
	   1,gridy,1,1,
	   100,0,
	   GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
	   new Insets(2,2,2,2),5,5	);		*** */
		
		
	addGridBagComponent(this.contentPane,paramsMsg,
			    0,++gridy,2,1,
			    0,0,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	); 
	    

	addGridBagComponent(this.contentPane,paramsLabel,
			    0,++gridy,2,1,
			    0,0,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	);
		
		
	addGridBagComponent(this.contentPane,paramsTableSP,
			    0,++gridy,2,1,
			    0,100,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	); 
	    

	/* ***
	   addGridBagComponent(this.contentPane,endScriptMsg,
	   0,++gridy,2,1,
	   0,0,
	   GridBagConstraints.CENTER, GridBagConstraints.BOTH,
	   new Insets(2,2,2,2),5,5	);		addGridBagComponent(this.contentPane,endScriptLabel,
	   0,++gridy,2,1,
	   0,0,
	   GridBagConstraints.CENTER, GridBagConstraints.BOTH,
	   new Insets(2,2,2,2),5,5	);
		
		
	   addGridBagComponent(this.contentPane,endScriptEPSP,
	   0,++gridy,2,1,
	   0,0,
	   GridBagConstraints.WEST, GridBagConstraints.BOTH,
	   new Insets(2,2,2,2),5,5	);
	   *** */		

	addGridBagComponent(this.contentPane,previewMsg,
			    0,++gridy,2,1,
			    0,0,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	); 
	    

	addGridBagComponent(this.contentPane,previewLabel,
			    0,++gridy,2,1,
			    0,0,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	);

	addGridBagComponent(this.contentPane,previewEPSP,
			    0,++gridy,2,1,
			    100,200,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	);
		
    }
	
	
    // Variables declaration - do not modify//GEN-BEGIN:variables	  
    private MultiLineLabel beginScriptMsg;
    private javax.swing.JLabel beginScriptLabel;   
    private javax.swing.JEditorPane beginScriptEP;  
    private javax.swing.JScrollPane beginScriptEPSP;
    private MultiLineLabel retVarMsg;
    private javax.swing.JLabel retVarLabel;   
    private javax.swing.JTextField retVarTF;
    private javax.swing.JLabel methodSigLabel;   
    private javax.swing.JTextField methodSigTF;
    private MultiLineLabel paramsMsg;
    private javax.swing.JLabel paramsLabel;   
    private javax.swing.JTable paramsTable;
    private javax.swing.JScrollPane paramsTableSP;
    private MultiLineLabel endScriptMsg;
    private javax.swing.JLabel endScriptLabel;   
    private javax.swing.JEditorPane endScriptEP;  
    private javax.swing.JScrollPane endScriptEPSP;  
    private MultiLineLabel previewMsg;  
    private javax.swing.JLabel previewLabel;   
    private javax.swing.JEditorPane previewEP;  
    private javax.swing.JScrollPane previewEPSP;

    private String methodEditorMsg;
    private String beginScript;
    private String endScript;
    private String retVar;
    private ParamsTableModel paramsTableModel;
    
    MethodScriptDoc methodDoc;
    JSPBeanMethod editingMethod;
  
    public void setDefaults() { }
  
    public void processParamTableChange(TableModelEvent evt) {
	  
	Debug.println("Processing ParamTableChange");	  
	if(evt.getType() == TableModelEvent.UPDATE) {
	    int column = evt.getColumn();
	    if(column != TableModelEvent.ALL_COLUMNS && column ==
	       ParamsTableModel.PARAM_VAR_COL) { 
		

		int row = evt.getFirstRow();
		int lastRow = evt.getLastRow();
		if(row != lastRow)
		    row = lastRow;			  
		if(row != TableModelEvent.HEADER_ROW) {
		    updateScriptEditor(row,paramsTableModel.getValueAt(row,column));			  
		}
	    }	  
	}
    }  


    public void startEditingScript(JSPBeanMethod jspBeanMethod) {
	try {	  previewEP.setText("");
	Document doc = previewEP.getDocument();	  
	methodDoc = new MethodScriptDoc((StyledDocument)doc,jspBeanMethod);
	}
	catch(Exception ex) { Debug.print(ex);}
    }
  
    public void updateScriptEditor(int row, Object aValue) {	  

	if(!editingMethod.isEdited()) {
	    editingMethod.setEdited(true);
	    methodDoc.setJSPBegin(editingMethod.getBeginJSPCode()); 
	    
	}	  

	if(row == 0 ) {  // return value in the table
	    editingMethod.setReturnVar((String)aValue);	  
	} 

	else {
	    editingMethod.setParamVars(row-1,(String)aValue);	  
	}	  
	methodDoc.setMethodCall(editingMethod.getMethodCallJSPCode());
    }   

    public void readJSPBeanMethod( JSPBeanMethod jspBeanMethod) {
	editingMethod = (JSPBeanMethod)jspBeanMethod.clone();  
	// is it deep copy or shallow copy ??	  
	startEditingScript(editingMethod);
	this.methodSigTF.setText(editingMethod.getName()); 
	
	this.paramsTableModel.readJSPBeanMethodParams(editingMethod);
	
    }    

    public void storeJSPBeanMethod( JSPBeanMethod jspBeanMethod ) { 
	
	jspBeanMethod.setBeginScript(methodDoc.getBeginScript()); 
	jspBeanMethod.setEndScript(methodDoc.getEndScript());
	  
	this.paramsTableModel.storeJSPBeanMethodParams(jspBeanMethod);
	jspBeanMethod.setEdited(true);  

    }
  
    public class ParamsTableModel extends javax.swing.table.AbstractTableModel {	
	
	public static final int PARAM_NAME_COL = 0;	
	public static final int PARAM_TYPE_COL = 1;
	public static final int PARAM_VAR_COL = 2;
	public static final int NUM_COLUMNS = 3;	
	private String paramNameColName;	
	private String paramTypeColName;	
	private String paramVarColName;		
	private String returnParamName;	
	private String methodParamName;
	
	Class[] paramTypes;
	String[] paramVars;		
	Class returnType;
	String returnVar;
		
	public ParamsTableModel() { 		

	    java.util.ResourceBundle resBundle =
		NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle);
	    paramNameColName = resBundle.getString("JBW_ME_PTC_ParamName");						 // NOI18N 
	    paramTypeColName = resBundle.getString("JBW_ME_PTC_ParamType");						 // NOI18N
	    paramVarColName = resBundle.getString("JBW_ME_PTC_ParamVar");							 // NOI18N
	    returnParamName = resBundle.getString("JBW_ME_PTC_ReturnParam");							 // NOI18N		
	    methodParamName = resBundle.getString("JBW_ME_PTC_MethodParam");							 // NOI18N		
	    paramTypes = new Class[0];		
	    paramVars =	 new String[0];		
	    returnVar = "";		
	    returnType = java.lang.Void.TYPE ;
	}		

	//// table model handling
	
	public int getColumnCount() { return NUM_COLUMNS; }
	
	public int getRowCount() { return paramTypes.length+1; } // +1 for return type 
	
	public String getColumnName(int column) {
	    switch (column) {        
	    case PARAM_NAME_COL: 
		return paramNameColName; 
	    case PARAM_TYPE_COL: 
		return paramTypeColName; 
	    case PARAM_VAR_COL: 
		return paramVarColName; 
	    default: 
		return "";			 // NOI18N
	    }
	}
	
	public Class getColumnClass(int column) {
	    switch (column) {        
	    case PARAM_NAME_COL: 
		return String.class;
	    case PARAM_TYPE_COL: 
		return String.class;
	    case PARAM_VAR_COL: 
		return String.class; 
	    default: 
		return Object.class;
	    }
	}
	
	
	public boolean isCellEditable(int rowIndex, int columnIdx) {
	    switch (columnIdx) {       
	    case PARAM_NAME_COL: 
		return false;
	    case PARAM_TYPE_COL: 
		return false;
	    case PARAM_VAR_COL: 		  
		if(rowIndex == 0 && returnType != null &&
		   returnType.isAssignableFrom(Void.TYPE))
		    return false;		  
		else 
		    return true; 
	    default: 
		return false;
	    }

	}
	
	public Object getValueAt(int row, int column) {		
	    if(row != 0) {
		switch (column) {				
		case PARAM_NAME_COL:				  
		    return methodParamName+"-"+row;
		case PARAM_TYPE_COL: 
		    return JSPBeanMethod.toClassTypeString(paramTypes[row-1]);
		case PARAM_VAR_COL: 				  
		    return paramVars[row-1];
		default: 
		    return "";			 // NOI18N
		}		
	    }
	    else {			// 0th row is return param column
			
		switch (column) {				
		case PARAM_NAME_COL:
		    return returnParamName;
		case PARAM_TYPE_COL: 
		    return JSPBeanMethod.toClassTypeString(returnType);
		case PARAM_VAR_COL: 
		    if(returnType != null &&
		       returnType.isAssignableFrom(Void.TYPE)) 
			return "void";			// NOI18N
		    else					
			return returnVar;
		default: 
		    return "";			 // NOI18N
		}		
	    }
	}
	
	public void setValueAt(Object aValue, int row, int column) {			if(row != 0) {		
	    switch (column) {				
	    case PARAM_VAR_COL: 
		paramVars[row-1] = (String)aValue;
		updateScriptEditor(row,aValue); 		
		break;
	    }		
	}
	else {
				// 0th row is return param column
	    switch (column) {				
	    case PARAM_VAR_COL: 
		returnVar = (String)aValue;
		updateScriptEditor(row,aValue); 
		break;
	    }	
	}
	}
	
	
	
	//// helpers
	
	public String[] getParamVars() { return paramVars;}	
	
	public void readJSPBeanMethodParams(JSPBeanMethod
					    jspBeanMethod) {
	    paramTypes = jspBeanMethod.getParamTypes(); 
	    paramVars = jspBeanMethod.getParamVars();  // copy of param vars in jspBeanMethod		
	    returnVar = jspBeanMethod.getReturnVar();		
	    returnType = jspBeanMethod.getReturnType();		
	    this.fireTableDataChanged();	}	
	public void storeJSPBeanMethodParams(JSPBeanMethod jspBeanMethod) {
	    jspBeanMethod.setParamVars(paramVars);		
	    jspBeanMethod.setReturnVar(returnVar);
	}  
    }
    // ---------------------------------------------------------------------------------------
  
    public final class MethodScriptDoc {
	StyledDocument doc;
	DocPositionBounds jspBeginBounds;
	DocPositionBounds beginScriptBounds;
	DocPositionBounds methodCallBounds;
	DocPositionBounds endScriptBounds;
	DocPositionBounds jspEndBounds;
	

	public MethodScriptDoc(StyledDocument doc, JSPBeanMethod jspBeanMethod) {
		
	    this.doc = doc;			
	    this.setMethodDocText(jspBeanMethod);		
	}
	    

	public void setMethodDocText(String jspBegin, String
				     scriptBegin, String
				     methodCall, String scriptEnd,
				     String jspEnd) { 

	    String newLine="\n";		// NOI18N
	    int beginOff, endOff;
		
	    try {
		if(!jspBegin.endsWith(newLine))
		    jspBegin += newLine;			
		if(!methodCall.endsWith(newLine))
		    methodCall += newLine;
		if(!jspEnd.endsWith(newLine))
		    jspEnd += newLine;
		doc.remove(0,doc.getLength()); 
		doc.insertString(0,jspBegin+
				 scriptBegin+
				 methodCall+
				 scriptEnd+
				 jspEnd,null);
		beginOff = 0; 
		endOff=0;
			
		Position beginPos,endPos;
                        
		beginOff = 0; 
		beginPos = NbDocument.createPosition(doc,beginOff,Position.Bias.Forward); 
		endOff=jspBegin.length();
		endPos = NbDocument.createPosition(doc,endOff,Position.Bias.Backward);
		jspBeginBounds = new DocPositionBounds(doc, beginPos, endPos);
		jspBeginBounds.markGaurded();
                        
		beginOff = endOff; 
		beginPos = NbDocument.createPosition(doc,beginOff,Position.Bias.Backward);
		endOff=beginOff+scriptBegin.length();
		endPos = NbDocument.createPosition(doc,endOff,Position.Bias.Forward);
		beginScriptBounds = new DocPositionBounds(doc, beginPos, endPos);
                        
		beginOff = endOff; 
		beginPos = NbDocument.createPosition(doc,beginOff,Position.Bias.Forward);
		endOff=beginOff+methodCall.length();
		endPos = NbDocument.createPosition(doc,endOff,Position.Bias.Backward);
		methodCallBounds = new DocPositionBounds(doc, beginPos, endPos);
		methodCallBounds.markGaurded();
                        
		beginOff = endOff; 
		beginPos = NbDocument.createPosition(doc,beginOff,Position.Bias.Backward);
		endOff=beginOff+scriptEnd.length();
		endPos = NbDocument.createPosition(doc,endOff,Position.Bias.Forward);
		endScriptBounds = new DocPositionBounds(doc, beginPos, endPos);
                        
		beginOff = endOff; 
		beginPos = NbDocument.createPosition(doc,beginOff,Position.Bias.Forward);
		endOff=beginOff+jspEnd.length();
		endPos = NbDocument.createPosition(doc,endOff,Position.Bias.Backward);
		jspEndBounds = new DocPositionBounds(doc, beginPos, endPos);
		jspEndBounds.markGaurded();
                        
	    }

	    catch(Exception ex) {Debug.print(ex);}
	}
		
	public void setMethodDocText(JSPBeanMethod jspBeanMethod) {
	    setMethodDocText(jspBeanMethod.getBeginJSPCode(),
			     jspBeanMethod.getBeginScript(),
			     jspBeanMethod.getMethodCallJSPCode(),
			     jspBeanMethod.getEndScript(), 
			     jspBeanMethod.getEndJSPCode()); 
	    
	}				

	public void setText(DocPositionBounds docPosBounds, 
			    String text) {		  
	    String newLine="\n";		// NOI18N		  
	    if(!text.endsWith(newLine))	text += newLine; 
	    try {
		docPosBounds.setText(text);
	    }
	    catch(Exception ex) { Debug.print(ex);}
	}
	
	public void setGaurdedText(DocPositionBounds docPosBounds,
				   String text) { 
	    try {
		docPosBounds.setText(text);
	    }
	    catch(Exception ex) { Debug.print(ex);}
	}						

	public String getText(DocPositionBounds docPosBounds) {
	    try {
		return docPosBounds.getText();
	    }
	    catch(Exception ex) { Debug.print(ex);}		  
	    return "";
	}

        public void setJSPBegin(String jspBegin) {
            this.setGaurdedText(jspBeginBounds,jspBegin);
        }

	public void setBeginScript(String beginScript) {
            this.setText(beginScriptBounds,beginScript);
        }
                
        public String getBeginScript() {
            return this.getText(beginScriptBounds);
        }
		
        public void setMethodCall(String methodCall) {		  
	    this.setGaurdedText(methodCallBounds,methodCall);        
	}
        
        public void setEndScript(String endScript) {
            this.setText(endScriptBounds,endScript);
        }
                
        public String getEndScript() {
            return this.getText(endScriptBounds);
        }                
    }
  
    // ---------------------------------------------------------------------------------------  
    public final class DocPositionBounds {
	  
	/** Begin */
	private Position begin;

	/** End */
	private Position end;
	  
	/** Document in which the positions belong
	 */
	private StyledDocument doc ;	  

	/** Creates new <code>PositionBounds</code>.
	 * @param begin the start position of the range
	 * @param end the end position of the range
	 */
	public DocPositionBounds(StyledDocument doc, Position begin,
				 Position end) { 
	    this.doc = doc;
	    this.begin = begin;
	    this.end = end;
	}

	/** 
	 * Get the starting position of this range.
	 * @return the begin position
	 */
	public Position getBegin() {
	    return begin;
	}

	/**
	 * Get the ending position of this range.
	 * @return the end position
	 */
	public Position getEnd() {
	    return end;
	}
          
	public void markGaurded() {
            int p1 = begin.getOffset();
            int p2 = end.getOffset();
            NbDocument.markGuarded(doc, p1, p2-p1);
	}
          
	public void unmarkGaurded() {
            int p1 = begin.getOffset();
            int p2 = end.getOffset();
            NbDocument.markGuarded(doc, p1, p2-p1);
	}

	/** Replaces the text contained in this range.
	 * This replacement is done atomically, and so is preferable to manual inserts & removes.
	 * <p>If you are running this from user-oriented code, you may want to wrap it in {@link NbDocument#runAtomicAsUser}.
	 * @param text new text to insert over existing text
	 * @exception IOException if any problem occurred during document loading (if that was necessary)
	 * @exception BadLocationException if the positions are out of the bounds of the document
	 */
	public void setText(final String text) throws IOException, BadLocationException {

	    final BadLocationException[] hold = new BadLocationException[] { null };
	    Runnable run = new Runnable() {
		    public void run() {
			try {
			    int p1 = begin.getOffset();
			    int p2 = end.getOffset();
			    int len = text.length();
			    if (len == 0) {  // 1) set empty string
				if (p2 > p1)
				    doc.remove(p1, p2 - p1);
			    }
			    else {                     // 2) set non empty string
				if (p2 - p1 >= 2) {
				    doc.insertString(p1 + 1, text, null);
				    doc.remove(p1 + 1 + len, p2 - p1 - 1);
				    doc.remove(p1, 1);
				}
				else {
				    doc.insertString(p1, text, null);
				    if (p2 > p1)
					doc.remove(p1 + len, p2 - p1);
				}
			    }
			}
			catch (BadLocationException e) {
			    hold[0] = e;
			}
		    }
		};
	    NbDocument.runAtomic (doc, run);
	    if (hold[0] != null)
		throw hold[0];
	}

	  
	/** Finds the text contained in this range.
	 * @return the text
	 * @exception IOException if any I/O problem occurred during document loading (if that was necessary)
	 * @exception BadLocationException if the positions are out of the bounds of the document
	 */
	public String getText() throws BadLocationException, IOException {
	    int p1 = begin.getOffset();
	    int p2 = end.getOffset();
	    if(p2 < p1) 
		return doc.getText(p2, p1 - p2);
	    else
		return doc.getText(p1, p2 - p1);
	}

    }
  
    // ---------------------------------------------------------------------------------------

    // Netbeans Dialog creation    

    public static void editJSPBeanMethod(JSPBeanMethod jspBeanMethod) {
	  
	JSPBeanMethodEditor jspBeanMethodEditor = 
	    new JSPBeanMethodEditor();
	java.util.ResourceBundle resBundle =
	    NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle); 
	String jspBeanMethodEditorTitle =
	    resBundle.getString("JBW_MethodEditorTitle");// NOI18N

	DialogDescriptor methodEditorDialogDescriptor =  
	    new DialogDescriptor(jspBeanMethodEditor,
				 jspBeanMethodEditorTitle); 
	  
	java.awt.Dialog dialog = 
	    TopManager.getDefault().createDialog(methodEditorDialogDescriptor);
	jspBeanMethodEditor.readJSPBeanMethod(jspBeanMethod); 
	
	dialog.show();  
	    
	Object option = methodEditorDialogDescriptor.getValue();
	if (option == DialogDescriptor.OK_OPTION ) {
	    Debug.println("Updating Edited Method ...");
	    jspBeanMethodEditor.storeJSPBeanMethod(jspBeanMethod);
	} else {
	    Debug.println("Canceled Method Editing...");
	}
    }
    
    public static void main(String[] args) { }
}
