/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package  org.netbeans.modules.web.wizards.beanjsp.ui;

import org.netbeans.modules.web.wizards.beanjsp.model.*;
import org.netbeans.modules.web.wizards.wizardfw.*;
import org.netbeans.modules.web.wizards.beanjsp.ide.*;

import org.netbeans.modules.web.wizards.util.*;
import org.netbeans.modules.web.wizards.beanjsp.util.*;

import org.openide.util.*;


import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;


  
public class JSPBeanPropInitPanel extends StandardWizardPanel {
  

    // ---------------------------------------------------------------------------------------
    // WizardPanel initialization

    /** Creates new JSPBeanPropInitPanel */

    public JSPBeanPropInitPanel() {
	super();
	initComponents ();
    }
    public HelpCtx getHelp () {
	return new HelpCtx (JSPBeanPropInitPanel.class);
    }

  
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents () {

	java.util.ResourceBundle resBundle = NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle);
	//// create components 
		
	this.setTopMessage(resBundle.getString("JBW_PorpInitMsg")); // NOI18N

	  
	jspBeanPropInitLabel = new JLabel(resBundle.getString("JBW_PorpInitTableTitle")); // NOI18N	

        
	jspBeanPropInitTable = new JSPBeanPropInitTable();
        spanedTableColumnHeader = jspBeanPropInitTable.createSpanedTableColumnHeader();	  

	//// layout and add components
	  
	arrangeComponents();
	  
	//// create and add listeners	  	  
        jspBeanPropInitTableModel = JSPPageWizard.jspPageWizardModel.simpleJSPPage.getInitPropertiesModel();
	this.jspBeanPropInitTable.setTableModel(jspBeanPropInitTableModel);
	  
    }
	
    //// layout components in 
    private void arrangeComponents() {
	arrangeCompsWithGridBag();
    }
	
	
    private void arrangeCompsWithGridBag() {
	
	// this.contentPane.setLayout(new GridBagLayout());
		
	
	addGridBagComponent(this.contentPane,spanedTableColumnHeader,
			    0,0,1,1,
			    0,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);

	addGridBagComponent(this.contentPane,jspBeanPropInitTable,
			    0,1,1,1,
			    100,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
    }
	
    // Variables declaration - do not modify
	

    private javax.swing.JLabel jspBeanPropInitLabel;  
    private JSPBeanPropInitTable.SpanedTableColumnHeader spanedTableColumnHeader;	
    private JSPBeanPropInitTable jspBeanPropInitTable;  
    private JSPBeanPropInitTableModel jspBeanPropInitTableModel;
  
    // methods

    //TODO: implement this as listener to the bean variable name changes  

    public void updateJSPBeanVariableNameChange() {
	//// check all bean variable names  
	//todo you can check only those bean vars that are changed

	int size = jspBeanPropInitTableModel.getSize();
	Vector items = jspBeanPropInitTableModel.getItems();
	Iterator itemIterator = items.iterator();
	
	for(;itemIterator.hasNext();) {
	    JSPBeanField jspBeanField =
		(JSPBeanField)itemIterator.next();
	    jspBeanField.updateBeanVariableChange();
	}  
    }
    

    public void readSettings(Object setting) {
	updateJSPBeanVariableNameChange();
    }
  
    public static void main (String[] args) {
        if(Debug.TEST) {
            JFrame testFrame = new JFrame("This is Test Frame");    // NOI18N
            testFrame.getContentPane().add(new JSPBeanPropInitPanel(),SwingConstants.CENTER);
            testFrame.setSize(500,300);
            testFrame.pack();
            testFrame.show();
        }
    }
}
