/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package  org.netbeans.modules.web.wizards.beanjsp.ui;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import javax.swing.border.*;

import org.netbeans.modules.web.wizards.beanjsp.model.*;
import org.netbeans.modules.web.wizards.wizardfw.*;
import org.netbeans.modules.web.wizards.beanjsp.ide.*;

import org.netbeans.modules.web.wizards.util.*;
import org.netbeans.modules.web.wizards.beanjsp.util.*;

import org.openide.util.*;

  
  public class JSPBeanPropInitTable extends JScrollPane {
  
  public JSPBeanPropInitTable() {
	super();
    initComponents ();
  }

  private void initComponents () {

      propInitTable = new JTable();
	  this.setViewportView(propInitTable);
	  
	  propInitTableModel = new JSPBeanPropInitTableModel(new JSPVector());
	  setTableModel(propInitTableModel);
	  
	  propInitTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
	  
  }
        
  private javax.swing.JTable propInitTable;
  private JSPBeanPropInitTableModel propInitTableModel; 
  
  public void setTableModel(JSPBeanPropInitTableModel tableModel) {
	propInitTableModel = tableModel;
	propInitTable.setModel(propInitTableModel);
	propInitTable.setPreferredScrollableViewportSize(new Dimension(200,100));

	installPropInitEditors();
	
	adjustColumnWidths();  // call this after installing Editors to find right size
	
  }
  //// delegation to JTable

  public JTable getTable() { return propInitTable; }
  
  public void adjustColumnWidths() {
	
	TableColumn separatorColOne = propInitTable.getColumnModel().getColumn(JSPBeanPropInitTableModel.SEPERATOR_COL_1);
	TableColumn separatorColTwo = propInitTable.getColumnModel().getColumn(JSPBeanPropInitTableModel.SEPERATOR_COL_2);
	
	TableColumn createInitChkCol = propInitTable.getColumnModel().getColumn(JSPBeanPropInitTableModel.CREATE_INIT_CHK_COL);
	TableColumn accessInitChkCol = propInitTable.getColumnModel().getColumn(JSPBeanPropInitTableModel.ACCESS_INIT_CHK_COL);
	
	TableColumn createInitOptCol = propInitTable.getColumnModel().getColumn(JSPBeanPropInitTableModel.CREATE_INIT_OPT_COL);
	TableColumn accessInitOptCol = propInitTable.getColumnModel().getColumn(JSPBeanPropInitTableModel.ACCESS_INIT_OPT_COL);
	
	
	int sepeartorWidth = 4;
	separatorColOne.setPreferredWidth(sepeartorWidth);
	separatorColOne.setMinWidth(sepeartorWidth);
	separatorColOne.setMaxWidth(sepeartorWidth);
	separatorColOne.setResizable(false);
	
	separatorColTwo.setPreferredWidth(sepeartorWidth);
	separatorColTwo.setMinWidth(sepeartorWidth);
	separatorColTwo.setMaxWidth(sepeartorWidth);
	separatorColTwo.setResizable(false);
	
	JCheckBox chkBox = new JCheckBox();
	Dimension dim = chkBox.getMinimumSize();
	
	createInitChkCol.setPreferredWidth(dim.width);
	createInitChkCol.setMinWidth(dim.width);
	createInitChkCol.setMaxWidth(dim.width);
	createInitChkCol.setResizable(false);

	accessInitChkCol.setPreferredWidth(dim.width);
	accessInitChkCol.setMinWidth(dim.width);
	accessInitChkCol.setMaxWidth(dim.width);
	accessInitChkCol.setResizable(false);
	
	JComboBox initOptComp = new JComboBox(JSPBeanField.getInitOptions());
	dim = initOptComp.getMinimumSize();
	
	createInitOptCol.setPreferredWidth(dim.width);
	createInitOptCol.setMinWidth(dim.width);
	createInitOptCol.setMaxWidth(dim.width);
	createInitOptCol.setResizable(false);
	
	accessInitOptCol.setPreferredWidth(dim.width);
	accessInitOptCol.setMinWidth(dim.width);
	accessInitOptCol.setMaxWidth(dim.width);
	accessInitOptCol.setResizable(false);
	
	//// make seperator renderer

        DefaultTableCellRenderer sepRenderer = new DefaultTableCellRenderer () {
            public Component getTableCellRendererComponent(JTable table,
                                                           Object value,
                                                           boolean isSelected,
                                                           boolean hasFocus,
                                                           int row,
                                                           int column) {
                return super.getTableCellRendererComponent(table,value,false,hasFocus,row,column);
            }
        };
	
	sepRenderer.setBackground(Color.lightGray);
	
	separatorColOne.setCellRenderer(sepRenderer);
	separatorColOne.setHeaderRenderer(sepRenderer);
	
	separatorColTwo.setCellRenderer(sepRenderer);
	separatorColTwo.setHeaderRenderer(sepRenderer);
	
	propInitTable.sizeColumnsToFit(0);
	
	propInitTable.getTableHeader().setReorderingAllowed(false);
	
	propInitTable.repaint();
	
  }
  
  public void installPropInitEditors() {
		TableColumn createOptionColumn = 
			propInitTable.getColumnModel().getColumn(JSPBeanPropInitTableModel.CREATE_INIT_OPT_COL);

		TableColumn accessOptionColumn = 
			propInitTable.getColumnModel().getColumn(JSPBeanPropInitTableModel.ACCESS_INIT_OPT_COL);
		
		final JComboBox editorComp = new JComboBox(JSPBeanField.getInitOptions());
		DefaultCellEditor optionEditor = new DefaultCellEditor(editorComp) {
				// implements javax.swing.CellEditor
				public Object getCellEditorValue() {
				    return new Integer(editorComp.getSelectedIndex());
				}
		};
		
		DefaultTableCellRenderer optionRenderer = new  DefaultTableCellRenderer () {
				public Component getTableCellRendererComponent(JTable table,
                                               Object value,
                                               boolean isSelected,
                                               boolean hasFocus,
                                               int row,
											   int column) {
					JLabel comp = (JLabel)super.getTableCellRendererComponent(table,value,isSelected,
																	  hasFocus,row,column);
					int idx = ((Integer)value).intValue();
					String option = (String)editorComp.getItemAt(idx);
					comp.setText(option);
					return comp;
				}
			};
												 
		createOptionColumn.setCellEditor(optionEditor);
		accessOptionColumn.setCellEditor(optionEditor);
		
		createOptionColumn.setCellRenderer(optionRenderer);
		accessOptionColumn.setCellRenderer(optionRenderer);

  }
  
  
  
  public static JSPBeanPropInitTableModel createModel(JSPVector items) {
	  return new JSPBeanPropInitTableModel(items);
  }

  //---------------------------------------------------------------------------
  
  public SpanedTableColumnHeader createSpanedTableColumnHeader() {
	  return new SpanedTableColumnHeader();
  }
  
  public class SpanedTableColumnHeader extends JPanel {
      
      public SpanedTableColumnHeader() {
          super();
          initComponents ();
      }
      
      private void initComponents () {
          
          java.util.ResourceBundle resBundle = NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle);
          //// create components
          
          propLabel = new MultiLineLabel(resBundle.getString("JBW_PIT_PopSpanColName"));				// NOI18N
          createInitLabel = new MultiLineLabel(resBundle.getString("JBW_PIT_CreateInitSpanColName"));	// NOI18N
          accessInitLabel = new MultiLineLabel(resBundle.getString("JBW_PIT_AccessInitSpanColName"));	// NOI18N
          //// layout and add components
          
          arrangeComponents();
          
          //// create and add listeners
      }
	
	//// layout components in 
	private void arrangeComponents() {
		arrangeCompsWithGridBag();
	}
	
	private void addGridBagComponent(Container parent, Component comp, 
									 int gridx, int gridy, int gridwidth, int gridheight,
									 double weightx, double weighty,
									 int anchor, int fill,
									 Insets insets, int ipadx, int ipady
									 ) {
		GridBagConstraints cons = new GridBagConstraints();
		cons.gridx = gridx;
		cons.gridy = gridy;
		cons.gridwidth = gridwidth;
		cons.gridheight = gridheight;
		cons.weightx = weightx;
		cons.weighty = weighty;
		cons.anchor = anchor;
		cons.fill = fill;
		cons.insets = insets;
		cons.ipadx = ipadx;
		cons.ipady = ipady;
		parent.add(comp,cons);
	}
	
	private void arrangeCompsWithGridBag() {
	
		this.setLayout(new GridBagLayout());
		
		int gridy = 0;	
		addGridBagComponent(this,propLabel,
							0,0,1,1,
							100,100,
							GridBagConstraints.WEST, GridBagConstraints.BOTH,
							new Insets(2,2,2,2),5,5	);		addGridBagComponent(this,createInitLabel,
							1,0,1,1,
							100,100,
							GridBagConstraints.WEST, GridBagConstraints.BOTH,
							new Insets(2,2,2,2),5,5	);
		addGridBagComponent(this,accessInitLabel,
							2,0,1,1,
							100,100,
							GridBagConstraints.WEST, GridBagConstraints.BOTH,
							new Insets(2,2,2,2),5,5	);
	}	
    // Variables declaration - do not modify
	private MultiLineLabel propLabel;
	private MultiLineLabel createInitLabel;
	private MultiLineLabel accessInitLabel;	  }
  
  //---------------------------------------------------------------------------
	
  public static void main(String[] args) {
	  
  }
  
}


