/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package  org.netbeans.modules.web.wizards.beanjsp.ui;

import org.netbeans.modules.web.wizards.beanjsp.model.*;
import org.netbeans.modules.web.wizards.wizardfw.*;
import org.netbeans.modules.web.wizards.beanjsp.ide.*;

import org.netbeans.modules.web.wizards.util.*;
import org.netbeans.modules.web.wizards.beanjsp.util.*;

import org.openide.util.*;
import org.openide.loaders.DataFolder;
import org.openide.loaders.DataObject;import org.openide.filesystems.*;
import org.openide.filesystems.FileObject;import org.openide.TopManager;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;

public class JSPBeansSelectionPanel extends StandardWizardPanel {
  
    public JSPBeansSelectionPanel() {
	super();
	initComponents ();
    }

    public HelpCtx getHelp () {
	return new HelpCtx (JSPBeansSelectionPanel.class);
    }

    private void initComponents () {

	java.util.ResourceBundle resBundle = NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle);
	loadSubPackageBeansLabel = resBundle.getString("JBW_BeanSubPackageBrowseCheckBLabel");	 	    // NOI18N
	//// create components 
		
	this.setTopMessage(resBundle.getString("JBW_JSPBeansSelectionMsg"));						 // NOI18N
	beanPackagePanel = new javax.swing.JPanel();	    
	beanPackageMsg = new MultiLineLabel(resBundle.getString("JBW_BeanPackageMsg"));			 // NOI18N
	beanPackageLabel = new JLabel(resBundle.getString("JBW_BeanPackageLabel"));				 // NOI18N
	//beanPackageCombo = new javax.swing.JComboBox();
	//beanPackageCombo.setEditable(false); 
		
	beanPackageList = new javax.swing.JList();
	beanPackageSPane = new JScrollPane(beanPackageList);
	  
	beanPackageSPane.setPreferredSize (new java.awt.Dimension(150, 50));
        beanPackageSPane.setMinimumSize (new java.awt.Dimension(150, 50));
        beanPackageSPane.setMaximumSize (new java.awt.Dimension(150, 50));
					  
	//beanPackageTF = new javax.swing.JTextField (30);	    
	// beanPackageTF.setEnabled(false);
	//beanPackageTF.setEditable(false);
	//beanPackageTF.setBackground (java.awt.Color.lightGray);
        
	beanPackageBrowseB = new JButton (resBundle.getString("JBW_BeanPackageBrowseBLabel"));	 // NOI18N	
	// netbeans convention
	beanPackageBrowseB.setFont (new java.awt.Font ("SansSerif", 0, 11));					 // NOI18N
	beanPackageBrowseB.setMinimumSize (new java.awt.Dimension(85, 15));
	beanPackageBrowseB.setMaximumSize (new java.awt.Dimension(85, 27));
	beanPackageBrowseB.setPreferredSize (new java.awt.Dimension(85, 25));
	  	  
	beansLabel = new JLabel(resBundle.getString("JBW_JSPBeansListName"));						 // NOI18N
	beansList = new JList();
	beansSPane = new JScrollPane(beansList);
	  
	beansSPane.setPreferredSize (new java.awt.Dimension(150, 150));
	beansSPane.setMinimumSize (new java.awt.Dimension(150, 150));
	beansSPane.setMaximumSize (new java.awt.Dimension(150, 150));
	  
	  
	//NB beansRepository = RepositoryBeanViewPane.createRepositoryBeanViewPane();

	useBeansLabel = new JLabel(resBundle.getString("JBW_JSPBeansTableName"));					 // NOI18N
	useBeansTable = new JSPUseBeanTable();

	// buttonsPanel = new javax.swing.JPanel();
	  
	buttonsPanel = new ButtonBarPanel(new int[] {ButtonBarPanel.ADD,
						     ButtonBarPanel.REMOVE,
						     ButtonBarPanel.MOVE_UP,
						     ButtonBarPanel.MOVE_DOWN });	  
	//// layout and add components
	arrangeComponents();	  

	//// create models
	createModels();	  
	//// configure listeners 
	addButtonBarActionListeners();	  
	addBrowseButtonActionListener();
	addSelectionListeners();
	addDoubleClickListeners();
	  
	setButtonPanelButtonStates();	  
    }
	
    //// layout components in 
    private void arrangeComponents() {		
	createBeanPackageComponents();
	arrangeCompsWithGridBag();
    }
	
    public void createBeanPackageComponents() {
	
	beanPackagePanel.setLayout(new GridBagLayout());
		
	Component packPanelSep = Box.createVerticalStrut(2);
	int gridy = 0;
	addGridBagComponent(this.beanPackagePanel,beanPackageMsg,
			    0,gridy,3,1,
			    0,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.beanPackagePanel,beanPackageLabel,
			    0,++gridy,1,1,
			    0,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.beanPackagePanel,beanPackageSPane, 
			    // beanPackageCombo, // beanPackageTF,
			    1,gridy,1,1,
			    100,0,
			    GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.beanPackagePanel,beanPackageBrowseB,
			    2,gridy,1,1,
			    0,0,
			    GridBagConstraints.NORTHWEST, GridBagConstraints.HORIZONTAL,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.beanPackagePanel,packPanelSep,
			    0,++gridy,3,1,
			    100,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
    }	
    
    private void arrangeCompsWithGridBag() {
	
	// this.contentPane.setLayout(new GridBagLayout());
		
	int gridy = 0;				
	addGridBagComponent(this.contentPane,beanPackagePanel,
			    0,gridy,3,1,
			    0,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
	
	addGridBagComponent(this.contentPane,beansLabel,
			    0,++gridy,1,1,
			    0,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);

	addGridBagComponent(this.contentPane,useBeansLabel,
			    2,gridy,1,1,
			    100,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,beansSPane,
			    0,++gridy,1,1,
			    0,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,buttonsPanel,
			    1,gridy,1,1,
			    0,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,useBeansTable,
			    2,gridy,1,1,
			    100,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
    }
	
    private void createModels() {
		
	//// add models	  
	JSPPageWizardModel jspPageWizardModel =
	    JSPPageWizard.jspPageWizardModel;	 
	JSPPage simpleJSPPage = jspPageWizardModel.simpleJSPPage; 
	beanPackageModel = jspPageWizardModel.getBeanPackagesModel();
	beanPackageList.setModel(beanPackageModel);
	beanPackageList.setCellRenderer(new DefaultListCellRenderer() {
		public Component getListCellRendererComponent(
							      JList listbox, 
							      Object value, 
							      int index, 
							      boolean isSelected, 
							      boolean cellHasFocus) {
		    JLabel comp = (JLabel) super.getListCellRendererComponent(listbox,value,index,isSelected,cellHasFocus);
		    DataFolder packageFolder = (DataFolder) value;
		    if(packageFolder != null) {
			String beanPackageName = packageFolder.getPrimaryFile().getPackageName('.');						comp.setText(beanPackageName);
		    }					return comp;
		}
	    });
	  
	beansListModel = jspPageWizardModel.getAvailableBeansModel();
	beansList.setModel(beansListModel);
	  
	useBeansTableModel = simpleJSPPage.getJSPBeansModel();
	this.useBeansTable.setTableModel(useBeansTableModel);
    }	  

    private void addButtonBarActionListeners() {
	buttonsPanel.addActionListener(ButtonBarPanel.ADD, new
	    ActionListener() { 
		public void actionPerformed(ActionEvent evt) {
		    addToUseBeansList();
		}
	    });

	buttonsPanel.addActionListener(ButtonBarPanel.REMOVE, new
	    ActionListener() { 
		public void actionPerformed(ActionEvent evt) {
		    removeFromUseBeansList();
		}
	    });	  	  

	buttonsPanel.addActionListener(ButtonBarPanel.MOVE_UP, new
	    ActionListener() { 
		public void actionPerformed(ActionEvent evt) {
		    moveUpUseBean();
		}
	    });

	buttonsPanel.addActionListener(ButtonBarPanel.MOVE_DOWN, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    moveDownUseBean();
		}
	    });
    }    

    private void addBrowseButtonActionListener() {
	beanPackageBrowseB.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    browseForBeanPacakge();  		  }
	    });
    }

    private void addSelectionListeners(){
	beansList.addListSelectionListener(new ListSelectionListener(){
		public void valueChanged(ListSelectionEvent e){
		    setButtonPanelButtonStates();
		}
	    });
	
	useBeansTable.getTable().getSelectionModel().addListSelectionListener
    (new ListSelectionListener(){
	    public void valueChanged(ListSelectionEvent e){ 
		setButtonPanelButtonStates();
	    }
	});
    }

    private void addDoubleClickListeners(){
	beansList.addMouseListener (new java.awt.event.MouseAdapter () {
		public void mouseClicked (java.awt.event.MouseEvent evt) {
		    beansListMouseClicked(evt);
		}
	    });
	
	useBeansTable.getTable().addMouseListener (new java.awt.event.MouseAdapter () {
		public void mouseClicked (java.awt.event.MouseEvent evt) {
		    useBeansTableMouseClicked(evt);
		}
	    });
    }
		
    // Variables declaration - do not modify//GEN-BEGIN:variables
	
  
    private javax.swing.JScrollPane beansSPane;
    private javax.swing.JList beansList;
    private javax.swing.JLabel beansLabel;
  
    //NB private RepositoryBeanViewPane beansRepository;
  
    private ButtonBarPanel buttonsPanel;
  
    private javax.swing.JLabel useBeansLabel;
    private JSPUseBeanTable useBeansTable;
  
    private javax.swing.JPanel beanPackagePanel; 
    private MultiLineLabel beanPackageMsg;
    private javax.swing.JLabel beanPackageLabel;
    //private javax.swing.JTextField beanPackageTF;
    // private javax.swing.JComboBox beanPackageCombo;
    javax.swing.JList beanPackageList;
    private javax.swing.JScrollPane beanPackageSPane;  
    private javax.swing.JButton beanPackageBrowseB;  
    // store locally for avoiding reloading beans when same pacakge is
    // selected multiple   // times or when navigating back and forth
    // from this panel  // DataFolder beanPakFolder = null; 

    private JSPItemListModel beansListModel;
    private JSPBeanTableModel useBeansTableModel;    
    private JSPItemListModel beanPackageModel;
  
    private boolean loadSubPackageBeans = false;  
    private String loadSubPackageBeansLabel = "";			// NOI18N  
    
    // End of variables declaration//GEN-END:variables     

    public void setButtonPanelButtonStates() {	
	int leftSize = beansListModel.getSize();
	int[] leftSelectionIndices = beansList.getSelectedIndices();
	  
	int rightSize = useBeansTable.getTable().getRowCount(); 
	int[] rightSelectionIndices =
	    useBeansTable.getTable().getSelectedRows();
	buttonsPanel.setButtonsState(leftSize,leftSelectionIndices,
				     rightSize,rightSelectionIndices);
    } 
    
    public void addToUseBeansList() {
	int[] idx = beansList.getSelectedIndices();
	int oldRows = useBeansTable.getTable().getRowCount(); 
	if( (idx.length > 0) && (idx[0] >= 0)) {
	    for (int i=0; i<idx.length; i++) {
		// Object obj = beansListModel.remove(idx);
		JSPBean jspBean = (JSPBean) beansListModel.get(idx[i]);		  
		useBeansTableModel.add((JSPBean)jspBean.clone());
	    }
	    int rows = useBeansTable.getTable().getRowCount();
	    useBeansTable.getTable().getSelectionModel().setSelectionInterval
		(oldRows, rows-1);
	    setButtonPanelButtonStates();
	}
    }
  
    public void removeFromUseBeansList() {
	int[] idx = useBeansTable.getTable().getSelectedRows();
	int count = 0;
	if((idx.length > 0) && (idx[0] >= 0)) {
	    for (int i=0; i<idx.length; i++) { 
		// always remove item 0, since index gets rearranged
		Object obj = useBeansTableModel.remove(idx[0]-count);
		count++;
	    }
	    setButtonPanelButtonStates();		
	}
    }
  
    public void moveUpUseBean() {
	int[] idx = useBeansTable.getTable().getSelectedRows();
	if((idx.length > 0) && (idx[0] > 0 )) {
	    for (int i=0; i<idx.length; i++){      
		// idx = useBeansTableModel.moveUp(idx);
		useBeansTableModel.moveUp(idx[i]);
	    }
	    useBeansTable.getTable().getSelectionModel().setSelectionInterval(
									      idx[0]-1, idx[idx.length-1]-1);
	    setButtonPanelButtonStates();
	}
    }
  
    public void moveDownUseBean() {
	int[] idx = useBeansTable.getTable().getSelectedRows();
	int rowCount = useBeansTable.getTable().getRowCount();
	if((idx.length >0) && (idx[0] >= 0) && 
	   (idx[idx.length-1] < rowCount-1)) { 
	    for (int i=idx.length-1; i>=0; i--){
		useBeansTableModel.moveDown(idx[i]);
	    }
	    useBeansTable.getTable().getSelectionModel().setSelectionInterval(
									  idx[0]+1,idx[idx.length-1]+1);
	    setButtonPanelButtonStates();
	}
    }

			

    private void beansListMouseClicked(java.awt.event.MouseEvent evt) {
	if (evt.getClickCount() == 2) {
	    addToUseBeansList();
	}
    }

    private void useBeansTableMouseClicked(java.awt.event.MouseEvent evt) {
	if (evt.getClickCount() == 2) {
	    removeFromUseBeansList();
	}
    }
       
    /* this method gets called on next && prev */ 
    public void readSettings(Object setting) {
	setButtonPanelButtonStates();  
    }
    
    private void browseForBeanPacakge() {
	boolean beansFound = false;
	JCheckBox loadSubPackageBeansCheckB = new
	    JCheckBox(loadSubPackageBeansLabel,loadSubPackageBeans); 
	DataFolder beanPakFolder =
	    IDEHelper.browseForBeanPackage(loadSubPackageBeansCheckB); 
	loadSubPackageBeans = loadSubPackageBeansCheckB.isSelected();	
	if(beanPakFolder == null ) return;
	
	beansFound =
	    JSPPageWizard.jspPageWizardModel.addToAvailableBeansFromBeanPackage(beanPakFolder);		

	if(loadSubPackageBeans) { 
	    FileObject folderFileObj = beanPakFolder.getPrimaryFile();
	    Enumeration enum = folderFileObj.getFolders(true); 
	    

	    for(; enum.hasMoreElements();) {			
		try {
		    folderFileObj = (FileObject)enum.nextElement();
		    beanPakFolder = (DataFolder)DataObject.find(folderFileObj);
		    beansFound =
			JSPPageWizard.jspPageWizardModel.addToAvailableBeansFromBeanPackage(beanPakFolder); 
		}
		catch(Exception ex) {Debug.print(ex);} 
		// ignore it safely and continue...		
	    }
	}		
	if(!beansFound) {
	    IDEHelper.showWarningMessageI18N("JBW_BeansNotFoundMsg"); 
	    
	}
    }   
 
    public static void main(String[] args) {	  if( Debug.TEST ) {
	
	JFrame testFrame = new JFrame("This is Test Frame");		 // NOI18N
	testFrame.getContentPane().add(new JSPBeansSelectionPanel(),SwingConstants.CENTER);
	testFrame.setSize(500,300);
	testFrame.pack();
	testFrame.show();	  }
    }
}
