/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package  org.netbeans.modules.web.wizards.beanjsp.ui;

import org.netbeans.modules.web.wizards.beanjsp.model.*;
import org.netbeans.modules.web.wizards.wizardfw.*;
import org.netbeans.modules.web.wizards.beanjsp.ide.*;

import org.netbeans.modules.web.wizards.util.*;
import org.netbeans.modules.web.wizards.beanjsp.util.*;

import org.openide.util.*;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;

  
public class JSPBizMethodsPanel extends StandardWizardPanel {
  
  
  public JSPBizMethodsPanel() {
    super();
    initComponents ();
  }

  public HelpCtx getHelp () {
    return new HelpCtx (JSPBizMethodsPanel.class);
  }
  
    private void initComponents () {

	java.util.ResourceBundle resBundle =
	    NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle); 
	  
	//// create components 
		
	this.setTopMessage(resBundle.getString("JBW_BizMethodsMsg")); // NOI18N

	beanMethodsLabel = new JLabel(resBundle.getString("JBW_AvailableBeansMethodsListTitle"));				 // NOI18N	

	beanMethodsList = new JList();
	beanMethodsSPane = new JScrollPane(beanMethodsList);

	useBeanMethodsLabel = new JLabel(resBundle.getString("JBW_UseBeansMethodsListTitle"));				 // NOI18N	

	useBeanMethodsList = new JList();
	useBeanMethodsSPane = new JScrollPane(useBeanMethodsList); 
	
	// useBeanMethodsTable = new JSPBeanMethodTable();
	  
	beanMethodsSPane.setPreferredSize (new java.awt.Dimension(200, 200));
	useBeanMethodsSPane.setPreferredSize (new
	    java.awt.Dimension(200, 200));	  	       

	methodEditButton = new javax.swing.JButton ();
	methodEditButton.setText (resBundle.getString("JBW_MethodEditorButton"));				 // NOI18N
	  
	// buttonsPanel = new javax.swing.JPanel();
	buttonsPanel = new ButtonBarPanel();
	  
	//// layout and add components
	  
	arrangeComponents();
	  
	//// create and add listeners and models
	//// create models	  
	createModels();	  
	//// configure listeners 
	addMethodEditButtonActionListener();
	addButtonBarActionListeners();
	addSelectionListeners();
	addDoubleClickListeners();	  	  
	setButtonPanelButtonStates();
    }
	
    //// layout components in 
    private void arrangeComponents() {
	arrangeCompsWithGridBag();
    }
	
    private void arrangeCompsWithGridBag() {
	
	// this.contentPane.setLayout(new GridBagLayout());
		
	
	addGridBagComponent(this.contentPane,beanMethodsLabel,
			    0,0,1,1,
			    100,0,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	);

	addGridBagComponent(this.contentPane,useBeanMethodsLabel,
			    2,0,1,1,
			    100,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
	
	addGridBagComponent(this.contentPane,beanMethodsSPane,
			    0,1,1,1,
			    100,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,buttonsPanel,
			    1,1,1,1,
			    0,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,useBeanMethodsSPane, 
			    // useBeanMethodsTable, 
			    // useBeanMethodsSPane,
			    2,1,1,1,
			    100,100,
			    GridBagConstraints.CENTER,
			    GridBagConstraints.BOTH, 
			    new Insets(2,2,2,2),5,5	); 
	

	addGridBagComponent(this.contentPane,methodEditButton, 
			    2,2,1,1,
			    0,0,
			    GridBagConstraints.EAST,
			    GridBagConstraints.NONE, 
			    new Insets(2,2,2,2),5,5	);
		
	}		

    private void createModels() {			  

	JSPPageWizardModel jspPageWizardModel =
	    JSPPageWizard.jspPageWizardModel;	 
	JSPPage simpleJSPPage = jspPageWizardModel.simpleJSPPage;		
	beanMethodsModel = jspPageWizardModel.getAvailableBeanMethodsModel();
	beanMethodsList.setModel(beanMethodsModel);
	  
	useBeanMethodsModel = simpleJSPPage.getMethodCallsModel();
	this.useBeanMethodsList.setModel(useBeanMethodsModel);	  

	// this.useBeanMethodsTable.setTableModel(useBeanMethodsModel);
    }	

    private void addButtonBarActionListeners() {
	buttonsPanel.addActionListener(ButtonBarPanel.ADD, new
	    ActionListener() { 
		public void actionPerformed(ActionEvent evt) {
		    addToUseBeanMethodsList();
		}
	    });

	buttonsPanel.addActionListener(ButtonBarPanel.REMOVE, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    removeFromUseBeanMethodsList();
		}
	    });	  	  buttonsPanel.addActionListener(ButtonBarPanel.ADD_ALL, new ActionListener() {
		    public void actionPerformed(ActionEvent evt) {
			addAllToUseBeanMethodsList();
		    }
		});

	buttonsPanel.addActionListener(ButtonBarPanel.REMOVE_ALL, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    removeAllFromUseBeanMethodsList();
		}
	    });
	  	  
	buttonsPanel.addActionListener(ButtonBarPanel.MOVE_UP, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    moveUpUseBeanMethod();
		}
	    });

	buttonsPanel.addActionListener(ButtonBarPanel.MOVE_DOWN, new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    moveDownUseBeanMethod();
		}
	    });
    }    private void addMethodEditButtonActionListener() {
	methodEditButton.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    startMethodEditing();
		}
	    });  
    }

    private void addSelectionListeners(){
	beanMethodsList.addListSelectionListener(new ListSelectionListener(){
		public void valueChanged(ListSelectionEvent e){
		    setButtonPanelButtonStates();
		}
	    });
	// useBeanMethodsTable.getTable().getSelectionModel().addListSelectionListener(		

	useBeanMethodsList.addListSelectionListener(new ListSelectionListener(){
		public void valueChanged(ListSelectionEvent e){
		    setButtonPanelButtonStates();
		}
	    });
    }

    private void addDoubleClickListeners(){
	beanMethodsList.addMouseListener (new java.awt.event.MouseAdapter () {
		public void mouseClicked (java.awt.event.MouseEvent evt) {
		    beanMethodsListMouseClicked(evt);
		}
	    });


	// useBeanMethodsTable.getTable().addMouseListener (new
	// java.awt.event.MouseAdapter () {		

	useBeanMethodsList.addMouseListener (new java.awt.event.MouseAdapter () {			
		public void mouseClicked (java.awt.event.MouseEvent evt) {
		    useBeanMethodsListMouseClicked(evt);
		}
	    });
    }
	
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
	
    private javax.swing.JLabel titleLabel;
  
    private javax.swing.JScrollPane beanMethodsSPane;
    private javax.swing.JList beanMethodsList;
    private javax.swing.JLabel beanMethodsLabel;
  
    // private javax.swing.JPanel buttonsPanel;  
    private ButtonBarPanel buttonsPanel;
    private javax.swing.JLabel useBeanMethodsLabel;  
    private javax.swing.JScrollPane useBeanMethodsSPane;
    private javax.swing.JList useBeanMethodsList;
    private javax.swing.JButton methodEditButton;
    //private JSPBeanMethodTable useBeanMethodsTable;
  
    private JSPItemListModel beanMethodsModel;
    private JSPItemListModel useBeanMethodsModel;
    // private JSPBeanMethodTable.JSPBeanMethodTableModel useBeanMethodsModel;
  
    // methods
    public void setButtonPanelButtonStates() {	

	int leftSize = beanMethodsModel.getSize();
	int[] leftSelectionIndices = beanMethodsList.getSelectedIndices();
	  
	int rightSize = useBeanMethodsModel.getSize();
	int[] rightSelectionIndices =
	    useBeanMethodsList.getSelectedIndices();		

	buttonsPanel.setButtonsState(leftSize,leftSelectionIndices,
				     rightSize,rightSelectionIndices);
	methodEditButton.setEnabled(( rightSize > 0  &&
				      rightSelectionIndices.length > 0 )); 
    }    

    
    public void startMethodEditing() {
	  
	int[] idx = useBeanMethodsList.getSelectedIndices();
	if(idx.length > 0) {		  

	    JSPBeanMethod jspBeanMethod =
		(JSPBeanMethod)useBeanMethodsModel.get(idx[0]); 
	    

	    JSPBeanMethodEditor.editJSPBeanMethod(jspBeanMethod);
	} 
    }    

    public void addAllToUseBeanMethodsList() {
	JSPVector addMethods = beanMethodsModel.getItems();
	useBeanMethodsModel.addItems(addMethods);
	beanMethodsModel.removeAll();
	setButtonPanelButtonStates();
    }
  
    public void removeAllFromUseBeanMethodsList() {
	// JSPVector removeMethods =
	// useBeanMethodsModel.getJSPBeanMethods();	  
	JSPVector removeMethods = useBeanMethodsModel.getItems();
	beanMethodsModel.addItems(removeMethods);
	useBeanMethodsModel.removeAll();
	setButtonPanelButtonStates();
    }
    
    public void addToUseBeanMethodsList() {
	int[] idx = beanMethodsList.getSelectedIndices();
	int count = 0;
	// int	oldRows = useBeanMethodsTable.getTable().getRowCount();
	int	oldRows = useBeanMethodsModel.getSize();		
	if( (idx.length > 0) && (idx[0] >= 0)){
	    for (int i=0; i<idx.length; i++) {
		Object obj = beanMethodsModel.remove(idx[i]-count);
		useBeanMethodsModel.add((JSPBeanMethod)obj);				count++;
	    }
	    // set selection display fields
	    int rows = useBeanMethodsModel.getSize();
	    useBeanMethodsList.getSelectionModel().setSelectionInterval(oldRows, rows-1);			
	    // int rows = useBeanMethodsTable.getTable().getRowCount();
	    // useBeanMethodsTable.getTable().getSelectionModel().setSelectionInterval(oldRows, rows-1);			 

	    setButtonPanelButtonStates();
	}
    }
  
    public void removeFromUseBeanMethodsList() {
	// int[] idx =
	// useBeanMethodsTable.getTable().getSelectedRows(); 
	// 
	int[] idx = useBeanMethodsList.getSelectedIndices();
	int		count = 0;
	int oldRows = beanMethodsModel.getSize();
	if((idx.length > 0) && (idx[0] >= 0)) {
	    for (int i=0; i<idx.length; i++) {
		Object obj = useBeanMethodsModel.remove(idx[i]-count);
		beanMethodsModel.add(obj);
		count++;
	    }
	    // set selection display fields
	    int rows = beanMethodsModel.getSize();
	    beanMethodsList.getSelectionModel().setSelectionInterval(oldRows, rows-1);
	    setButtonPanelButtonStates();
	}
    }
  
    public void moveUpUseBeanMethod() {
	//int[] idx = useBeanMethodsTable.getTable().getSelectedRows();	  

	int[] idx = useBeanMethodsList.getSelectedIndices();
	if((idx.length > 0) && (idx[0] > 0 )) {
	    for (int i=0; i<idx.length; i++){
	    	useBeanMethodsModel.moveUp(idx[i]);
	    }
	    // useBeanMethodsTable.getTable().getSelectionModel().setSelectionInterval(idx[0]-1, idx[idx.length-1]-1);	
		
	    useBeanMethodsList.getSelectionModel().setSelectionInterval(idx[0]-1, idx[idx.length-1]-1);	
	    setButtonPanelButtonStates();
	}
    }
  
    public void moveDownUseBeanMethod() {
	// int[] idx = useBeanMethodsTable.getTable().getSelectedRows();
	// int rowCount =
	// useBeanMethodsTable.getTable().getRowCount();	    

	int[] idx = useBeanMethodsList.getSelectedIndices(); 
	int rowCount = useBeanMethodsModel.getSize();
	if((idx.length >0) && (idx[0] >= 0) && (idx[idx.length-1] < rowCount-1)) {
	    for (int i=idx.length-1; i>=0; i--){
		useBeanMethodsModel.moveDown(idx[i]);
	    }
		

	    //
	    // useBeanMethodsTable.getTable().getSelectionModel().setSelectionInterval(idx[0]+1,idx[idx.length-1]+1);				

	    useBeanMethodsList.getSelectionModel().setSelectionInterval(idx[0]+1,idx[idx.length-1]+1);	
	    
	    setButtonPanelButtonStates();
	}
    }    

    private void beanMethodsListMouseClicked(java.awt.event.MouseEvent evt) {
	if (evt.getClickCount() == 2) {
	    addToUseBeanMethodsList();
	}
    }

    private void useBeanMethodsListMouseClicked(java.awt.event.MouseEvent evt) {
	if (evt.getClickCount() == 2) {
	    removeFromUseBeanMethodsList();
	}
  }    

    public void readSettings(Object setting) {
	setButtonPanelButtonStates();  
    }
		
    public static void main(String[] args) {	  

	if(Debug.TEST) {
	    JFrame testFrame = new JFrame("This is Test Frame"); // NOI18N
	    testFrame.getContentPane().add(new JSPBizMethodsPanel(),SwingConstants.CENTER);
	    testFrame.setSize(500,300);
	    testFrame.pack();
	    testFrame.show();	  }
    }
}
