/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package  org.netbeans.modules.web.wizards.beanjsp.ui;

import javax.swing.*;
import javax.swing.event.*;
import java.beans.*;

import java.awt.*;
import java.awt.event.*;

import org.netbeans.modules.web.wizards.beanjsp.model.*;
import org.netbeans.modules.web.wizards.wizardfw.*;
import org.netbeans.modules.web.wizards.beanjsp.ide.*;

import org.netbeans.modules.web.wizards.util.*;
import org.netbeans.modules.web.wizards.beanjsp.util.*;

import org.netbeans.modules.web.templates.model.DWBeanTemplate;
import java.io.*;

import org.openide.util.*;
import org.openide.loaders.DataFolder;
import org.openide.filesystems.*;


public class JSPPageNameAndStyleInfoPanel extends StandardWizardPanel {

    // ---------------------------------------------------------------------------------------
    // WizardPanel initialization

    /** Creates new BeanTypePanel */
	
    public JSPPageNameAndStyleInfoPanel() {
	super();
	initComponents ();
    }

    public HelpCtx getHelp () {
	return new HelpCtx (JSPPageNameAndStyleInfoPanel.class);
    }
  
    private void initComponents () {

	java.util.ResourceBundle resBundle = NbBundle.getBundle(JSPPageWizardGlobals.jspPageWizardI18NBundle);
	
	this.setTopMessage(resBundle.getString("JBW_JSPPageNameAndStyleInfoMsg"));				 // NOI18N
	  
	//// create components

	jspPageTemplateLabel = new JLabel(resBundle.getString("JBW_JSPTemplateLabel"));					 // NOI18N
	jspPageTemplateTF = new javax.swing.JTextField (30);
	jspPageTemplateBrowseB = new JButton (resBundle.getString("JBW_JSPTemplateBrowseBLabel"));		 // NOI18N
	// netbeans convention
	jspPageTemplateBrowseB.setFont (new java.awt.Font ("SansSerif", 0, 11));						 // NOI18N
	jspPageTemplateBrowseB.setMinimumSize (new java.awt.Dimension(85, 15));
	jspPageTemplateBrowseB.setMaximumSize (new java.awt.Dimension(85, 25));
	jspPageTemplateBrowseB.setPreferredSize (new java.awt.Dimension(85, 25));
	  
	pageFormStyleLabel = new JLabel(resBundle.getString("JBW_JSPFormStyleLabel"));			 // NOI18N
	pageFormStyleCombo = new JComboBox();
	  
	pageNameLabel = new JLabel(resBundle.getString("JBW_JSPPageNameLabel"));					 // NOI18N
	pageNameTF = new JTextField(30);	  	  jspFolderLabel = new JLabel(resBundle.getString("JBW_JSPFolderLabel"));					 // NOI18N
	jspFolderTF = new javax.swing.JTextField (30);
	// jspFolderTF.setEnabled(false);
	jspFolderTF.setEditable(false);
	jspFolderTF.setBackground (java.awt.Color.lightGray);
        jspFolderBrowseB = new JButton (resBundle.getString("JBW_JSPFolderBrowseBLabel"));		 // NOI18N
	// netbeans convention
	jspFolderBrowseB.setFont (new java.awt.Font ("SansSerif", 0, 11));						 // NOI18N
	jspFolderBrowseB.setMinimumSize (new java.awt.Dimension(85, 15));
	jspFolderBrowseB.setMaximumSize (new java.awt.Dimension(85, 25));
	jspFolderBrowseB.setPreferredSize (new java.awt.Dimension(85, 25));
	  	  
	//// layout components
	arrangeComponents();
	  
	//// setup models
	  
	pageFormStyleCombo.setModel(new DefaultComboBoxModel(HTMLForm.getFormStyles()));
	  
	this.setDefaults();
	  
	  
	pageFormStyleCombo.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    JComboBox cb = (JComboBox)e.getSource();
		    formStyle = cb.getSelectedIndex();
		}
	    });
	
	jspFolderBrowseB.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent evt) {
		    browseForJSPFolder();
		}
	    });	  	  jspPageTemplateBrowseB.addActionListener( new ActionListener() {
		    public void actionPerformed(ActionEvent evt) {
			browseForJSPPageTemplate();
		    }
		});
	  
		
    }

    //// layout components in 
    private void arrangeComponents() {
	arrangeCompsWithGridBag();
    }
	
	
    private void arrangeCompsWithGridBag() {
	
	//this.contentPane.setLayout(new GridBagLayout());
		
	int gridy = 0;
		
	Component topGlue = Box.createGlue();
	Component styleGlue = Box.createVerticalStrut(10);
		
	Component bottomGlue = Box.createGlue();
		
	addGridBagComponent(this.contentPane,topGlue,
			    0,gridy,2,1,
			    100,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);				addGridBagComponent(this.contentPane,jspPageTemplateLabel,
													    0,++gridy,1,1,
													    0,0,
													    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
													    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,jspPageTemplateTF,
			    1,gridy,1,1,
			    100,0,
			    GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,jspPageTemplateBrowseB,
			    2,gridy,1,1,
			    0,0,
			    GridBagConstraints.WEST, GridBagConstraints.NONE,
			    new Insets(2,2,2,2),5,5	);
		

	addGridBagComponent(this.contentPane,pageFormStyleLabel,
			    0,++gridy,1,1,
			    0,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,pageFormStyleCombo,
			    1,gridy,1,1,
			    100,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);		addGridBagComponent(this.contentPane,styleGlue,
											    0,++gridy,3,1,
											    100,0,
											    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
											    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,pageNameLabel,
			    0,++gridy,1,1,
			    0,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,pageNameTF,
			    1,gridy,1,1,
			    100,0,
			    GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
			    new Insets(2,2,2,2),5,5	);				
	addGridBagComponent(this.contentPane,jspFolderLabel,
			    0,++gridy,1,1,
			    0,0,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,jspFolderTF,
			    1,gridy,1,1,
			    100,0,
			    GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
			    new Insets(2,2,2,2),5,5	);
		
	addGridBagComponent(this.contentPane,jspFolderBrowseB,
			    2,gridy,1,1,
			    0,0,
			    GridBagConstraints.WEST, GridBagConstraints.NONE,
			    new Insets(2,2,2,2),5,5	);
		
		
	addGridBagComponent(this.contentPane,bottomGlue,
			    0,++gridy,3,1,
			    100,100,
			    GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			    new Insets(2,2,2,2),5,5	);			}
	
	

    // Variables declaration - do not modify//GEN-BEGIN:variables
  
    private javax.swing.JLabel pageNameLabel;	
    private javax.swing.JTextField pageNameTF;
    private javax.swing.JLabel jspFolderLabel;
    private javax.swing.JTextField jspFolderTF;
    private javax.swing.JButton jspFolderBrowseB;
    private javax.swing.JLabel jspPageTemplateLabel;
    private javax.swing.JTextField jspPageTemplateTF;
    private javax.swing.JButton jspPageTemplateBrowseB;
    
    private javax.swing.JLabel pageFormStyleLabel; 	  	  
    private javax.swing.JComboBox pageFormStyleCombo;
  
    private javax.swing.JLabel pageInfoMsgLabel; 	  	      
    public static final String DEF_JSPPAGE_TLT  = "Default Template"; // NOI18N
  
    private String templateName = DEF_JSPPAGE_TLT;
    private int formStyle = HTMLForm.FS_COLUMN;
  
    
    public void rearrangeComponents() {
	this.contentPane.removeAll();
	arrangeComponents();
    }
  
    public String getPageName() { return pageNameTF.getText(); }
    public void setPageName(String pageName) {pageNameTF.setText(pageName);}
  
    public String getPageTemplate() { return templateName; }
    public void setPageTemplate(String templateName) {
	this.templateName = templateName;
    }

    public int getPageFormStyle() { return pageFormStyleCombo.getSelectedIndex(); }
    public void setPageFormStyle(int formStyle) {pageFormStyleCombo.setSelectedIndex(formStyle);}
  
  
    public void setDefaults() {
	  
	pageNameTF.setText(JSPPageWizard.jspPageWizardModel.simpleJSPPage.getJSPName());								 // NOI18N
	pageFormStyleCombo.setSelectedIndex(HTMLForm.FS_COLUMN);
	templateName = DEF_JSPPAGE_TLT;
	jspPageTemplateTF.setText(DEF_JSPPAGE_TLT);	  
    }
  
  
    public void readPageInfo() {	 
	JSPPageWizardModel jspPageWizardModel = JSPPageWizard.jspPageWizardModel;
	JSPPage jspPage = jspPageWizardModel.simpleJSPPage;

	pageNameTF.setText(jspPage.getJSPName());
	pageFormStyleCombo.setSelectedIndex(jspPage.getPageFormStyle());
	
	if(jspPageWizardModel.jspTemplateFileObject == null) {
	    jspPageTemplateTF.setText(DEF_JSPPAGE_TLT);	  
	} 
	else {		  
	    jspPageTemplateTF.setText(getFileObjectFullyQualifiedName(jspPageWizardModel.jspTemplateFileObject)); 
	}
	if(jspPageWizardModel.jspFolder == null) {	    
	    jspFolderTF.setText("");   // NOI18N
	} 
	else {		
	    jspFolderTF.setText(getFileObjectFullyQualifiedName(jspPageWizardModel.jspFolder));	  }
    }
  
    public void storePageInfo() {
	////NB validate here and show message box if info missing.
	  
	JSPPage jspPage = JSPPageWizard.jspPageWizardModel.simpleJSPPage;
	  
	jspPage.setJSPName(this.getJSPPageName());

	jspPage.setPageFormStyle(this.getPageFormStyle());
	  
	String jspPageTemplateFileName = jspPageTemplateTF.getText();
	if(jspPageTemplateFileName == null || jspPageTemplateFileName.trim().length() <= 0) {
	    JSPPageWizard.jspPageWizardModel.jspTemplateFileObject = null;
	    jspPage.setJSPTemplate(null);
	}
    }
  
    // JSP Page Name without extension
  
    private void setJSPPageName(String pageName) throws Exception {
	pageName = pageName.trim();
	int idx = pageName.trim().lastIndexOf(".");								 // NOI18N
	if(idx >= 0) {
	    String name = pageName.substring(0,idx);
	    String ext = pageName.substring(idx,pageName.length());
	    if( name.length() <= 0 || !ext.equalsIgnoreCase(".jsp")) {			 // NOI18N
		throw new Exception("Not a Valid JSP Name");						 // NOI18N
	    }
		  
	}
	else {
	    pageName = pageName.concat(".jsp");									 // NOI18N
	}
	pageNameTF.setText(pageName);
    }
  
    private String getJSPPageName() {
	String pageName = pageNameTF.getText().trim();
	int idx = pageName.lastIndexOf(".");										 // NOI18N
	if(idx >= 0 ) {
	    pageName = pageName.substring(0,idx);
	}
	return pageName;
    }
    // check for name and extensions and check for file in the repository.
    // if exists, ask user for overwrite permision , set overwrite permision
    // on JSP page.
    public boolean isValidJSPPageName() {
	String jspPageName = this.getJSPPageName();
	try {
	    this.setJSPPageName(jspPageName);
	}catch(Exception ex) {
	    IDEHelper.showErrorMessageI18N("JBW_NotValidJSPFileNameErr");		 // NOI18N
	    return false;
	}
	  
	if(IDEHelper.fileExists(JSPPageWizard.jspPageWizardModel.jspFolder,jspPageName,"jsp")) {			 // NOI18N
		  
	    if(jspPageName.equals(JSPPageWizard.jspPageWizardModel.simpleJSPPage.getJSPName()) && 
	       JSPPageWizard.jspPageWizardModel.isOverwriteJSPFile() )
		return true;
		  
	    if(!IDEHelper.askConfirmationI18N("JBW_OverWriteJSPFileConfirmMsg")) {			 // NOI18N
		JSPPageWizard.jspPageWizardModel.setOverwriteJSPFile(false);			  
		return false;
	    }	else {
		JSPPageWizard.jspPageWizardModel.setOverwriteJSPFile(true);
	    }
	}
	return true;
    }
  
    private String getFileObjectFullyQualifiedName(FileObject fileObject) {
	
	if(fileObject == null) return "";	  
	
	String rootName = "";	 
	String filePathName="";
	
	try {	  
	    filePathName = (fileObject.isFolder()) ?
		fileObject.getPackageName(File.separatorChar) :
		fileObject.getPackageNameExt(File.separatorChar,'.');
	    rootName = fileObject.getFileSystem().getDisplayName();
	    return rootName+File.separator+filePathName;
	}
	catch(Exception ex){Debug.print(ex);} // ignored safely 
	// 
	
	return "";
    }   

    private void browseForJSPFolder() {
	DataFolder jspFolder = IDEHelper.browseForJSPFolder();
	if(jspFolder != null) {
	    JSPPageWizard.jspPageWizardModel.jspFolder =
		jspFolder.getPrimaryFile(); 
	}	  

	if(JSPPageWizard.jspPageWizardModel.jspFolder == null) {
	    jspFolderTF.setText("");   // NOI18N 
	} 
	else {		
	    jspFolderTF.setText(getFileObjectFullyQualifiedName(JSPPageWizard.jspPageWizardModel.jspFolder));	  
	}
    }    

    private void browseForJSPPageTemplate() {
	FileObject jspTemplateFO = IDEHelper.browseForJSPPageTemplate();
	if(jspTemplateFO != null) {
	    JSPPageWizard.jspPageWizardModel.jspTemplateFileObject = jspTemplateFO;
	}
	if(JSPPageWizard.jspPageWizardModel.jspTemplateFileObject == null) {
	 
	    jspPageTemplateTF.setText(DEF_JSPPAGE_TLT);	
	} 
	else {		
	    jspPageTemplateTF.setText(getFileObjectFullyQualifiedName(JSPPageWizard.jspPageWizardModel.jspTemplateFileObject));
	}
    }
  
    public boolean validateInput() {	  
	if(JSPPageWizard.jspPageWizardModel.jspFolder == null) {
	
	    IDEHelper.showErrorMessageI18N("JBW_NullJSPFolderErr"); // NOI18N
	    return false;
	}	  	  
	// validate Dreamweaver template	  
	if(JSPPageWizard.jspPageWizardModel.jspTemplateFileObject != null) {
	
	    FileObject jspTemplateFO =
		JSPPageWizard.jspPageWizardModel.jspTemplateFileObject;	
	    try {			
		DWBeanTemplate dwTemplate =
		    DWBeanTemplate.getCustomTemplate(jspTemplateFO);  
		JSPPageWizard.jspPageWizardModel.simpleJSPPage.setJSPTemplate(dwTemplate);		
	    }
	    catch(Exception ex) {  
		String dwTemplateFilePath =
		    getFileObjectFullyQualifiedName(jspTemplateFO); 
		IDEHelper.showErrorMessageI18N("JBW_DWTemplateNotValidMsg", // NOI18N				
					       new Object[] {
						   dwTemplateFilePath});
		return false;
	    }
	}			  
	return isValidJSPPageName();
    }
  
    // WizardDescriptor.Panel implementations
  
    // public boolean isValid() {
    //  return isValidJSPPageName();
    // }
  
    public void readSettings(Object setting) {
	readPageInfo();
    }
  
    public void storeSettings(Object setting) {
	storePageInfo();
    }
  
  
  
    // ---------------------------------------------------------------------------------------
    // WizardDescriptor.Panel implementation

    public static void main(String[] args) {	  if(Debug.TEST) {
	
	JFrame testFrame = new JFrame("This is Test Frame");			 // NOI18N

	JSPPageNameAndStyleInfoPanel jspPageInfoPanel1 = new JSPPageNameAndStyleInfoPanel();
	  
	testFrame.getContentPane().setLayout(new GridLayout(0,1));
	testFrame.getContentPane().add(jspPageInfoPanel1);
	testFrame.setSize(500,300);
	testFrame.pack();
	testFrame.show();	  }
    }
}
