/*
 *                 Sun Public License Notice
 * 
 * The contents of this file are subject to the Sun Public License
 * Version 1.0 (the "License"). You may not use this file except in
 * compliance with the License. A copy of the License is available at
 * http://www.sun.com/
 * 
 * The Original Code is NetBeans. The Initial Developer of the Original
 * Code is Sun Microsystems, Inc. Portions Copyright 1997-2000 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.web.wizards.util;
import org.openide.modules.ModuleInstall;

/**
 * Implements the default behaviour for SubModules the way  * the
 * ModuleInstall will do to the parent Module 
 *  
 */
public class BasicSubModuleInstaller implements SubModuleInstaller {

    // Module installed for the first time.

    public void installed(ModuleInstall parentModule){
	restored (parentModule);	
    } 
    /** Module installed again.
     * Add applet executor
     */

    public void restored(ModuleInstall parentModule) {}
    /** Module was uninstalled. */

    public void uninstalled(ModuleInstall parentModule){}
    /** Module is being closed. */

    public boolean closing (ModuleInstall parentModule){ return true;}
    /** Called when all modules agreed with closing and the IDE will
     * be closed.*/ 

    public void close(ModuleInstall parentModule){}
    /** Called when the module is loaded and the version is higher
     * than by the previous load The default implementation 
     *  calls restored(). 
     */

    public void update(ModuleInstall parentModule,int release, String
		       specVersion){ 
	this.restored(parentModule);	
    }
}

