
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.ajde;

import java.util.List;
import javax.swing.JFrame;
import org.aspectj.ajde.ui.Icons;

/**
 * Represents the core functionality required from the IDE.
 *
 * @author Mik Kersten
 */
public interface IdeManager {

    public static final String TITLE = "AspectJ Browser";

    public static final String CONFIG_FILE_SUFFIX = ".lst";

    public void setStatusText(String text);

    public void setEditorStatusText(String text);

    public void build();

    public String getDefaultConfigFile();

    public void editConfigFile(String configFile);

    public void run();

    public void saveAll();

    public Icons getIcons();

    public List getConfigFiles();

    public void mountConfigFile(String configFile);

    public void removeConfigFile(String configFile);

    public void showMessages();

    public void hideMessages();

    public String getDumpFilePath();

    public JFrame getRootFrame();
}