/* -*- Mode: JDE; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.ajde.debugger;

//import org.aspectj.debugger.ide.FullPathSourceShower;
//import org.aspectj.debugger.request.BreakpointRequestAction;
import org.aspectj.ajde.editor.AjdeEditor;

/**
 * Debugger integration is not supported, hence this class is not currently used.
 *
 * @author  Mik Kersten
 */
public class AJDESourceShower { //extends FullPathSourceShower {

    private AjdeEditor actions;

    /**
     * Constructs a source shower that delegates to <code>actions</code>
     *
     * @param actions The <code>IDEActions</code> to which this shower delegates.
     */
//    public AJDESourceShower(AjdeEditor actions) {
//        this.actions = actions;
//    }

    /**
     * Displays the source file <code>fullPath</code> in a window.
     *
     * @param fullPath The fully-qualified file name to display
     */
    public void showSourceForFullPath(String fullPath) {
        actions.showSourceForFile(fullPath);
    }

    /**
     * Shows the line #<code>line</code> for the file currently being displayed.
     * This method will <b>only</b> follow a call to <code>showSourceForFullPath</code>.
     *
     * @param line            The line to display
     * @param isAtBreakpoint  <code>true</code> is this line is at a breakpoint
     * @see                   #showSourceForFullPath
     */
    public void showLineForCurrentModel(int line, boolean isAtBreakpoint) {
        actions.showSourceForLine(line, isAtBreakpoint);
    }

    /**
     * Should return the name of the currently-displayed source.
     *
     * @return The name of the currently-display source.
     */
    public String getSourceName() {
        //XXX Possibly just get the name
        return actions.getCurrSourceFilePath();
    }

    /**
     * Set the description in org.aspectj.debugger.gui.AbstractSourcePane.
     */
//    public void requestSet(String filename, int line, BreakpointRequestAction ba) {
//        actions.setBreakpointRequest(filename, line, false);
//    }

    /**
     * Set the description in org.aspectj.debugger.gui.AbstractSourcePane.
     */
//    public void requestClear(String filename, int line, BreakpointRequestAction ba) {
//        actions.clearBreakpointRequest(filename, line);
//    }

    /**
     * Set the description in org.aspectj.debugger.gui.AbstractSourcePane.
     */
//    public void requestDeferred(String filename, int line, BreakpointRequestAction ba) {
//        actions.setBreakpointRequest(filename, line, true);
//    }
}

