/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.compiler.crosscuts;

import org.aspectj.compiler.base.ast.*;
import org.aspectj.compiler.base.*;

import java.util.*;


public class AccessFixer extends Walker {
    /** The TypeDec that needs privilaged access to others types */
   // public TypeDec fromTypeDec;

    /** apply mode - only create backdoor methods if apply  is false,
     *  or replace methods/fields access with backdoor methods calls,
     *  if apply is true
     */
    public boolean apply;

    AccessFixer(JavaCompiler compiler, TypeDec fromTypeDec, boolean apply) {
        super(compiler);
        //this.fromTypeDec = fromTypeDec;
        this.apply = apply;
    }
    
    public void fixAccesses(ASTObject node) {
        //System.out.println("fixing: " + node + " in " + fromTypeDec + " apply " + apply);
        this.process(node);
    }
    
    public ASTObject process(ASTObject node) {
        node.walk(this);
        return node.fixAccessPost(this);
    }
}

