
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.tools.ajde.netbeans;

import java.net.URL;
import javax.swing.*;
import org.openide.TopManager;
import org.aspectj.ajde.ui.Icons;

public class ForteIcons extends Icons {

    public static final ForteIcons INSTANCE = new ForteIcons();
    public static final String OPENIDE_ICON_PATH = "org/openide/resources/";

    public Icon getPackageIcon() { return makeForteIcon("defaultFolder.gif"); }
    public Icon getProjectIcon() { return makeForteIcon("localFS.gif"); }

    public Icon getClassPrivateIcon() { return makeForteIcon("src/class.gif"); }
    public Icon getClassPackageIcon() { return makeForteIcon("src/class.gif"); }
    public Icon getClassProtectedIcon() { return makeForteIcon("src/class.gif"); }
    public Icon getClassPublicIcon() { return makeForteIcon("src/class.gif"); }

    public Icon getInterfacePrivateIcon() { return makeForteIcon("src/interface.gif"); }
    public Icon getInterfacePackageIcon() { return makeForteIcon("src/interface.gif"); }
    public Icon getInterfaceProtectedIcon() { return makeForteIcon("src/interface.gif"); }
    public Icon getInterfacePublicIcon() { return makeForteIcon("src/interface.gif"); }

    public Icon getFieldPrivateIcon() { return makeForteIcon("src/variablePrivate.gif"); }
    public Icon getFieldPackageIcon() { return makeForteIcon("src/variablePackage.gif"); }
    public Icon getFieldProtectedIcon() { return makeForteIcon("src/variableProtected.gif"); }
    public Icon getFieldPublicIcon() { return makeForteIcon("src/variablePublic.gif"); }

    public Icon getMethodPrivateIcon() { return makeForteIcon("src/methodPrivate.gif"); }
    public Icon getMethodPackageIcon() { return makeForteIcon("src/methodPackage.gif"); }
    public Icon getMethodProtectedIcon() { return makeForteIcon("src/methodProtected.gif"); }
    public Icon getMethodPublicIcon() { return makeForteIcon("src/methodPublic.gif"); }

    protected Icon makeIcon(String iconPath) {
        URL imageURL = TopManager.getDefault().currentClassLoader().getResource(ICON_PATH + iconPath);
        try {
            return new ImageIcon(imageURL);
        } catch (Exception e) {
            System.err.println("AJDE ERROR: could not load icon: " + iconPath);
            return null;
        }
    }

    private Icon makeForteIcon(String name) {
        String iconString = OPENIDE_ICON_PATH + name;
        URL imageURL = TopManager.getDefault().currentClassLoader().getResource(iconString);
        try {
            return new ImageIcon(imageURL);
        } catch (Exception e) {
            System.err.println("AJDE ERROR: could not load icon: " + iconString);
            return null;
        }
    }
}