package org.aspectj.tools.ajde.netbeans;

import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CallableSystemAction;

/** Action that can always be invoked and work procedurally.
 *
 * @author  Phil Sager
 */
public class RunAction extends CallableSystemAction {
    
    public void performAction() {
        ForteManager.INSTANCE.run();
       
    }
    
    public String getName() {
        return NbBundle.getMessage(RunAction.class, "LBL_RunAction");
    }
    
    protected String iconResource() {
        return "/org/aspectj/ajde/resources/actions/execute.gif";
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (RunAction.class);
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (RunAction.class, "HINT_Action"));
     * }
     */
    
}
