package com.xerox.printing;

import java.io.IOException;
import junit.framework.*;

public class InjectionTestCase extends TestCase {

	public InjectionTestCase(String name) {
		super(name);
	}

	public void testPrintJobExceptionHandling() throws Exception {
        final String label = "Injection.main() - ";
        Runnable r = new Runnable() {
                public void run() {
                    Exception testRunException = null;
                    Exception expectedException = null;
                    TestDriver testDriver = null;
                    try {
                         testDriver = new TestDriver();
                         testDriver.startTest();
                    } catch (IOException e) {
                        testRunException = e;
                        expectedException = testDriver.createException(null);
                        Util.log("ok, got injected error " + e.getMessage());
                        testRunException.printStackTrace();
                        assertTrue(testRunException == expectedException);
                    }
                }
            };

        Util.log(label + "starting separate test thread");
        Thread t = new Thread(r);
        t.start();

        Util.log(label + "running test in this thread");
        r.run();
        t.join();

        Util.log(label + "running job normally (not TestDriver)");
        new PrintJob().runPrintJob();
    }

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
}