/*
 * Copyright (c) 2002 PARC Inc.  All rights reserved.
 *
 * Use and copying of this software and preparation of derivative works based
 * upon this software are permitted.  Any distribution of this software or
 * derivative works must comply with all applicable United States export
 * control laws.
 *
 * This software is made available AS IS, and PARC Inc. makes no
 * warranty about the software, its performance or its conformity to any
 * specification.
 */

package com.xerox.printing; 
import java.io.IOException;

public class StubReplace {
  public static void main(String[] args) throws IOException {
      Util.log("StubReplace.main() run print job" );
      new PrintJob().runPrintJob();
  } 
} 

aspect Stubs {

    // article page 76 - stubs

    /**
     * Replace all PrintStream with our StubStream
     * by replacing the call to any constructor of 
     * PrinterStream or any subclasses.
     */
    PrinterStream around () : within(PrintJob) 
        && call (PrinterStream+.new(..)) && !call (StubStream+.new(..)) {
        return new StubStream(thisJoinPoint.getArgs());
    }  

    pointcut stubWrite() : printerStreamTestCalls() && target(StubStream);

    pointcut printerStreamTestCalls() : call(* PrinterStream.write());

    before() : stubWrite() {
        Util.log("picking out stubWrite" );
    }
}

class StubStream extends PrinterStream {
    public StubStream(Object[] args) {}
}
