/*
 * Copyright (c) 2002 PARC Inc.  All rights reserved.
 *
 * Use and copying of this software and preparation of derivative works based
 * upon this software are permitted.  Any distribution of this software or
 * derivative works must comply with all applicable United States export
 * control laws.
 *
 * This software is made available AS IS, and PARC Inc. makes no
 * warranty about the software, its performance or its conformity to any
 * specification.
 */

package com.xerox.printing; 

import java.util.Arrays;

import org.aspectj.lang.JoinPoint;

public class Util {
    public static boolean LOGGING = true;
    public static String render(JoinPoint jp) {
        if (null == jp) return "null";
        return "this ("
                + jp.getThis() 
                + ") target (" + jp.getTarget() 
                + ") signature (" + jp.getSignature() 
                + ") source location (" 
                + jp.getSourceLocation().getFileName()
                + ":" + jp.getSourceLocation().getColumn()
                + ") args ("
                + Arrays.asList(jp.getArgs())
                + ")";
    }
    public static void log(String s) {
        if (LOGGING) {
            System.err.println(s);
        }
    }
}
