
package figures;

aspect Tracing { 

  pointcut setXY(): call(void Point.setX(int)) ||
                    call(void Point.setY(int));

  before(): setXY() {
    System.out.println("Entering:" + thisJoinPoint); 
  }


  after() returning: call(void Display.needsRepaint()) && 
                     !within(DisplayUpdating) {
      System.out.print("Display was marked dirty outside of DisplayUpdating.");
  }

  after() returning: call(void Display.needsRepaint()) && 
                     within(DisplayUpdating) {
      System.out.print("Display was marked dirty by DisplayUpdating.");
  }
      
}
