/*   Generated by AspectJ version 1.0.3 */
package figures.gui;
import figures.Figure;
import figures.FigureElement;
import figures.Line;
import figures.Mobility;
import figures.MoveCollecting;
import figures.MoveTracking;
import figures.Point;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.border.*;

public class FigurePanel extends JComponent {
  static org.aspectj.runtime.reflect.Factory ajc$JPF;
  private static org.aspectj.lang.JoinPoint.StaticPart incrXY$ajcjp1;
  FigurePanel.ButtonsPanel bp;
  FigurePanel.FigureSurface fs;
  FigurePanel.ConsolePanel cp;
  public FigurePanel() {
    super();
    {
      this.bp = this.new ButtonsPanel();
      this.fs = new FigurePanel.FigureSurface(this.bp);
      this.cp = new FigurePanel.ConsolePanel();
    } 
    this.setLayout(new BorderLayout());
    JPanel panel = new JPanel();
    panel.setLayout(new BoxLayout(panel, 1));
    panel.add(this.fs);
    panel.add(this.bp);
    JSplitPane sp = new JSplitPane(0, panel, this.cp);
    sp.setPreferredSize(new Dimension(500, 400));
    sp.setDividerLocation(250);
    this.add("Center", sp);
  } 
  class ButtonsPanel extends JPanel {
    private JLabel msgs;
    public ButtonsPanel() {
      super();
      {
        this.msgs = new JLabel("click to add a point or line");
      } 
      this.setLayout(new FlowLayout(0));
      this.add(new JButton(this.new _1("Get Movers")));
      final JButton testAndClearButton = new JButton("Test and Clear");
      testAndClearButton.addActionListener(this.new _2(testAndClearButton, 
          testAndClearButton.getActionCommand()));
      this.add(testAndClearButton);
      this.add(new JButton(this.new _4("Main")));
      this.add(new JCheckBox(this.new _5("Mobility")));
      this.add(this.msgs);
    } 
    public void log(String msg) {
      this.msgs.setText(msg);
    } 

    class _1 extends AbstractAction {
      public void actionPerformed(ActionEvent e) {
        FigurePanel.this.fs.showMovers();
      } 

      _1(final String __0) {
        super(__0);
      } 
    } 
    class _2 extends AbstractAction {
      Color defaultColor;
      Color trueColor;
      Color falseColor;
      public void actionPerformed(ActionEvent e) {
        boolean b = MoveTracking.testAndClear();
        this.val$testAndClearButton.setForeground(b ? this.trueColor : this.falseColor);
        ButtonsPanel.this.log(b ? "there were moves!" : "no moves :(");
        SwingUtilities.invokeLater(this.new _3());
      } 

      _2(JButton val$testAndClearButton, final String __0) {
        super(__0);
        this.val$testAndClearButton = val$testAndClearButton;
        {
          this.defaultColor = val$testAndClearButton.getForeground();
          this.trueColor = Color.green.darker();
          this.falseColor = Color.red.darker();
        } 
      } 
      class _3 extends Object implements Runnable {
        public void run() {
          try {
            Thread.sleep(1000);
          } catch (Throwable t) {
          } finally {
            _2.this.val$testAndClearButton.setForeground(_2.this.defaultColor);
          } 
        } 

        _3() {
          super();
        } 
      } 
      final JButton val$testAndClearButton;
    } 
    class _4 extends AbstractAction {
      public void actionPerformed(ActionEvent e) {
        Main.main(new java.lang.String[] {});
        FigurePanel.this.fs.repaint();
      } 

      _4(final String __0) {
        super(__0);
      } 
    } 
    class _5 extends AbstractAction {
      public void actionPerformed(ActionEvent e) {
        if (!((JCheckBox)e.getSource()).isSelected()) {
          ButtonsPanel.this.log("enabling moves");
          Mobility.enableMoves();
        } else {
          ButtonsPanel.this.log("disabling moves");
          Mobility.disableMoves();
        } 
      } 

      _5(final String __0) {
        super(__0);
        {
          Mobility.enableMoves();
        } 
      } 
    } 
  } 
  static class ConsolePanel extends JPanel {
    JTextArea text;
    public ConsolePanel() {
      super(new BorderLayout());
      {
        this.text = new JTextArea();
      } 
      ;
      this.text.setFont(StyleContext.getDefaultStyleContext().getFont("SansSerif", 0, 10));
      JScrollPane scroller = new JScrollPane(this.text);
      scroller.setVerticalScrollBarPolicy(22);
      this.add("Center", scroller);
      System.setOut(new PrintStream(new BufferedOutputStream(this.new _6())));
    } 
    public void println(String msg) {
      this.text.append(msg + '\n');
    } 

    class _6 extends OutputStream {
      StringBuffer buf;
      public void write(int b) throws IOException {
        if (b == '\n') {
          ConsolePanel.this.println(this.buf.toString());
          this.buf = new StringBuffer();
        } else {
          this.buf.append((char)b);
        } 
      } 

      _6() {
        super();
        {
          this.buf = new StringBuffer();
        } 
      } 
    } 
  } 
  static Color BACKGROUND;
  static Color POINT_FILL;
  static Color POINT_OUTLINE;
  static Color LINE_FILL;
  static Color LINE_OUTLINE;
  static Color MOVED_FILL;
  static Color SELECTED_FILL;
  public static class FigureSurface extends JPanel implements MouseListener, MouseMotionListener {
    private Set movers;
    private boolean useMovers;
    private FigurePanel.ButtonsPanel bp;
    public FigureSurface(FigurePanel.ButtonsPanel bp) {
      super();
      {
        this.movers = new HashSet();
        this.useMovers = false;
        this.dragging = false;
        this.first = null;
        this.selected = null;
        this.point = null;
      } 
      this.bp = bp;
      this.addMouseMotionListener(this);
      this.addMouseListener(this);
      this.setPreferredSize(new Dimension(500, 500));
    } 
    public void showMovers() {
      this.useMovers = true;
      this.movers = MoveCollecting.getMovers();
      this.bp.log(this.movers.size() + " mover" + (this.movers.size() != 1 ? "s" : ""));
      this.paintImmediately(new Rectangle(0, 0, this.getSize().width, this.getSize().height));
      this.useMovers = false;
    } 

    private Point addPoint(int x, int y) {
      Point p = Figure.makePoint(x, y);
      this.repaint();
      return p;
    } 

    private Line addLine(Point p1, Point p2) {
      if (p1.equals(p2) || Math.abs(p1.getX() - p2.getX()) < 3 || Math.abs(p1.getY() - p2.getY()) 
          < 3) return ((Line)(null));
      Line line = null;
      if (p1 != null && p2 != null) line = Figure.makeLine(p1, p2);
      this.repaint();
      return line;
    } 

    public void paint(Graphics g) {
      Graphics2D g2 = (Graphics2D)g;
      g2.setPaint(FigurePanel.BACKGROUND);
      g2.fill(new Rectangle2D.Float(0.0f, 0.0f, (float)g2.getClipBounds().width, 
          (float)g2.getClipBounds().height));
      g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
      Iterator iter;
      iter = Figure.getFigureElementSet(Line.class).iterator();
      while (iter.hasNext())((Line)iter.next()).paintDispatch_figures_gui$ajc$backdoor(g2, this);
      iter = Figure.getFigureElementSet(Point.class).iterator();
      while (iter.hasNext())((Point)iter.next()).paintDispatch_figures_gui$ajc$backdoor(g2, this);
    } 

    static class Painting {
      /* IntroducedDec(dec: MethodDec(id: paintDispatch)) */

      /* IntroducedDec(dec: MethodDec(id: paintDispatch)) */

      /* IntroducedDec(dec: MethodDec(id: paintDispatch)) */

      Painting() {
        super();
      } 
      public static FigurePanel.FigureSurface.Painting aspectInstance;
      public static FigurePanel.FigureSurface.Painting aspectOf() {
        return FigurePanel.FigureSurface.Painting.aspectInstance;
      } 

      public static boolean hasAspect() {
        return FigurePanel.FigureSurface.Painting.aspectInstance != null;
      } 

      static {
        FigurePanel.FigureSurface.Painting.aspectInstance = new FigurePanel.FigureSurface.Painting(
            );
      } 

    } 
    public void paint(Point point, Graphics2D g2) {
      g2.setPaint(FigurePanel.POINT_OUTLINE);
      g2.draw(point);
      g2.setPaint(this.useMovers && this.movers.contains(point) ? FigurePanel.MOVED_FILL : 
          (point.equals(this.selected) ? FigurePanel.SELECTED_FILL : FigurePanel.POINT_FILL));
      g2.fill(point);
    } 

    public void paint(Line line, Graphics2D g2) {
      g2.setPaint(this.useMovers && this.movers.contains(line) ? FigurePanel.MOVED_FILL : 
          (line.equals(this.selected) ? FigurePanel.SELECTED_FILL : FigurePanel.LINE_FILL));
      g2.draw(line);
    } 

    int lastX;
    int lastY;
    int pressX;
    int pressY;
    boolean dragging;
    Shape first;
    Point selected;
    Point point;
    public void mousePressed(MouseEvent e) {
      int x = e.getX();
      int y = e.getY();
      this.first = this.shape(x, y);
      this.lastX = this.pressX = x;
      this.lastY = this.pressY = y;
      if (SwingUtilities.isLeftMouseButton(e)) {
        if (this.first == null && this.selected == null) {
          this.point = this.addPoint(x, y);
        } 
      } else if (SwingUtilities.isRightMouseButton(e)) {
        if (this.first == null && this.selected == null) {
          this.first = this.addPoint(x, y);
        } 
        if (this.selected == null && this.first != null && this.first instanceof Point) {
          this.select((Point)this.first);
        } 
      } 
    } 

    public void mouseDragged(MouseEvent e) {
      this.dragging = true;
      int x = e.getX();
      int y = e.getY();
      int dx = this.lastX - x;
      int dy = this.lastY - y;
      this.lastX = x;
      this.lastY = y;
      if (this.first != null) this.incrXY$method_call(((FigureElement)this.first), -dx, -dy);
      this.repaint();
    } 

    public void mouseReleased(MouseEvent e) {
      int x = e.getX();
      int y = e.getY();
      Shape landed = this.shape(x, y);
      if (this.dragging && landed == null && this.point == null) {
      } else if (this.first != null && this.selected == null) {
        this.first = null;
      } else if (SwingUtilities.isLeftMouseButton(e)) {
        if (this.dragging && this.point != null && landed == null) {
          this.addLine(this.point, this.addPoint(x, y));
        } else if (this.selected == null && this.point != null && landed == null) {
          this.addLine(this.point, this.addPoint(x, y));
        } else if (this.selected == null && this.point != null && landed != null && 
            landed instanceof Point) {
          this.addLine(this.point, (Point)landed);
        } else if (this.selected != null && landed != null && landed instanceof Point) {
          this.addLine(this.selected, (Point)landed);
        } else if (this.selected != null && this.first != null && this.first instanceof Point) {
          this.addLine(this.selected, (Point)this.first);
        } else if (this.selected != null) {
          this.addLine(this.selected, this.addPoint(x, y));
        } 
      } else if (!this.dragging && SwingUtilities.isRightMouseButton(e)) {
        if (this.selected != null && landed != null) {
          Line line = this.addLine(this.selected, (Point)landed);
          if (line != null) this.select(line.getP2());
        } else if (this.selected != null && this.first != null) {
          Line line = this.addLine(this.selected, (Point)this.first);
          if (line != null) this.select(line.getP2());
        } else if (this.selected != null) {
          Line line = this.addLine(this.selected, this.addPoint(x, y));
          if (line != null) this.select(line.getP2());
        } 
      } else if (this.dragging && SwingUtilities.isRightMouseButton(e) && 
          this.first instanceof Point) {
        this.select((Point)this.first);
      } 
      if (!this.dragging && !(SwingUtilities.isRightMouseButton(e))) {
        this.select(null);
      } 
      this.dragging = false;
      this.first = null;
    } 

    private void select(Point point) {
      this.selected = point;
      if (this.selected != null) this.bp.log("selected " + this.selected);
      this.repaint();
    } 

    public void mouseMoved(MouseEvent e) {
    } 

    public void mouseClicked(MouseEvent e) {
    } 

    public void mouseExited(MouseEvent e) {
    } 

    public void mouseEntered(MouseEvent e) {
    } 

    private Shape shape(int x, int y) {
      Iterator iter;
      iter = Figure.getFigureElementSet(Point.class).iterator();
      while (iter.hasNext()){
        Shape s = (Shape)iter.next();
        if (s.contains(x, y)) return s;
      } 
      iter = Figure.getFigureElementSet(Line.class).iterator();
      while (iter.hasNext()){
        Shape s = (Shape)iter.next();
        if (s.contains(x, y)) return s;
      } 
      return ((Shape)(null));
    } 

    final Object dispatch15_incrXY$method_call(FigureElement target, final int dx, final int dy) {
      if (true) {
        try {
          MoveCollecting.cflow$ajc0.push(new org.aspectj.runtime.CFlow());
          try {
            if (target instanceof Line) ((Line)(target)).incrXY$ajcPostCall(dx, 
                dy);else if (target instanceof Point) ((Point)(target)).incrXY$ajcPostCall(dx, 
                dy);else target.incrXY(dx, dy);
          } finally {
            MoveCollecting.cflow$ajc0.pop();
          } 
        } finally {
          if (!MoveCollecting.cflow$ajc0.isValid()) MoveCollecting.aspectInstance.after0$ajc(
              target);
        } 
      } 
      return null;
    } 

    final void around15_incrXY$method_call(final org.aspectj.runtime.internal.AroundClosure 
        ajc$closure, final Mobility this_, final FigureElement target, final int dx, 
        final int dy) {
      if (Mobility.enableMoves_ajget()) this.dispatch15_incrXY$method_call(target, dx, dy);
    } 

    private void incrXY$method_call(FigureElement target, final int dx, final int dy) {
      final org.aspectj.lang.JoinPoint thisJoinPoint = org.aspectj.runtime.reflect.Factory.makeJP(
          FigurePanel.incrXY$ajcjp1, this, target, new java.lang.Object[] {new Integer(dx), 
          new Integer(dy)});
      try {
        try {
          figures.IncrXYTracing.aspectInstance.before0$ajc(thisJoinPoint);
          this.around15_incrXY$method_call(((org.aspectj.runtime.internal.AroundClosure)(null)), 
              Mobility.aspectInstance, target, dx, dy);
        } finally {
          figures.IncrXYTracing.aspectInstance.after0$ajc(thisJoinPoint);
        } 
      } finally {
        figures.DisplayUpdating.aspectInstance.after0$ajc();
      } 
    } 

  } 
  static {
    FigurePanel.ajc$JPF = new org.aspectj.runtime.reflect.Factory("FigurePanel.java", 
        FigurePanel.class);
    FigurePanel.incrXY$ajcjp1 = FigurePanel.ajc$JPF.makeSJP("method-call", 
        FigurePanel.ajc$JPF.makeMethodSig(
        "401-incrXY-figures.FigureElement-int:int:-dx:dy:--void-"), 517, 32);
    FigurePanel.BACKGROUND = Color.white;
    FigurePanel.POINT_FILL = Color.red;
    FigurePanel.POINT_OUTLINE = Color.black;
    FigurePanel.LINE_FILL = Color.black;
    FigurePanel.LINE_OUTLINE = Color.black;
    FigurePanel.MOVED_FILL = Color.yellow;
    FigurePanel.SELECTED_FILL = Color.blue.darker();
  } 

} 