/*

Copyright (c) Xerox Corporation 2001.  All rights reserved.

Use and copying of this software and preparation of derivative works based
upon this software are permitted.  Any distribution of this software or
derivative works must comply with all applicable United States export control
laws.

This software is made available AS IS, and Xerox Corporation makes no warranty
about the software, its performance or its conformity to any specification.

|<---            this code is formatted to fit into 80 columns             --->|
|<---            this code is formatted to fit into 80 columns             --->|
|<---            this code is formatted to fit into 80 columns             --->|

*/

package figures;

import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

public class Figure {

    public pointcut constructions():
	(call(Point.new(..)) ||
	 call(Line.new(..)));

    public pointcut moves(FigureElement fe):
	target(fe) &&
	(call(void FigureElement.incrXY(int, int)) ||
	 call(void Line.setP1(Point))              ||
	 call(void Line.setP2(Point))              ||
	 call(void Point.setX(int))                ||
	 call(void Point.setY(int)));

    static aspect FactoryEnforcement {
	after() returning (FigureElement fe): constructions() &&
	                                      !within(Figure) {
	    throw new Error("Figure is only FigureElement factory.");
	}
    }

    private static Map figureElementSets = new HashMap();

    public static Set getFigureElementSet(Class type) {
        Set set = (Set)figureElementSets.get(type);
        if (set == null) {
            figureElementSets.put(type, set = new HashSet());
        }
        return set;
    }

    static aspect FactoryCollector {
	after() returning (FigureElement fe): constructions() {

	    System.out.println(fe);
            Set set = getFigureElementSet(fe.getClass());
            set.add(fe);
            figureElementSets.put(fe.getClass(), set);
	}
    }

    public static Point makePoint(int x, int y) {
	return new Point(x, y);
    }

    public static Line makeLine(Point p1, Point p2) {
	return new Line(p1, p2);
    }
}

