/*
Copyright (c) Xerox Corporation 2001.  All rights reserved.

Use and copying of this software and preparation of derivative works based
upon this software are permitted.  Any distribution of this software or
derivative works must comply with all applicable United States export control
laws.

This software is made available AS IS, and Xerox Corporation makes no warranty
about the software, its performance or its conformity to any specification.

|<---            this code is formatted to fit into 80 columns             --->|
|<---            this code is formatted to fit into 80 columns             --->|
|<---            this code is formatted to fit into 80 columns             --->|

*/

package figures;

public class Line implements FigureElement {

    private Point _p1;

    private Point _p2;

    protected Line(Point p1, Point p2) {
        _p1 = p1;
        _p2 = p2;
    }

    public Point getP1() { return _p1; }

    public Point getP2() { return _p2; }

    public void setP1(Point p1) { _p1 = p1; }

    public void setP2(Point p2) { _p2 = p2; }

    public void incrXY(int dx, int dy) {
        _p1.incrXY(dx, dy);
        _p2.incrXY(dx, dy);
    }

    public boolean equals(Object o) {
        if (!(o instanceof Line)) return super.equals(o);
        return ((Line)o).getP1().equals(getP1()) &&
               ((Line)o).getP2().equals(getP2());
    }
}

