/*
Copyright (c) Xerox Corporation 2001.  All rights reserved.

Use and copying of this software and preparation of derivative works based
upon this software are permitted.  Any distribution of this software or
derivative works must comply with all applicable United States export control
laws.

This software is made available AS IS, and Xerox Corporation makes no warranty
about the software, its performance or its conformity to any specification.

|<---            this code is formatted to fit into 80 columns             --->|
|<---            this code is formatted to fit into 80 columns             --->|
|<---            this code is formatted to fit into 80 columns             --->|
*/

package figures;

public class Point implements FigureElement {

    private int _x;

    private int _y;

    public Point(int x, int y) {
        _x = x;
        _y = y;
    }

    public int getX() { return _x; }

    public int getY() { return _y; }

    public void setX(int x) { _x = x; }

    public void setY(int y) { _y = y; }

    public void incrXY(int dx, int dy) {
        setX(getX() + dx);
        setY(getY() + dy);
    }

    public boolean equals(Object o) {
        if (!(o instanceof Point)) return super.equals(o);
        return ((Point)o).getX() == getX() && ((Point)o).getY() == getY();
    }
}

