/*
 * Copyright (c) 2002 PARC Inc.  All rights reserved.
 *
 * Use and copying of this software and preparation of derivative works based
 * upon this software are permitted.  Any distribution of this software or
 * derivative works must comply with all applicable United States export
 * control laws.
 *
 * This software is made available AS IS, and PARC Inc. makes no
 * warranty about the software, its performance or its conformity to any
 * specification.
 */

package com.xerox.printing;

import java.io.IOException;

public class PrinterStream {
    int number;
    int one;
    private int another;

    /** static factory method for round-trip with BufferedPrinterStream */
    static PrinterStream make(BufferedPrinterStream p) { 
        return new PrinterStream(p.num); 
    }

    /** demonstrate setting a field directly in a constructor */
    PrinterStream(int i) { 
        this.number = i;  // CompileTime.java warning: write outside setter
    }

    /** demonstrate setting a field in the control flow of a constructor */
    PrinterStream() { 
        setOne(1); 
    }

    /** demonstrate setting the field of another instance in a constructor */
    PrinterStream(PrinterStream other) { 
        other.another = 3;  // CompileTime.java warning: write outside setter
    }

    public void setOne(int i) { 
        one = i; 
    }

    /** this printer stream writes without exception */
    public final void write() throws IOException {
        delegate();
        Util.log("exiting PrinterStream.write()");
    }

    protected void delegate() throws IOException { 
        Util.log("exiting PrinterStream.delegate()");
    }
}

