/*
 * Copyright (c) 2002 PARC Inc.  All rights reserved.
 *
 * Use and copying of this software and preparation of derivative works based
 * upon this software are permitted.  Any distribution of this software or
 * derivative works must comply with all applicable United States export
 * control laws.
 *
 * This software is made available AS IS, and PARC Inc. makes no
 * warranty about the software, its performance or its conformity to any
 * specification.
 */

package com.xerox.printing; 

import java.io.IOException;

public class SubPrinterStream extends PrinterStream {
    private int two;

    /** demonstrate that pointcut picks out subclasses */
    SubPrinterStream() { 
        setOne(2); 
        setTwo(); 
    }

    public void setTwo() { 
        two = 2; 
    }

    /** demonstrate compile-time error when delegate handles IOException */
    public void delegate() {
        try {
            throw new IOException("");
        } catch (IOException e) {} // CompileTime.java error: do not handle
    }
}

