
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.ajde;

import java.awt.event.*;
import javax.swing.*;
import org.aspectj.ajde.ui.Icons;

/**
 * Contains the top-level AJDE actions.
 *
 * @todo    move the other actions whose implementations are scattered in <CODE>TopFrame</CODE>
 *          and <CODE>TopManager</CODE> into this class
 * @author  Mik Kersten
 */
public class Actions {
    public static final AjdeAction BUILD = new AjdeAction() {
        public void actionPerformed(ActionEvent e) {
            TopManager.IDE_MANAGER.saveAll();
            TopManager.IDE_MANAGER.build();
        }

        public String getName() {
            return "Build";
        }

        public ImageIcon getIcon() {
            return (ImageIcon)Icons.INSTANCE.getBuildIcon();
        }
    };

    public static final AjdeAction JOINPOINT_PROBE = new AjdeAction() {
        public void actionPerformed(ActionEvent e) {

        }

        public String getName() {
            return "Joinpoint Probe";
        }

        public ImageIcon getIcon() {
            return (ImageIcon)Icons.INSTANCE.getRelationAdviceForwardIcon();
        }
    };
}
