
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.ajde.compiler;

/**
 * Minimal interface for manipulating compiler output messages.
 *
 * @author Mik Kersten
 */
public interface CompilerMessages {

	public static int ERROR_MESSAGE = 0;
	
	public static int WARNING_MESSAGE = 1;
	
	public static int INFO_MESSAGE = 2;

	/**
	 * @param	message			description of compiler message
	 * @param	file			source file corresponding to the message
	 * @param	lineNumber		corresponding file line number
	 * @param	columnNumber            corresponding file column number
	 * @param	kind			one of <code>ERROR_MESSAGE, WARNING_MESSAGE, INFO_MESSAGE</code>
	 */ 
    public void addMessage(String message, String file, int lineNumber, int columnNumber, int kind);
    
    public void clearMessages();
}