
/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.ajde.ui;

import javax.swing.*;
import java.util.*;

/**
 * Default icons.  Override behavior for custom icons.
 *
 * @author  Mik Kersten
 */
public class Icons {

    public static Icons INSTANCE = null;
    protected String ICON_PATH = "org/aspectj/ajde/resources/";

    private final Icon START_AJDE = makeIcon("actions/startAjde.gif");
    private final Icon STOP_AJDE = makeIcon("actions/stopAjde.gif");
    private final Icon BUILD = makeIcon("actions/build.gif");
    private final Icon DEBUG = makeIcon("actions/debug.gif");
    private final Icon EXECUTE = makeIcon("actions/execute.gif");

    private final Icon BACK = makeIcon("actions/back.gif");
    private final Icon FORWARD = makeIcon("actions/forward.gif");
    private final Icon SEARCH = makeIcon("actions/search.gif");
    private final Icon OPEN_CONFIG = makeIcon("actions/openConfig.gif");
    private final Icon CLOSE_CONFIG = makeIcon("actions/closeConfig.gif");
    private final Icon SAVE = makeIcon("actions/save.gif");
    private final Icon SAVE_ALL = makeIcon("actions/saveAll.gif");
    private final Icon BROWSER_OPTIONS = makeIcon("actions/browseroptions.gif");
    private final Icon PROJECT = makeIcon("structure/project.gif");
    private final Icon PACKAGE = makeIcon("structure/package.gif");
    private final Icon FILE_ASPECT = makeIcon("structure/file-aspect.gif");
    private final Icon FILE_CLASS = makeIcon("structure/file-class.gif");
    private final Icon FILE_LST = makeIcon("structure/file-lst.gif");
    private final Icon ASPECT = makeIcon("structure/aspect.gif");
    private final Icon CLASS = makeIcon("structure/class.gif");
    private final Icon FIELD = makeIcon("structure/field.gif");
    private final Icon INTRODUCTION = makeIcon("structure/introduction.gif");
    private final Icon JOINPOINT = makeIcon("structure/joinPoint.gif");
    private final Icon METHOD = makeIcon("structure/method.gif");
    private final Icon ADVICE = makeIcon("structure/advice.gif");
    private final Icon DECLARE_PARENTS = makeIcon("structure/declareParents.gif");
    private final Icon DECLARE_WARNING = makeIcon("structure/declareWarning.gif");
    private final Icon DECLARE_ERROR = makeIcon("structure/declareError.gif");
    private final Icon DECLARE_SOFT = makeIcon("structure/declareSoft.gif");
    private final Icon CODE = makeIcon("structure/code.gif");
    private final Icon ZOOM_STRUCTURE_TO_FILE_MODE = makeIcon("actions/zoomStructureToFileMode.gif");
    private final Icon ZOOM_STRUCTURE_TO_GLOBAL_MODE = makeIcon("actions/zoomStructureToGlobalMode.gif");
    private final Icon SPLIT_STRUCTURE_VIEW = makeIcon("actions/splitStructureView.gif");
    private final Icon MERGE_STRUCTURE_VIEW = makeIcon("actions/mergeStructureView.gif");

    private final Icon RELATION_ADVICE_FORWARD = makeIcon("structure/adviceForward.gif");
    private final Icon RELATION_ADVICE_BACK = makeIcon("structure/adviceBack.gif");
    private final Icon RELATOIN_INHERITANCE_FORWARD = makeIcon("structure/inheritanceForward.gif");
    private final Icon RELATION_INHERITANCE_BACK = makeIcon("structure/inheritanceBack.gif");
    private final Icon RELATION_REFERENCE_FORWARD = makeIcon("structure/referenceForward.gif");
    private final Icon RELATION_REFERENCE_BACK = makeIcon("structure/referenceBack.gif");

    public Icon getStartAjdeIcon() { return START_AJDE; }
    public Icon getStopAjdeIcon() { return STOP_AJDE; }
    public Icon getBackIcon() { return BACK; }
    public Icon getForwardIcon() { return FORWARD; }
    public Icon getSearchIcon() { return SEARCH; }
    public Icon getBuildIcon() { return BUILD; }
    public Icon getDebugIcon() { return DEBUG; }
    public Icon getExecuteIcon() { return EXECUTE; }
    public Icon getOpenConfigIcon() { return OPEN_CONFIG; }
    public Icon getCloseConfigIcon() { return CLOSE_CONFIG; }
    public Icon getOpenIcon() { return OPEN_CONFIG; }
    public Icon getSaveIcon() { return SAVE; }
    public Icon getSaveAllIcon() { return SAVE_ALL; }
    public Icon getBrowserOptionsIcon() { return BROWSER_OPTIONS; }
    public Icon getZoomStructureToFileModeIcon() { return ZOOM_STRUCTURE_TO_FILE_MODE; }
    public Icon getZoomStructureToGlobalModeIcon() { return ZOOM_STRUCTURE_TO_GLOBAL_MODE; }
    public Icon getSplitStructureViewIcon() { return SPLIT_STRUCTURE_VIEW; }
    public Icon getMergeStructureViewIcon() { return MERGE_STRUCTURE_VIEW; }

    public Icon getProjectIcon() { return PROJECT; }
    public Icon getPackageIcon() { return PACKAGE; }
    public Icon getFileAspectIcon() { return FILE_ASPECT; }
    public Icon getFileClassIcon() { return FILE_CLASS; }
    public Icon getFileLstIcon() { return FILE_LST; }

    public Icon getAspectPublicIcon() { return ASPECT; }
    public Icon getAspectPackageIcon() { return ASPECT; }
    public Icon getAspectProtectedIcon() { return ASPECT; }
    public Icon getAspectPrivateIcon() { return ASPECT; }
    public Icon getAspectPrivilegedIcon() { return ASPECT; }

    public Icon getClassPublicIcon() { return CLASS; }
    public Icon getClassPackageIcon() { return CLASS; }
    public Icon getClassProtectedIcon() { return CLASS; }
    public Icon getClassPrivateIcon() { return CLASS; }

    public Icon getInterfacePublicIcon() { return CLASS; }
    public Icon getInterfacePackageIcon() { return CLASS; }
    public Icon getInterfaceProtectedIcon() { return CLASS; }
    public Icon getInterfacePrivateIcon() { return CLASS; }

    public Icon getFieldPublicIcon() { return FIELD; }
    public Icon getFieldPackageIcon() { return FIELD; }
    public Icon getFieldProtectedIcon() { return FIELD; }
    public Icon getFieldPrivateIcon() { return FIELD; }

    public Icon getIntroductionPublicIcon() { return INTRODUCTION; }
    public Icon getIntroductionPackageIcon() { return INTRODUCTION; }
    public Icon getIntroductionProtectedIcon() { return INTRODUCTION; }
    public Icon getIntroductionPrivateIcon() { return INTRODUCTION; }

    public Icon getJoinpointPublicIcon() { return JOINPOINT; }
    public Icon getJoinpointPackageIcon() { return JOINPOINT; }
    public Icon getJoinpointProtectedIcon() { return JOINPOINT; }
    public Icon getJoinpointPrivateIcon() { return JOINPOINT; }

    public Icon getMethodPublicIcon() { return METHOD; }
    public Icon getMethodPackageIcon() { return METHOD; }
    public Icon getMethodProtectedIcon() { return METHOD; }
    public Icon getMethodPrivateIcon() { return METHOD; }

    public Icon getAdviceIcon() { return ADVICE; }
    public Icon getDeclareParentsIcon() { return DECLARE_PARENTS; }
    public Icon getDeclareErrorIcon() { return DECLARE_ERROR; }
    public Icon getDeclareWarningIcon() { return DECLARE_WARNING; }
    public Icon getDeclareSoftIcon() { return DECLARE_SOFT; }

    public Icon getCodeIcon() { return CODE; }

    public Icon getRelationAdviceForwardIcon() { return RELATION_ADVICE_FORWARD; }
    public Icon getRelationAdviceBackIcon() { return RELATION_ADVICE_BACK; }
    public Icon getRelationInheritanceForwardIcon() { return RELATOIN_INHERITANCE_FORWARD; }
    public Icon getRelationInheritanceBackIcon() { return RELATION_INHERITANCE_BACK; }
    public Icon getRelationReferenceForwardIcon() { return RELATION_REFERENCE_FORWARD; }
    public Icon getRelationReferenceBackIcon() { return RELATION_REFERENCE_BACK; }

    protected Icon makeIcon(String iconPath) {
        return new ImageIcon(ClassLoader.getSystemResource(ICON_PATH + iconPath));
    }
}