/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the IDE support for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.ajde.views;

import java.util.*;
import java.io.*;

/**
 * User-defineable properties that control what program structure is displayed.
 *
 * @author Mik Kersten
 */
public class ViewProperties implements Serializable {

    private String name;
    private List associations = new ArrayList();
    private List memberVisibility = new ArrayList();
    private List memberModifiers = new ArrayList();
    private String sorting = "";
    private String granularity = "";

    public ViewProperties(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public List getAssociations() {
        return associations;
    }

    public void addAssociation(String association) {
        associations.add(association);
    }

    public void setMemberVisibility(List memberVisibility) {
        this.memberVisibility = memberVisibility;
    }

    public List getMemberVisibility() {
        return memberVisibility;
    }

    public List getMemberModifiers() {
        return memberVisibility;
    }

    public void setMemberModifiers(List memberModifiers) {
        this.memberModifiers = memberModifiers;
    }

    public String getSorting() {
        return sorting;
    }

    public void setSorting(String sorting) {
        this.sorting = sorting;
    }

    public String getGranularity() {
        return granularity;
    }

    public void getGranularity(String granularity) {
        this.granularity = granularity;
    }

    public String toString() {
        return name;
    }
}