/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.compiler.base;

import org.aspectj.compiler.base.ast.*;
import org.aspectj.compiler.base.*;


import java.util.*;

public class TypeValidator extends AbstractCompilerPass implements WorldPass {
    public TypeValidator(JavaCompiler compiler) {
        super(compiler);
    }

    public void transformWorld() {
//        // first put all source types in the TypeManager
//        for (Iterator i = getWorld().sourceTypesIterator(); i.hasNext(); ) {
//            Type type = (Type)i.next();
//            getTypeManager().addType(type);
//        }        
//        
        
        // first build up the inner type maps
        //XXX TBD
        
        
        
        
        // then bind implements/extends and build the type graph
        for (Iterator i = getWorld().sourceTypesIterator(); i.hasNext(); ) {
            Type type = (Type)i.next();
            type.buildTypeGraph();
        }
    
        // now check for circularites
        getTypeManager().getObjectType().validateTypeGraph();
        
        // now do type level introductions
        for (Iterator i = getWorld().sourceTypesIterator(); i.hasNext(); ) {
            Type type = (Type)i.next();
            type.finishTypeIntroductions();
        }
    
        
        
    }
        
//        Enumeration cuEnum = getWorld().enumerateCompilationUnits();
//        while (cuEnum.hasMoreElements()) {
//            CompilationUnit cu = (CompilationUnit)cuEnum.nextElement();
//            Decs decs = cu.getDecs();
//            for (int j=0; j < decs.size(); j++) {
//                Dec dec = (Dec)decs.get(j);
//                if (dec instanceof TypeDec) {
//                    TypeDec typeDec = (TypeDec)dec;
//                    if (typeDec.isInnerType()) continue;
//                    getCompiler().enterNode(dec);
//                    //System.out.println("type "+typeDec+": building type graph");
//                    typeDec.buildTypeGraph();
//                    //if (!((TypeDec)dec).validate(new LinkedList())) break;
//                    getCompiler().exitNode(dec);
//                }
//            }
//        }


        
        
//        // now check for circularities   
//        cuEnum = getWorld().enumerateCompilationUnits();
//        while (cuEnum.hasMoreElements()) {
//            CompilationUnit cu = (CompilationUnit)cuEnum.nextElement();
//            Decs decs = cu.getDecs();
//            for (int j=0; j < decs.size(); j++) {
//                Dec dec = (Dec)decs.get(j);
//                if (dec instanceof TypeDec) {
//                    TypeDec typeDec = (TypeDec)dec;
//                    if (typeDec.isInnerType()) continue;
//                    getCompiler().enterNode(dec);
//                    //System.out.println("type "+typeDec+": building type graph");
//                    typeDec.validate();
//                    //if (!((TypeDec)dec).validate(new LinkedList())) break;
//                    getCompiler().exitNode(dec);
//                }
//            }
//        }             

    public String getDisplayName() {
        return "building type graph";
    }

}
