/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.compiler.base.ast;

import org.aspectj.compiler.base.JavaCompiler;
/**
 * This should be called CallExpr and CallExpr should be MethodInvocationExpr
 *
  * @grammar
  */

public abstract class AnyCallExpr extends Expr implements PossibleSoftThrowable {
    private boolean _isSoft = false;
    public boolean isSoftThrowable() { return _isSoft; }
    public void setSoftThrowable() { _isSoft = true; }

    public abstract Expr getExpr();
    public abstract Expr getExprOrThis();
    public abstract void setExpr(Expr expr);
    public abstract String getId();
    public abstract void setArgs(Exprs args);
    public abstract Exprs getArgs();
    public abstract CodeDec getCodeDec();
    public abstract Type getReturnType();
    public abstract Type getCalledType();

    //BEGIN: Generated from @child and @property

    public AnyCallExpr(SourceLocation location) {
        super(location);

    }


    public String getDefaultDisplayName() {
        return "AnyCallExpr()";
    }

    //END: Generated from @child and @property
}
