/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.compiler.base.ast;

import org.aspectj.compiler.base.*;

import java.util.*;

import org.aspectj.compiler.base.*;
import org.aspectj.compiler.crosscuts.*;

/**
 * @grammar ...
 * @property Type type
 */
public class ResolvedTypeD extends TypeD implements SOLink {
    //INTRO from MovingWalker
    public ASTObject postMove(MovingWalker walker) {
        walker.moveLink(this);
        return this;
    }


    //SOLink interface
    public SemanticObject getTarget() {
        return getType();
    }

    public void setTarget(SemanticObject newTarget) {
        setType((Type)newTarget);
    }

    //BEGIN: Generated from @child and @property
    protected Type type;
    public Type getType() { return type; }
    public void setType(Type _type) { type = _type; }

    public ResolvedTypeD(SourceLocation location, Type _type) {
        super(location);
        setType(_type);
    }
    protected ResolvedTypeD(SourceLocation source) {
        super(source);
    }

    public ASTObject copyWalk(CopyWalker walker) {
        ResolvedTypeD ret = new ResolvedTypeD(getSourceLocation());
        ret.preCopy(walker, this);
        ret.type = type;
        return ret;
    }


    public String getDefaultDisplayName() {
        return "ResolvedTypeD(type: "+type+")";
    }

    //END: Generated from @child and @property
}
