/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

//XXX This set of constants is in the process of being removed from the design
package org.aspectj.compiler.base.parser;

public interface JavaConstants {

  int EOF = 0;
  int SINGLE_LINE_COMMENT = 9;
  int FORMAL_COMMENT = 10;
  int MULTI_LINE_COMMENT = 11;
  int INTEGER_LITERAL = 13;
  int DECIMAL_LITERAL = 14;
  int HEX_LITERAL = 15;
  int OCTAL_LITERAL = 16;
  int FLOATING_POINT_LITERAL = 17;
  int EXPONENT = 18;
  int CHARACTER_LITERAL = 19;
  int STRING_LITERAL = 20;
  int LPAREN = 21;
  int RPAREN = 22;
  int LBRACE = 23;
  int RBRACE = 24;
  int LBRACKET = 25;
  int RBRACKET = 26;
  int SEMICOLON = 27;
  int COMMA = 28;
  int DOT = 29;
  int ASSIGN = 30;
  int GT = 31;
  int LT = 32;
  int BANG = 33;
  int TILDE = 34;
  int HOOK = 35;
  int COLON = 36;
  int EQ = 37;
  int LE = 38;
  int GE = 39;
  int NE = 40;
  int SC_OR = 41;
  int SC_AND = 42;
  int INCR = 43;
  int DECR = 44;
  int PLUS = 45;
  int MINUS = 46;
  int STAR = 47;
  int SLASH = 48;
  int BIT_AND = 49;
  int BIT_OR = 50;
  int XOR = 51;
  int REM = 52;
  int LSHIFT = 53;
  int RSIGNEDSHIFT = 54;
  int RUNSIGNEDSHIFT = 55;
  int PLUSASSIGN = 56;
  int MINUSASSIGN = 57;
  int STARASSIGN = 58;
  int SLASHASSIGN = 59;
  int ANDASSIGN = 60;
  int ORASSIGN = 61;
  int XORASSIGN = 62;
  int REMASSIGN = 63;
  int LSHIFTASSIGN = 64;
  int RSIGNEDSHIFTASSIGN = 65;
  int RUNSIGNEDSHIFTASSIGN = 66;
  int INSTANCEOF = 67;
  int NEW = 68;
  int AT = 69;
  int IDENTIFIER = 70;
  int LETTER = 71;
  int DIGIT = 72;

  int PUBLIC = 73;
  int PRIVATE = 74;
  int PROTECTED = 75;
  int STATIC = 76;
  int FINAL = 77;
  int SYNCHRONIZED = 78;
  int VOLATILE = 79;
  int TRANSIENT = 80;
  int NATIVE = 81;
  int ABSTRACT = 82;
  int STRICT = 83;
  int CONST = 84;

  int CLASS = 85;
  int INTERFACE = 86;

  int THROWS = 87;
  int TRY = 88;
  int CATCH = 89;
  int FINALLY = 90;

  int IF = 91;
  int WHILE = 92;
  int DO = 93;
  int FOR = 94;
  int SWITCH = 95;
  int CASE = 96;
  int DEFAULT_CASE = 97;
  int BREAK = 98;
  int CONTINUE = 99;
  int RETURN = 100;
  int THROW = 101;
  int GOTO = 102;

  //int BOOLEAN = 103;
  //int BYTE = 104;
  //int CHAR = 105;
  //int SHORT = 106;
  //int INT = 107;
  //int LONG = 108;
  //int FLOAT = 109;
  //int DOUBLE = 110;
  //int VOID = 111;

  int DEFAULT = 0;
  int IN_SINGLE_LINE_COMMENT = 1;
  int IN_FORMAL_COMMENT = 2;
  int IN_MULTI_LINE_COMMENT = 3;

  String[] tokenImage = {
    "<EOF>",
    "\" \"",
    "\"\\t\"",
    "\"\\n\"",
    "\"\\r\"",
    "\"\\f\"",
    "\"//\"",
    "<token of kind 7>",
    "\"/*\"",
    "<SINGLE_LINE_COMMENT>",
    "\"*/\"",
    "\"*/\"",
    "<token of kind 12>",
    "<INTEGER_LITERAL>",
    "<DECIMAL_LITERAL>",
    "<HEX_LITERAL>",
    "<OCTAL_LITERAL>",
    "<FLOATING_POINT_LITERAL>",
    "<EXPONENT>",
    "<CHARACTER_LITERAL>",
    "<STRING_LITERAL>",
    "\"(\"",
    "\")\"",
    "\"{\"",
    "\"}\"",
    "\"[\"",
    "\"]\"",
    "\";\"",
    "\",\"",
    "\".\"",
    "\"=\"",
    "\">\"",
    "\"<\"",
    "\"!\"",
    "\"~\"",
    "\"?\"",
    "\":\"",
    "\"==\"",
    "\"<=\"",
    "\">=\"",
    "\"!=\"",
    "\"||\"",
    "\"&&\"",
    "\"++\"",
    "\"--\"",
    "\"+\"",
    "\"-\"",
    "\"*\"",
    "\"/\"",
    "\"&\"",
    "\"|\"",
    "\"^\"",
    "\"%\"",
    "\"<<\"",
    "\">>\"",
    "\">>>\"",
    "\"+=\"",
    "\"-=\"",
    "\"*=\"",
    "\"/=\"",
    "\"&=\"",
    "\"|=\"",
    "\"^=\"",
    "\"%=\"",
    "\"<<=\"",
    "\">>=\"",
    "\">>>=\"",
    "\"instanceof\"",
    "\"new\"",
    "\"@\"",
    "<IDENTIFIER>",
    "<LETTER>",
    "<DIGIT>",

    "public",
    "private",
    "protected",
    "static",
    "final",
    "synchronized",
    "volatile",
    "transient",
    "native",
    "abstract",
    "strictfp",
    "const",

    "class",
    "interface",

    "throws",
    "try",
    "catch",
    "finally",

    "if",
    "while",
    "do",
    "for",
    "switch",
    "case",
    "default",
    "break",
    "continue",
    "return",
    "throw",
    "goto",

    //"boolean",
    //"byte",
    //"char",
    //"short",
    //"int",
    //"long",
    //"float",
    //"double",
    //"void"
  };

}
