/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.compiler.crosscuts.ast;
import org.aspectj.compiler.base.ast.*;
import org.aspectj.compiler.crosscuts.joinpoints.*;

import org.aspectj.compiler.base.JavaCompiler;
import org.aspectj.util.FuzzyBoolean;

import java.util.*;

/**
 * @grammar ...
 */

//XXX This extends Expr so I can use the ExprParser to parse them
//XXX This is a flaw in the design of my JavaParser class
public abstract class GenTypeName extends Expr {
    //XXX see comment above for why this is messed up
    protected Type discoverType() { return null; }

    public static final int EXACT_STATIC_TYPE = 1;
    public static final int STATIC_TYPE_OR_SUBTYPE = 2;
    public static final int INSTANCEOF = 3;

//    public boolean matches(TypeDec typeDec, int kind) {
//        return matches(typeDec.getType(), kind);
//    }
//
//    public boolean matches(Type type) {
//        return matches(type, EXACT_STATIC_TYPE);
//    }
    
    public abstract boolean matches(Type type);
    public abstract FuzzyBoolean matchesInstance(Type type);
    public abstract JpPlan makePlan(JoinPoint jp, Expr expr);
    
    //XXX make abstract
//    public boolean bindToExpr(AdvicePlan plan, Expr expr, int kind) {
//        return matches(expr.getType(), kind);
//    }    
    
    //BEGIN: Generated from @child and @property
    
    public GenTypeName(SourceLocation location) {
        super(location);
    
    }
    
    
    public String getDefaultDisplayName() {
        return "GenTypeName()";
    }
    
    //END: Generated from @child and @property
}

