/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * This file is part of the compiler and core tools for the AspectJ(tm)
 * programming language; see http://aspectj.org
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * either http://www.mozilla.org/MPL/ or http://aspectj.org/MPL/.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AspectJ.
 *
 * The Initial Developer of the Original Code is Xerox Corporation. Portions
 * created by Xerox Corporation are Copyright (C) 1999-2002 Xerox Corporation.
 * All Rights Reserved.
 *
 * Contributor(s):
 */

package org.aspectj.util;


import java.util.*;

public class IntList {
    private final int BASE_SIZE = 256;
    
    private int[] data;
    private int size;
    
    public IntList() {
        size = 0;
        data = new int[BASE_SIZE];
    }
    
    private void ensureSize(int needsSize) {
        if (needsSize <= data.length) return;
        
        int[] newData = new int[data.length*2];
        System.arraycopy(data, 0, newData, 0, data.length);
        data = newData;
    }
    
    public void add(int value) {
        ensureSize(size+1);
        data[size++] = value;
    }
    
    public int[] toIntArray() {
        int[] ret = new int[size];
        System.arraycopy(data, 0, ret, 0, size);
        return ret;
    }
}
