/*
 * (c) Copyright IBM Corp. 2000, 2002.
 * All Rights Reserved.
 */
package org.eclipse.tomcat.internal;

import org.eclipse.core.runtime.*;
/**
 */
public class TomcatPlugin extends Plugin {
	public final static String PLUGIN_ID = "org.eclipse.tomcat";
	private static TomcatPlugin plugin;

	/**
	 */
	public TomcatPlugin(IPluginDescriptor descriptor) {
		super(descriptor);
		plugin = this;

	}

	/** 
	 * Logs an Error message with an exception. Note that the message should already 
	 * be localized to proper locale.
	 * ie: TomcatResources.getString() should already have been called
	 */
	public static synchronized void logError(String message, Throwable ex) {
		if (message == null)
			message = "";
		Status errorStatus =
			new Status(IStatus.ERROR, PLUGIN_ID, IStatus.OK, message, ex);
		TomcatPlugin.getDefault().getLog().log(errorStatus);
	}

	/**
	 */
	public static TomcatPlugin getDefault() {
		return plugin;
	}

	/**
	 */
	public void shutdown() throws CoreException {
		super.shutdown();
	}
	/**
	 */
	public void startup() throws CoreException {
		super.startup();
	}

}